        .equiv .L__NR_fcntl, 72
        .equiv .L__NR_read, 0
#       .equiv .L__NR_write, 1
#       .equiv .LSTDIN, 0
#       .equiv .LSTDOUT, 1
        .equiv .LF_GETFL, 3
        .equiv .LF_SETFL, 4
        .equiv .LO_NONBLOCK, 2048
#       .equiv .LNEWLINE, 10
#       .equiv .LOUTPUT_WIDTH, ??
#       .equiv .LMAX_INPUT_BYTES, ??
#       .equiv .LMAX_STRING_BYTES, ??

#
# BEGIN support for runtime INPUT subsystem
#
        .equiv .LMAX_INPUT_VARS, 30

        .section .rodata.str,"aS",@progbits

        .type .LEOF_on_input_msg, @object
.LEOF_on_input_msg:
        .asciz "EOF ON INPUT"
        .size .LEOF_on_input_msg, .-.LEOF_on_input_msg

        .section .text,"ax",@progbits

#
# This procedure clears the .LSTDIN input buffer, discarding its contents (if any)
# FYI, It has no real error checking...
#
        .type   .Ldrain_stdin, @function
.Ldrain_stdin:
        pushq   %rbp                     # create the stack frame
        movq    %rsp,%rbp
        pushq   %rax                     # save value of rax
        pushq   %rdx                     # save value of rdx
        pushq   %rdi                     # save value of rdi
        pushq   %rsi                     # save value of rsi
        subq    $16,%rsp                 # allocate space for two 8-byte local variables
                                         # flags   %rbp-8
                                         # tbuffer %rbp-16
        # get current flags and save them in flags local variable
        movq    $.LSTDIN, %rdi           # rdi = STDIN
        movq    $.LF_GETFL, %rsi         # rsi = F_GETFL (get the file access mode
                                         #                and the file status flags)
        xorl    %edx,%edx                # rdx = 0
        movq    $.L__NR_fcntl, %rax      # call fcntl(STDIN,F_GETFL,0)
        syscall
        movq    %rax,-8(%rbp)            # store status flags in flags local variable
        # set STDIN nonblocking
        movq    $.LSTDIN,%rdi            # rdi = STDIN
        movq    $.LF_SETFL,%rsi          # rsi = F_SETFL
        movq    -8(%rbp),%rdx            # rdx = flags from local variable
        orq     $.LO_NONBLOCK,%rdx       #       enable O_NONBLOCK to set non-blocking
        movq    $.L__NR_fcntl,%rax       # call fcntl(STDIN,F_SETFL,flags|O_NONBLOCK)
        syscall
0:
        # read one byte at a time from STDIN until EOF
        movq    $.LSTDIN,%rdi            # rdi = STDIN
        leaq    -16(%rsp),%rsi           # rsi = tbuffer (16 bytes on stack local variable)
        movl    $1, %edx                 # rdx = 1 (read one byte)
        movq    $.L__NR_read,%rax        # call read(STDIN,tbuffer,1)
        syscall
        cmpq    $0,%rax                  # if not EOF
        jg      0b                       # goto 0
        # set STDIN to blocking
        movq    $.LSTDIN,%rdi            # rdi = STDIN
        movq    $.LF_SETFL,%rsi          # rsi = F_SETFL
        movq    -8(%rbp),%rdx            # rdx = flags (original value)
        movq    $.L__NR_fcntl,%rax       # call fcntl(STDIN,F_SETFL,flags)
        syscall
        addq    $16,%rsp                 # deallocate two 8-byte local variables
        popq    %rsi                     # restore value of rsi
        popq    %rdi                     # restore value of rdi
        popq    %rdx                     # restore value of rdx
        popq    %rax                     # restore value of rax
        movq    %rbp, %rsp               # destroy the stack frame
        popq    %rbp
        retq
        .size   .Ldrain_stdin, .-.Ldrain_stdin
#
# This function will ASCII bytes of input from .LSTDIN until a newline
# is read or the buffer is full (which we know from the length).
# It expects the caller to pass the address of the buffer to hold the
# ASCIIZ string in rdi, and it expects the caller to pass the
# length of that buffer in rsi.  The function returns its
# result in %rax.  On success, the result is the number of
# bytes read; on failure the program jumps to prints an error
# message and jumps to badexit to terminate the program.
#
        .type   .LINPUT, @function
.LINPUT:
        # rdi = address of buffer
        # rsi = length of buffer
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        movq    %rdi, %r13
        leaq    (%rdi,%rsi), %r12
        movq    %rdi, %rbx
0:
        movl    $.L__NR_read, %eax
        movl    $1, %edx
        movl    $.LSTDIN, %edi
        movq    %rbx, %rsi
        syscall
        testq   %rax, %rax
        jg      1f
        movabsq $.Lcurzone, %rdx
        movabsq $.Lobuf_next, %rsi
        movabsq $.LOBUF, %rdi
        movabsq $.Loutputbuffer, %r14
        callq   *%r14
        movabsq $.LEOF_on_input_msg, %rcx
        movabsq $.Lbadxit_msg, %rax
        jmpq    *%rax                  # DOES NOT RETURN
1:
        cmpb    $.LNEWLINE, (%rbx)
        je      2f
        addq    $1, %rbx
        cmpq    %rbx, %r12
        ja      0b
2:
        movb    $0, (%rbx)
        movabsl .Lecho_input, %eax
        testl   %eax, %eax
        jne     4f
        movabsq $.Lobuf_next, %rsi
        movl    $.LOUTPUT_WIDTH+2, %r12d
        subq    (%rsi), %r12
        movq    %r13, %rcx
        movabsq $.Lcurzone, %rdx
        movabsq $.LOBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        callq   *%rax
        movabsq $.LOBUF, %rax
        movb    $.LNEWLINE, .LOUTPUT_WIDTH(%rax)
        movb    $0, .LOUTPUT_WIDTH+1(%rax)
3:
        movl    $.LOUTPUT_WIDTH+1, %esi
        subq    %r12, %rsi
        movabsq $.LOBUF, %rax
        addq    %rax, %rsi
        movl    $.L__NR_write, %eax
        movl    $.LSTDOUT, %edi
        movq    %r12, %rdx
        syscall
        subq    %rax, %r12
        setne   %dl
        testq   %rax, %rax
        setg    %al
        testb   %al, %dl
        jne     3b
4:
        movabsq $.Lcurzone, %rdx
        movabsq $.Lobuf_next, %rsi
        movabsq $.LOBUF, %rdi
        movabsq $.Linitbuffer, %rax
        callq   *%rax
        movq    %rbx, %rax
        subq    %r13, %rax
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %rbp
        retq
        .size   .LINPUT, .-.LINPUT

        .section .bss,"aw",@nobits
#
# The INPUT statement for Minimal BASIC has the requirement that all data is input,
# then validated, and then, only if all validation for every variable in the INPUT
# statement passed, is the data actually copied to the destination variables.  To
# make that possible, data must be input into temporary storage.  The .Lrt_nput_stack
# is used for this, but is actually sometimes used more like a vector than a stack,
# accessing by a slot number instead of stricly from the top of the stack.  When
# used as a stack, the .Lrt_nput_stack_top is the stack pointer.  To record the types
# required for the variables in the INPUT statement, a format statement is created.
# That is stored in the .Linformat variable.
#
        .align 32
        .type   .Lrt_nput_stack, @object
.Lrt_nput_stack:
        .rept .LMAX_INPUT_VARS
        .zero 1
        .zero 2*.LMAX_STRING_BYTES+1  # larger than required to allow LONG numeric constants
        .endr
        .size   .Lrt_nput_stack, .-.Lrt_nput_stack

        .align 8
        .type   .Lrt_nput_stack_top, @object
.Lrt_nput_stack_top:
        .zero   8
        .size   .Lrt_nput_stack_top, .-.Lrt_nput_stack_top
#
# The .Linformat holds the format specification ASCIIZ string for an INPUT statement
# each byte of of the string will hold either 'N' or 'S'.  An 'N' signals that a
# numeric (floating point) value is needed.  An 'S' signals that a 7-bit ASCIIZ string
# value is needed.  For example, given a Minimal BASIC statement like:
# INPUT X,Y$,Z[3]
# the value in .Linformat would be "NSN"
#
        .align 16
        .type   .Linformat, @object
.Linformat:
        .zero   .LMAX_STRING_BYTES+1
        .size   .Linformat, .-.Linformat
#
# Minimal BASIC rules for values entered in response to an INPUT statement
# state that for data outside of a quoted string, all whitespace should be
# ignored.  To remove such space from the raw ASCIIZ data in the input
# buffer, the mytrim() function is used.
#
        .section .text,"ax",@progbits
#
# mytrim() procedure, takes one argument, ptr to ASCIIZ string, in rdi
# nothing is returned - removes all leading/trailing spaces and tabs in place
#
        .type   .Lmytrim, @function
.Lmytrim:
        xorl    %eax, %eax
        cmpb    $0, (%rdi)
        pushq   %rbp
        movq    %rsp, %rbp
        je      11f
0:
        movb    (%rdi,%rax), %dl
        testb   %dl, %dl
        je      3f
        cmpb    $9, %dl
        jne     2f
1:
        incq    %rax
        jmp     0b
2:
        cmpb    $32, %dl
        je      1b
3:
        movq    %rax, %rdx
4:
        cmpb    $0, (%rdi,%rax)
        je      6f
        incq    %rax
        jmp     4b
5:
        movb    (%rdi,%rax), %cl
        cmpb    $9, %cl
        jne     8f
6:
        decq    %rax
        cmpq    %rdx, %rax
        ja      5b
7:
        subq    %rdx, %rax
        addq    %rdi, %rdx
        leaq    1(%rax), %rcx
        xorl    %eax, %eax
        jmp     9f
8:
        cmpb    $32, %cl
        je      6b
        jmp     7b
9:
        cmpq    %rcx, %rax
        je      10f
        movb    (%rdx,%rax), %sil
        movb    %sil, (%rdi,%rax)
        incq    %rax
        jmp     9b
10:
        movb    $0, (%rdi,%rax)
11:
        popq    %rbp
        retq
        .size   .Lmytrim, .-.Lmytrim
#
# At runtime, scanning values is required for the INPUT statment.
# This is done using a DFSM (deterministic finite state machine).
# This machine uses character classes and states.
#
        .section .rodata,"a",@progbits
#
# The .Lcharacter_class is a conversion map to convert between
# an input 7 bit ASCII value and a character class number for use
# with the DFSM used by the INPUT statement scanner.  .Lcharacter_class
# is a vector in which there are 127 elements.
# The ASCII code of the byte in question is used as an
# index into the .Lcharacter_class vector to get the
# character class number which is stored in that element.
#
#  0  is A..D,F..Z upper case
#  1  is E upper case
#  2  is DIGIT
#  3  is ADD
#  4  is MINUS
#  5  is .LCOMMA
#  6  is .LSPACE
#  7  is .LNEWLINE
#  8  is DOT
#  9  is QUOTE
# 10  is anything else
#
        .align 32
        .type   .Lcharacter_class, @object
.Lcharacter_class:
        .byte  10, 10, 10, 10, 10, 10, 10, 10, 10, 10
        .byte   7, 10, 10, 10, 10, 10, 10, 10, 10, 10
        .byte  10, 10, 10, 10, 10, 10, 10, 10, 10, 10
        .byte  10, 10,  6, 10,  9, 10, 10, 10, 10, 10
        .byte  10, 10, 10,  3,  5,  4,  8, 10,  2,  2
        .byte   2,  2,  2,  2,  2,  2,  2,  2, 10, 10
        .byte  10, 10, 10, 10, 10,  0,  0,  0,  0,  1
        .byte   0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        .byte   0,  0,  0,  0,  0,  0,  0,  0,  0,  0
        .byte   0, 10, 10, 10, 10, 10, 10, 10, 10, 10
        .byte  10, 10, 10, 10, 10, 10, 10, 10, 10, 10
        .byte  10, 10, 10, 10, 10, 10, 10, 10, 10, 10
        .byte  10, 10, 10, 10, 10, 10, 10, 10
        .size   .Lcharacter_class, .-.Lcharacter_class
#
# .Lstates is a matrix containing the DFSM used to scan
# data from an INPUT statement.  The rows correspond to the
# states, and the columns correspond to character classes.
# To find the next action, the character class value for the
# current byte is used as the column index, and the current
# state is used as the row index in the .Lstates matrix.
# Actions can be accept (see list below), move to a new
# state, or reject.  Values 0 through 12 move to a new state.
# Values 13 through 18 accept tokens.  Value 19 is a reject.
#
        .align 32
        .type   .Lstates, @object
.Lstates:
         # 13 accept T_.LCOMMA
         # 14 accept T_EOL
         # 15 accept T_INTEGER
         # 16 accept T_REAL
         # 17 accept T_UQSTRING
         # 18 accept T_QSTRING
         # 19 reject
         #    A..D,                       new
         #    F..Z E  0..9 +   -   ,  ' ' line .   " other
        .byte  8,  8,  2,  1,  1, 13,  0, 14,  3,  9, 19  # state 0
        .byte  8,  8,  2,  8,  8, 17,  8, 17,  3, 19, 19  # state 1
        .byte  8,  5,  2,  8,  8, 15, 11, 15,  3, 19, 19  # state 2
        .byte  8,  5,  4,  8,  8, 16, 12, 16,  8, 19, 19  # state 3
        .byte  8,  5,  4,  8,  8, 16, 12, 16,  8, 19, 19  # state 4
        .byte  8,  8,  7,  6,  6, 17,  8, 17,  8, 19, 19  # state 5
        .byte  8,  8,  7,  8,  8, 17,  8, 17,  8, 19, 19  # state 6
        .byte  8,  8,  7,  8,  8, 16, 12, 16,  8, 19, 19  # state 7
        .byte  8,  8,  8,  8,  8, 17, 10, 17,  8, 19, 19  # state 8
        .byte  9,  9,  9,  9,  9,  9,  9, 19,  9, 18,  9  # state 9
        .byte  8,  8,  8,  8,  8, 17, 10, 17,  8, 19, 19  # state 10
        .byte  8,  8,  8,  8,  8, 15, 11, 15,  8, 19, 19  # state 11
        .byte  8,  8,  8,  8,  8, 16, 12, 16,  8, 19, 19  # state 12
        .size    .Lstates, .-.Lstates

        .section .rodata.str,"aS",@progbits

.LparseinputC2:
        .asciz "ERROR: COMMA ENCOUNTERED WHEN DATA EXPECTED"
.LparseinputC3:
        .asciz "ERROR: NEWLINE ENCOUNTERED WHEN DATA EXPECTED"
.LparseinputC4:
        .asciz "ERROR: NUMBER ENCOUNTERED WHEN COMMA OR NEWLINE EXPECTED"
.LparseinputC5:
        .asciz "ERROR: NUMERIC CONSTANT STRING MAXIMUM SIZE IS 36 BYTES"
.LparseinputC6:
        .asciz "ERROR: RUNTIME FAILURE: TOO MANY INPUT VARIABLES"
.LparseinputC7:
        .asciz "ERROR: UNQUOTED STRING ENCOUNTERED WHEN COMMA OR NEWLINE EXPECTED"
.LparseinputC8:
        .asciz "ERROR: UNQUOTED STRING MAXIMUM SIZE IS 18 BYTES"
.LparseinputC9:
        .asciz "ERROR: QUOTED STRING ENCOUNTERED WHEN COMMA OR NEWLINE EXPECTED"
.LparseinputC10:
        .asciz "ERROR: QUOTED STRING MAXIMUM SIZE IS 18 BYTES"

        .section .text,"ax",@progbits
#
# This boolean function will parse the input line buffer passed in %rdi with the length
# passed in %rsi.  It will push the values obtained onto the .Lrt_nput_stack and generate
# a new format string in .Linformat.  The return value is passed in the rax register, and
# will 0 or 1 corresponding to false (error) or true (success).
#
        .type   .Lparseinput, @function
.Lparseinput:
        # rdi = buffer (arg 1)
        # rsi = buflen (arg 2)
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        subq    $120, %rsp
        movq    %rdi, -152(%rbp)
        movq    %rsi, -160(%rbp)
        movabsq $.Lrt_nput_stack_top, %rax
        movq    $0, (%rax)
        movabsq $.Linformat, %rax
        movb    $0, (%rax)
        movb    $0, -144(%rbp)
        movl    $0, %r12d
        movl    $0, %ebx
        movl    $0, %r14d
        movl    $0, %eax
        movl    $0, %r13d
        jmp     22f
0:
        movq    -152(%rbp), %rcx
        movzbl  (%rcx,%r14), %ecx
        movsbl  %cl, %edx
        movabsq $.Lcharacter_class, %rsi
        movzbl  (%rsi,%rdx), %edx
        leaq    (%rax,%rax,4), %rsi
        leaq    (%rax,%rsi,2), %rax
        movabsq $.Lstates, %rsi
        addq    %rsi, %rax
        movzbl  (%rax,%rdx), %edx
        movzbl  %dl, %eax
        cmpb    $16, %dl
        ja      1f
        cmpb    $15, %dl
        jnb     6f
        cmpb    $13, %dl
        je      2f
        cmpb    $14, %dl
        je      4f
        jmp     19f
1:
        cmpb    $18, %dl
        je      14f
        cmpb    $18, %dl
        jb      10f
        cmpb    $19, %dl
        je      20f
        jmp     19f
2:
        addq    $1, %r12
        addq    $1, %r14
        testb   $1, %r12b
        je      3f
        movabsq $.LparseinputC2, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movl    $19, %eax
        movl    $1, %r13d
        jmp     22f
3:
        movb    $0, -144(%rbp)
        movl    $0, %ebx
        movl    $0, %eax
        jmp     22f
4:
        addq    $1, %r12
        testb   $1, %r12b
        je      5f
        movabsq $.LparseinputC3, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movl    $19, %eax
5:
        movabsq $.Linformat, %rcx
        movabsq $.Lrt_nput_stack_top, %rdi
        movq    (%rdi), %rdx
        movb    $0, (%rcx,%rdx)
        movl    $1, %r13d
        jmp     22f
6:
        addq    $1, %r12
        testb   $1, %r12b
        jne     7f
        movabsq $.LparseinputC4, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movl    $19, %eax
        movl    $1, %r13d
        jmp     22f
7:
        movb    $0, -144(%rbp,%rbx)
        leaq    -144(%rbp), %rdi
        movabsq $.Lmytrim, %rax
        call    *%rax
        leaq    -144(%rbp), %rdi
        movabsq $.Lmystrlen, %rax
        call    *%rax
        cmpq    $.LMAX_STRING_BYTES*2, %rax
        jbe     8f
        movabsq $.LparseinputC5, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movl    $19, %eax
        movl    $1, %r13d
        jmp     22f
8:
        movabsq $.Lrt_nput_stack_top, %rax
        movq    (%rax), %r8
        cmpq    $29, %r8
        jbe     9f
        movabsq $.LparseinputC6, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movl    $19, %eax
        movl    $1, %r13d
        jmp     22f
9:
        movabsq $.Linformat, %rdx
        movb    $78, (%rdx,%r8)
        movabsq $.Lrt_nput_stack, %rcx
        leaq    (%r8,%r8,8), %rdx
        addq    %rdx, %rdx
        leaq    (%rdx,%r8), %rdi
        leaq    (%rdi,%rdi), %rsi
        movb    $43, (%rcx,%rsi)
        leaq    1(%r8), %rsi
        movq    %rsi, %rax
        movabsq %rax, .Lrt_nput_stack_top
        leaq    (%rdi,%rdi), %rdx
        leaq    1(%rcx,%rdx), %rdi
        leaq    -144(%rbp), %rsi
        movabsq $.Lmystrcpy, %rax
        call    *%rax
        movb    $0, -144(%rbp)
        movl    $0, %ebx
        movl    $0, %eax
        jmp     22f
10:
        addq    $1, %r12
        testb   $1, %r12b
        jne     11f
        movabsq $.LparseinputC7, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movl    $19, %eax
        movl    $1, %r13d
        jmp     22f
11:
        movb    $0, -144(%rbp,%rbx)
        leaq    -144(%rbp), %rdi
        movabsq $.Lmytrim, %rax
        call    *%rax
        leaq    -144(%rbp), %rdi
        movabsq $.Lmystrlen, %rax
        call    *%rax
        cmpq    $18, %rax
        jbe     12f
        movabsq $.LparseinputC8, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movl    $19, %eax
        movl    $1, %r13d
        jmp     22f
12:
        movabsq $.Lrt_nput_stack_top, %rax
        movq    (%rax), %r9
        cmpq    $29, %r9
        jbe     13f
        movabsq $.LparseinputC6, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movl    $19, %eax
        movl    $1, %r13d
        jmp     22f
13:
        movabsq $.Linformat, %rdx
        movb    $85, (%rdx,%r9)
        movabsq $.Lrt_nput_stack, %rcx
        leaq    (%r9,%r9,8), %rdx
        addq    %rdx, %rdx
        leaq    (%rdx,%r9), %rdi
        leaq    (%rdi,%rdi), %rsi
        movb    $62, (%rcx,%rsi)
        leaq    1(%r9), %rsi
        movq    %rsi, %rax
        movabsq %rax, .Lrt_nput_stack_top
        leaq    (%rdi,%rdi), %rdx
        leaq    1(%rcx,%rdx), %rdi
        leaq    -144(%rbp), %rsi
        movabsq $.Lmystrcpy, %rax
        call    *%rax
        movb    $0, -144(%rbp)
        movl    $0, %ebx
        movl    $0, %eax
        jmp     22f
14:
        addq    $1, %r12
        leaq    1(%rbx), %r15
        movb    %cl, -144(%rbp,%rbx)
        testb   $1, %r12b
        jne     15f
        movabsq $.LparseinputC9, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movq    %r15, %rbx
        movl    $19, %eax
        movl    $1, %r13d
        jmp     22f
15:
        movb    $0, -144(%rbp,%r15)
        leaq    -144(%rbp), %rdi
        movabsq $.Lmytrim, %rax
        call    *%rax
        leaq    -144(%rbp), %rdi
        movabsq $.Lmystrlen, %rax
        call    *%rax
        cmpq    $20, %rax
        jbe     16f
        movabsq $.LparseinputC10, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movq    %r15, %rbx
        movl    $19, %eax
        movl    $1, %r13d
        jmp     22f
16:
        cmpb    $0, -144(%rbp)
        je      17f
        movb    $0, -145(%rbp,%rax)
17:
        addq    $1, %r14
        movabsq $.Lrt_nput_stack_top, %rax
        movq    (%rax), %rbx
        cmpq    $29, %rbx
        jbe     18f
        movabsq $.LparseinputC6, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movq    %r15, %rbx
        movl    $19, %eax
        movl    $1, %r13d
        jmp     22f
18:
        movabsq $.Linformat, %rdx
        movb    $83, (%rdx,%rbx)
        movabsq $.Lrt_nput_stack, %rcx
        leaq    (%rbx,%rbx,8), %rdx
        addq    %rdx, %rdx
        leaq    (%rdx,%rbx), %rdi
        leaq    (%rdi,%rdi), %rsi
        movb    $40, (%rcx,%rsi)
        leaq    1(%rbx), %rsi
        movq    %rsi, %rax
        movabsq %rax, .Lrt_nput_stack_top
        leaq    (%rdi,%rdi), %rdx
        leaq    1(%rcx,%rdx), %rdi
        leaq    -143(%rbp), %rsi
        movabsq $.Lmystrcpy, %rax
        call    *%rax
        movb    $0, -144(%rbp)
        movl    $0, %ebx
        movl    $0, %eax
        jmp     22f
19:
        leaq    1(%rbx), %rdx
        addq    $1, %r14
        movb    %cl, -144(%rbp,%rbx)
        cmpq    $80, %rdx
        seta    %sil
        cmpq    -160(%rbp), %r14
        seta    %cl
        orb     %cl, %sil
        jne     21f
        movq    %rdx, %rbx
        jmp     22f
20:
        movl    $1, %r13d
        jmp     22f
21:
        movq    %rdx, %rbx
        movl    $19, %eax
        movl    $1, %r13d
22:
        testb   %r13b, %r13b
        je      0b
        cmpq    $14, %rax
        sete    %al
        addq    $120, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Lparseinput, .-.Lparseinput

        .section .rodata.str,"aS",@progbits

.LdoinputC12:
        .asciz "? "
.LdoinputC13:
        .asciz "EOF ON INPUT"
.LdoinputC14:
        .asciz "INVALID INPUT: STRING EXCEEDS 18 BYTES"
.LdoinputC15:
        .asciz "INVALID INPUT: EXPECTED "
.LdoinputC16:
        .asciz ","
.LdoinputC17: # quoted string
        .asciz "STRING"
.LdoinputC18:
        .asciz "NUMBER"
.LdoinputC19: # unquoted string
        .asciz "STRING"
.LdoinputC20:
        .asciz "UNKNOWN FORMAT!"

        .section .text,"ax",@progbits

        .type   .Ldoinput, @function
.Ldoinput:
        # rdi = pointer to fmt buffer
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        subq    $120, %rsp
        cld
        movq    %rdi, %r12
        movl    $0, %r13d
0:
        leaq    -144(%rbp), %rdi
        movl    $.LMAX_INPUT_BYTES+1, %ecx
        movb    $0, %al
rep     stosb
        movb    $0, (%rdi)
        addq    $1, %r13
        movabsq $.LdoinputC12, %rcx
        movabsq $.Lcurzone, %rdx
        movabsq $.Lobuf_next, %rsi
        movabsq $.LOBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq .Lobuf_next, %rax
        leaq    -1(%rax), %r8
        movq    %r8, %rdx
1:
        movq    %r8, %rsi
        subq    %rdx, %rsi
        movabsq $.LOBUF, %rax
        addq    %rax, %rsi
        movl    $.L__NR_write, %eax
        movl    $.LSTDOUT, %edi
        syscall
        movq    %rax, %rcx
        subq    %rax, %rdx
        setne   %sil
        testq   %rax, %rax
        setg    %al
        testb   %al, %sil
        jne     1b
        testq   %rcx, %rcx
        movl    $.LMAX_INPUT_BYTES, %esi
        leaq    -144(%rbp), %rdi
        movabsq $.LINPUT, %rax
        call    *%rax
        testq   %rax, %rax
        jns     2f
        movabsq $.LdoinputC13, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        movl    $0, %eax
        jmp     19f
2:
        leaq    1(%rax), %rsi
        movb    $.LNEWLINE, -144(%rbp,%rax)
        movb    $0, -144(%rbp,%rsi)
        leaq    -144(%rbp), %rdi
        movabsq $.Lparseinput, %rax
        call    *%rax
        testb   %al, %al
        je      10f
        movabsq $.Linformat, %rsi
        movq    %r12, %rdi
        movabsq $.Lmystrcmp, %rax
        call    *%rax
        testl   %eax, %eax
        je      18f
        movabsq $.Linformat, %rdi
        movabsq $.Lmystrlen, %rax
        call    *%rax
        movq    %rax, %rcx
        movq    %rax, -152(%rbp)
        movabsq .Lrt_nput_stack_top, %rax
        cmpq    %rax, %rcx
        je      8f
        jmp     10f
3:
        leaq    (%r12,%rbx), %r14
        movzbl  (%r14), %r15d
        cmpb    $'S', %r15b
        sete    %dl
        cmpb    $'U', %r15b
        sete    %al
        orb     %al, %dl
        je      6f
        movabsq $.Linformat, %rax
        cmpb    $'N', (%rax,%rbx)
        jne     6f
        leaq    (%rbx,%rbx,8), %rax
        leaq    (%rbx,%rax,2), %rdx
        leaq    (%rdx,%rdx), %rax
        movabsq $.Lrt_nput_stack, %rdx
        leaq    1(%rdx,%rax), %rdi
        movabsq $.Lmystrlen, %rax
        call    *%rax
        cmpq    $.LMAX_STRING_BYTES, %rax
        jbe     4f
        movabsq $.LdoinputC14, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        jmp     7f
4:
        movabsq $.Linformat, %rax
        movb    %r15b, (%rax,%rbx)
        cmpb    $'S', (%r14)
        jne     5f
        leaq    (%rbx,%rbx,8), %rax
        leaq    (%rbx,%rax,2), %rdx
        leaq    (%rdx,%rdx), %rax
        movabsq $.Lrt_nput_stack, %rdx
        movb    $40, (%rdx,%rax)           # T_QSTRING
        jmp     6f
5:
        leaq    (%rbx,%rbx,8), %rax
        leaq    (%rbx,%rax,2), %rdx
        leaq    (%rdx,%rdx), %rax
        movabsq $.Lrt_nput_stack, %rdx
        movb    $62, (%rdx,%rax)           # T_UQSTRING
6:
        cmpb    $'U', (%r14)
        jne     7f
        movabsq $.Linformat, %rax
        cmpb    $'S', (%rax,%rbx)
        jne     7f
        movb    $'U', (%rax,%rbx)
        leaq    (%rbx,%rbx,8), %rax
        leaq    (%rbx,%rax,2), %rdx
        leaq    (%rdx,%rdx), %rax
        movabsq $.Lrt_nput_stack, %rdx
        movb    $62, (%rdx,%rax)           # T_UQSTRING
7:
        addq    $1, %rbx
        jmp     9f
8:
        movl    $0, %ebx
9:
        cmpq    -152(%rbp), %rbx
        jb      3b
        movabsq $.Linformat, %rsi
        movq    %r12, %rdi
        movabsq $.Lmystrcmp, %rax
        call    *%rax
        testl   %eax, %eax
        je      18f
10:
        movabsq $.Lcurzone, %rdx
        movabsq $.Lobuf_next, %rsi
        movabsq $.LOBUF, %rdi
        movabsq $.Linitbuffer, %rax
        call    *%rax
        movabsq $.LdoinputC15, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        movq    %r12, %rdi
        movabsq $.Lmystrlen, %rax
        call    *%rax
        movq    %rax, %r14
        movl    $0, %ebx
        jmp     17f
11:
        testq   %rbx, %rbx
        je      12f
        movabsq $.LdoinputC16, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
12:
        movzbl  (%r12,%rbx), %eax
        cmpb    $'S', %al
        jne     13f
        movabsq $.LdoinputC17, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        jmp     16f
13:
        cmpb    $'N', %al
        jne     14f
        movabsq $.LdoinputC18, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        jmp     16f
14:
        cmpb    $'U', %al
        jne     15f
        movabsq $.LdoinputC19, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
        jmp     16f
15:
        movabsq $.LdoinputC20, %rcx
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Lappendbuffer, %rax
        call    *%rax
16:
        addq    $1, %rbx
17:
        cmpq    %r14, %rbx
        jb      11b
        movabsq $.Lcurezone, %rdx
        movabsq $.Lebuf_next, %rsi
        movabsq $.LEBUF, %rdi
        movabsq $.Loutputbuffer, %rax
        call    *%rax
        cmpq    $4, %r13
        jbe     0b
        movl    $0, %eax
        jmp     19f
18:
        movl    $1, %eax
19:
        addq    $120, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Ldoinput, .-.Ldoinput
