         #
         # Code uses Bob Jenkins' public domain ISAAC-64 random number generator
         # This code is in the public domain.
         # http://burtleburtle.net/bob/rand/isaacafa.html
         #
        .section .rodata.cst16,"aM",@progbits,16
        .align  16, 0
.LRAND_0:
        .long   1127219200              # 0x43300000
        .long   1160773632              # 0x45300000
        .long   0                       # 0x0
        .long   0                       # 0x0
.LRAND_1:
        .quad   4841369599423283200     # double 4.503600e+15
        .quad   4985484787499139072     # double 1.934281e+25

        .section .rodata.cst8,"aM",@progbits,8
        .align  8, 0
.LRAND_2:
        .quad   4323455642275676160     # double 1.084202172485504E-19

        .section .data,"aw",@progbits

        .align  8
        .type   .LRAND_aa,@object
.LRAND_aa:
        .quad   0
        .size   .LRAND_aa, .-.LRAND_aa

        .type   .LRAND_bb,@object
.LRAND_bb:
        .quad   0
        .size   .LRAND_bb, .-.LRAND_bb

        .type   .LRAND_cc,@object
.LRAND_cc:
        .quad   0
        .size   .LRAND_cc, .-.LRAND_cc

        .type   .LRAND_randcnt,@object
.LRAND_randcnt:
        .quad   0
        .size   .LRAND_randcnt, .-.LRAND_randcnt

        .type   .LRAND_mm,@object
        .align  16, 0
.LRAND_mm:
        .skip   2048, 0
        .size   .LRAND_mm, .-.LRAND_mm

        .type   .LRAND_randrsl,@object
        .align  16
.LRAND_randrsl:
        .skip   2048, 0
        .size   .LRAND_randrsl, .-.LRAND_randrsl

        .section .text,"ax",@progbits

        .type   .Lisaac64,@function
.Lisaac64:
        pushq   %rbp
        movq    %rsp, %rbp
        movabsq $.LRAND_mm, %rax
        movq    %rax, -40(%rbp)
        movabsq $.LRAND_randrsl, %rcx
        movq    %rcx, -56(%rbp)
        movabsq $.LRAND_aa, %rcx
        movq    (%rcx), %rcx
        movq    %rcx, -8(%rbp)
        movabsq $.LRAND_bb, %rcx
        movq    (%rcx), %rcx
        movabsq $.LRAND_cc, %rdx
        movq    (%rdx), %rsi
        movq    %rsi, %rdi
        incq    %rdi
        movq    %rdi, (%rdx)
        leaq    1(%rcx,%rsi), %rcx
        movq    %rcx, -16(%rbp)
        movq    %rax, -40(%rbp)
        movq    -40(%rbp), %rax
        addq    $1024, %rax             # imm = 0x400
        movq    %rax, -48(%rbp)
        movq    %rax, -64(%rbp)
0:
        movq    -40(%rbp), %rax
        cmpq    -64(%rbp), %rax
        jb      1f
        jmp     2f
1:
        movq    -40(%rbp), %rax
        movq    (%rax), %rax
        movq    %rax, -24(%rbp)
        movq    -8(%rbp), %rax
        movq    %rax, %rcx
        shlq    $21, %rcx
        xorq    %rcx, %rax
        notq    %rax
        movq    -48(%rbp), %rcx
        movq    %rcx, %rdx
        addq    $8, %rdx
        movq    %rdx, -48(%rbp)
        movq    (%rcx), %rcx
        addq    %rcx, %rax
        movq    %rax, -8(%rbp)
        movq    -24(%rbp), %rcx
        andq    $2040, %rcx             # imm = 0x7F8
        movabsq $.LRAND_mm, %rdx
        movq    (%rdx,%rcx), %rcx
        addq    %rax, %rcx
        movq    -16(%rbp), %rax
        addq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -40(%rbp), %rax
        movq    %rax, %rsi
        addq    $8, %rsi
        movq    %rsi, -40(%rbp)
        movq    %rcx, (%rax)
        movq    -32(%rbp), %rax
        shrq    $8, %rax
        andq    $2040, %rax             # imm = 0x7F8
        movq    (%rdx,%rax), %rax
        movq    -24(%rbp), %rcx
        addq    %rcx, %rax
        movq    %rax, -16(%rbp)
        movq    -56(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -56(%rbp)
        movq    %rax, (%rcx)
        movq    -40(%rbp), %rax
        movq    (%rax), %rax
        movq    %rax, -24(%rbp)
        movq    -8(%rbp), %rax
        movq    %rax, %rcx
        shrq    $5, %rcx
        xorq    %rcx, %rax
        movq    -48(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -48(%rbp)
        movq    (%rcx), %rcx
        addq    %rcx, %rax
        movq    %rax, -8(%rbp)
        movq    -24(%rbp), %rcx
        andq    $2040, %rcx             # imm = 0x7F8
        movq    (%rdx,%rcx), %rcx
        addq    %rax, %rcx
        movq    -16(%rbp), %rax
        addq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -40(%rbp), %rax
        movq    %rax, %rsi
        addq    $8, %rsi
        movq    %rsi, -40(%rbp)
        movq    %rcx, (%rax)
        movq    -32(%rbp), %rax
        shrq    $8, %rax
        andq    $2040, %rax             # imm = 0x7F8
        movq    (%rdx,%rax), %rax
        movq    -24(%rbp), %rcx
        addq    %rcx, %rax
        movq    %rax, -16(%rbp)
        movq    -56(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -56(%rbp)
        movq    %rax, (%rcx)
        movq    -40(%rbp), %rax
        movq    (%rax), %rax
        movq    %rax, -24(%rbp)
        movq    -8(%rbp), %rax
        movq    %rax, %rcx
        shlq    $12, %rcx
        xorq    %rcx, %rax
        movq    -48(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -48(%rbp)
        movq    (%rcx), %rcx
        addq    %rcx, %rax
        movq    %rax, -8(%rbp)
        movq    -24(%rbp), %rcx
        andq    $2040, %rcx             # imm = 0x7F8
        movq    (%rdx,%rcx), %rcx
        addq    %rax, %rcx
        movq    -16(%rbp), %rax
        addq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -40(%rbp), %rax
        movq    %rax, %rsi
        addq    $8, %rsi
        movq    %rsi, -40(%rbp)
        movq    %rcx, (%rax)
        movq    -32(%rbp), %rax
        shrq    $8, %rax
        andq    $2040, %rax             # imm = 0x7F8
        movq    (%rdx,%rax), %rax
        movq    -24(%rbp), %rcx
        addq    %rcx, %rax
        movq    %rax, -16(%rbp)
        movq    -56(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -56(%rbp)
        movq    %rax, (%rcx)
        movq    -40(%rbp), %rax
        movq    (%rax), %rax
        movq    %rax, -24(%rbp)
        movq    -8(%rbp), %rax
        movq    %rax, %rcx
        shrq    $33, %rcx
        xorq    %rcx, %rax
        movq    -48(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -48(%rbp)
        movq    (%rcx), %rcx
        addq    %rcx, %rax
        movq    %rax, -8(%rbp)
        movq    -24(%rbp), %rcx
        andq    $2040, %rcx             # imm = 0x7F8
        movq    (%rdx,%rcx), %rcx
        addq    %rax, %rcx
        movq    -16(%rbp), %rax
        addq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -40(%rbp), %rax
        movq    %rax, %rsi
        addq    $8, %rsi
        movq    %rsi, -40(%rbp)
        movq    %rcx, (%rax)
        movq    -32(%rbp), %rax
        shrq    $8, %rax
        andq    $2040, %rax             # imm = 0x7F8
        addq    %rax, %rdx
        movq    (%rdx), %rax
        addq    -24(%rbp), %rax
        movq    %rax, -16(%rbp)
        movq    -56(%rbp), %rcx
        movq    %rcx, %rdx
        addq    $8, %rdx
        movq    %rdx, -56(%rbp)
        movq    %rax, (%rcx)
        jmp     0b
2:
        movabsq $.LRAND_mm, %rax
        movq    %rax, -48(%rbp)
3:
        movq    -48(%rbp), %rax
        cmpq    -64(%rbp), %rax
        jb      4f
        jmp     5f
4:
        movq    -40(%rbp), %rax
        movq    (%rax), %rax
        movq    %rax, -24(%rbp)
        movq    -8(%rbp), %rax
        movq    %rax, %rcx
        shlq    $21, %rcx
        xorq    %rcx, %rax
        notq    %rax
        movq    -48(%rbp), %rcx
        movq    %rcx, %rdx
        addq    $8, %rdx
        movq    %rdx, -48(%rbp)
        movq    (%rcx), %rcx
        addq    %rcx, %rax
        movq    %rax, -8(%rbp)
        movq    -24(%rbp), %rcx
        andq    $2040, %rcx             # imm = 0x7F8
        movabsq $.LRAND_mm, %rdx
        movq    (%rdx,%rcx), %rcx
        addq    %rax, %rcx
        movq    -16(%rbp), %rax
        addq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -40(%rbp), %rax
        movq    %rax, %rsi
        addq    $8, %rsi
        movq    %rsi, -40(%rbp)
        movq    %rcx, (%rax)
        movq    -32(%rbp), %rax
        shrq    $8, %rax
        andq    $2040, %rax             # imm = 0x7F8
        movq    (%rdx,%rax), %rax
        movq    -24(%rbp), %rcx
        addq    %rcx, %rax
        movq    %rax, -16(%rbp)
        movq    -56(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -56(%rbp)
        movq    %rax, (%rcx)
        movq    -40(%rbp), %rax
        movq    (%rax), %rax
        movq    %rax, -24(%rbp)
        movq    -8(%rbp), %rax
        movq    %rax, %rcx
        shrq    $5, %rcx
        xorq    %rcx, %rax
        movq    -48(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -48(%rbp)
        movq    (%rcx), %rcx
        addq    %rcx, %rax
        movq    %rax, -8(%rbp)
        movq    -24(%rbp), %rcx
        andq    $2040, %rcx             # imm = 0x7F8
        movq    (%rdx,%rcx), %rcx
        addq    %rax, %rcx
        movq    -16(%rbp), %rax
        addq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -40(%rbp), %rax
        movq    %rax, %rsi
        addq    $8, %rsi
        movq    %rsi, -40(%rbp)
        movq    %rcx, (%rax)
        movq    -32(%rbp), %rax
        shrq    $8, %rax
        andq    $2040, %rax             # imm = 0x7F8
        movq    (%rdx,%rax), %rax
        movq    -24(%rbp), %rcx
        addq    %rcx, %rax
        movq    %rax, -16(%rbp)
        movq    -56(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -56(%rbp)
        movq    %rax, (%rcx)
        movq    -40(%rbp), %rax
        movq    (%rax), %rax
        movq    %rax, -24(%rbp)
        movq    -8(%rbp), %rax
        movq    %rax, %rcx
        shlq    $12, %rcx
        xorq    %rcx, %rax
        movq    -48(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -48(%rbp)
        movq    (%rcx), %rcx
        addq    %rcx, %rax
        movq    %rax, -8(%rbp)
        movq    -24(%rbp), %rcx
        andq    $2040, %rcx             # imm = 0x7F8
        movq    (%rdx,%rcx), %rcx
        addq    %rax, %rcx
        movq    -16(%rbp), %rax
        addq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -40(%rbp), %rax
        movq    %rax, %rsi
        addq    $8, %rsi
        movq    %rsi, -40(%rbp)
        movq    %rcx, (%rax)
        movq    -32(%rbp), %rax
        shrq    $8, %rax
        andq    $2040, %rax             # imm = 0x7F8
        movq    (%rdx,%rax), %rax
        movq    -24(%rbp), %rcx
        addq    %rcx, %rax
        movq    %rax, -16(%rbp)
        movq    -56(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -56(%rbp)
        movq    %rax, (%rcx)
        movq    -40(%rbp), %rax
        movq    (%rax), %rax
        movq    %rax, -24(%rbp)
        movq    -8(%rbp), %rax
        movq    %rax, %rcx
        shrq    $33, %rcx
        xorq    %rcx, %rax
        movq    -48(%rbp), %rcx
        movq    %rcx, %rsi
        addq    $8, %rsi
        movq    %rsi, -48(%rbp)
        movq    (%rcx), %rcx
        addq    %rcx, %rax
        movq    %rax, -8(%rbp)
        movq    -24(%rbp), %rcx
        andq    $2040, %rcx             # imm = 0x7F8
        movq    (%rdx,%rcx), %rcx
        addq    %rax, %rcx
        movq    -16(%rbp), %rax
        addq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -40(%rbp), %rax
        movq    %rax, %rsi
        addq    $8, %rsi
        movq    %rsi, -40(%rbp)
        movq    %rcx, (%rax)
        movq    -32(%rbp), %rax
        shrq    $8, %rax
        andq    $2040, %rax             # imm = 0x7F8
        addq    %rax, %rdx
        movq    (%rdx), %rax
        addq    -24(%rbp), %rax
        movq    %rax, -16(%rbp)
        movq    -56(%rbp), %rcx
        movq    %rcx, %rdx
        addq    $8, %rdx
        movq    %rdx, -56(%rbp)
        movq    %rax, (%rcx)
        jmp     3b
5:
        movq    -16(%rbp), %rax
        movabsq $.LRAND_bb, %rcx
        movq    %rax, (%rcx)
        movq    -8(%rbp), %rax
        movabsq $.LRAND_aa, %rcx
        movq    %rax, (%rcx)
        popq    %rbp
        retq
        .size   .Lisaac64, .-.Lisaac64

        .type   .Lrandinit,@function
.Lrandinit:
        pushq   %rbp
        movq    %rsp, %rbp
        subq    $80, %rsp
        movabsq $0x9E3779B97F4A7C13, %rax
        movl    %edi, -4(%rbp)
        movabsq $.LRAND_cc, %rcx
        movq    $0, (%rcx)
        movabsq $.LRAND_bb, %rcx
        movq    $0, (%rcx)
        movabsq $.LRAND_aa, %rcx
        movq    $0, (%rcx)
        movq    %rax, -72(%rbp)
        movq    %rax, -64(%rbp)
        movq    %rax, -56(%rbp)
        movq    %rax, -48(%rbp)
        movq    %rax, -40(%rbp)
        movq    %rax, -32(%rbp)
        movq    %rax, -24(%rbp)
        movq    %rax, -16(%rbp)
        movl    $0, -8(%rbp)
0:
        cmpl    $4, -8(%rbp)
        jl      1f
        jmp     2f
1:
        movq    -48(%rbp), %rax
        movq    -16(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -16(%rbp)
        movq    -72(%rbp), %rax
        shrq    $9, %rax
        movq    -56(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -56(%rbp)
        movq    -16(%rbp), %rax
        movq    -72(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -72(%rbp)
        movq    -56(%rbp), %rax
        movq    -24(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -24(%rbp)
        movq    -16(%rbp), %rax
        shlq    $9, %rax
        movq    -64(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -64(%rbp)
        movq    -24(%rbp), %rax
        movq    -16(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -16(%rbp)
        movq    -64(%rbp), %rax
        movq    -32(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -24(%rbp), %rax
        shrq    $23, %rax
        movq    -72(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -72(%rbp)
        movq    -32(%rbp), %rax
        movq    -24(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -24(%rbp)
        movq    -72(%rbp), %rax
        movq    -40(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -40(%rbp)
        movq    -32(%rbp), %rax
        shlq    $15, %rax
        movq    -16(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -16(%rbp)
        movq    -40(%rbp), %rax
        movq    -32(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -16(%rbp), %rax
        movq    -48(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -48(%rbp)
        movq    -40(%rbp), %rax
        shrq    $14, %rax
        movq    -24(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -24(%rbp)
        movq    -48(%rbp), %rax
        movq    -40(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -40(%rbp)
        movq    -24(%rbp), %rax
        movq    -56(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -56(%rbp)
        movq    -48(%rbp), %rax
        shlq    $20, %rax
        movq    -32(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -56(%rbp), %rax
        movq    -48(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -48(%rbp)
        movq    -32(%rbp), %rax
        movq    -64(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -64(%rbp)
        movq    -56(%rbp), %rax
        shrq    $17, %rax
        movq    -40(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -40(%rbp)
        movq    -64(%rbp), %rax
        movq    -56(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -56(%rbp)
        movq    -40(%rbp), %rax
        movq    -72(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -72(%rbp)
        movq    -64(%rbp), %rax
        shlq    $14, %rax
        movq    -48(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -48(%rbp)
        movq    -72(%rbp), %rax
        movq    -64(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -64(%rbp)
        movl    -8(%rbp), %eax
        addl    $1, %eax
        movl    %eax, -8(%rbp)
        jmp     0b
2:
        movl    $0, -8(%rbp)
3:
        cmpl    $256, -8(%rbp)          # imm = 0x100
        jl      4f
        jmp     7f
4:
        cmpl    $0, -4(%rbp)
        jne     5f
        jmp     6f
5:
        movslq  -8(%rbp), %rax
        movabsq $.LRAND_randrsl, %rcx
        movq    (%rcx,%rax,8), %rax
        movq    -16(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -16(%rbp)
        movl    -8(%rbp), %esi
        incl    %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -24(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -24(%rbp)
        movl    -8(%rbp), %esi
        addl    $2, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -32(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -32(%rbp)
        movl    -8(%rbp), %esi
        addl    $3, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -40(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -40(%rbp)
        movl    -8(%rbp), %esi
        addl    $4, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -48(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -48(%rbp)
        movl    -8(%rbp), %esi
        addl    $5, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -56(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -56(%rbp)
        movl    -8(%rbp), %esi
        addl    $6, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -64(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -64(%rbp)
        movl    -8(%rbp), %esi
        addl    $7, %esi
        movslq  %esi, %rax
        leaq    (%rcx,%rax,8), %rax
        movq    (%rax), %rax
        movq    -72(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -72(%rbp)
6:
        movq    -48(%rbp), %rax
        movq    -16(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -16(%rbp)
        movq    -72(%rbp), %rax
        shrq    $9, %rax
        movq    -56(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -56(%rbp)
        movq    -16(%rbp), %rax
        movq    -72(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -72(%rbp)
        movq    -56(%rbp), %rax
        movq    -24(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -24(%rbp)
        movq    -16(%rbp), %rax
        shlq    $9, %rax
        movq    -64(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -64(%rbp)
        movq    -24(%rbp), %rax
        movq    -16(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -16(%rbp)
        movq    -64(%rbp), %rax
        movq    -32(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -24(%rbp), %rax
        shrq    $23, %rax
        movq    -72(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -72(%rbp)
        movq    -32(%rbp), %rax
        movq    -24(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -24(%rbp)
        movq    -72(%rbp), %rax
        movq    -40(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -40(%rbp)
        movq    -32(%rbp), %rax
        shlq    $15, %rax
        movq    -16(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -16(%rbp)
        movq    -40(%rbp), %rax
        movq    -32(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -16(%rbp), %rax
        movq    -48(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -48(%rbp)
        movq    -40(%rbp), %rax
        shrq    $14, %rax
        movq    -24(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -24(%rbp)
        movq    -48(%rbp), %rax
        movq    -40(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -40(%rbp)
        movq    -24(%rbp), %rax
        movq    -56(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -56(%rbp)
        movq    -48(%rbp), %rax
        shlq    $20, %rax
        movq    -32(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -32(%rbp)
        movq    -56(%rbp), %rax
        movq    -48(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -48(%rbp)
        movq    -32(%rbp), %rax
        movq    -64(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -64(%rbp)
        movq    -56(%rbp), %rax
        shrq    $17, %rax
        movq    -40(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -40(%rbp)
        movq    -64(%rbp), %rax
        movq    -56(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -56(%rbp)
        movq    -40(%rbp), %rax
        movq    -72(%rbp), %rcx
        subq    %rax, %rcx
        movq    %rcx, -72(%rbp)
        movq    -64(%rbp), %rax
        shlq    $14, %rax
        movq    -48(%rbp), %rcx
        xorq    %rax, %rcx
        movq    %rcx, -48(%rbp)
        movq    -72(%rbp), %rax
        movq    -64(%rbp), %rcx
        addq    %rax, %rcx
        movq    %rcx, -64(%rbp)
        movq    -16(%rbp), %rax
        movslq  -8(%rbp), %rcx
        movabsq $.LRAND_mm, %rdx
        movq    %rax, (%rdx,%rcx,8)
        movq    -24(%rbp), %rax
        movl    -8(%rbp), %esi
        incl    %esi
        movslq  %esi, %rcx
        movq    %rax, (%rdx,%rcx,8)
        movq    -32(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $2, %esi
        movslq  %esi, %rcx
        movq    %rax, (%rdx,%rcx,8)
        movq    -40(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $3, %esi
        movslq  %esi, %rcx
        movq    %rax, (%rdx,%rcx,8)
        movq    -48(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $4, %esi
        movslq  %esi, %rcx
        movq    %rax, (%rdx,%rcx,8)
        movq    -56(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $5, %esi
        movslq  %esi, %rcx
        movq    %rax, (%rdx,%rcx,8)
        movq    -64(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $6, %esi
        movslq  %esi, %rcx
        movq    %rax, (%rdx,%rcx,8)
        movq    -72(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $7, %esi
        movslq  %esi, %rcx
        leaq    (%rdx,%rcx,8), %rcx
        movq    %rax, (%rcx)
        movl    -8(%rbp), %eax
        addl    $8, %eax
        movl    %eax, -8(%rbp)
        jmp     3b
7:
        cmpl    $0, -4(%rbp)
        jne     8f
        jmp     11f
8:
        movl    $0, -8(%rbp)
9:
        cmpl    $256, -8(%rbp)          # imm = 0x100
        jl      10f
        jmp     11f
10:
        movslq  -8(%rbp), %rax
        movabsq $.LRAND_mm, %rcx
        movq    (%rcx,%rax,8), %rax
        movq    -16(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -16(%rbp)
        movl    -8(%rbp), %esi
        incl    %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -24(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -24(%rbp)
        movl    -8(%rbp), %esi
        addl    $2, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -32(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -32(%rbp)
        movl    -8(%rbp), %esi
        addl    $3, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -40(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -40(%rbp)
        movl    -8(%rbp), %esi
        addl    $4, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -48(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -48(%rbp)
        movl    -8(%rbp), %esi
        addl    $5, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -56(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -56(%rbp)
        movl    -8(%rbp), %esi
        addl    $6, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -64(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -64(%rbp)
        movl    -8(%rbp), %esi
        addl    $7, %esi
        movslq  %esi, %rax
        movq    (%rcx,%rax,8), %rax
        movq    -72(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -72(%rbp)
        movq    -48(%rbp), %rax
        movq    -16(%rbp), %rdx
        subq    %rax, %rdx
        movq    %rdx, -16(%rbp)
        movq    -72(%rbp), %rax
        shrq    $9, %rax
        movq    -56(%rbp), %rdx
        xorq    %rax, %rdx
        movq    %rdx, -56(%rbp)
        movq    -16(%rbp), %rax
        movq    -72(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -72(%rbp)
        movq    -56(%rbp), %rax
        movq    -24(%rbp), %rdx
        subq    %rax, %rdx
        movq    %rdx, -24(%rbp)
        movq    -16(%rbp), %rax
        shlq    $9, %rax
        movq    -64(%rbp), %rdx
        xorq    %rax, %rdx
        movq    %rdx, -64(%rbp)
        movq    -24(%rbp), %rax
        movq    -16(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -16(%rbp)
        movq    -64(%rbp), %rax
        movq    -32(%rbp), %rdx
        subq    %rax, %rdx
        movq    %rdx, -32(%rbp)
        movq    -24(%rbp), %rax
        shrq    $23, %rax
        movq    -72(%rbp), %rdx
        xorq    %rax, %rdx
        movq    %rdx, -72(%rbp)
        movq    -32(%rbp), %rax
        movq    -24(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -24(%rbp)
        movq    -72(%rbp), %rax
        movq    -40(%rbp), %rdx
        subq    %rax, %rdx
        movq    %rdx, -40(%rbp)
        movq    -32(%rbp), %rax
        shlq    $15, %rax
        movq    -16(%rbp), %rdx
        xorq    %rax, %rdx
        movq    %rdx, -16(%rbp)
        movq    -40(%rbp), %rax
        movq    -32(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -32(%rbp)
        movq    -16(%rbp), %rax
        movq    -48(%rbp), %rdx
        subq    %rax, %rdx
        movq    %rdx, -48(%rbp)
        movq    -40(%rbp), %rax
        shrq    $14, %rax
        movq    -24(%rbp), %rdx
        xorq    %rax, %rdx
        movq    %rdx, -24(%rbp)
        movq    -48(%rbp), %rax
        movq    -40(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -40(%rbp)
        movq    -24(%rbp), %rax
        movq    -56(%rbp), %rdx
        subq    %rax, %rdx
        movq    %rdx, -56(%rbp)
        movq    -48(%rbp), %rax
        shlq    $20, %rax
        movq    -32(%rbp), %rdx
        xorq    %rax, %rdx
        movq    %rdx, -32(%rbp)
        movq    -56(%rbp), %rax
        movq    -48(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -48(%rbp)
        movq    -32(%rbp), %rax
        movq    -64(%rbp), %rdx
        subq    %rax, %rdx
        movq    %rdx, -64(%rbp)
        movq    -56(%rbp), %rax
        shrq    $17, %rax
        movq    -40(%rbp), %rdx
        xorq    %rax, %rdx
        movq    %rdx, -40(%rbp)
        movq    -64(%rbp), %rax
        movq    -56(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -56(%rbp)
        movq    -40(%rbp), %rax
        movq    -72(%rbp), %rdx
        subq    %rax, %rdx
        movq    %rdx, -72(%rbp)
        movq    -64(%rbp), %rax
        shlq    $14, %rax
        movq    -48(%rbp), %rdx
        xorq    %rax, %rdx
        movq    %rdx, -48(%rbp)
        movq    -72(%rbp), %rax
        movq    -64(%rbp), %rdx
        addq    %rax, %rdx
        movq    %rdx, -64(%rbp)
        movq    -16(%rbp), %rax
        movslq  -8(%rbp), %rdx
        movq    %rax, (%rcx,%rdx,8)
        movq    -24(%rbp), %rax
        movl    -8(%rbp), %esi
        incl    %esi
        movslq  %esi, %rdx
        movq    %rax, (%rcx,%rdx,8)
        movq    -32(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $2, %esi
        movslq  %esi, %rdx
        movq    %rax, (%rcx,%rdx,8)
        movq    -40(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $3, %esi
        movslq  %esi, %rdx
        movq    %rax, (%rcx,%rdx,8)
        movq    -48(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $4, %esi
        movslq  %esi, %rdx
        movq    %rax, (%rcx,%rdx,8)
        movq    -56(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $5, %esi
        movslq  %esi, %rdx
        movq    %rax, (%rcx,%rdx,8)
        movq    -64(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $6, %esi
        movslq  %esi, %rdx
        movq    %rax, (%rcx,%rdx,8)
        movq    -72(%rbp), %rax
        movl    -8(%rbp), %esi
        addl    $7, %esi
        movslq  %esi, %rdx
        leaq    (%rcx,%rdx,8), %rcx
        movq    %rax, (%rcx)
        movl    -8(%rbp), %eax
        addl    $8, %eax
        movl    %eax, -8(%rbp)
        jmp     9b
11:
        movabsq $.Lisaac64, %rax
        callq   *%rax
        movabsq $.LRAND_randcnt, %rax
        movq    $256, (%rax)            # imm = 0x100
        addq    $80, %rsp
        popq    %rbp
        retq
        .size   .Lrandinit, .-.Lrandinit

# This function takes no input parameters, and will generate
# a pseudo-random number which upon return is left in the xmm0 register.

        .type   .Ldrand,@function
.Ldrand:
        movq    %xmm1,%r8    # save a copy of xmm1 in r8
        pushq   %rbp
        movq    %rsp, %rbp
        subq    $80, %rsp
0:
        movabsq $.LRAND_randcnt, %rax
        movq    (%rax), %rcx
        movq    %rcx, %rdx
        decq    %rdx
        movq    %rdx, (%rax)
        cmpq    $0, %rcx
        jne     1f
        movabsq $.Lisaac64, %rax
        callq   *%rax
        movabsq $.LRAND_randcnt, %rax
        movq    $255, (%rax)
        movl    $255, %eax
        movabsq $.LRAND_randrsl, %rcx
        addq    $2040, %rcx             # imm = 0x7F8
        movq    (%rcx), %rcx
        movq    %rax, -16(%rbp)
        movq    %rcx, -24(%rbp)
        jmp     2f
1:
        movabsq $.LRAND_randcnt, %rax
        movq    (%rax), %rax
        movabsq $.LRAND_randrsl, %rcx
        leaq    (%rcx,%rax,8), %rax
        movq    (%rax), %rax
        movq    %rax, -24(%rbp)
2:
        movq    -24(%rbp), %rax
        movabsq $.LRAND_0, %rcx
        movaps  (%rcx), %xmm0
        movd    %rax, %xmm1
        punpckldq       %xmm0, %xmm1    # xmm1 = xmm1[0],xmm0[0],xmm1[1],xmm0[1]
        movabsq $.LRAND_1, %rax
        movapd  (%rax), %xmm0
        subpd   %xmm0, %xmm1
        haddpd  %xmm1, %xmm1
        movabsq $.LRAND_2, %rax
        movsd   (%rax), %xmm0
        mulsd   %xmm0, %xmm1
        movabsq $.LRAND_randcnt, %rax
        movq    (%rax), %rcx
        movq    %rcx, %rdx
        decq    %rdx
        movq    %rdx, (%rax)
        cmpq    $0, %rcx
        movsd   %xmm1, -32(%rbp)
        jne     3f
        movabsq $.Lisaac64, %rax
        callq   *%rax
        movabsq $.LRAND_randcnt, %rax
        movq    $255, (%rax)
        movl    $255, %eax
        movabsq $.LRAND_randrsl, %rcx
        addq    $2040, %rcx             # imm = 0x7F8
        movq    (%rcx), %rcx
        movq    %rax, -40(%rbp)
        movq    %rcx, -48(%rbp)
        jmp     4f
3:
        movabsq $.LRAND_randcnt, %rax
        movq    (%rax), %rax
        movabsq $.LRAND_randrsl, %rcx
        leaq    (%rcx,%rax,8), %rax
        movq    (%rax), %rax
        movq    %rax, -48(%rbp)
4:
        movq    -48(%rbp), %rax
        movabsq $.LRAND_0, %rcx
        movaps  (%rcx), %xmm0
        movd    %rax, %xmm1
        punpckldq       %xmm0, %xmm1    # xmm1 = xmm1[0],xmm0[0],xmm1[1],xmm0[1]
        movabsq $.LRAND_1, %rax
        movapd  (%rax), %xmm0
        subpd   %xmm0, %xmm1
        haddpd  %xmm1, %xmm1
        movsd   -32(%rbp), %xmm0
        addsd   %xmm1, %xmm0
        movabsq $.LRAND_2, %rax
        movsd   (%rax), %xmm1
        mulsd   %xmm1, %xmm0
        movabsq $.LRAND_randcnt, %rax
        movq    (%rax), %rcx
        movq    %rcx, %rdx
        decq    %rdx
        movq    %rdx, (%rax)
        cmpq    $0, %rcx
        movsd   %xmm0, -56(%rbp)
        jne     5f
        movabsq $.Lisaac64, %rax
        callq   *%rax
        movabsq $.LRAND_randcnt, %rax
        movq    $255, (%rax)
        movl    $255, %eax
        movabsq $.LRAND_randrsl, %rcx
        addq    $2040, %rcx             # imm = 0x7F8
        movq    (%rcx), %rcx
        movq    %rax, -64(%rbp)
        movq    %rcx, -72(%rbp)
        jmp     6f
5:
        movabsq $.LRAND_randcnt, %rax
        movq    (%rax), %rax
        movabsq $.LRAND_randrsl, %rcx
        leaq    (%rcx,%rax,8), %rax
        movq    (%rax), %rax
        movq    %rax, -72(%rbp)
6:
        movq    -72(%rbp), %rax
        movabsq $.LRAND_0, %rcx
        movaps  (%rcx), %xmm0
        movd    %rax, %xmm1
        punpckldq %xmm0, %xmm1    # xmm1 = xmm1[0],xmm0[0],xmm1[1],xmm0[1]
        movabsq $.LRAND_1, %rax
        movapd  (%rax), %xmm0
        subpd   %xmm0, %xmm1
        haddpd  %xmm1, %xmm1
        movsd   -56(%rbp), %xmm0
        addsd   %xmm1, %xmm0
        movabsq $.LRAND_2, %rax
        movsd   (%rax), %xmm1
        mulsd   %xmm1, %xmm0
        movsd   %xmm0, -8(%rbp)
        movl    $1, %eax
        cvtsi2sdq %rax, %xmm0
        movsd   -8(%rbp), %xmm1
        ucomisd %xmm0, %xmm1
        jb      7f
        jmp     0b
7:
        movsd   -8(%rbp), %xmm0
        addq    $80, %rsp
        popq    %rbp
        movq    %r8, %xmm1    # restore copy of xmm1 from r8
        retq
        .size   .Ldrand, .-.Ldrand


# This procedure is called to initialize the random number generator.
# It takes one parameter in register rdi to determine the behavior of the
# generated random number sequence.
# If rdi == 0, the random number system should generate repeatable sequence.
# If rdi <> 0, the random number system should generate a random sequence.

        .type   .Lrealinit, @function
.Lrealinit:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %rbx
        movl    %edi, %ebx
        subq    $24, %rsp
        movabsq $.LRAND_mm, %rdi
        movl    $256, %ecx
        xorl    %eax, %eax
rep     stosq
        movabsq $.LRAND_cc, %rax
        movq    $0, (%rax)
        movabsq $.LRAND_bb, %rax
        movq    $0, (%rax)
        movabsq $.LRAND_aa, %rax
        movq    $0, (%rax)
        xorl    %edi, %edi      # rdi=0
        testl   %ebx, %ebx
        je      1f
        xorl    %edi, %edi      # CLOCK_REALTIME
        leaq    -32(%rbp), %rsi # &ts (ts is a 16 byte out parameter)
                                # struct timespec {
                                #   time_t   tv_sec;  (seconds)
                                #   long     tv_nsec; (nanoseconds)
                                # };
        movabsq $.Lclock_gettime, %rcx
        call    *(%rcx)         # clock_gettime(CLOCK_REALTIME, &ts)
        movq    -32(%rbp), %rbx
        movabsq $.LRAND_mm, %rdx
        movq    -24(%rbp), %rdx
        movq    %rbx, %rax
        leaq    0(,%rdx,8), %rsi
        movabsq %rax, .LRAND_randrsl+16
        imulq   %rbx, %rdx
        movq    %rsi, %rax
        movabsq %rax, .LRAND_randrsl+32
        salq    $9, %rdx
        movq    %rdx, %rax
        movq    %rbx, %rdx
        movabsq %rax, .LRAND_randrsl+48
        salq    $13, %rdx
        movq    %rdx, %rax
        movabsq %rax, .LRAND_randrsl+64
        movq    %rbx, %rax
        salq    $29, %rax
        movabsq %rax, .LRAND_randrsl+80
        movl    $1, %edi        # rdi=1
1:
        movabsq $.Lrandinit, %rcx
        callq   *%rcx
        addq    $24, %rsp
        popq    %rbx
        popq    %rbp
        retq
        .size   .Lrealinit, .-.Lrealinit
