        .section .text,"ax",@progbits

        # input pointer to lhs string in rdi
        #       pointer to rhs string in rsi
        # return result in rax (negative value for <, 0 for ==, positive value for >)
        .type   .Lmystrcmp, @function
.Lmystrcmp:
        cld                         # set forward direction
0:
        movb    (%rdi), %al         # load lhs byte into al
        testb   %al, %al            # if it is zero then
        jz      1f                  # goto following 1
        movb    (%rsi), %dl         # load rhs byte into dl
        testb   %dl, %dl            # if it is zero then
        je      1f                  # goto following 1
        cmpb    %dl, %al            # if bytes in al and dl are not equal then
        jne     1f                  # goto following 1
        incq    %rdi                # move to next lhs byte
        incq    %rsi                # move to next rhs byte
        {disp8} jmp 0b              # goto previous 0
1:
        movb    (%rsi), %dl         # (re)load rhs byte
        subb    %dl, %al            # al-=dl (al is lhs byte - rhs byte)
        cbtw                        # sign extend al to ax
        cwtl                        # sign extend ax to eax
        cltq                        # sign extend eax to rax
        retq
        .size   .Lmystrcmp, .-.Lmystrcmp
