        .section .text,"ax",@progbits

        # on input, address of buffer in rdi
        # output is size in bytes in rax
        # clobbers rcx
        .type   .Lmystrlen,@function
.Lmystrlen:
        xorl    %ecx, %ecx      # set rcx to maximum value
        notq    %rcx            # of 0xFFFFFFFFFFFFFFFF, the maximum number of
                                # repetitions in repne loop
        xorb    %al, %al        # set al to 0, the string terminator
        cld                     # use a forward scan
repne   scasb                   # scan from rdi until character is 0 or rcx reaches zero
                                # (rcx is decremented for each character processed)
        notq    %rcx            # flip bits and subtract 1 to get
        leaq    -1(%rcx), %rax  # string length and store it in rax
        retq
        .size   .Lmystrlen, .-.Lmystrlen
