# ---------- begin startup vDSO stuff ---------
# ----------- begin Andrew Lutomirski code ----------
# vdso_test.c: Sample code to test parse_vdso.c on x86
# Copyright (c) 2011-2014 Andrew Lutomirski
# GPL v2.0 Only
#
        mov %rsp,%rdi
        pushq   %rbp
        pushq   %rbx
        subq    $72, %rsp
        movq    (%rdi), %rax
        leaq    16(%rdi,%rax,8), %rdi
0:
        movq    (%rdi), %rax
        addq    $8, %rdi
        testq   %rax, %rax
        jne     0b
        movabsq $.Lvdso_init_from_auxv, %rax
        call    *%rax
                             # now get pointer to clock_gettime()
        movabsq $.LCvdso_clock_gettime_string, %rsi
        movabsq $.LClinux_two_six_string, %rdi
        movabsq $.Lvdso_sym, %rax
        call    *%rax
        # at this point &clock_gettime in rax
        testq   %rax, %rax   # if did not get NULL pointer
        jne     1f           # then goto 1
                             # else fall through to exit message
                             # got NULL pointer (not found)
        movl    $1, %eax     # system call 1 is write
        movl    $1, %edi     # file handle 1 is stdout
        movabs  $.LCnovdso, %rsi    # address of string to output
        movq    $14, %rdx    # number of bytes
        syscall              # invoke operating system to do the write
        movl    $1, %edi     # exit code 1
        movl    $60, %eax    # exit(), does not return
        syscall
1:
# ----------- end Andrew Lutomirski code ----------
        movabsq $.Lclock_gettime, %rcx # save function pointer for later
        movq    %rax, (%rcx) # .Lclock_gettime = &clock_gettime() in vdso
# ----------- end startup vDSO stuff ----------
