        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_acosd2_u10sse2, @function
.LSleef_acosd2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCACOS_0, %rax
        movapd  %xmm0, %xmm6
        movapd  (%rax), %xmm4
        movapd  %xmm6, %xmm2
        movabsq $.LCACOS_2, %rax
        movapd  (%rax), %xmm13
        mulpd   %xmm6, %xmm2
        movabsq $.LCACOS_3, %rax
        movapd  (%rax), %xmm12
        movapd  %xmm4, %xmm0
        movabsq $.LCACOS_7, %rax
        andnpd  %xmm6, %xmm0
        movapd  (%rax), %xmm14
        movabsq $.LCACOS_297, %rax
        movapd  %xmm12, %xmm1
        movapd  %xmm0, %xmm3
        movapd  %xmm12, %xmm11
        subpd   %xmm0, %xmm1
        cmpltpd %xmm13, %xmm3
        mulpd   %xmm13, %xmm1
        movapd  %xmm3, %xmm5
        andpd   %xmm3, %xmm2
        andnpd  %xmm1, %xmm5
        orpd    %xmm5, %xmm2
        sqrtpd  %xmm2, %xmm5
        divpd   %xmm5, %xmm11
        movapd  %xmm5, %xmm1
        movapd  %xmm5, %xmm9
        mulpd   %xmm5, %xmm5
        andpd   %xmm14, %xmm1
        subpd   %xmm1, %xmm9
        movapd  %xmm1, %xmm15
        mulpd   %xmm9, %xmm15
        movapd  %xmm5, %xmm8
        movaps  %xmm5, -104(%rsp)
        addpd   %xmm2, %xmm8
        movaps  %xmm15, -88(%rsp)
        movapd  %xmm5, %xmm15
        movapd  %xmm8, %xmm5
        xorpd   %xmm4, %xmm15
        subpd   %xmm2, %xmm5
        movaps  %xmm15, -24(%rsp)
        movapd  %xmm8, %xmm15
        movaps  %xmm5, -72(%rsp)
        movapd  %xmm1, %xmm5
        movapd  %xmm11, %xmm7
        movapd  %xmm11, %xmm10
        andpd   %xmm14, %xmm7
        andpd   %xmm8, %xmm14
        subpd   %xmm14, %xmm15
        mulpd   %xmm7, %xmm5
        subpd   %xmm7, %xmm10
        movaps  %xmm14, -120(%rsp)
        movaps  %xmm15, -56(%rsp)
        movapd  %xmm11, %xmm15
        mulpd   %xmm8, %xmm15
        movaps  %xmm15, -40(%rsp)
        movapd  %xmm15, %xmm14
        movapd  %xmm5, %xmm15
        movapd  %xmm12, %xmm5
        subpd   %xmm15, %xmm5
        movapd  %xmm1, %xmm15
        xorpd   %xmm4, %xmm14
        mulpd   %xmm10, %xmm15
        andpd   %xmm6, %xmm4
        mulpd   %xmm1, %xmm1
        addpd   -24(%rsp), %xmm1
        subpd   %xmm15, %xmm5
        movapd  %xmm9, %xmm15
        mulpd   %xmm7, %xmm15
        subpd   %xmm15, %xmm5
        movapd  %xmm9, %xmm15
        mulpd   %xmm10, %xmm15
        mulpd   %xmm9, %xmm9
        subpd   %xmm15, %xmm5
        movapd  -120(%rsp), %xmm15
        mulpd   %xmm7, %xmm15
        mulpd   %xmm11, %xmm5
        addpd   %xmm15, %xmm14
        movapd  -56(%rsp), %xmm15
        mulpd   %xmm8, %xmm5
        mulpd   %xmm15, %xmm7
        addpd   %xmm14, %xmm7
        movapd  -120(%rsp), %xmm14
        mulpd   %xmm10, %xmm14
        mulpd   %xmm15, %xmm10
        addpd   %xmm7, %xmm14
        movapd  -88(%rsp), %xmm7
        addpd   %xmm7, %xmm1
        addpd   %xmm10, %xmm14
        movdqa  %xmm4, %xmm10
        addpd   %xmm7, %xmm1
        movapd  -72(%rsp), %xmm7
        addpd   %xmm5, %xmm14
        movapd  -104(%rsp), %xmm5
        subpd   %xmm7, %xmm8
        addpd   %xmm1, %xmm9
        movapd  %xmm2, %xmm1
        subpd   %xmm7, %xmm5
        movapd  %xmm3, %xmm7
        subpd   %xmm8, %xmm1
        movapd  %xmm2, %xmm8
        mulpd   %xmm2, %xmm8
        addpd   %xmm5, %xmm1
        movapd  %xmm3, %xmm5
        addpd   %xmm9, %xmm1
        mulpd   %xmm1, %xmm11
        movapd  %xmm3, %xmm1
        andpd   %xmm0, %xmm1
        cmpeqpd %xmm12, %xmm0
        addpd   %xmm11, %xmm14
        movapd  %xmm0, %xmm11
        mulpd   %xmm13, %xmm14
        mulpd   -40(%rsp), %xmm13
        andnpd  %xmm14, %xmm5
        andnpd  %xmm5, %xmm11
        movapd  (%rax), %xmm5
        andnpd  %xmm13, %xmm7
        movabsq $.LCACOS_298, %rax
        orpd    %xmm7, %xmm1
        movapd  %xmm8, %xmm7
        mulpd   %xmm2, %xmm5
        andnpd  %xmm1, %xmm0
        addpd   (%rax), %xmm5
        mulpd   %xmm8, %xmm7
        pxor    %xmm0, %xmm4
        movabsq $.LCACOS_299, %rax
        movapd  (%rax), %xmm1
        movabsq $.LCACOS_300, %rax
        mulpd   %xmm8, %xmm5
        mulpd   %xmm2, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCACOS_301, %rax
        addpd   %xmm1, %xmm5
        movapd  (%rax), %xmm1
        movabsq $.LCACOS_302, %rax
        mulpd   %xmm2, %xmm1
        addpd   (%rax), %xmm1
        mulpd   %xmm7, %xmm5
        movabsq $.LCACOS_303, %rax
        movapd  (%rax), %xmm9
        mulpd   %xmm7, %xmm7
        movabsq $.LCACOS_304, %rax
        mulpd   %xmm8, %xmm1
        mulpd   %xmm2, %xmm9
        addpd   (%rax), %xmm9
        movabsq $.LCACOS_305, %rax
        addpd   %xmm9, %xmm1
        addpd   %xmm1, %xmm5
        movapd  (%rax), %xmm1
        movabsq $.LCACOS_306, %rax
        mulpd   %xmm2, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCACOS_307, %rax
        mulpd   %xmm8, %xmm1
        movapd  (%rax), %xmm8
        movabsq $.LCACOS_308, %rax
        mulpd   %xmm2, %xmm8
        addpd   (%rax), %xmm8
        mulpd   %xmm0, %xmm2
        movabsq $.LCACOS_268, %rax
        addpd   %xmm8, %xmm1
        mulpd   %xmm7, %xmm1
        addpd   %xmm5, %xmm1
        movapd  (%rax), %xmm5
        movabsq $.LCACOS_296, %rax
        movapd  %xmm5, %xmm7
        mulpd   %xmm1, %xmm2
        pxor    %xmm2, %xmm10
        movapd  %xmm2, %xmm8
        movapd  %xmm10, %xmm9
        addpd   %xmm0, %xmm8
        addpd   %xmm4, %xmm9
        subpd   %xmm8, %xmm0
        addpd   %xmm8, %xmm8
        subpd   %xmm9, %xmm7
        subpd   %xmm9, %xmm4
        addpd   %xmm2, %xmm0
        movapd  %xmm3, %xmm2
        subpd   %xmm7, %xmm5
        addpd   %xmm4, %xmm10
        andpd   %xmm3, %xmm7
        addpd   %xmm11, %xmm0
        movapd  %xmm5, %xmm1
        subpd   %xmm9, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCACOS_310, %rax
        addpd   %xmm0, %xmm0
        subpd   %xmm10, %xmm1
        andnpd  %xmm0, %xmm2
        movapd  %xmm3, %xmm0
        andnpd  %xmm8, %xmm0
        andpd   %xmm3, %xmm1
        orpd    %xmm0, %xmm7
        pxor    %xmm0, %xmm0
        orpd    %xmm2, %xmm1
        movapd  (%rax), %xmm2
        cmpltpd %xmm0, %xmm6
        movabsq $.LCACOS_311, %rax
        movapd  %xmm2, %xmm4
        subpd   %xmm7, %xmm4
        pandn   %xmm6, %xmm3
        movapd  %xmm3, %xmm5
        andnpd  %xmm1, %xmm5
        subpd   %xmm4, %xmm2
        movapd  %xmm2, %xmm0
        subpd   %xmm7, %xmm0
        addpd   (%rax), %xmm0
        subpd   %xmm1, %xmm0
        movapd  %xmm3, %xmm1
        andnpd  %xmm7, %xmm1
        andpd   %xmm3, %xmm0
        andpd   %xmm4, %xmm3
        orpd    %xmm5, %xmm0
        orpd    %xmm1, %xmm3
        addpd   %xmm3, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_acosd2_u10sse2, .-.LSleef_acosd2_u10sse2
        .set .Lxacos_u1, .LSleef_acosd2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCACOS_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCACOS_2:
        .long   0
        .long   1071644672
        .long   0
        .long   1071644672
        .align 16
.LCACOS_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCACOS_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCACOS_268:
        .long   1413754136
        .long   1073291771
        .long   1413754136
        .long   1073291771
        .align 16
.LCACOS_296:
        .long   856972295
        .long   1016178214
        .long   856972295
        .long   1016178214
        .align 16
.LCACOS_297:
        .long   1221655407
        .long   1065935869
        .long   1221655407
        .long   1065935869
        .align 16
.LCACOS_298:
        .long   -133019140
        .long   1066168541
        .long   -133019140
        .long   1066168541
        .align 16
.LCACOS_299:
        .long   70174386
        .long   1066518197
        .long   70174386
        .long   1066518197
        .align 16
.LCACOS_300:
        .long   -2055686578
        .long   1066854559
        .long   -2055686578
        .long   1066854559
        .align 16
.LCACOS_301:
        .long   -973236806
        .long   1067392114
        .long   -973236806
        .long   1067392114
        .align 16
.LCACOS_302:
        .long   -1274559821
        .long   1067899757
        .long   -1274559821
        .long   1067899757
        .align 16
.LCACOS_303:
        .long   859266256
        .long   1068708659
        .long   859266256
        .long   1068708659
        .align 16
.LCACOS_304:
        .long   1431655156
        .long   1069897045
        .long   1431655156
        .long   1069897045
        .align 16
.LCACOS_305:
        .long   -951940537
        .long   1067462644
        .long   -951940537
        .long   1067462644
        .align 16
.LCACOS_306:
        .long   1556957928
        .long   -1081068825
        .long   1556957928
        .long   -1081068825
        .align 16
.LCACOS_307:
        .long   -2122410174
        .long   1066647776
        .long   -2122410174
        .long   1066647776
        .align 16
.LCACOS_308:
        .long   1802665598
        .long   1065029369
        .long   1802665598
        .long   1065029369
        .align 16
.LCACOS_310:
        .long   1413754136
        .long   1074340347
        .long   1413754136
        .long   1074340347
        .align 16
.LCACOS_311:
        .long   856972295
        .long   1017226790
        .long   856972295
        .long   1017226790
