        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_atan2d2_u10sse2, @function
.LSleef_atan2d2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCATAN_0, %rax
        subq    $192, %rsp
        movapd  (%rax), %xmm5
        movabsq $.LCATAN_272, %rax
        movapd  %xmm5, %xmm2
        movapd  %xmm5, %xmm6
        movapd  %xmm5, %xmm13
        andnpd  %xmm1, %xmm2
        movapd  %xmm5, %xmm11
        cmpltpd (%rax), %xmm2
        movabsq $.LCATAN_273, %rax
        movapd  (%rax), %xmm3
        movabsq $.LCATAN_145, %rax
        movapd  %xmm2, %xmm4
        andnpd  %xmm1, %xmm4
        mulpd   %xmm3, %xmm1
        andpd   %xmm2, %xmm1
        movapd  %xmm1, %xmm7
        movapd  %xmm2, %xmm1
        andnpd  %xmm0, %xmm1
        orpd    %xmm4, %xmm7
        movdqa  (%rax), %xmm4
        movabsq $.LCATAN_180, %rax
        mulpd   %xmm3, %xmm0
        movaps  %xmm7, -120(%rsp)
        pand    %xmm7, %xmm4
        movaps  %xmm4, -88(%rsp)
        andpd   %xmm0, %xmm2
        movdqa  %xmm4, %xmm0
        pcmpeqd (%rax), %xmm0
        orpd    %xmm1, %xmm2
        movabsq $.LCATAN_122, %rax
        movdqa  (%rax), %xmm14
        andnpd  %xmm2, %xmm6
        movaps  %xmm2, 56(%rsp)
        movapd  %xmm7, %xmm2
        movabsq $.LCATAN_3, %rax
        movapd  %xmm6, %xmm10
        pshufd  $177, %xmm0, %xmm1
        movaps  %xmm10, 72(%rsp)
        pand    %xmm1, %xmm0
        movaps  %xmm0, -104(%rsp)
        pshufd  $8, -104(%rsp), %xmm3
        pand    %xmm3, %xmm14
        pxor    %xmm3, %xmm3
        cmpltpd %xmm3, %xmm2
        movdqa  %xmm7, %xmm3
        andpd   %xmm5, %xmm2
        pxor    %xmm2, %xmm3
        xorpd   %xmm2, %xmm11
        movapd  %xmm3, %xmm1
        xorpd   %xmm3, %xmm13
        movapd  %xmm11, %xmm4
        cmpltpd %xmm6, %xmm1
        movapd  %xmm13, %xmm0
        pshufd  $8, %xmm1, %xmm12
        movapd  %xmm1, %xmm13
        andpd   %xmm1, %xmm4
        movdqa  %xmm12, %xmm6
        andnpd  %xmm3, %xmm13
        movapd  (%rax), %xmm3
        andpd   %xmm1, %xmm0
        pandn   %xmm14, %xmm6
        movapd  %xmm1, %xmm11
        movabsq $.LCATAN_7, %rax
        movaps  %xmm6, 8(%rsp)
        movapd  %xmm1, %xmm6
        andpd   %xmm10, %xmm1
        movapd  (%rax), %xmm7
        orpd    %xmm13, %xmm1
        andnpd  %xmm10, %xmm6
        movapd  %xmm3, %xmm10
        movabsq $.LCATAN_274, %rax
        divpd   %xmm1, %xmm10
        movapd  %xmm1, %xmm9
        orpd    %xmm6, %xmm0
        andpd   %xmm7, %xmm9
        movapd  %xmm0, %xmm15
        andnpd  %xmm2, %xmm11
        movapd  %xmm9, %xmm13
        subpd   %xmm9, %xmm1
        andpd   %xmm7, %xmm15
        movapd  %xmm15, %xmm2
        movapd  %xmm0, %xmm15
        subpd   %xmm2, %xmm15
        mulpd   %xmm10, %xmm0
        movapd  %xmm10, %xmm6
        movapd  %xmm10, %xmm8
        andpd   %xmm7, %xmm6
        subpd   %xmm6, %xmm8
        mulpd   %xmm6, %xmm13
        mulpd   %xmm8, %xmm9
        mulpd   %xmm0, %xmm11
        subpd   %xmm13, %xmm3
        subpd   %xmm9, %xmm3
        movapd  %xmm1, %xmm9
        mulpd   %xmm6, %xmm9
        subpd   %xmm11, %xmm4
        mulpd   %xmm8, %xmm1
        mulpd   %xmm4, %xmm10
        subpd   %xmm9, %xmm3
        subpd   %xmm1, %xmm3
        movapd  %xmm6, %xmm1
        mulpd   %xmm2, %xmm1
        mulpd   %xmm8, %xmm2
        mulpd   %xmm15, %xmm6
        mulpd   %xmm15, %xmm8
        mulpd   %xmm0, %xmm3
        subpd   %xmm0, %xmm1
        addpd   %xmm1, %xmm2
        addpd   %xmm6, %xmm2
        movapd  %xmm0, %xmm6
        mulpd   %xmm0, %xmm6
        addpd   %xmm8, %xmm2
        addpd   %xmm3, %xmm2
        movapd  %xmm0, %xmm3
        movapd  %xmm6, %xmm15
        movaps  %xmm6, -56(%rsp)
        andpd   %xmm7, %xmm3
        xorpd   %xmm5, %xmm15
        movapd  %xmm3, %xmm4
        movapd  %xmm0, %xmm3
        subpd   %xmm4, %xmm3
        movapd  %xmm4, %xmm1
        movapd  %xmm2, %xmm8
        mulpd   %xmm4, %xmm1
        addpd   %xmm10, %xmm8
        movapd  %xmm5, %xmm10
        movapd  %xmm3, %xmm13
        movapd  %xmm4, %xmm3
        addpd   %xmm4, %xmm3
        movaps  %xmm8, -72(%rsp)
        addpd   %xmm1, %xmm15
        movapd  %xmm8, %xmm1
        movapd  %xmm3, %xmm2
        movapd  %xmm13, %xmm3
        addpd   %xmm8, %xmm1
        mulpd   %xmm13, %xmm2
        mulpd   %xmm13, %xmm3
        mulpd   %xmm0, %xmm1
        addpd   %xmm2, %xmm15
        addpd   %xmm3, %xmm15
        movapd  %xmm6, %xmm3
        movapd  %xmm15, %xmm11
        addpd   %xmm1, %xmm11
        addpd   %xmm11, %xmm3
        movaps  %xmm11, -40(%rsp)
        movapd  %xmm3, %xmm15
        movapd  %xmm3, %xmm2
        mulpd   %xmm3, %xmm15
        movapd  %xmm15, %xmm9
        movapd  %xmm15, %xmm6
        mulpd   %xmm15, %xmm9
        movapd  %xmm9, %xmm8
        movapd  (%rax), %xmm9
        movabsq $.LCATAN_275, %rax
        mulpd   %xmm3, %xmm9
        addpd   (%rax), %xmm9
        movabsq $.LCATAN_276, %rax
        movapd  (%rax), %xmm1
        movabsq $.LCATAN_277, %rax
        mulpd   %xmm15, %xmm9
        mulpd   %xmm3, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCATAN_278, %rax
        mulpd   (%rax), %xmm3
        movabsq $.LCATAN_279, %rax
        addpd   (%rax), %xmm3
        movabsq $.LCATAN_280, %rax
        addpd   %xmm1, %xmm9
        movapd  (%rax), %xmm1
        movabsq $.LCATAN_281, %rax
        mulpd   %xmm15, %xmm3
        mulpd   %xmm2, %xmm1
        addpd   (%rax), %xmm1
        mulpd   %xmm8, %xmm9
        movabsq $.LCATAN_282, %rax
        addpd   %xmm3, %xmm1
        movapd  %xmm8, %xmm3
        mulpd   %xmm8, %xmm3
        addpd   %xmm9, %xmm1
        mulpd   %xmm3, %xmm1
        movapd  (%rax), %xmm3
        movabsq $.LCATAN_283, %rax
        mulpd   %xmm2, %xmm3
        addpd   (%rax), %xmm3
        movabsq $.LCATAN_284, %rax
        movapd  (%rax), %xmm9
        movabsq $.LCATAN_285, %rax
        mulpd   %xmm15, %xmm3
        movapd  %xmm2, %xmm15
        mulpd   %xmm2, %xmm9
        andpd   %xmm7, %xmm15
        addpd   (%rax), %xmm9
        movabsq $.LCATAN_286, %rax
        addpd   %xmm9, %xmm3
        movapd  %xmm0, %xmm9
        mulpd   %xmm2, %xmm9
        mulpd   %xmm3, %xmm8
        movapd  (%rax), %xmm3
        movabsq $.LCATAN_287, %rax
        mulpd   %xmm2, %xmm3
        addpd   (%rax), %xmm3
        movabsq $.LCATAN_288, %rax
        mulpd   %xmm3, %xmm6
        movapd  (%rax), %xmm3
        movabsq $.LCATAN_289, %rax
        mulpd   %xmm2, %xmm3
        addpd   (%rax), %xmm3
        movabsq $.LCATAN_290, %rax
        addpd   %xmm3, %xmm6
        addpd   %xmm8, %xmm6
        movapd  %xmm15, %xmm8
        movapd  %xmm2, %xmm15
        subpd   %xmm8, %xmm15
        addpd   %xmm6, %xmm1
        movapd  %xmm9, %xmm6
        movapd  %xmm5, %xmm9
        xorpd   %xmm6, %xmm9
        movapd  %xmm6, %xmm11
        movaps  %xmm9, 88(%rsp)
        andpd   %xmm7, %xmm11
        movapd  %xmm6, %xmm9
        mulpd   %xmm2, %xmm1
        subpd   %xmm11, %xmm9
        movaps  %xmm11, 104(%rsp)
        movapd  %xmm0, %xmm11
        addpd   (%rax), %xmm1
        movabsq $.LCATAN_291, %rax
        movaps  %xmm9, -24(%rsp)
        mulpd   %xmm2, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCATAN_292, %rax
        mulpd   %xmm2, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCATAN_293, %rax
        mulpd   %xmm2, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCATAN_178, %rax
        mulpd   %xmm1, %xmm6
        movapd  %xmm1, %xmm9
        movapd  %xmm1, %xmm3
        andpd   %xmm7, %xmm9
        subpd   %xmm9, %xmm3
        movaps  %xmm9, 120(%rsp)
        movaps  %xmm3, -8(%rsp)
        movdqa  (%rax), %xmm3
        xorpd   %xmm6, %xmm10
        movabsq $.LCATAN_268, %rax
        movapd  (%rax), %xmm9
        addpd   %xmm6, %xmm11
        movaps  %xmm10, 136(%rsp)
        movabsq $.LCATAN_152, %rax
        paddd   %xmm14, %xmm3
        movapd  %xmm7, %xmm14
        pand    %xmm12, %xmm3
        por     8(%rsp), %xmm3
        movapd  -120(%rsp), %xmm12
        movaps  %xmm11, 8(%rsp)
        cvtdq2pd        %xmm3, %xmm3
        movapd  %xmm3, %xmm7
        andpd   %xmm3, %xmm14
        movapd  %xmm3, %xmm10
        mulpd   %xmm9, %xmm7
        subpd   %xmm14, %xmm10
        movaps  %xmm10, 24(%rsp)
        movapd  %xmm5, %xmm10
        xorpd   %xmm7, %xmm10
        movaps  %xmm10, 152(%rsp)
        movapd  %xmm11, %xmm10
        movapd  (%rax), %xmm11
        movabsq $.LCATAN_294, %rax
        addpd   %xmm7, %xmm10
        movaps  %xmm11, 168(%rsp)
        movaps  %xmm10, 40(%rsp)
        movapd  %xmm5, %xmm10
        andnpd  %xmm12, %xmm10
        cmpeqpd %xmm11, %xmm10
        pxor    %xmm11, %xmm11
        cmpeqpd %xmm12, %xmm11
        movapd  %xmm4, %xmm12
        mulpd   %xmm8, %xmm12
        mulpd   %xmm13, %xmm8
        addpd   88(%rsp), %xmm12
        mulpd   %xmm15, %xmm4
        por     %xmm10, %xmm11
        mulpd   %xmm15, %xmm13
        movapd  -56(%rsp), %xmm15
        subpd   %xmm2, %xmm15
        addpd   -40(%rsp), %xmm15
        addpd   %xmm8, %xmm12
        movapd  -72(%rsp), %xmm8
        mulpd   %xmm0, %xmm15
        addpd   %xmm12, %xmm4
        mulpd   %xmm8, %xmm2
        addpd   %xmm13, %xmm4
        movapd  -8(%rsp), %xmm13
        addpd   %xmm15, %xmm4
        movapd  104(%rsp), %xmm15
        movapd  %xmm15, %xmm12
        addpd   %xmm2, %xmm4
        mulpd   %xmm13, %xmm15
        movapd  136(%rsp), %xmm2
        mulpd   %xmm4, %xmm1
        movapd  120(%rsp), %xmm4
        mulpd   %xmm4, %xmm12
        addpd   %xmm12, %xmm2
        movapd  -24(%rsp), %xmm12
        mulpd   %xmm12, %xmm4
        addpd   %xmm4, %xmm2
        addpd   %xmm15, %xmm2
        movapd  %xmm12, %xmm15
        mulpd   %xmm13, %xmm15
        movapd  8(%rsp), %xmm13
        subpd   %xmm13, %xmm0
        addpd   %xmm15, %xmm2
        addpd   %xmm6, %xmm0
        addpd   %xmm1, %xmm2
        addpd   %xmm8, %xmm0
        movapd  %xmm14, %xmm1
        addpd   %xmm0, %xmm2
        movapd  (%rax), %xmm0
        movabsq $.LCATAN_295, %rax
        movapd  (%rax), %xmm4
        movabsq $.LCATAN_296, %rax
        mulpd   %xmm0, %xmm1
        addpd   152(%rsp), %xmm1
        mulpd   %xmm4, %xmm14
        mulpd   (%rax), %xmm3
        movabsq $.LCATAN_269, %rax
        movapd  %xmm14, %xmm6
        addpd   %xmm1, %xmm6
        movapd  24(%rsp), %xmm1
        mulpd   %xmm1, %xmm0
        mulpd   %xmm1, %xmm4
        movdqa  (%rax), %xmm1
        movabsq $.LCATAN_270, %rax
        addpd   %xmm0, %xmm6
        movapd  40(%rsp), %xmm0
        subpd   %xmm0, %xmm7
        addpd   %xmm4, %xmm6
        movdqa  -88(%rsp), %xmm4
        addpd   %xmm13, %xmm7
        por     %xmm4, %xmm1
        movapd  72(%rsp), %xmm13
        addpd   %xmm3, %xmm6
        movapd  %xmm11, %xmm3
        pand    %xmm10, %xmm1
        cmpeqpd 168(%rsp), %xmm13
        addpd   %xmm7, %xmm6
        movapd  56(%rsp), %xmm7
        addpd   %xmm6, %xmm2
        addpd   %xmm2, %xmm0
        movapd  %xmm0, %xmm14
        movdqa  -104(%rsp), %xmm0
        pxor    %xmm4, %xmm14
        por     (%rax), %xmm4
        movabsq $.LCATAN_271, %rax
        andnpd  %xmm14, %xmm3
        pand    (%rax), %xmm0
        movapd  %xmm3, %xmm2
        movapd  %xmm9, %xmm3
        pand    %xmm4, %xmm10
        subpd   %xmm1, %xmm3
        subpd   %xmm10, %xmm9
        movapd  %xmm13, %xmm1
        andpd   %xmm3, %xmm11
        andpd   %xmm9, %xmm13
        movapd  %xmm7, %xmm3
        orpd    %xmm2, %xmm11
        movapd  -120(%rsp), %xmm2
        cmpneqpd        %xmm7, %xmm3
        addq    $192, %rsp
        andnpd  %xmm11, %xmm1
        orpd    %xmm1, %xmm13
        cmpneqpd        %xmm2, %xmm2
        pxor    %xmm1, %xmm1
        cmpeqpd %xmm7, %xmm1
        andpd   %xmm5, %xmm7
        orpd    %xmm3, %xmm2
        movapd  %xmm1, %xmm4
        andpd   %xmm0, %xmm1
        movapd  %xmm7, %xmm0
        andnpd  %xmm13, %xmm4
        orpd    %xmm4, %xmm1
        pxor    %xmm1, %xmm0
        por     %xmm2, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_atan2d2_u10sse2, .-.LSleef_atan2d2_u10sse2
        .set    .Lxatan2_u1, .LSleef_atan2d2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCATAN_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCATAN_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCATAN_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCATAN_122:
        .quad   -4294967298
        .quad   0
        .align 16
.LCATAN_145:
        .quad   -9223372036854775808
        .quad   -9223372036854775808
        .align 16
.LCATAN_152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCATAN_178:
        .long   1
        .long   1
        .long   0
        .long   0
        .align 16
.LCATAN_180:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCATAN_268:
        .long   1413754136
        .long   1073291771
        .long   1413754136
        .long   1073291771
        .align 16
.LCATAN_269:
        .quad   4609753056924675352
        .quad   4609753056924675352
        .align 16
.LCATAN_270:
        .quad   4605249457297304856
        .quad   4605249457297304856
        .align 16
.LCATAN_271:
        .quad   4614256656552045848
        .quad   4614256656552045848
        .align 16
.LCATAN_272:
        .long   1
        .long   262144
        .long   1
        .long   262144
        .align 16
.LCATAN_273:
        .long   0
        .long   1128267776
        .long   0
        .long   1128267776
        .align 16
.LCATAN_274:
        .long   1040641650
        .long   1055279835
        .long   1040641650
        .long   1055279835
        .align 16
.LCATAN_275:
        .long   715642574
        .long   -1088391391
        .long   715642574
        .long   -1088391391
        .align 16
.LCATAN_276:
        .long   1302130072
        .long   1061625550
        .long   1302130072
        .long   1061625550
        .align 16
.LCATAN_277:
        .long   951651566
        .long   -1083923967
        .long   951651566
        .long   -1083923967
        .align 16
.LCATAN_278:
        .long   -1030840397
        .long   1064990862
        .long   -1030840397
        .long   1064990862
        .align 16
.LCATAN_279:
        .long   -365453899
        .long   -1081457246
        .long   -365453899
        .long   -1081457246
        .align 16
.LCATAN_280:
        .long   -856100064
        .long   1066749246
        .long   -856100064
        .long   1066749246
        .align 16
.LCATAN_281:
        .long   -407231513
        .long   -1080190971
        .long   -407231513
        .long   -1080190971
        .align 16
.LCATAN_282:
        .long   638262237
        .long   1067609030
        .long   638262237
        .long   1067609030
        .align 16
.LCATAN_283:
        .long   1382810999
        .long   -1079677651
        .long   1382810999
        .long   -1079677651
        .align 16
.LCATAN_284:
        .long   -78514010
        .long   1067981678
        .long   -78514010
        .long   1067981678
        .align 16
.LCATAN_285:
        .long   -779526354
        .long   -1079320537
        .long   -779526354
        .long   -1079320537
        .align 16
.LCATAN_286:
        .long   1677751931
        .long   1068374613
        .long   1677751931
        .long   1068374613
        .align 16
.LCATAN_287:
        .long   1105543894
        .long   -1078914876
        .long   1105543894
        .long   -1078914876
        .align 16
.LCATAN_288:
        .long   -206566128
        .long   1068740913
        .long   -206566128
        .long   1068740913
        .align 16
.LCATAN_289:
        .long   -1407914004
        .long   -1078508080
        .long   -1407914004
        .long   -1078508080
        .align 16
.LCATAN_290:
        .long   280197643
        .long   1069314503
        .long   280197643
        .long   1069314503
        .align 16
.LCATAN_291:
        .long   -1844334649
        .long   -1077786332
        .long   -1844334649
        .long   -1077786332
        .align 16
.LCATAN_292:
        .long   -1718059792
        .long   1070176665
        .long   -1718059792
        .long   1070176665
        .align 16
.LCATAN_293:
        .long   1431655482
        .long   -1076538027
        .long   1431655482
        .long   -1076538027
        .align 16
.LCATAN_294:
        .long   1342177280
        .long   1073291771
        .long   1342177280
        .long   1073291771
        .align 16
.LCATAN_295:
        .long   1610612736
        .long   1045500084
        .long   1610612736
        .long   1045500084
        .align 16
.LCATAN_296:
        .long   856972295
        .long   1016178214
        .long   856972295
        .long   1016178214
