        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_log2d2_u10sse2, @function
.LSleef_log2d2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        addq    $-128, %rsp
        movapd  %xmm0, %xmm13
        movabsq $.LCLOG2_315, %rax
        cmpltpd (%rax), %xmm13
        movabsq $.LCLOG2_316, %rax
        movapd  (%rax), %xmm1
        movabsq $.LCLOG2_83, %rax
        movapd  (%rax), %xmm6
        movabsq $.LCLOG2_149, %rax
        mulpd   %xmm0, %xmm1
        movapd  %xmm13, %xmm2
        andnpd  %xmm0, %xmm2
        andpd   %xmm13, %xmm1
        pshufd  $8, %xmm13, %xmm13
        orpd    %xmm2, %xmm1
        movdqa  %xmm13, %xmm3
        mulpd   %xmm1, %xmm6
        pshufd  $13, %xmm6, %xmm6
        psrld   $20, %xmm6
        pand    (%rax), %xmm6
        movabsq $.LCLOG2_89, %rax
        movdqa  (%rax), %xmm2
        movabsq $.LCLOG2_90, %rax
        psubd   %xmm6, %xmm2
        pshufd  $115, %xmm2, %xmm2
        pand    (%rax), %xmm2
        movabsq $.LCLOG2_317, %rax
        movdqa  (%rax), %xmm0
        movabsq $.LCLOG2_3, %rax
        movapd  (%rax), %xmm5
        pslld   $20, %xmm2
        movabsq $.LCLOG2_4, %rax
        paddd   %xmm1, %xmm2
        paddd   %xmm6, %xmm0
        movapd  %xmm5, %xmm8
        movapd  %xmm5, %xmm4
        pandn   %xmm0, %xmm3
        addpd   %xmm2, %xmm8
        movaps  %xmm3, -104(%rsp)
        movapd  (%rax), %xmm3
        movabsq $.LCLOG2_7, %rax
        movapd  (%rax), %xmm7
        movabsq $.LCLOG2_451, %rax
        movapd  %xmm3, %xmm9
        movapd  %xmm3, %xmm0
        movaps  %xmm3, 24(%rsp)
        divpd   %xmm8, %xmm4
        addpd   %xmm2, %xmm9
        addpd   %xmm8, %xmm0
        movapd  %xmm8, %xmm10
        movapd  %xmm8, %xmm15
        andpd   %xmm7, %xmm10
        movapd  %xmm9, %xmm12
        movaps  %xmm0, 8(%rsp)
        movapd  %xmm9, %xmm14
        movapd  %xmm9, %xmm11
        addpd   %xmm5, %xmm12
        andpd   %xmm7, %xmm14
        subpd   %xmm10, %xmm15
        subpd   %xmm14, %xmm11
        movaps  %xmm14, 40(%rsp)
        movaps  %xmm12, -8(%rsp)
        movaps  %xmm11, -24(%rsp)
        movaps  %xmm15, -120(%rsp)
        movapd  %xmm5, %xmm15
        movaps  %xmm4, -40(%rsp)
        movapd  %xmm4, %xmm0
        movapd  %xmm4, %xmm12
        mulpd   %xmm9, %xmm4
        andpd   %xmm7, %xmm0
        subpd   %xmm0, %xmm12
        movapd  %xmm4, %xmm11
        andpd   %xmm4, %xmm7
        mulpd   %xmm4, %xmm11
        movaps  %xmm7, 56(%rsp)
        movapd  %xmm11, %xmm3
        mulpd   %xmm11, %xmm3
        movapd  %xmm3, %xmm14
        movapd  %xmm4, %xmm3
        subpd   %xmm7, %xmm3
        movapd  (%rax), %xmm7
        movabsq $.LCLOG2_0, %rax
        movaps  %xmm7, 72(%rsp)
        mulpd   %xmm4, %xmm7
        movaps  %xmm3, -72(%rsp)
        movapd  (%rax), %xmm3
        movabsq $.LCLOG2_318, %rax
        paddd   (%rax), %xmm6
        movabsq $.LCLOG2_452, %rax
        pand    %xmm13, %xmm6
        por     -104(%rsp), %xmm6
        movapd  (%rax), %xmm13
        movabsq $.LCLOG2_453, %rax
        xorpd   %xmm7, %xmm3
        movaps  %xmm7, -56(%rsp)
        movaps  %xmm3, 88(%rsp)
        cvtdq2pd        %xmm6, %xmm6
        movapd  %xmm6, %xmm3
        addpd   %xmm7, %xmm6
        mulpd   %xmm11, %xmm13
        movaps  %xmm3, 104(%rsp)
        addpd   (%rax), %xmm13
        movabsq $.LCLOG2_454, %rax
        movapd  %xmm6, %xmm7
        subpd   %xmm3, %xmm7
        movapd  %xmm13, %xmm3
        movaps  %xmm7, -104(%rsp)
        movapd  (%rax), %xmm13
        movabsq $.LCLOG2_455, %rax
        mulpd   %xmm14, %xmm13
        addpd   %xmm3, %xmm13
        movapd  %xmm14, %xmm3
        mulpd   %xmm14, %xmm3
        mulpd   %xmm3, %xmm13
        movapd  (%rax), %xmm3
        movabsq $.LCLOG2_456, %rax
        mulpd   %xmm11, %xmm3
        movapd  %xmm3, %xmm7
        addpd   (%rax), %xmm7
        movabsq $.LCLOG2_457, %rax
        mulpd   %xmm14, %xmm7
        movapd  (%rax), %xmm14
        movabsq $.LCLOG2_458, %rax
        mulpd   %xmm11, %xmm14
        mulpd   %xmm4, %xmm11
        movapd  %xmm14, %xmm3
        addpd   (%rax), %xmm3
        movabsq $.LCLOG2_152, %rax
        movapd  (%rax), %xmm14
        movabsq $.LCLOG2_459, %rax
        addpd   %xmm7, %xmm3
        movapd  %xmm10, %xmm7
        mulpd   %xmm0, %xmm7
        mulpd   %xmm12, %xmm10
        addpd   %xmm13, %xmm3
        subpd   %xmm7, %xmm15
        mulpd   %xmm11, %xmm3
        movapd  %xmm6, %xmm11
        movapd  %xmm15, %xmm7
        movapd  -120(%rsp), %xmm15
        subpd   %xmm10, %xmm7
        movapd  40(%rsp), %xmm10
        mulpd   %xmm0, %xmm15
        addpd   %xmm3, %xmm11
        movapd  %xmm11, %xmm13
        subpd   %xmm6, %xmm11
        subpd   %xmm15, %xmm7
        movapd  -120(%rsp), %xmm15
        movaps  %xmm11, -88(%rsp)
        movapd  %xmm1, %xmm11
        mulpd   %xmm12, %xmm15
        cmpeqpd %xmm14, %xmm11
        subpd   %xmm15, %xmm7
        movapd  %xmm10, %xmm15
        mulpd   %xmm0, %xmm15
        mulpd   %xmm12, %xmm10
        mulpd   %xmm4, %xmm7
        subpd   %xmm4, %xmm15
        addpd   %xmm15, %xmm10
        movapd  -24(%rsp), %xmm15
        mulpd   %xmm15, %xmm0
        mulpd   %xmm15, %xmm12
        movapd  24(%rsp), %xmm15
        addpd   %xmm0, %xmm10
        addpd   %xmm12, %xmm10
        movapd  -8(%rsp), %xmm12
        subpd   %xmm12, %xmm9
        addpd   %xmm7, %xmm10
        subpd   %xmm9, %xmm15
        movapd  -72(%rsp), %xmm9
        movapd  %xmm15, %xmm0
        movapd  %xmm2, %xmm15
        subpd   %xmm12, %xmm15
        movapd  %xmm15, %xmm7
        addpd   %xmm0, %xmm7
        movapd  8(%rsp), %xmm0
        subpd   %xmm0, %xmm8
        subpd   %xmm0, %xmm2
        subpd   %xmm8, %xmm5
        movapd  56(%rsp), %xmm8
        movapd  %xmm8, %xmm0
        addpd   %xmm2, %xmm5
        movapd  (%rax), %xmm2
        movabsq $.LCLOG2_460, %rax
        mulpd   %xmm2, %xmm0
        mulpd   %xmm4, %xmm5
        mulpd   %xmm9, %xmm2
        subpd   %xmm5, %xmm7
        mulpd   -40(%rsp), %xmm7
        movapd  88(%rsp), %xmm5
        addpd   %xmm0, %xmm5
        movapd  %xmm8, %xmm0
        addpd   %xmm10, %xmm7
        movapd  72(%rsp), %xmm10
        mulpd   %xmm7, %xmm10
        movapd  %xmm5, %xmm7
        movapd  (%rax), %xmm5
        movabsq $.LCLOG2_461, %rax
        addpd   %xmm2, %xmm7
        mulpd   (%rax), %xmm4
        movapd  %xmm1, %xmm2
        movabsq $.LCLOG2_326, %rax
        mulpd   %xmm5, %xmm0
        cmpneqpd        %xmm1, %xmm2
        mulpd   %xmm9, %xmm5
        addpd   %xmm0, %xmm7
        movapd  %xmm6, %xmm0
        addpd   %xmm5, %xmm7
        movapd  -104(%rsp), %xmm5
        subpd   %xmm5, %xmm0
        addpd   %xmm7, %xmm4
        movapd  -56(%rsp), %xmm7
        subpd   %xmm5, %xmm7
        movapd  -88(%rsp), %xmm5
        addpd   %xmm4, %xmm10
        movapd  104(%rsp), %xmm4
        subpd   %xmm5, %xmm3
        subpd   %xmm0, %xmm4
        movapd  %xmm13, %xmm0
        subpd   %xmm5, %xmm0
        addpd   %xmm7, %xmm4
        subpd   %xmm0, %xmm6
        movapd  %xmm11, %xmm0
        andpd   %xmm14, %xmm11
        addpd   %xmm4, %xmm10
        addpd   %xmm3, %xmm6
        movapd  %xmm1, %xmm3
        addpd   %xmm10, %xmm6
        addpd   %xmm6, %xmm13
        andnpd  %xmm13, %xmm0
        orpd    %xmm0, %xmm11
        pxor    %xmm0, %xmm0
        cmpltpd %xmm0, %xmm3
        cmpeqpd %xmm0, %xmm1
        orpd    %xmm3, %xmm2
        movapd  %xmm1, %xmm0
        movapd  %xmm2, %xmm3
        andpd   (%rax), %xmm2
        movabsq $.LCLOG2_327, %rax
        andnpd  %xmm11, %xmm3
        andpd   (%rax), %xmm1
        subq    $-128, %rsp
        orpd    %xmm3, %xmm2
        andnpd  %xmm2, %xmm0
        orpd    %xmm1, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_log2d2_u10sse2, .-.LSleef_log2d2_u10sse2
        .set .Lxlog2_u1, .LSleef_log2d2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCLOG2_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCLOG2_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCLOG2_4:
        .long   0
        .long   -1074790400
        .long   0
        .long   -1074790400
        .align 16
.LCLOG2_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCLOG2_83:
        .long   1431655765
        .long   1073042773
        .long   1431655765
        .long   1073042773
        .align 16
.LCLOG2_89:
        .long   1023
        .long   1023
        .long   0
        .long   0
        .align 16
.LCLOG2_90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCLOG2_149:
        .quad   8791798056959
        .quad   0
        .align 16
.LCLOG2_152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCLOG2_315:
        .long   0
        .long   1048576
        .long   0
        .long   1048576
        .align 16
.LCLOG2_316:
        .long   0
        .long   1139802112
        .long   0
        .long   1139802112
        .align 16
.LCLOG2_317:
        .long   -1023
        .long   -1023
        .long   0
        .long   0
        .align 16
.LCLOG2_318:
        .long   -1087
        .long   -1087
        .long   0
        .long   0
        .align 16
.LCLOG2_326:
        .long   0
        .long   2146959360
        .long   0
        .long   2146959360
        .align 16
.LCLOG2_327:
        .long   0
        .long   -1048576
        .long   0
        .long   -1048576
        .align 16
.LCLOG2_451:
        .long   1697350398
        .long   1074206023
        .long   1697350398
        .long   1074206023
        .align 16
.LCLOG2_452:
        .long   -1775742743
        .long   1070345082
        .long   -1775742743
        .long   1070345082
        .align 16
.LCLOG2_453:
        .long   -343444351
        .long   1070647982
        .long   -343444351
        .long   1070647982
        .align 16
.LCLOG2_454:
        .long   972127145
        .long   1070354455
        .long   972127145
        .long   1070354455
        .align 16
.LCLOG2_455:
        .long   1786557149
        .long   1070892204
        .long   1786557149
        .long   1070892204
        .align 16
.LCLOG2_456:
        .long   918733396
        .long   1071276406
        .long   918733396
        .long   1071276406
        .align 16
.LCLOG2_457:
        .long   1357377001
        .long   1071806316
        .long   1357377001
        .long   1071806316
        .align 16
.LCLOG2_458:
        .long   -600176718
        .long   1072613129
        .long   -600176718
        .long   1072613129
        .align 16
.LCLOG2_459:
        .long   1610612736
        .long   1074206023
        .long   1610612736
        .long   1074206023
        .align 16
.LCLOG2_460:
        .long   -134217728
        .long   1046785547
        .long   -134217728
        .long   1046785547
        .align 16
.LCLOG2_461:
        .long   854310065
        .long   1012657626
        .long   854310065
        .long   1012657626
