        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_tand2_u10sse2, @function
.LSleef_tand2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCTAN0, %rax
        movapd  %xmm0, %xmm7
        movaps  %xmm0, -120(%rsp)
        movabsq $.LCTAN153, %rdx
        movapd  (%rax), %xmm0
        movapd  %xmm0, %xmm3
        andnpd  %xmm7, %xmm3
        movapd  %xmm3, %xmm1
        cmpltpd (%rdx), %xmm1
        pmovmskb        %xmm1, %edx
        cmpl    $65535, %edx
        jne     1f
        movabsq $.LCTAN208, %rdx
        movabsq $.LCTAN2, %rcx
        movapd  (%rdx), %xmm0
        movabsq $.LCTAN197, %rdx
        movapd  (%rdx), %xmm4
        movabsq $.LCTAN198, %rdx
        mulpd   %xmm7, %xmm0
        cvtpd2dq        %xmm0, %xmm0
        cvtdq2pd        %xmm0, %xmm0
        mulpd   %xmm0, %xmm4
        cvtpd2dq        %xmm0, %xmm1
        mulpd   (%rdx), %xmm0
        movaps  %xmm1, -104(%rsp)
        movabsq $.LCTAN7, %rdx
        addpd   %xmm7, %xmm4
        movapd  %xmm4, %xmm2
        addpd   %xmm0, %xmm2
        subpd   %xmm2, %xmm4
        addpd   %xmm4, %xmm0
0:
        movapd  (%rcx), %xmm1
        movapd  %xmm0, %xmm4
        movapd  (%rdx), %xmm5
        mulpd   %xmm1, %xmm2
        mulpd   %xmm1, %xmm4
        movapd  (%rax), %xmm1
        movabsq $.LCTAN237, %rax
        movapd  (%rax), %xmm3
        movabsq $.LCTAN238, %rax
        movapd  %xmm1, %xmm14
        movapd  %xmm1, %xmm15
        movapd  %xmm2, %xmm6
        movapd  %xmm2, %xmm7
        movapd  %xmm2, %xmm12
        mulpd   %xmm2, %xmm6
        andpd   %xmm5, %xmm7
        subpd   %xmm7, %xmm12
        movapd  %xmm6, %xmm8
        xorpd   %xmm6, %xmm15
        movapd  %xmm6, %xmm13
        mulpd   %xmm6, %xmm8
        andpd   %xmm5, %xmm13
        movapd  %xmm6, %xmm9
        mulpd   %xmm6, %xmm3
        subpd   %xmm13, %xmm9
        addpd   (%rax), %xmm3
        movabsq $.LCTAN239, %rax
        movapd  (%rax), %xmm0
        movabsq $.LCTAN240, %rax
        mulpd   %xmm8, %xmm3
        mulpd   %xmm6, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCTAN241, %rax
        addpd   %xmm0, %xmm3
        movapd  %xmm8, %xmm0
        mulpd   %xmm8, %xmm0
        mulpd   %xmm0, %xmm3
        movapd  (%rax), %xmm0
        movabsq $.LCTAN242, %rax
        mulpd   %xmm6, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCTAN243, %rax
        mulpd   %xmm8, %xmm0
        movapd  (%rax), %xmm8
        movabsq $.LCTAN244, %rax
        mulpd   %xmm6, %xmm8
        addpd   (%rax), %xmm8
        movabsq $.LCTAN245, %rax
        addpd   %xmm8, %xmm0
        movapd  %xmm6, %xmm8
        mulpd   %xmm2, %xmm8
        addpd   %xmm0, %xmm3
        movapd  %xmm1, %xmm0
        mulpd   %xmm6, %xmm3
        xorpd   %xmm8, %xmm0
        movapd  %xmm8, %xmm11
        addpd   (%rax), %xmm3
        andpd   %xmm5, %xmm11
        movaps  %xmm0, -56(%rsp)
        movapd  %xmm8, %xmm0
        subpd   %xmm11, %xmm0
        mulpd   %xmm4, %xmm6
        movabsq $.LCTAN4, %rax
        mulpd   %xmm3, %xmm8
        movapd  %xmm3, %xmm10
        movaps  %xmm0, -88(%rsp)
        movapd  %xmm3, %xmm0
        andpd   %xmm5, %xmm0
        subpd   %xmm0, %xmm10
        movaps  %xmm0, -40(%rsp)
        movapd  %xmm7, %xmm0
        mulpd   %xmm7, %xmm0
        xorpd   %xmm8, %xmm14
        movaps  %xmm14, -24(%rsp)
        movapd  %xmm7, %xmm14
        addpd   %xmm7, %xmm14
        movaps  %xmm10, -72(%rsp)
        movapd  %xmm8, %xmm10
        addpd   %xmm2, %xmm10
        addpd   %xmm15, %xmm0
        movapd  %xmm12, %xmm15
        mulpd   %xmm12, %xmm14
        mulpd   %xmm12, %xmm15
        addpd   %xmm0, %xmm14
        movapd  -56(%rsp), %xmm0
        addpd   %xmm15, %xmm14
        movapd  %xmm4, %xmm15
        addpd   %xmm4, %xmm15
        mulpd   %xmm2, %xmm15
        addpd   %xmm15, %xmm14
        movapd  %xmm13, %xmm15
        mulpd   %xmm7, %xmm15
        mulpd   %xmm9, %xmm7
        mulpd   %xmm12, %xmm13
        mulpd   %xmm12, %xmm9
        movdqa  -104(%rsp), %xmm12
        mulpd   %xmm2, %xmm14
        subpd   %xmm10, %xmm2
        addpd   %xmm15, %xmm0
        addpd   %xmm2, %xmm8
        movapd  %xmm10, %xmm2
        addpd   %xmm0, %xmm7
        andpd   %xmm5, %xmm2
        movapd  %xmm1, %xmm0
        movapd  %xmm2, %xmm15
        addpd   %xmm2, %xmm15
        addpd   %xmm8, %xmm4
        addpd   %xmm13, %xmm7
        addpd   %xmm9, %xmm7
        addpd   %xmm6, %xmm7
        movapd  -40(%rsp), %xmm6
        addpd   %xmm7, %xmm14
        movapd  -88(%rsp), %xmm7
        mulpd   %xmm14, %xmm3
        movapd  %xmm6, %xmm14
        mulpd   %xmm7, %xmm6
        mulpd   %xmm11, %xmm14
        addpd   -24(%rsp), %xmm14
        addpd   %xmm6, %xmm14
        movapd  -72(%rsp), %xmm6
        mulpd   %xmm6, %xmm11
        mulpd   %xmm6, %xmm7
        movapd  %xmm10, %xmm6
        mulpd   %xmm10, %xmm6
        addpd   %xmm14, %xmm11
        xorpd   %xmm6, %xmm0
        movapd  %xmm6, %xmm9
        addpd   %xmm7, %xmm11
        movapd  %xmm10, %xmm7
        subpd   %xmm2, %xmm7
        mulpd   %xmm2, %xmm2
        addpd   %xmm11, %xmm3
        mulpd   %xmm7, %xmm15
        addpd   %xmm2, %xmm0
        movapd  %xmm7, %xmm2
        addpd   %xmm3, %xmm4
        movapd  (%rax), %xmm3
        mulpd   %xmm7, %xmm2
        movabsq $.LCTAN13, %rax
        addpd   %xmm3, %xmm9
        addpd   %xmm15, %xmm0
        movapd  (%rax), %xmm15
        movabsq $.LCTAN119, %rax
        pand    (%rax), %xmm12
        movabsq $.LCTAN178, %rax
        subpd   %xmm9, %xmm3
        addpd   %xmm2, %xmm0
        pcmpeqd (%rax), %xmm12
        movapd  %xmm4, %xmm2
        movabsq $.LCTAN3, %rax
        addpd   %xmm4, %xmm2
        mulpd   %xmm15, %xmm4
        addpd   %xmm3, %xmm6
        mulpd   %xmm10, %xmm15
        pxor    %xmm3, %xmm3
        pshufd  $80, %xmm12, %xmm12
        mulpd   %xmm10, %xmm2
        movapd  %xmm4, %xmm13
        andpd   %xmm12, %xmm13
        movapd  %xmm15, %xmm10
        andpd   %xmm12, %xmm10
        addpd   %xmm2, %xmm0
        movapd  %xmm12, %xmm2
        addpd   %xmm6, %xmm0
        andnpd  %xmm0, %xmm2
        xorpd   %xmm1, %xmm0
        xorpd   %xmm9, %xmm1
        orpd    %xmm2, %xmm13
        movapd  %xmm12, %xmm2
        andpd   %xmm12, %xmm0
        andnpd  %xmm9, %xmm2
        andpd   %xmm12, %xmm1
        orpd    %xmm2, %xmm10
        movapd  %xmm12, %xmm2
        andnpd  %xmm4, %xmm2
        movapd  %xmm10, %xmm11
        orpd    %xmm2, %xmm0
        movapd  %xmm12, %xmm2
        andpd   %xmm5, %xmm11
        andnpd  %xmm15, %xmm2
        movapd  -120(%rsp), %xmm15
        orpd    %xmm2, %xmm1
        movapd  (%rax), %xmm2
        movapd  %xmm1, %xmm8
        cmpeqpd %xmm15, %xmm3
        movapd  %xmm2, %xmm6
        divpd   %xmm10, %xmm6
        subpd   %xmm11, %xmm10
        movapd  %xmm6, %xmm4
        movapd  %xmm6, %xmm7
        andpd   %xmm5, %xmm4
        andpd   %xmm1, %xmm5
        subpd   %xmm5, %xmm8
        movapd  %xmm5, %xmm9
        movapd  %xmm11, %xmm5
        mulpd   %xmm4, %xmm5
        subpd   %xmm4, %xmm7
        mulpd   %xmm6, %xmm1
        subpd   %xmm5, %xmm2
        movapd  %xmm11, %xmm5
        mulpd   %xmm7, %xmm5
        mulpd   %xmm1, %xmm13
        subpd   %xmm5, %xmm2
        movapd  %xmm10, %xmm5
        mulpd   %xmm4, %xmm5
        subpd   %xmm13, %xmm0
        mulpd   %xmm7, %xmm10
        mulpd   %xmm0, %xmm6
        movapd  %xmm15, %xmm0
        andpd   %xmm3, %xmm0
        subpd   %xmm5, %xmm2
        movapd  %xmm4, %xmm5
        mulpd   %xmm9, %xmm5
        mulpd   %xmm7, %xmm9
        mulpd   %xmm8, %xmm4
        subpd   %xmm10, %xmm2
        mulpd   %xmm8, %xmm7
        subpd   %xmm1, %xmm5
        mulpd   %xmm1, %xmm2
        addpd   %xmm9, %xmm5
        addpd   %xmm4, %xmm5
        addpd   %xmm7, %xmm5
        addpd   %xmm2, %xmm5
        movapd  %xmm3, %xmm2
        addpd   %xmm6, %xmm5
        addpd   %xmm5, %xmm1
        andnpd  %xmm1, %xmm2
        orpd    %xmm2, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .p2align 4,,10
        .p2align 3
1:
        movabsq $.LCTAN157, %rdx
        movapd  %xmm3, %xmm1
        cmpltpd (%rdx), %xmm1
        pmovmskb        %xmm1, %edx
        cmpl    $65535, %edx
        jne     2f
        pxor    %xmm1, %xmm1
        movapd  %xmm7, %xmm3
        movabsq $.LCTAN199, %rdx
        movabsq $.LCTAN208, %rsi
        movapd  (%rdx), %xmm4
        cmpltpd %xmm1, %xmm3
        movapd  %xmm7, %xmm8
        movabsq $.LCTAN159, %rdx
        movabsq $.LCTAN2, %rcx
        movapd  %xmm7, %xmm13
        mulpd   %xmm7, %xmm4
        movapd  %xmm3, %xmm1
        andnpd  (%rcx), %xmm1
        cvttpd2dq       %xmm4, %xmm4
        cvtdq2pd        %xmm4, %xmm4
        mulpd   (%rdx), %xmm4
        movabsq $.LCTAN100, %rdx
        andpd   (%rdx), %xmm3
        movabsq $.LCTAN7, %rdx
        movapd  (%rdx), %xmm5
        movapd  %xmm3, %xmm2
        movapd  (%rsi), %xmm3
        movabsq $.LCTAN246, %rsi
        andpd   %xmm7, %xmm5
        orpd    %xmm1, %xmm2
        movapd  (%rsi), %xmm1
        movabsq $.LCTAN247, %rsi
        mulpd   %xmm7, %xmm3
        subpd   %xmm5, %xmm8
        subpd   %xmm4, %xmm2
        movapd  %xmm4, %xmm10
        movapd  %xmm4, %xmm11
        xorpd   %xmm3, %xmm0
        movapd  %xmm3, %xmm6
        movapd  %xmm0, %xmm9
        movapd  %xmm5, %xmm0
        addpd   %xmm2, %xmm6
        mulpd   %xmm1, %xmm0
        mulpd   %xmm8, %xmm1
        movapd  %xmm6, %xmm7
        subpd   %xmm3, %xmm7
        addpd   %xmm9, %xmm0
        movapd  (%rsi), %xmm9
        movabsq $.LCTAN248, %rsi
        subpd   %xmm7, %xmm2
        mulpd   %xmm9, %xmm5
        mulpd   %xmm9, %xmm8
        addpd   %xmm5, %xmm0
        addpd   %xmm0, %xmm1
        movapd  (%rsi), %xmm0
        movabsq $.LCTAN202, %rsi
        movapd  (%rsi), %xmm14
        movabsq $.LCTAN203, %rsi
        mulpd   %xmm13, %xmm0
        movapd  (%rsi), %xmm9
        movabsq $.LCTAN204, %rsi
        addpd   %xmm8, %xmm1
        movapd  (%rsi), %xmm8
        movabsq $.LCTAN205, %rsi
        mulpd   %xmm9, %xmm10
        mulpd   %xmm8, %xmm11
        addpd   %xmm0, %xmm1
        movapd  %xmm6, %xmm0
        subpd   %xmm7, %xmm0
        subpd   %xmm0, %xmm3
        movapd  %xmm4, %xmm0
        mulpd   %xmm14, %xmm0
        addpd   %xmm2, %xmm3
        addpd   %xmm3, %xmm1
        addpd   %xmm6, %xmm1
        cvttpd2dq       %xmm1, %xmm1
        cvtdq2pd        %xmm1, %xmm1
        mulpd   %xmm1, %xmm14
        cvtpd2dq        %xmm1, %xmm3
        movaps  %xmm3, -104(%rsp)
        mulpd   %xmm1, %xmm9
        movapd  %xmm0, %xmm3
        addpd   %xmm13, %xmm3
        mulpd   %xmm1, %xmm8
        addpd   %xmm4, %xmm1
        mulpd   (%rsi), %xmm1
        movapd  %xmm14, %xmm12
        movaps  %xmm3, -56(%rsp)
        addpd   %xmm3, %xmm12
        movapd  %xmm12, %xmm6
        movapd  %xmm12, %xmm4
        addpd   %xmm10, %xmm6
        movapd  %xmm6, %xmm3
        movapd  %xmm6, %xmm5
        movapd  %xmm6, %xmm0
        subpd   %xmm12, %xmm3
        addpd   %xmm9, %xmm5
        movaps  %xmm3, -88(%rsp)
        subpd   -88(%rsp), %xmm0
        movapd  %xmm5, %xmm3
        movapd  %xmm5, %xmm15
        subpd   -88(%rsp), %xmm10
        addpd   %xmm11, %xmm3
        subpd   %xmm6, %xmm15
        subpd   %xmm0, %xmm4
        movapd  -56(%rsp), %xmm0
        movapd  %xmm3, %xmm7
        subpd   %xmm12, %xmm0
        subpd   %xmm5, %xmm7
        addpd   %xmm4, %xmm10
        movapd  %xmm5, %xmm4
        subpd   %xmm15, %xmm9
        subpd   %xmm15, %xmm4
        addpd   %xmm14, %xmm0
        movaps  %xmm7, -72(%rsp)
        movapd  %xmm3, %xmm7
        addpd   %xmm8, %xmm7
        subpd   %xmm4, %xmm6
        movapd  %xmm3, %xmm4
        addpd   %xmm0, %xmm10
        movapd  %xmm7, %xmm13
        movapd  %xmm7, %xmm2
        movapd  %xmm6, %xmm0
        movapd  -72(%rsp), %xmm6
        subpd   %xmm3, %xmm13
        addpd   %xmm1, %xmm2
        addpd   %xmm9, %xmm0
        subpd   %xmm6, %xmm4
        subpd   %xmm6, %xmm11
        subpd   %xmm13, %xmm8
        addpd   %xmm10, %xmm0
        subpd   %xmm4, %xmm5
        movapd  %xmm7, %xmm4
        subpd   %xmm13, %xmm4
        addpd   %xmm11, %xmm5
        subpd   %xmm4, %xmm3
        movapd  %xmm7, %xmm4
        subpd   %xmm2, %xmm4
        addpd   %xmm5, %xmm0
        addpd   %xmm8, %xmm3
        addpd   %xmm1, %xmm4
        addpd   %xmm3, %xmm0
        addpd   %xmm4, %xmm0
        {disp32} jmp 0b
        .p2align 4,,10
        .p2align 3
2:
        pshufd  $13, %xmm7, %xmm4
        movapd  %xmm0, %xmm13
        movabsq $.LCTAN149, %rdx
        movabsq $.LCTAN167, %rdi
        psrld   $20, %xmm4
        pand    (%rdx), %xmm4
        movabsq $.LCTAN164, %rdx
        paddd   (%rdx), %xmm4
        movabsq $.LCTAN165, %rdx
        movdqa  %xmm4, %xmm2
        movdqa  %xmm4, %xmm1
        psrad   $31, %xmm2
        pcmpgtd (%rdx), %xmm1
        movabsq $.LCTAN166, %rdx
        pandn   %xmm4, %xmm2
        pand    (%rdx), %xmm1
        movabsq $.LCTAN90, %rdx
        pslld   $2, %xmm2
        movd    %xmm2, %esi
        pshufd  $115, %xmm1, %xmm1
        pshufd  $85, %xmm2, %xmm2
        movslq  %esi, %rsi
        pand    (%rdx), %xmm1
        movd    %xmm2, %ecx
        movabsq $.LSleef_rempitabdp, %rdx
        salq    $3, %rsi
        movslq  %ecx, %rcx
        movsd   (%rdx,%rsi), %xmm6
        pslld   $20, %xmm1
        paddd   -120(%rsp), %xmm1
        movhpd  (%rdx,%rcx,8), %xmm6
        movapd  %xmm1, %xmm14
        movabsq $.LCTAN146, %rdx
        movdqa  (%rdx), %xmm2
        movapd  %xmm6, %xmm4
        movapd  %xmm6, %xmm7
        movabsq $.LCTAN7, %rdx
        movapd  (%rdx), %xmm15
        mulpd   %xmm1, %xmm6
        pand    %xmm1, %xmm2
        andpd   %xmm15, %xmm4
        subpd   %xmm2, %xmm14
        movapd  %xmm4, %xmm9
        subpd   %xmm4, %xmm7
        mulpd   %xmm2, %xmm9
        mulpd   %xmm14, %xmm4
        movapd  %xmm6, %xmm5
        movapd  %xmm0, %xmm6
        xorpd   %xmm5, %xmm6
        movapd  %xmm5, %xmm8
        andpd   %xmm0, %xmm8
        addpd   %xmm6, %xmm9
        movdqa  (%rdi), %xmm6
        movabsq $.LCTAN10, %rdi
        movaps  %xmm6, -72(%rsp)
        movdqa  %xmm6, %xmm10
        movapd  (%rdi), %xmm6
        movabsq $.LCTAN168, %rdi
        addpd   %xmm4, %xmm9
        movapd  %xmm7, %xmm4
        pxor    %xmm8, %xmm10
        mulpd   %xmm2, %xmm4
        movaps  %xmm6, -56(%rsp)
        mulpd   %xmm14, %xmm7
        addpd   %xmm4, %xmm9
        addpd   %xmm7, %xmm9
        movapd  %xmm6, %xmm7
        mulpd   %xmm5, %xmm7
        movapd  %xmm7, %xmm11
        andnpd  %xmm7, %xmm13
        movapd  (%rdi), %xmm7
        movabsq $.LCTAN169, %rdi
        movapd  %xmm7, %xmm4
        cmpltpd %xmm13, %xmm4
        movapd  %xmm11, %xmm13
        addpd   %xmm10, %xmm13
        movapd  %xmm4, %xmm12
        andpd   %xmm11, %xmm4
        movapd  %xmm13, %xmm6
        movapd  %xmm7, %xmm13
        subpd   %xmm10, %xmm6
        por     %xmm8, %xmm6
        andnpd  %xmm6, %xmm12
        orpd    %xmm4, %xmm12
        movapd  %xmm0, %xmm4
        andnpd  %xmm5, %xmm4
        cmpltpd %xmm4, %xmm13
        movapd  %xmm5, %xmm4
        addpd   %xmm10, %xmm4
        subpd   %xmm10, %xmm4
        por     %xmm8, %xmm4
        movapd  %xmm13, %xmm8
        andpd   %xmm5, %xmm13
        andnpd  %xmm4, %xmm8
        movapd  %xmm13, %xmm4
        movapd  (%rdi), %xmm13
        movabsq $.LCTAN170, %rdi
        orpd    %xmm8, %xmm4
        mulpd   %xmm13, %xmm4
        movaps  %xmm13, -24(%rsp)
        movapd  (%rdi), %xmm13
        movabsq $.LSleef_rempitabdp+8, %rdi
        addpd   %xmm12, %xmm4
        mulpd   %xmm13, %xmm12
        cvttpd2dq       %xmm4, %xmm8
        movaps  %xmm8, -40(%rsp)
        movapd  %xmm0, %xmm4
        movsd   (%rdi,%rsi), %xmm8
        addpd   %xmm5, %xmm12
        movhpd  (%rdi,%rcx,8), %xmm8
        addq    $8, %rdi
        movapd  %xmm8, %xmm11
        andpd   %xmm15, %xmm11
        movapd  %xmm12, %xmm6
        movapd  %xmm9, %xmm12
        addpd   %xmm6, %xmm12
        movapd  %xmm12, %xmm5
        movapd  %xmm8, %xmm12
        mulpd   %xmm1, %xmm8
        subpd   %xmm11, %xmm12
        subpd   %xmm5, %xmm6
        movaps  %xmm12, -104(%rsp)
        movapd  %xmm5, %xmm12
        addpd   %xmm9, %xmm6
        addpd   %xmm8, %xmm12
        xorpd   %xmm8, %xmm4
        movapd  %xmm12, %xmm10
        subpd   %xmm5, %xmm12
        movaps  %xmm12, -88(%rsp)
        movapd  %xmm11, %xmm12
        movapd  -88(%rsp), %xmm9
        mulpd   %xmm2, %xmm12
        mulpd   %xmm14, %xmm11
        subpd   %xmm9, %xmm8
        addpd   %xmm12, %xmm4
        movapd  -104(%rsp), %xmm12
        addpd   %xmm11, %xmm4
        movapd  %xmm12, %xmm11
        mulpd   %xmm2, %xmm11
        mulpd   %xmm14, %xmm12
        addpd   %xmm11, %xmm4
        movapd  %xmm10, %xmm11
        subpd   %xmm9, %xmm11
        movapd  %xmm0, %xmm9
        addpd   %xmm12, %xmm4
        movapd  %xmm7, %xmm12
        subpd   %xmm11, %xmm5
        movdqa  -72(%rsp), %xmm11
        addpd   %xmm6, %xmm4
        movapd  -56(%rsp), %xmm6
        addpd   %xmm8, %xmm5
        movapd  %xmm10, %xmm8
        mulpd   %xmm10, %xmm6
        andpd   %xmm0, %xmm8
        pxor    %xmm8, %xmm11
        addpd   %xmm5, %xmm4
        andnpd  %xmm6, %xmm9
        cmpltpd %xmm9, %xmm12
        movapd  %xmm6, %xmm9
        addpd   %xmm11, %xmm9
        movapd  %xmm12, %xmm5
        subpd   %xmm11, %xmm9
        andpd   %xmm6, %xmm5
        por     %xmm8, %xmm9
        andnpd  %xmm9, %xmm12
        movapd  %xmm0, %xmm9
        andnpd  %xmm10, %xmm9
        orpd    %xmm5, %xmm12
        cmpltpd %xmm9, %xmm7
        movapd  %xmm10, %xmm9
        addpd   %xmm11, %xmm9
        movapd  %xmm7, %xmm6
        andpd   %xmm10, %xmm7
        movapd  %xmm9, %xmm5
        subpd   %xmm11, %xmm5
        por     %xmm8, %xmm5
        movapd  %xmm4, %xmm8
        andnpd  %xmm5, %xmm6
        orpd    %xmm6, %xmm7
        movsd   (%rdi,%rsi), %xmm6
        mulpd   -24(%rsp), %xmm7
        movhpd  (%rdi,%rcx,8), %xmm6
        movapd  %xmm6, %xmm9
        andpd   %xmm15, %xmm9
        addpd   %xmm12, %xmm7
        mulpd   %xmm13, %xmm12
        movapd  %xmm9, %xmm13
        mulpd   %xmm2, %xmm13
        cvttpd2dq       %xmm7, %xmm7
        paddd   -40(%rsp), %xmm7
        addpd   %xmm10, %xmm12
        movapd  %xmm0, %xmm10
        movaps  %xmm7, -104(%rsp)
        addpd   %xmm12, %xmm8
        movapd  %xmm12, %xmm5
        movapd  %xmm6, %xmm12
        mulpd   %xmm1, %xmm6
        subpd   %xmm9, %xmm12
        mulpd   %xmm14, %xmm9
        movapd  %xmm8, %xmm7
        subpd   %xmm8, %xmm5
        mulpd   %xmm12, %xmm2
        mulpd   %xmm14, %xmm12
        xorpd   %xmm6, %xmm10
        addpd   %xmm6, %xmm7
        addpd   %xmm5, %xmm4
        addpd   %xmm13, %xmm10
        movapd  %xmm7, %xmm11
        addpd   %xmm10, %xmm2
        subpd   %xmm8, %xmm11
        movapd  %xmm0, %xmm10
        andnpd  %xmm1, %xmm0
        addpd   %xmm9, %xmm2
        subpd   %xmm11, %xmm6
        addpd   %xmm12, %xmm2
        movsd   8(%rdi,%rsi), %xmm12
        addq    $8, %rdi
        movhpd  (%rdi,%rcx,8), %xmm12
        movabsq $.LCTAN171, %rcx
        mulpd   %xmm1, %xmm12
        addpd   %xmm2, %xmm12
        movapd  %xmm7, %xmm2
        subpd   %xmm11, %xmm2
        addpd   %xmm12, %xmm4
        subpd   %xmm2, %xmm8
        movapd  %xmm7, %xmm2
        addpd   %xmm8, %xmm6
        movapd  (%rcx), %xmm8
        movabsq $.LCTAN172, %rcx
        cmpltpd (%rcx), %xmm0
        movabsq $.LCTAN173, %rcx
        addpd   %xmm4, %xmm6
        movapd  %xmm0, %xmm11
        addpd   %xmm6, %xmm2
        movapd  %xmm2, %xmm4
        movapd  %xmm2, %xmm5
        andpd   %xmm2, %xmm15
        mulpd   %xmm8, %xmm4
        movapd  %xmm2, %xmm9
        movapd  %xmm1, %xmm2
        movapd  (%rcx), %xmm1
        subpd   %xmm15, %xmm9
        subpd   %xmm5, %xmm7
        andpd   %xmm0, %xmm2
        movabsq $.LCTAN174, %rcx
        addpd   %xmm7, %xmm6
        xorpd   %xmm4, %xmm10
        andnpd  %xmm4, %xmm11
        movapd  %xmm15, %xmm4
        mulpd   %xmm1, %xmm4
        orpd    %xmm11, %xmm2
        mulpd   %xmm9, %xmm1
        mulpd   %xmm6, %xmm8
        addpd   %xmm10, %xmm4
        addpd   %xmm1, %xmm4
        movapd  (%rcx), %xmm1
        movabsq $.LCTAN175, %rcx
        mulpd   %xmm1, %xmm15
        mulpd   %xmm1, %xmm9
        movapd  (%rcx), %xmm1
        movabsq $.LCTAN152, %rcx
        cmpeqpd (%rcx), %xmm3
        movabsq $.LCTAN2, %rcx
        mulpd   %xmm5, %xmm1
        movapd  -120(%rsp), %xmm5
        addpd   %xmm15, %xmm4
        addpd   %xmm9, %xmm4
        addpd   %xmm1, %xmm4
        addpd   %xmm8, %xmm4
        pandn   %xmm4, %xmm0
        movapd  %xmm5, %xmm4
        cmpneqpd        %xmm5, %xmm4
        orpd    %xmm3, %xmm4
        por     %xmm4, %xmm2
        por     %xmm4, %xmm0
        {disp32} jmp 0b
        .size   .LSleef_tand2_u10sse2, .-.LSleef_tand2_u10sse2
        .set    .Lxtan_u1, .LSleef_tand2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCTAN0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCTAN2:
        .long   0
        .long   1071644672
        .long   0
        .long   1071644672
        .align 16
.LCTAN3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCTAN4:
        .long   0
        .long   -1074790400
        .long   0
        .long   -1074790400
        .align 16
.LCTAN7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCTAN10:
        .long   0
        .long   1074790400
        .long   0
        .long   1074790400
        .align 16
.LCTAN13:
        .long   0
        .long   -1073741824
        .long   0
        .long   -1073741824
        .align 16
.LCTAN90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCTAN100:
        .long   0
        .long   -1075838976
        .long   0
        .long   -1075838976
        .align 16
.LCTAN119:
        .quad   4294967297
        .quad   0
        .align 16
.LCTAN146:
        .quad   -134217728
        .quad   -134217728
        .align 16
.LCTAN149:
        .quad   8791798056959
        .quad   0
        .align 16
.LCTAN152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCTAN153:
        .long   0
        .long   1076756480
        .long   0
        .long   1076756480
        .align 16
.LCTAN157:
        .long   512753664
        .long   1121369284
        .long   512753664
        .long   1121369284
        .align 16
.LCTAN159:
        .long   0
        .long   1097859072
        .long   0
        .long   1097859072
        .align 16
.LCTAN164:
        .long   -1078
        .long   -1078
        .long   0
        .long   0
        .align 16
.LCTAN165:
        .long   645
        .long   645
        .long   0
        .long   0
        .align 16
.LCTAN166:
        .quad   -270582939712
        .quad   0
        .align 16
.LCTAN167:
        .quad   4841369599423283200
        .quad   4841369599423283200
        .align 16
.LCTAN168:
        .long   0
        .long   1127219200
        .long   0
        .long   1127219200
        .align 16
.LCTAN169:
        .long   0
        .long   -1072693248
        .long   0
        .long   -1072693248
        .align 16
.LCTAN170:
        .long   0
        .long   -1076887552
        .long   0
        .long   -1076887552
        .align 16
.LCTAN171:
        .long   1413754136
        .long   1075388923
        .long   1413754136
        .long   1075388923
        .align 16
.LCTAN172:
        .long   1717986918
        .long   1072064102
        .long   1717986918
        .long   1072064102
        .align 16
.LCTAN173:
        .long   1342177280
        .long   1075388923
        .long   1342177280
        .long   1075388923
        .align 16
.LCTAN174:
        .long   1610612736
        .long   1047597236
        .long   1610612736
        .long   1047597236
        .align 16
.LCTAN175:
        .long   856972295
        .long   1018275366
        .long   856972295
        .long   1018275366
        .align 16
.LCTAN178:
        .long   1
        .long   1
        .long   0
        .long   0
        .align 16
.LCTAN197:
        .long   1413754136
        .long   -1074191877
        .long   1413754136
        .long   -1074191877
        .align 16
.LCTAN198:
        .long   856972295
        .long   -1131305434
        .long   856972295
        .long   -1131305434
        .align 16
.LCTAN199:
        .long   1841940611
        .long   1046765360
        .long   1841940611
        .long   1046765360
        .align 16
.LCTAN202:
        .long   1342177280
        .long   -1074191877
        .long   1342177280
        .long   -1074191877
        .align 16
.LCTAN203:
        .long   1610612736
        .long   -1101983564
        .long   1610612736
        .long   -1101983564
        .align 16
.LCTAN204:
        .long   805306368
        .long   -1131305434
        .long   805306368
        .long   -1131305434
        .align 16
.LCTAN205:
        .long   923219018
        .long   -1159159072
        .long   923219018
        .long   -1159159072
        .align 16
.LCTAN208:
        .long   1841940611
        .long   1071931184
        .long   1841940611
        .long   1071931184
        .align 16
.LCTAN237:
        .long   1431385325
        .long   1060455519
        .long   1431385325
        .long   1060455519
        .align 16
.LCTAN238:
        .long   1074652079
        .long   1061317054
        .long   1074652079
        .long   1061317054
        .align 16
.LCTAN239:
        .long   836897683
        .long   1062727414
        .long   836897683
        .long   1062727414
        .align 16
.LCTAN240:
        .long   -1015953063
        .long   1064135719
        .long   -1015953063
        .long   1064135719
        .align 16
.LCTAN241:
        .long   -1079816048
        .long   1065494247
        .long   -1079816048
        .long   1065494247
        .align 16
.LCTAN242:
        .long   1923061989
        .long   1066820852
        .long   1923061989
        .long   1066820852
        .align 16
.LCTAN243:
        .long   467463174
        .long   1068212666
        .long   467463174
        .long   1068212666
        .align 16
.LCTAN244:
        .long   286320947
        .long   1069617425
        .long   286320947
        .long   1069617425
        .align 16
.LCTAN245:
        .long   1431655784
        .long   1070945621
        .long   1431655784
        .long   1070945621
        .align 16
.LCTAN246:
        .long   1744830464
        .long   1071931184
        .long   1744830464
        .long   1071931184
        .align 16
.LCTAN247:
        .long   201326592
        .long   1044850466
        .long   201326592
        .long   1044850466
        .align 16
.LCTAN248:
        .long   -985567146
        .long   -1132023778
        .long   -985567146
        .long   -1132023778
