        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_tanhd2_u10sse2, @function
.LSleef_tanhd2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCTANH_0, %rax
        subq    $336, %rsp
        pxor    %xmm5, %xmm5
        movapd  (%rax), %xmm12
        movaps  %xmm0, 184(%rsp)
        movabsq $.LCTANH_328, %rax
        movapd  %xmm12, %xmm2
        andnpd  %xmm0, %xmm2
        movapd  %xmm2, %xmm0
        movapd  %xmm2, %xmm14
        movaps  %xmm2, -56(%rsp)
        addpd   %xmm5, %xmm0
        mulpd   (%rax), %xmm0
        movabsq $.LCTANH_329, %rax
        movapd  (%rax), %xmm3
        movabsq $.LCTANH_330, %rax
        cvtpd2dq        %xmm0, %xmm0
        cvtdq2pd        %xmm0, %xmm0
        mulpd   %xmm0, %xmm3
        cvtpd2dq        %xmm0, %xmm4
        mulpd   (%rax), %xmm0
        movabsq $.LCTANH_7, %rax
        addpd   %xmm3, %xmm14
        movapd  %xmm14, %xmm7
        movapd  %xmm14, %xmm1
        movapd  %xmm14, %xmm8
        subpd   %xmm2, %xmm7
        addpd   %xmm0, %xmm1
        subpd   %xmm7, %xmm8
        subpd   %xmm7, %xmm3
        movapd  %xmm1, %xmm6
        subpd   %xmm14, %xmm6
        movapd  %xmm1, %xmm9
        subpd   %xmm8, %xmm2
        movapd  %xmm12, %xmm8
        subpd   %xmm6, %xmm0
        addpd   %xmm3, %xmm2
        movapd  %xmm1, %xmm3
        subpd   %xmm6, %xmm3
        addpd   %xmm5, %xmm2
        movapd  %xmm1, %xmm5
        subpd   %xmm3, %xmm14
        movapd  %xmm1, %xmm3
        addpd   %xmm0, %xmm14
        movapd  (%rax), %xmm0
        movabsq $.LCTANH_374, %rax
        andpd   %xmm0, %xmm5
        subpd   %xmm5, %xmm3
        addpd   %xmm2, %xmm14
        movapd  %xmm5, %xmm2
        movapd  %xmm1, %xmm5
        movapd  %xmm2, %xmm6
        movapd  %xmm2, %xmm7
        mulpd   %xmm1, %xmm5
        addpd   %xmm2, %xmm6
        mulpd   %xmm2, %xmm7
        mulpd   %xmm3, %xmm6
        xorpd   %xmm5, %xmm8
        movapd  %xmm5, %xmm10
        movapd  %xmm5, %xmm15
        addpd   %xmm8, %xmm7
        mulpd   %xmm5, %xmm15
        andpd   %xmm0, %xmm10
        addpd   %xmm7, %xmm6
        movapd  %xmm3, %xmm7
        mulpd   %xmm3, %xmm7
        addpd   %xmm7, %xmm6
        movapd  %xmm14, %xmm7
        addpd   %xmm14, %xmm7
        mulpd   %xmm1, %xmm7
        addpd   %xmm7, %xmm6
        movapd  %xmm5, %xmm7
        subpd   %xmm10, %xmm7
        movaps  %xmm6, 8(%rsp)
        movapd  (%rax), %xmm6
        movabsq $.LCTANH_375, %rax
        movaps  %xmm7, 24(%rsp)
        movapd  %xmm12, %xmm7
        mulpd   %xmm1, %xmm6
        xorpd   %xmm15, %xmm7
        addpd   (%rax), %xmm6
        movaps  %xmm7, 200(%rsp)
        movabsq $.LCTANH_376, %rax
        movapd  (%rax), %xmm13
        movabsq $.LCTANH_377, %rax
        mulpd   %xmm1, %xmm13
        mulpd   %xmm5, %xmm6
        movapd  %xmm13, %xmm7
        addpd   (%rax), %xmm7
        movabsq $.LCTANH_378, %rax
        movapd  (%rax), %xmm13
        movabsq $.LCTANH_379, %rax
        mulpd   %xmm1, %xmm13
        addpd   %xmm7, %xmm6
        mulpd   %xmm15, %xmm6
        movapd  %xmm13, %xmm7
        addpd   (%rax), %xmm7
        movabsq $.LCTANH_380, %rax
        movapd  (%rax), %xmm8
        movabsq $.LCTANH_381, %rax
        mulpd   %xmm1, %xmm8
        addpd   (%rax), %xmm8
        mulpd   %xmm5, %xmm7
        movabsq $.LCTANH_382, %rax
        movapd  (%rax), %xmm13
        movabsq $.LCTANH_383, %rax
        mulpd   %xmm1, %xmm13
        addpd   %xmm8, %xmm7
        movapd  %xmm15, %xmm8
        mulpd   %xmm15, %xmm8
        addpd   %xmm7, %xmm6
        movapd  %xmm13, %xmm7
        addpd   (%rax), %xmm7
        movabsq $.LCTANH_384, %rax
        movapd  (%rax), %xmm13
        movabsq $.LCTANH_2, %rax
        mulpd   %xmm8, %xmm7
        movapd  (%rax), %xmm8
        movabsq $.LCTANH_3, %rax
        mulpd   %xmm13, %xmm9
        mulpd   %xmm14, %xmm13
        addpd   %xmm7, %xmm6
        movapd  %xmm12, %xmm7
        xorpd   %xmm9, %xmm7
        movaps  %xmm9, 40(%rsp)
        addpd   %xmm8, %xmm9
        movaps  %xmm7, 216(%rsp)
        movaps  %xmm6, -104(%rsp)
        movapd  %xmm12, %xmm6
        movapd  %xmm1, %xmm12
        movapd  %xmm9, %xmm7
        andpd   %xmm0, %xmm9
        mulpd   %xmm7, %xmm12
        movapd  %xmm7, %xmm11
        subpd   %xmm7, %xmm8
        movaps  %xmm9, 232(%rsp)
        subpd   %xmm9, %xmm11
        mulpd   %xmm14, %xmm7
        movapd  %xmm6, %xmm9
        movaps  %xmm11, 56(%rsp)
        movapd  (%rax), %xmm11
        movabsq $.LCTANH_89, %rax
        xorpd   %xmm12, %xmm9
        movaps  %xmm12, 72(%rsp)
        addpd   %xmm11, %xmm12
        movaps  %xmm11, -120(%rsp)
        movaps  %xmm9, 248(%rsp)
        movapd  %xmm12, %xmm9
        andpd   %xmm0, %xmm12
        mulpd   %xmm9, %xmm14
        movapd  %xmm12, %xmm11
        movapd  %xmm9, %xmm12
        movaps  %xmm11, 264(%rsp)
        subpd   %xmm11, %xmm12
        addpd   40(%rsp), %xmm8
        movaps  %xmm6, -88(%rsp)
        movaps  %xmm12, 88(%rsp)
        movapd  %xmm1, %xmm12
        mulpd   %xmm9, %xmm12
        movapd  %xmm12, %xmm11
        movapd  %xmm6, %xmm12
        xorpd   %xmm11, %xmm12
        movaps  %xmm11, 104(%rsp)
        addpd   -120(%rsp), %xmm11
        movaps  %xmm12, 280(%rsp)
        movapd  %xmm15, %xmm12
        andpd   %xmm0, %xmm12
        movaps  %xmm11, -72(%rsp)
        movapd  %xmm15, %xmm11
        movaps  %xmm12, 296(%rsp)
        subpd   %xmm12, %xmm11
        movaps  %xmm11, 120(%rsp)
        movapd  -104(%rsp), %xmm11
        movapd  %xmm11, %xmm12
        andpd   %xmm0, %xmm12
        movaps  %xmm12, -40(%rsp)
        movapd  %xmm11, %xmm12
        subpd   -40(%rsp), %xmm11
        movaps  %xmm11, 136(%rsp)
        movapd  %xmm15, %xmm11
        movapd  %xmm6, %xmm15
        mulpd   %xmm12, %xmm11
        xorpd   %xmm11, %xmm15
        movapd  %xmm11, %xmm6
        movapd  -72(%rsp), %xmm11
        movaps  %xmm15, 312(%rsp)
        movdqa  %xmm4, %xmm15
        psrad   $1, %xmm15
        addpd   %xmm6, %xmm11
        movaps  %xmm6, 152(%rsp)
        movdqa  %xmm15, %xmm6
        movdqa  (%rax), %xmm15
        movabsq $.LCTANH_90, %rax
        movdqa  (%rax), %xmm12
        movabsq $.LCTANH_342, %rax
        movaps  %xmm11, 168(%rsp)
        paddd   %xmm15, %xmm4
        psubd   %xmm6, %xmm4
        paddd   %xmm15, %xmm6
        pshufd  $115, %xmm4, %xmm4
        pshufd  $115, %xmm6, %xmm6
        pand    %xmm12, %xmm4
        pand    %xmm12, %xmm6
        pslld   $20, %xmm4
        movaps  %xmm4, -24(%rsp)
        movdqa  %xmm6, %xmm4
        movapd  %xmm2, %xmm6
        pslld   $20, %xmm4
        movdqa  %xmm4, %xmm15
        movapd  -56(%rsp), %xmm4
        movaps  %xmm15, -8(%rsp)
        cmpltpd (%rax), %xmm4
        movabsq $.LCTANH_385, %rax
        movapd  %xmm4, %xmm12
        movapd  %xmm11, %xmm4
        movapd  %xmm2, %xmm11
        mulpd   -8(%rsp), %xmm4
        movdqa  %xmm12, %xmm15
        mulpd   -24(%rsp), %xmm4
        pandn   %xmm4, %xmm15
        movapd  (%rax), %xmm4
        movabsq $.LCTANH_386, %rax
        mulpd   %xmm4, %xmm6
        addpd   216(%rsp), %xmm6
        mulpd   %xmm3, %xmm4
        addpd   %xmm4, %xmm6
        movapd  (%rax), %xmm4
        movabsq $.LCTANH_146, %rax
        mulpd   %xmm4, %xmm11
        mulpd   %xmm3, %xmm4
        addpd   %xmm11, %xmm6
        movapd  56(%rsp), %xmm11
        addpd   %xmm6, %xmm4
        movapd  232(%rsp), %xmm6
        addpd   %xmm13, %xmm4
        movapd  %xmm4, %xmm13
        movapd  %xmm6, %xmm4
        addpd   %xmm8, %xmm13
        mulpd   %xmm2, %xmm4
        movapd  %xmm11, %xmm8
        addpd   248(%rsp), %xmm4
        mulpd   %xmm2, %xmm8
        mulpd   %xmm1, %xmm13
        addpd   %xmm8, %xmm4
        movapd  %xmm6, %xmm8
        movapd  %xmm11, %xmm6
        mulpd   %xmm3, %xmm8
        mulpd   %xmm3, %xmm6
        addpd   %xmm4, %xmm8
        addpd   %xmm8, %xmm6
        movapd  -120(%rsp), %xmm8
        movapd  %xmm8, %xmm11
        addpd   %xmm7, %xmm6
        movapd  %xmm8, %xmm7
        subpd   %xmm9, %xmm7
        addpd   72(%rsp), %xmm7
        movapd  280(%rsp), %xmm4
        movapd  -40(%rsp), %xmm9
        addpd   %xmm6, %xmm13
        movapd  312(%rsp), %xmm6
        addpd   %xmm13, %xmm7
        movapd  %xmm2, %xmm13
        mulpd   %xmm7, %xmm1
        movapd  264(%rsp), %xmm7
        mulpd   %xmm7, %xmm13
        addpd   %xmm13, %xmm4
        movapd  88(%rsp), %xmm13
        mulpd   %xmm13, %xmm2
        addpd   %xmm4, %xmm2
        movapd  %xmm7, %xmm4
        mulpd   %xmm3, %xmm4
        mulpd   %xmm13, %xmm3
        movapd  %xmm8, %xmm13
        movapd  %xmm10, %xmm8
        addpd   %xmm10, %xmm8
        mulpd   %xmm10, %xmm10
        addpd   %xmm4, %xmm2
        addpd   %xmm3, %xmm2
        movapd  -72(%rsp), %xmm3
        subpd   %xmm3, %xmm11
        addpd   104(%rsp), %xmm11
        subpd   168(%rsp), %xmm3
        addpd   %xmm14, %xmm2
        movapd  24(%rsp), %xmm14
        addpd   %xmm2, %xmm1
        movapd  %xmm8, %xmm2
        mulpd   %xmm14, %xmm2
        mulpd   %xmm14, %xmm14
        addpd   %xmm11, %xmm1
        movapd  152(%rsp), %xmm11
        addpd   %xmm3, %xmm11
        movapd  200(%rsp), %xmm3
        addpd   %xmm10, %xmm3
        movapd  296(%rsp), %xmm10
        addpd   %xmm11, %xmm1
        movapd  %xmm10, %xmm7
        mulpd   %xmm9, %xmm7
        addpd   %xmm2, %xmm3
        movapd  %xmm14, %xmm2
        movapd  120(%rsp), %xmm14
        addpd   %xmm3, %xmm2
        movapd  8(%rsp), %xmm3
        addpd   %xmm7, %xmm6
        movapd  %xmm9, %xmm7
        addpd   %xmm3, %xmm3
        mulpd   %xmm14, %xmm7
        mulpd   %xmm5, %xmm3
        movapd  136(%rsp), %xmm5
        mulpd   %xmm5, %xmm14
        addpd   %xmm7, %xmm6
        movapd  %xmm10, %xmm7
        movapd  %xmm13, %xmm10
        mulpd   %xmm5, %xmm7
        movapd  -8(%rsp), %xmm5
        addpd   %xmm2, %xmm3
        mulpd   -104(%rsp), %xmm3
        movapd  %xmm13, %xmm2
        addpd   %xmm7, %xmm6
        addpd   %xmm14, %xmm6
        addpd   %xmm3, %xmm6
        addpd   %xmm6, %xmm1
        mulpd   %xmm1, %xmm5
        movapd  %xmm13, %xmm1
        divpd   %xmm15, %xmm1
        movapd  %xmm5, %xmm6
        movapd  -24(%rsp), %xmm5
        mulpd   %xmm6, %xmm5
        movapd  %xmm5, %xmm4
        movdqa  %xmm12, %xmm5
        movapd  -88(%rsp), %xmm12
        pandn   %xmm4, %xmm5
        movdqa  %xmm5, %xmm6
        movdqa  (%rax), %xmm5
        movapd  %xmm12, %xmm11
        movabsq $.LCTANH_388, %rax
        pand    %xmm15, %xmm5
        movdqa  %xmm5, %xmm4
        movapd  %xmm15, %xmm5
        subpd   %xmm4, %xmm5
        movapd  %xmm1, %xmm3
        movapd  %xmm1, %xmm7
        xorpd   %xmm1, %xmm11
        andpd   %xmm0, %xmm3
        movapd  %xmm11, %xmm9
        movapd  %xmm3, %xmm8
        subpd   %xmm3, %xmm7
        addpd   %xmm15, %xmm9
        mulpd   %xmm4, %xmm8
        mulpd   %xmm5, %xmm3
        mulpd   %xmm7, %xmm4
        movapd  %xmm9, %xmm14
        mulpd   %xmm7, %xmm5
        subpd   %xmm15, %xmm14
        subpd   %xmm8, %xmm2
        subpd   %xmm14, %xmm11
        subpd   %xmm4, %xmm2
        movapd  %xmm9, %xmm4
        subpd   %xmm3, %xmm2
        movapd  %xmm1, %xmm3
        mulpd   %xmm6, %xmm3
        subpd   %xmm5, %xmm2
        movapd  %xmm12, %xmm5
        subpd   %xmm3, %xmm2
        movapd  %xmm1, %xmm3
        addpd   %xmm15, %xmm3
        movapd  %xmm2, %xmm7
        movapd  %xmm10, %xmm2
        divpd   %xmm3, %xmm10
        movapd  %xmm3, %xmm8
        movapd  %xmm3, %xmm9
        mulpd   %xmm1, %xmm7
        andpd   %xmm0, %xmm8
        movapd  %xmm3, %xmm13
        subpd   %xmm8, %xmm9
        subpd   %xmm15, %xmm13
        movapd  %xmm9, %xmm12
        movaps  %xmm13, -72(%rsp)
        movapd  %xmm8, %xmm13
        xorpd   %xmm7, %xmm5
        movaps  %xmm7, -40(%rsp)
        movaps  %xmm5, -24(%rsp)
        movapd  %xmm10, %xmm9
        andpd   %xmm0, %xmm9
        andpd   %xmm4, %xmm0
        movapd  %xmm9, %xmm5
        movapd  %xmm10, %xmm9
        subpd   %xmm5, %xmm9
        mulpd   %xmm5, %xmm13
        movapd  %xmm9, %xmm7
        movapd  %xmm4, %xmm9
        mulpd   %xmm7, %xmm8
        subpd   %xmm0, %xmm9
        subpd   %xmm13, %xmm2
        movapd  %xmm12, %xmm13
        mulpd   %xmm5, %xmm13
        movaps  %xmm9, -104(%rsp)
        mulpd   %xmm7, %xmm12
        movapd  %xmm10, %xmm9
        mulpd   %xmm4, %xmm9
        subpd   %xmm14, %xmm4
        subpd   %xmm8, %xmm2
        subpd   %xmm13, %xmm2
        movapd  %xmm5, %xmm13
        mulpd   %xmm0, %xmm13
        mulpd   %xmm7, %xmm0
        subpd   %xmm12, %xmm2
        mulpd   %xmm9, %xmm2
        movapd  %xmm13, %xmm8
        movapd  %xmm15, %xmm13
        subpd   %xmm9, %xmm8
        subpd   %xmm4, %xmm13
        movapd  -72(%rsp), %xmm4
        subpd   %xmm4, %xmm3
        subpd   %xmm4, %xmm1
        addpd   %xmm8, %xmm0
        movapd  -104(%rsp), %xmm8
        addpd   %xmm13, %xmm11
        mulpd   %xmm8, %xmm5
        mulpd   %xmm8, %xmm7
        addpd   %xmm5, %xmm0
        movapd  -24(%rsp), %xmm5
        addpd   %xmm6, %xmm5
        addpd   -40(%rsp), %xmm6
        addpd   %xmm7, %xmm0
        addpd   %xmm5, %xmm11
        movapd  %xmm15, %xmm5
        subpd   %xmm3, %xmm5
        addpd   %xmm0, %xmm2
        addpd   %xmm5, %xmm1
        addpd   %xmm1, %xmm6
        mulpd   %xmm9, %xmm6
        subpd   %xmm6, %xmm11
        mulpd   %xmm11, %xmm10
        addpd   %xmm10, %xmm2
        addpd   %xmm2, %xmm9
        movapd  %xmm9, %xmm1
        cmpneqpd        %xmm9, %xmm1
        movapd  %xmm1, %xmm0
        movapd  (%rax), %xmm1
        cmpltpd -56(%rsp), %xmm1
        orpd    %xmm0, %xmm1
        movapd  %xmm1, %xmm5
        andpd   -120(%rsp), %xmm1
        movapd  184(%rsp), %xmm0
        andnpd  %xmm9, %xmm5
        movapd  %xmm0, %xmm2
        orpd    %xmm5, %xmm1
        cmpneqpd        %xmm0, %xmm2
        andpd   -88(%rsp), %xmm0
        addq    $336, %rsp
        pxor    %xmm1, %xmm0
        por     %xmm2, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_tanhd2_u10sse2, .-.LSleef_tanhd2_u10sse2
        .set .Lxtanh_u1, .LSleef_tanhd2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCTANH_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCTANH_2:
        .long   0
        .long   1071644672
        .long   0
        .long   1071644672
        .align 16
.LCTANH_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCTANH_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCTANH_89:
        .long   1023
        .long   1023
        .long   0
        .long   0
        .align 16
.LCTANH_90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCTANH_146:
        .quad   -134217728
        .quad   -134217728
        .align 16
.LCTANH_328:
        .long   1697350398
        .long   1073157447
        .long   1697350398
        .long   1073157447
        .align 16
.LCTANH_329:
        .long   -17158144
        .long   -1075433918
        .long   -17158144
        .long   -1075433918
        .align 16
.LCTANH_330:
        .long   -226956058
        .long   -1118577046
        .long   -226956058
        .long   -1118577046
        .align 16
.LCTANH_342:
        .long   0
        .long   -1064353792
        .long   0
        .long   -1064353792
        .align 16
.LCTANH_374:
        .long   -401589578
        .long   1046144594
        .long   -401589578
        .long   1046144594
        .align 16
.LCTANH_375:
        .long   -1784056228
        .long   1049787980
        .long   -1784056228
        .long   1049787980
        .align 16
.LCTANH_376:
        .long   -1591904682
        .long   1053236707
        .long   -1591904682
        .long   1053236707
        .align 16
.LCTANH_377:
        .long   452391095
        .long   1056571808
        .long   452391095
        .long   1056571808
        .align 16
.LCTANH_378:
        .long   436391938
        .long   1059717536
        .long   436391938
        .long   1059717536
        .align 16
.LCTANH_379:
        .long   381765068
        .long   1062650220
        .long   381765068
        .long   1062650220
        .align 16
.LCTANH_380:
        .long   286331161
        .long   1065423121
        .long   286331161
        .long   1065423121
        .align 16
.LCTANH_381:
        .long   1431655770
        .long   1067799893
        .long   1431655770
        .long   1067799893
        .align 16
.LCTANH_382:
        .long   -1467541172
        .long   1038485042
        .long   -1467541172
        .long   1038485042
        .align 16
.LCTANH_383:
        .long   -179820068
        .long   1042413802
        .long   -179820068
        .long   1042413802
        .align 16
.LCTANH_384:
        .long   1431655765
        .long   1069897045
        .long   1431655765
        .long   1069897045
        .align 16
.LCTANH_385:
        .long   1342177280
        .long   1069897045
        .long   1342177280
        .long   1069897045
        .align 16
.LCTANH_386:
        .long   1409286144
        .long   1042634069
        .long   1409286144
        .long   1042634069
        .align 16
.LCTANH_388:
        .long   -2027774320
        .long   1077065480
        .long   -2027774320
        .long   1077065480
