PROGRAM FILE 390: ACCURACY OF LOG10 FUNCTION.                                   
    ECMA-116 STANDARD                                                           
                                                                                
SECTION 390.1: ACCURACY OF LOG10 FUNCTION.                                      
                                                                                
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                        
LOG10 FUNCTION FOR ACCURACY.                                                    
                                                                                
THIS TEST IS INFORMATIVE ONLY, SINCE THE ECMA-116 STANDARD                      
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                           
                                                                                
              BEGIN TEST                                                        
                                                                                
  ARGUMENT        TRUE         COMPUTED         ACTUAL                          
   VALUE         ANSWER         ANSWER          ERROR                           
------------   ------------   ------------   ------------                       
 1.E-38        -38            -38                EXACT      OK                  
 1.00001E-38   -38            -38                EXACT      OK                  
 9.87654E-38   -37.0054       -37.0054           EXACT      OK                  
 8.98989E-37   -36.0462       -36.0462           EXACT      OK                  
 7.87878E-36   -35.1035       -35.1035           EXACT      OK                  
 6.76767E-35   -34.1696       -34.1696           EXACT      OK                  
 5.65656E-30   -29.2474       -29.2474           EXACT      OK                  
 4.54545E-25   -24.3424       -24.3424           EXACT      OK                  
 3.43434E-20   -19.4642       -19.4642           EXACT      OK                  
 2.32323E-15   -14.6339       -14.6339           EXACT      OK                  
 1.21212E-10   -9.91645       -9.91645           EXACT      OK                  
 9.0909E-07    -6.04139       -6.04139           EXACT      OK                  
 8.88888E-05   -4.05115       -4.05115           EXACT      OK                  
 7.77777E-04   -3.10914       -3.10914           EXACT      OK                  
 6.66666E-03   -2.17609       -2.17609           EXACT      OK                  
 5.55555E-02   -1.25527       -1.25527           EXACT      OK                  
 .123456       -.908488       -.908488           EXACT      OK                  
 .298347       -.525278       -.525278           EXACT      OK                  
 .535353       -.27136        -.27136            EXACT      OK                  
 .893481       -4.89147E-02   -4.89147E-02       EXACT      OK                  
 .999          -4.34512E-04   -4.34512E-04       EXACT      OK                  
 .9995         -2.17202E-04   -2.17202E-04    2.71051E-20   OK                  
 .9999         -4.34316E-05   -4.34316E-05       EXACT      OK                  
 .99995        -2.17153E-05   -2.17153E-05       EXACT      OK                  
 .99999        -4.34297E-06   -4.34297E-06       EXACT      OK                  
 .999995       -2.17148E-06   -2.17148E-06       EXACT      OK                  
 .999998       -8.6859E-07    -8.6859E-07        EXACT      OK                  
 .999999       -4.34295E-07   -4.34295E-07       EXACT      OK                  
 1              0              0                 EXACT      OK                  
 1.00001        4.34292E-06    4.34292E-06       EXACT      OK                  
 1.00002        8.6858E-06     8.6858E-06        EXACT      OK                  
 1.00005        2.17142E-05    2.17142E-05       EXACT      OK                  
 1.0001         4.34273E-05    4.34273E-05    6.77626E-21   OK                  
 1.0003         1.30269E-04    1.30269E-04    2.71051E-20   OK                  
 1.001          4.34077E-04    4.34077E-04       EXACT      OK                  
 1.003          1.30093E-03    1.30093E-03       EXACT      OK                  
 1.01           4.32137E-03    4.32137E-03       EXACT      OK                  
 1.03           1.28372E-02    1.28372E-02       EXACT      OK                  
 1.11111        4.57571E-02    4.57571E-02    6.93889E-18   OK                  
 1.54321        .188425        .188425           EXACT      OK                  
 2              .30103         .30103            EXACT      OK                  
 2.32323        .366092        .366092           EXACT      OK                  
 2.71828        .434294        .434294           EXACT      OK                  
 4              .60206         .60206            EXACT      OK                  
 7.14286        .853872        .853872           EXACT      OK                  
 8              .90309         .90309            EXACT      OK                  
 53.6789        1.7298         1.7298            EXACT      OK                  
 482.284        2.6833         2.6833            EXACT      OK                  
 9621.12        3.98323        3.98323           EXACT      OK                  
 86321.4        4.93612        4.93612           EXACT      OK                  
 777777         5.89086        5.89086           EXACT      OK                  
 9.87654E+07    7.9946         7.9946            EXACT      OK                  
 8.98989E+10    10.9538        10.9538        1.77636E-15   OK                  
 7.97979E+15    15.902         15.902            EXACT      OK                  
 6.96969E+20    20.8432        20.8432           EXACT      OK                  
 5.95959E+25    25.7752        25.7752           EXACT      OK                  
 4.94949E+30    30.6946        30.6946           EXACT      OK                  
 3.93939E+35    35.5954        35.5954           EXACT      OK                  
 9.87654E+36    36.9946        36.9946           EXACT      OK                  
 9.87654E+37    37.9946        37.9946           EXACT      OK                  
 1.E+38         38             38                EXACT      OK                  
                                                                                
          *** TEST PASSED ***                                                   
                                                                                
               END TEST                                                         
                                                                                
