PROGRAM FILE 390: ACCURACY OF LOG10 FUNCTION.                                                                                       
    ECMA-116 STANDARD                                                                                                               
                                                                                                                                    
SECTION 390.1: ACCURACY OF LOG10 FUNCTION.                                                                                          
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
LOG10 FUNCTION FOR ACCURACY.                                                                                                        
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ECMA-116 STANDARD                                                                          
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
  ARGUMENT                   TRUE                    COMPUTED                    ACTUAL                                             
   VALUE                    ANSWER                    ANSWER                     ERROR                                              
------------              ------------              ------------              ------------                                          
 1.E-38                   -38                       -38                           EXACT                 OK                          
 1.00001E-38              -37.999995657076894       -37.999995657076894           EXACT                 OK                          
 9.87654E-38              -37.00539517303243        -37.00539517303243            EXACT                 OK                          
 8.98989E-37              -36.04624562224733        -36.04624562224733            EXACT                 OK                          
 7.87878E-36              -35.10354102620177        -35.10354102620177            EXACT                 OK                          
 6.76767E-35              -34.16956082619142        -34.16956082619142            EXACT                 OK                          
 5.65656E-30              -29.247447601886048       -29.247447601886048           EXACT                 OK                          
 4.54545E-25              -24.342423115116905       -24.342423115116905           EXACT                 OK                          
 3.43434E-20              -19.464156711849995       -19.464156711849995           EXACT                 OK                          
 2.32323E-15              -14.633907792874655       -14.633907792874655           EXACT                 OK                          
 .000000000121212         -9.916454382844623        -9.916454382844623            EXACT                 OK                          
 .00000090909             -6.041393119452924        -6.041393119452924            EXACT                 OK                          
 .0000888888              -4.05115295674208         -4.05115295674208             EXACT                 OK                          
 .000777777               -3.109144903719767        -3.109144903719767            EXACT                 OK                          
 .00666666                -2.17609169335038         -2.17609169335038             EXACT                 OK                          
 .0555555                 -1.255272939398005        -1.255272939398005            EXACT                 OK                          
 .123456                  -.9084877983722284        -.9084877983722284            EXACT                 OK                          
 .298347                  -.5252783248049551        -.5252783248049551            EXACT                 OK                          
 .535353                  -.27135975929145995       -.27135975929145995           EXACT                 OK                          
 .893481                  -.04891467839380559       -.04891467839380559           EXACT                 OK                          
 .999                     -4.345117740176917E-04    -4.345117740176917E-04        EXACT                 OK                          
 .9995                    -2.172015458642319E-04    -2.1720154586423186E-04    2.710505431213761E-20    OK                          
 .9999                    -4.3431619807505604E-05   -4.3431619807505604E-05       EXACT                 OK                          
 .99995                   -2.171526698135886E-05    -2.171526698135886E-05        EXACT                 OK                          
 .99999                   -4.342966533881614E-06    -4.342966533881614E-06        EXACT                 OK                          
 .999995                  -2.1714778382296045E-06   -2.1714778382296045E-06       EXACT                 OK                          
 .999998                  -8.68589832373386E-07     -8.68589832373386E-07         EXACT                 OK                          
 .999999                  -4.34294699063126E-07     -4.34294699063126E-07         EXACT                 OK                          
 1                         0                         0                            EXACT                 OK                          
 1.00001                   4.342923104481638E-06     4.342923104481638E-06        EXACT                 OK                          
 1.00002                   8.685802780287228E-06     8.685802780287228E-06        EXACT                 OK                          
 1.00005                   2.171418124520096E-05     2.171418124520096E-05        EXACT                 OK                          
 1.0001                    4.342727686266485E-05     4.342727686266486E-05     6.776263578034403E-21    OK                          
 1.0003                    1.3026880522704664E-04    1.3026880522704667E-04    2.710505431213761E-20    OK                          
 1.001                     4.340774793185929E-04     4.340774793185929E-04        EXACT                 OK                          
 1.003                     1.300933020418072E-03     1.300933020418072E-03        EXACT                 OK                          
 1.01                      4.321373782642578E-03     4.321373782642578E-03        EXACT                 OK                          
 1.03                      1.2837224705172217E-02    1.2837224705172217E-02       EXACT                 OK                          
 1.11111                   4.5757056265976086E-02    .04575705626597609        6.938893903907228E-18    OK                          
 1.54321                   .1884250288729638         .1884250288729638            EXACT                 OK                          
 2                         .3010299956639812         .3010299956639812            EXACT                 OK                          
 2.32323                   .36609220712534396        .36609220712534396           EXACT                 OK                          
 2.71828                   .4342941897738882         .4342941897738882            EXACT                 OK                          
 4                         .6020599913279624         .6020599913279624            EXACT                 OK                          
 7.14286                   .85387213803952           .85387213803952              EXACT                 OK                          
 8                         .9030899869919435         .9030899869919435            EXACT                 OK                          
 53.6789                   1.729803607592663         1.729803607592663            EXACT                 OK                          
 482.284                   2.683302854235852         2.683302854235852            EXACT                 OK                          
 9621.12                   3.983225631446026         3.983225631446026            EXACT                 OK                          
 86321.4                   4.936118475318786         4.936118475318786            EXACT                 OK                          
 777777                    5.890855096280233         5.890855096280233            EXACT                 OK                          
 98765400                  7.9946048269675645        7.9946048269675645           EXACT                 OK                          
 89898900000               10.953754377752663        10.953754377752665        1.7763568394002505E-15   OK                          
 7979790000000000          15.901991462398193        15.901991462398193           EXACT                 OK                          
 6.96969E+20               20.843213461845007        20.843213461845007           EXACT                 OK                          
 5.95959E+25               25.775216382749896        25.775216382749896           EXACT                 OK                          
 4.94949E+30               30.694560451136265        30.694560451136265           EXACT                 OK                          
 3.93939E+35               35.59542897813425         35.59542897813425            EXACT                 OK                          
 9.87654E+36               36.99460482696757         36.99460482696757            EXACT                 OK                          
 9.87654E+37               37.99460482696757         37.99460482696757            EXACT                 OK                          
 1.E+38                    38                        38                           EXACT                 OK                          
                                                                                                                                    
          *** TEST PASSED ***                                                                                                       
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
