PROGRAM FILE 26: PRECEDENCE RULES FOR NUMERIC EXPRESSIONS.                                                                          
    ANSI STANDARD 7.2, 7.4                                                                                                          
                                                                                                                                    
THIS PROGRAM TESTS WHETHER THE PRECEDENCE RULES ARE                                                                                 
CORRECTLY IMPLEMENTED.                                                                                                              
                                                                                                                                    
SECTION 26.1: PRECEDENCE ACCORDING TO OPERATOR AND                                                                                  
        POSITION (LEFT TO RIGHT).                                                                                                   
                                                                                                                                    
THIS SECTION TESTS THE PRECEDENCE RULES USING SIMPLE                                                                                
INTEGER OPERANDS AND ALL ORDERED PAIRS OF OPERATORS                                                                                 
FOR WHICH THE ORDER OF EVALUATION MAKES A DIFFERENCE.                                                                               
NO PARENTHESES ARE USED.                                                                                                            
                                                                                                                                    
                  BEGIN TEST                                                                                                        
                                                                                                                                    
CASE #                    SHOULD BE                 ACTUAL                    OUTCOME                                               
                                                                                                                                    
1                          23                        23                       TEST PASSES                                           
2                          10                        10                       TEST PASSES                                           
3                          30                        30                       TEST PASSES                                           
4                          4                         4                        TEST PASSES                                           
5                         -6                        -6                        TEST PASSES                                           
6                         -10                       -10                       TEST PASSES                                           
7                          6                         6                        TEST PASSES                                           
8                         -5                        -5                        TEST PASSES                                           
9                          17                        17                       TEST PASSES                                           
10                         7                         7                        TEST PASSES                                           
11                         24                        24                       TEST PASSES                                           
12                         4                         4                        TEST PASSES                                           
13                         2                         2                        TEST PASSES                                           
14                         4                         4                        TEST PASSES                                           
15                         2                         2                        TEST PASSES                                           
16                         2                         2                        TEST PASSES                                           
17                         6                         6                        TEST PASSES                                           
18                         6                         6                        TEST PASSES                                           
19                         8                         8                        TEST PASSES                                           
20                         9                         9                        TEST PASSES                                           
21                         64                        64                       TEST PASSES                                           
22                         0                         0                        TEST PASSES                                           
23                        -4                        -4                        TEST PASSES                                           
24                        -4                        -4                        TEST PASSES                                           
                                                                                                                                    
*** TEST PASSED ***                                                                                                                 
                                                                                                                                    
                  END TEST                                                                                                          
                                                                                                                                    
SECTION 26.2: MIXED OPERATORS, PARENTHESES, AND VARIABLES                                                                           
                                                                                                                                    
THIS SECTION TESTS THE USE OF PARENTHESES TO ALTER THE                                                                              
ORDER OF EVALUATION, EXPRESSIONS WITH SEVERAL OPERATORS,                                                                            
AND THE USE OF VARIABLES AND CONSTANTS.                                                                                             
                                                                                                                                    
                   BEGIN TEST                                                                                                       
                                                                                                                                    
CASE #                    SHOULD BE                 ACTUAL                    OUTCOME                                               
                                                                                                                                    
1                          4                         4                        TEST PASSES                                           
2                          4                         4                        TEST PASSES                                           
3                          0                         0                        TEST PASSES                                           
4                          6                         6                        TEST PASSES                                           
5                         -16                       -16                       TEST PASSES                                           
6                          3                         3                        TEST PASSES                                           
7                         -5                        -5                        TEST PASSES                                           
                                                                                                                                    
*** TEST PASSED ***                                                                                                                 
                                                                                                                                    
                    END TEST                                                                                                        
                                                                                                                                    
END PROGRAM 26                                                                                                                      
