PROGRAM FILE 29: EXCEPTION - OVERFLOW OF NUMERIC EXPRESSIONS.                                                                       
    ANSI STANDARD 7.5                                                                                                               
                                                                                                                                    
THIS PROGRAM TESTS VARIOUS CASES OF NUMERIC OVERFLOW.                                                                               
                                                                                                                                    
SECTION 29.1: POSITIVE OVERFLOW                                                                                                     
                                                                                                                                    
THIS SECTION TESTS THE RESULT OF EXPRESSION EVALUATION                                                                              
EXCEEDING POSITIVE MACHINE INFINITY.                                                                                                
                                                                                                                                    
TO PASS THIS TEST:                                                                                                                  
                                                                                                                                    
    1) A MESSAGE IDENTIFYING THE EXCEPTION MUST BE                                                                                  
       DISPLAYED, AND                                                                                                               
                                                                                                                                    
    2) POSITIVE INFINITY MUST BE SUPPLIED AS THE VALUE                                                                              
       OF THE EXPRESSION AND EXECUTION CONTINUES.                                                                                   
                                                                                                                                    
               BEGIN TEST                                                                                                           
                                                                                                                                    
ABOUT TO COMPUTE  1.E+36  *  10                                                                                                     
RESULT =  1.0000000000000001E+37                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.0000000000000001E+37  *  12.589254117941675                                                                     
RESULT =  1.2589254117941676E+38                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.2589254117941676E+38  *  16.21810097358931                                                                      
RESULT =  2.041737944669531E+39                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  2.041737944669531E+39  *  21.428906011200606                                                                      
RESULT =  4.375221051582528E+40                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  4.375221051582528E+40  *  29.113874126187586                                                                      
RESULT =  1.273796349700198E+42                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.273796349700198E+42  *  40.78589529626015                                                                       
RESULT =  5.1952924547630655E+43                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  5.1952924547630655E+43  *  59.09639651795                                                                         
RESULT =  3.0702306293339195E+45                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  3.0702306293339195E+45  *  88.86220796871265                                                                      
RESULT =  2.7282747269578227E+47                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  2.7282747269578227E+47  *  139.18383863707643                                                                     
RESULT =  3.7973174935451134E+49                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  3.7973174935451134E+49  *  228.00674306334236                                                                     
RESULT =  8.658139940806759E+51                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  8.658139940806759E+51  *  392.41216301919997                                                                      
RESULT =  3.397559421894908E+54                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  3.397559421894908E+54  *  713.0446178321989                                                                       
RESULT =  2.4226114595472417E+57                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  2.4226114595472417E+57  *  1375.3979627336498                                                                     
RESULT =  3.33205486595647E+60                                                                                                      
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  3.33205486595647E+60  *  2833.160735957772                                                                        
RESULT =  9.440247016284909E+63                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  9.440247016284909E+63  *  6273.332921088484                                                                       
RESULT =  5.922181239046745E+67                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  5.922181239046745E+67  *  15040.011537629474                                                                      
RESULT =  8.906967416319586E+71                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  8.906967416319586E+71  *  39352.55969257338                                                                       
RESULT =  3.5051196693052257E+76                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  3.5051196693052257E+76  *  113362.72711636165                                                                     
RESULT =  3.973499245816401E+81                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  3.973499245816401E+81  *  363008.9339318833                                                                       
RESULT =  1.4424157252029541E+87                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.4424157252029541E+87  *  1305897.3628040925                                                                     
RESULT =  1.8836468916096904E+93                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.8836468916096904E+93  *  5339492.1127186045                                                                     
RESULT =  1.0057717720896858E+100                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.0057717720896858E+100  *  25133324.8324575                                                                      
RESULT =  2.5278388655246488E+107                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  2.5278388655246488E+107  *  138125842.07478952                                                                    
RESULT =  3.4915987192997276E+115                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  3.4915987192997276E+115  *  900124188.8276502                                                                     
RESULT =  3.1428724649213294E+124                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  3.1428724649213294E+124  *  7075101518.596477                                                                     
RESULT =  2.223614174931995E+134                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  2.223614174931995E+134  *  68344873402.55986                                                                      
RESULT =  1.5197262928186478E+145                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.5197262928186478E+145  *  828278784933.9053                                                                     
RESULT =  1.258757047247938E+157                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.258757047247938E+157  *  12882323220301.918                                                                     
RESULT =  1.621571513848079E+170                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.621571513848079E+170  *  263629260034487.47                                                                     
RESULT =  4.2749369828877275E+184                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  4.2749369828877275E+184  *  7296136857949718                                                                      
RESULT =  3.119052528625951E+200                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  3.119052528625951E+200  *  2.8145065836120374E+17                                                                 
RESULT =  8.778593876449512E+217                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  8.778593876449512E+217  *  1.5643808672042537E+19                                                                 
RESULT =  1.373306430127404E+237                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.373306430127404E+237  *  1.2995013809519198E+21                                                                 
RESULT =  1.7846136024207125E+258                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.7846136024207125E+258  *  1.679401048094026E+23                                                                 
RESULT =  2.9970819543482E+281                                                                                                      
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  2.9970819543482E+281  *  3.529147921650811E+25                                                                    
RESULT =  1.05771455502051E+307                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.05771455502051E+307  *  1.2660091603080607E+28                                                                  
ARITHMETIC OVERFLOW ON LINE NUMBER 260                                                                                              
RESULT =  INFINITY                                                                                                                  
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  INFINITY  *  8.178629466169412E+30                                                                                
ARITHMETIC OVERFLOW ON LINE NUMBER 260                                                                                              
RESULT =  INFINITY                                                                                                                  
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
LAST TWO MULTIPLICATIONS SHOULD HAVE BEEN REPORTED                                                                                  
AS OVERFLOW, AND POSITIVE INFINITY SUPPLIED; IF SO,                                                                                 
*** TEST PASSED *** OTHERWISE *** TEST FAILED ***                                                                                   
                                                                                                                                    
                END TEST                                                                                                            
                                                                                                                                    
SECTION 29.2: NEGATIVE OVERFLOW                                                                                                     
                                                                                                                                    
THIS SECTION TESTS THE RESULT OF EXPRESSION EVALUATION                                                                              
EXCEEDING NEGATIVE MACHINE INFINITY.                                                                                                
                                                                                                                                    
TO PASS THIS TEST:                                                                                                                  
                                                                                                                                    
    1) A MESSAGE IDENTIFYING THE EXCEPTION MUST BE                                                                                  
       DISPLAYED, AND                                                                                                               
                                                                                                                                    
    2) NEGATIVE INFINITY MUST BE SUPPLIED AS THE VALUE                                                                              
       OF THE EXPRESSION AND EXECUTION CONTINUES.                                                                                   
                                                                                                                                    
               BEGIN TEST                                                                                                           
                                                                                                                                    
ABOUT TO COMPUTE -1.E+36  *  10                                                                                                     
RESULT = -1.0000000000000001E+37                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.0000000000000001E+37  *  12.589254117941675                                                                     
RESULT = -1.2589254117941676E+38                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.2589254117941676E+38  *  16.21810097358931                                                                      
RESULT = -2.041737944669531E+39                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -2.041737944669531E+39  *  21.428906011200606                                                                      
RESULT = -4.375221051582528E+40                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -4.375221051582528E+40  *  29.113874126187586                                                                      
RESULT = -1.273796349700198E+42                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.273796349700198E+42  *  40.78589529626015                                                                       
RESULT = -5.1952924547630655E+43                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -5.1952924547630655E+43  *  59.09639651795                                                                         
RESULT = -3.0702306293339195E+45                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -3.0702306293339195E+45  *  88.86220796871265                                                                      
RESULT = -2.7282747269578227E+47                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -2.7282747269578227E+47  *  139.18383863707643                                                                     
RESULT = -3.7973174935451134E+49                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -3.7973174935451134E+49  *  228.00674306334236                                                                     
RESULT = -8.658139940806759E+51                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -8.658139940806759E+51  *  392.41216301919997                                                                      
RESULT = -3.397559421894908E+54                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -3.397559421894908E+54  *  713.0446178321989                                                                       
RESULT = -2.4226114595472417E+57                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -2.4226114595472417E+57  *  1375.3979627336498                                                                     
RESULT = -3.33205486595647E+60                                                                                                      
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -3.33205486595647E+60  *  2833.160735957772                                                                        
RESULT = -9.440247016284909E+63                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -9.440247016284909E+63  *  6273.332921088484                                                                       
RESULT = -5.922181239046745E+67                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -5.922181239046745E+67  *  15040.011537629474                                                                      
RESULT = -8.906967416319586E+71                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -8.906967416319586E+71  *  39352.55969257338                                                                       
RESULT = -3.5051196693052257E+76                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -3.5051196693052257E+76  *  113362.72711636165                                                                     
RESULT = -3.973499245816401E+81                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -3.973499245816401E+81  *  363008.9339318833                                                                       
RESULT = -1.4424157252029541E+87                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.4424157252029541E+87  *  1305897.3628040925                                                                     
RESULT = -1.8836468916096904E+93                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.8836468916096904E+93  *  5339492.1127186045                                                                     
RESULT = -1.0057717720896858E+100                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.0057717720896858E+100  *  25133324.8324575                                                                      
RESULT = -2.5278388655246488E+107                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -2.5278388655246488E+107  *  138125842.07478952                                                                    
RESULT = -3.4915987192997276E+115                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -3.4915987192997276E+115  *  900124188.8276502                                                                     
RESULT = -3.1428724649213294E+124                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -3.1428724649213294E+124  *  7075101518.596477                                                                     
RESULT = -2.223614174931995E+134                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -2.223614174931995E+134  *  68344873402.55986                                                                      
RESULT = -1.5197262928186478E+145                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.5197262928186478E+145  *  828278784933.9053                                                                     
RESULT = -1.258757047247938E+157                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.258757047247938E+157  *  12882323220301.918                                                                     
RESULT = -1.621571513848079E+170                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.621571513848079E+170  *  263629260034487.47                                                                     
RESULT = -4.2749369828877275E+184                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -4.2749369828877275E+184  *  7296136857949718                                                                      
RESULT = -3.119052528625951E+200                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -3.119052528625951E+200  *  2.8145065836120374E+17                                                                 
RESULT = -8.778593876449512E+217                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -8.778593876449512E+217  *  1.5643808672042537E+19                                                                 
RESULT = -1.373306430127404E+237                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.373306430127404E+237  *  1.2995013809519198E+21                                                                 
RESULT = -1.7846136024207125E+258                                                                                                   
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.7846136024207125E+258  *  1.679401048094026E+23                                                                 
RESULT = -2.9970819543482E+281                                                                                                      
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -2.9970819543482E+281  *  3.529147921650811E+25                                                                    
RESULT = -1.05771455502051E+307                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.05771455502051E+307  *  1.2660091603080607E+28                                                                  
ARITHMETIC OVERFLOW ON LINE NUMBER 670                                                                                              
RESULT = -INFINITY                                                                                                                  
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -INFINITY  *  8.178629466169412E+30                                                                                
ARITHMETIC OVERFLOW ON LINE NUMBER 670                                                                                              
RESULT = -INFINITY                                                                                                                  
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
LAST TWO MULTIPLICATIONS SHOULD HAVE BEEN REPORTED                                                                                  
AS OVERFLOW, AND NEGATIVE INFINITY SUPPLIED; IF SO,                                                                                 
*** TEST PASSES *** OTHERWISE *** TEST FAILS ***                                                                                    
                                                                                                                                    
                END TEST                                                                                                            
                                                                                                                                    
END PROGRAM 29                                                                                                                      
