PROGRAM FILE 29: EXCEPTION - OVERFLOW OF NUMERIC EXPRESSIONS.                                                                       
    ANSI STANDARD 7.5                                                                                                               
                                                                                                                                    
THIS PROGRAM TESTS VARIOUS CASES OF NUMERIC OVERFLOW.                                                                               
                                                                                                                                    
SECTION 29.1: POSITIVE OVERFLOW                                                                                                     
                                                                                                                                    
THIS SECTION TESTS THE RESULT OF EXPRESSION EVALUATION                                                                              
EXCEEDING POSITIVE MACHINE INFINITY.                                                                                                
                                                                                                                                    
TO PASS THIS TEST:                                                                                                                  
                                                                                                                                    
    1) A MESSAGE IDENTIFYING THE EXCEPTION MUST BE                                                                                  
       DISPLAYED, AND                                                                                                               
                                                                                                                                    
    2) POSITIVE INFINITY MUST BE SUPPLIED AS THE VALUE                                                                              
       OF THE EXPRESSION AND EXECUTION CONTINUES.                                                                                   
                                                                                                                                    
               BEGIN TEST                                                                                                           
                                                                                                                                    
ABOUT TO COMPUTE  9.999999616903162E+35  *  10                                                                                      
RESULT =  9.999999933815813E+36                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  9.999999933815813E+36  *  12.589254379272461                                                                      
RESULT =  1.2589254118528825E+38                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  1.2589254118528825E+38  *  16.218101501464844                                                                     
ARITHMETIC OVERFLOW ON LINE NUMBER 260                                                                                              
RESULT =  INFINITY                                                                                                                  
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE  INFINITY  *  21.428911209106445                                                                                   
ARITHMETIC OVERFLOW ON LINE NUMBER 260                                                                                              
RESULT =  INFINITY                                                                                                                  
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
LAST TWO MULTIPLICATIONS SHOULD HAVE BEEN REPORTED                                                                                  
AS OVERFLOW, AND POSITIVE INFINITY SUPPLIED; IF SO,                                                                                 
*** TEST PASSED *** OTHERWISE *** TEST FAILED ***                                                                                   
                                                                                                                                    
                END TEST                                                                                                            
                                                                                                                                    
SECTION 29.2: NEGATIVE OVERFLOW                                                                                                     
                                                                                                                                    
THIS SECTION TESTS THE RESULT OF EXPRESSION EVALUATION                                                                              
EXCEEDING NEGATIVE MACHINE INFINITY.                                                                                                
                                                                                                                                    
TO PASS THIS TEST:                                                                                                                  
                                                                                                                                    
    1) A MESSAGE IDENTIFYING THE EXCEPTION MUST BE                                                                                  
       DISPLAYED, AND                                                                                                               
                                                                                                                                    
    2) NEGATIVE INFINITY MUST BE SUPPLIED AS THE VALUE                                                                              
       OF THE EXPRESSION AND EXECUTION CONTINUES.                                                                                   
                                                                                                                                    
               BEGIN TEST                                                                                                           
                                                                                                                                    
ABOUT TO COMPUTE -9.999999616903162E+35  *  10                                                                                      
RESULT = -9.999999933815813E+36                                                                                                     
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -9.999999933815813E+36  *  12.589254379272461                                                                      
RESULT = -1.2589254118528825E+38                                                                                                    
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -1.2589254118528825E+38  *  16.218101501464844                                                                     
ARITHMETIC OVERFLOW ON LINE NUMBER 670                                                                                              
RESULT = -INFINITY                                                                                                                  
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
ABOUT TO COMPUTE -INFINITY  *  21.428911209106445                                                                                   
ARITHMETIC OVERFLOW ON LINE NUMBER 670                                                                                              
RESULT = -INFINITY                                                                                                                  
                                                                                                                                    
----------------------------------------                                                                                            
                                                                                                                                    
LAST TWO MULTIPLICATIONS SHOULD HAVE BEEN REPORTED                                                                                  
AS OVERFLOW, AND NEGATIVE INFINITY SUPPLIED; IF SO,                                                                                 
*** TEST PASSES *** OTHERWISE *** TEST FAILS ***                                                                                    
                                                                                                                                    
                END TEST                                                                                                            
                                                                                                                                    
END PROGRAM 29                                                                                                                      
