PROGRAM FILE 95: GENERAL USE OF THE READ, DATA,                                                                                     
        AND RESTORE STATEMENTS.                                                                                                     
    ANSI STANDARD 14.2, 14.4                                                                                                        
                                                                                                                                    
SECTION 95.1: GENERAL SYNTAX AND SEMANTICS OF READ AND DATA                                                                         
                                                                                                                                    
THIS SECTION EXERCISES SOME OF THE GENERAL CAPABILITIES                                                                             
AND PROPERTIES OF THE READ AND DATA STATEMENTS, AS LISTED:                                                                          
  1) READ AND DATA CAN MIX STRING AND NUMERIC DATA                                                                                  
  2) CONTROL FALLS THROUGH DATA STATEMENTS WITHOUT EFFECT                                                                           
  3) DATA STATEMENTS MAY BE SCATTERED THROUGHOUT SOURCE                                                                             
  4) READ AND DATA LISTS CAN OVERLAP                                                                                                
  5) READ CAN ACCESS DATA ANYWHERE IN SOURCE                                                                                        
                                                                                                                                    
                BEGIN TEST                                                                                                          
                                                                                                                                    
                                                                                                                                    
SHOULD BE:                 1                        A                          2                        B                           
ACTUAL:                    1                        A                          2                        B                           
READ OK                                                                                                                             
                                                                                                                                    
SHOULD BE:                 3                         4                         5                        C                           
ACTUAL:                    3                         4                         5                        C                           
READ OK                                                                                                                             
                                                                                                                                    
SHOULD BE:                D                         E                         F                         6                           
7                          8                                                                                                        
ACTUAL:                   D                         E                         F                         6                           
7                          8                                                                                                        
READ OK                                                                                                                             
                                                                                                                                    
SHOULD BE:                9                                                                                                         
ACTUAL:                   9                                                                                                         
READ OK                                                                                                                             
                                                                                                                                    
SHOULD BE:                 10                        11                                                                             
ACTUAL:                    10                        11                                                                             
READ OK                                                                                                                             
                                                                                                                                    
*** TEST PASSED ***                                                                                                                 
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
SECTION 95.2: RESTORE STATEMENT                                                                                                     
                                                                                                                                    
THIS SECTION TESTS THE CAPABILITY OF THE RESTORE STATEMENT                                                                          
TO ENABLE READING FROM THE BEGINNING OF THE DATA SEQUENCE.                                                                          
FURTHERMORE, DATA VALUES WHICH WERE ORIGINALLY READ AS                                                                              
NUMERIC MAY BE SUBSEQUENTLY READ AS STRINGS, AND                                                                                    
VICE-VERSA, AS LONG AS DATA-TYPE IS COMPATIBLE WITH                                                                                 
VARIABLE-TYPE.                                                                                                                      
                                                                                                                                    
               BEGIN TEST                                                                                                           
                                                                                                                                    
EXECUTE FIRST RESTORE                                                                                                               
                                                                                                                                    
SHOULD BE:                1                         A                         2                         B                           
3                         4                         5                                                                               
ACTUAL:                   1                         A                         2                         B                           
3                         4                         5                                                                               
READ OK                                                                                                                             
                                                                                                                                    
SHOULD BE:                C                         D                         E                         F                           
 6                         7                        8                                                                               
ACTUAL:                   C                         D                         E                         F                           
 6                         7                        8                                                                               
READ OK                                                                                                                             
                                                                                                                                    
EXECUTE SECOND RESTORE                                                                                                              
                                                                                                                                    
                                                                                                                                    
SHOULD BE:                 1                        A                         2                         B                           
 3                                                                                                                                  
ACTUAL:                    1                        A                         2                         B                           
 3                                                                                                                                  
READ OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
*** TEST PASSED ***                                                                                                                 
                                                                                                                                    
              END TEST                                                                                                              
                                                                                                                                    
END PROGRAM 95                                                                                                                      
