PROGRAM FILE 107: INPUT OF NUMERIC CONSTANTS.                                                                                       
    ANSI STANDARD 5.2, 13.2, 13.4                                                                                                   
                                                                                                                                    
SECTION 107.1: INPUT OF NUMERIC CONSTANTS.                                                                                          
                                                                                                                                    
 THIS SECTION TESTS THE PROCESSOR'S CAPABILITY TO INPUT                                                                             
 NUMERIC VALUES CORRECTLY. IF AN INPUT VALUE IS NOT ACCURATE                                                                        
 TO AT LEAST SIX DIGITS, IT IS COUNTED AS A FAILURE.                                                                                
                                                                                                                                    
 ENTER THE NUMBERS BELOW EXACTLY AS REQUESTED.                                                                                      
 FOR USER CONVENIENCE, THE NUMBER TO BE ENTERED IS INDENTED                                                                         
 TWO SPACES, SO THAT IF THE INPUT-PROMPT OCCUPIES TWO                                                                               
 POSITIONS, AS RECOMMENDED, YOUR INPUT-REPLY WILL BE                                                                                
 ALIGNED WITH THE PROMPT STRING.                                                                                                    
                                                                                                                                    
ALL THE REPLIES PROMPTED FOR ARE VALID, THEREFORE                                                                                   
IF THE PROCESSOR REJECTS ANY OF THEM,                                                                                               
***  TEST FAILED  ***                                                                                                               
                                                                                                                                    
                 BEGIN TEST                                                                                                         
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  +.999999E38                                                                                                                       
? +.999999E38                                                                                                                       
SHOULD BE                 ACTUAL                    RESULT                                                                          
 9.99999E+37               9.99998953908089E+37     PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  -.999999E38                                                                                                                       
? -.999999E38                                                                                                                       
SHOULD BE                 ACTUAL                    RESULT                                                                          
-9.99999E+37              -9.99998953908089E+37     PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  +1.00001E-38                                                                                                                      
? +1.00001E-38                                                                                                                      
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.00001E-38               1.0000100243945835E-38   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  -1.00001E-38                                                                                                                      
? -1.00001E-38                                                                                                                      
SHOULD BE                 ACTUAL                    RESULT                                                                          
-1.00001E-38              -1.0000100243945835E-38   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  9.99999E-38                                                                                                                       
? 9.99999E-38                                                                                                                       
SHOULD BE                 ACTUAL                    RESULT                                                                          
 9.99999E-38               9.999989821626847E-38    PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  9.87654E37                                                                                                                        
? 9.87654E37                                                                                                                        
SHOULD BE                 ACTUAL                    RESULT                                                                          
 9.87654E+37               9.876539638907785E+37    PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123456                                                                                                                            
? 123456                                                                                                                            
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123456                    123456                   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123456.                                                                                                                           
? 123456.                                                                                                                           
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123456                    123456                   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123456.0                                                                                                                          
? 123456.0                                                                                                                          
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123456                    123456                   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  987.654                                                                                                                           
? 987.654                                                                                                                           
SHOULD BE                 ACTUAL                    RESULT                                                                          
 987.654                   987.6539916992188        PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  1234560                                                                                                                           
? 1234560                                                                                                                           
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23456E+6                1234560                  PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123456000                                                                                                                         
? 123456000                                                                                                                         
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23456E+8                123456000                PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  .0123456                                                                                                                          
? .0123456                                                                                                                          
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23456E-2                1.2345599941909313E-02   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  .000123456                                                                                                                        
? .000123456                                                                                                                        
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23456E-4                1.23456004075706E-04     PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  .12                                                                                                                               
? .12                                                                                                                               
SHOULD BE                 ACTUAL                    RESULT                                                                          
 .12                       .11999999731779099       PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  +.12                                                                                                                              
? +.12                                                                                                                              
SHOULD BE                 ACTUAL                    RESULT                                                                          
 .12                       .11999999731779099       PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  -.12                                                                                                                              
? -.12                                                                                                                              
SHOULD BE                 ACTUAL                    RESULT                                                                          
-.12                      -.11999999731779099       PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  0.12                                                                                                                              
? 0.12                                                                                                                              
SHOULD BE                 ACTUAL                    RESULT                                                                          
 .12                       .11999999731779099       PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  0.0                                                                                                                               
? 0.0                                                                                                                               
SHOULD BE                 ACTUAL                    RESULT                                                                          
 0                         0                        PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  +0                                                                                                                                
? +0                                                                                                                                
SHOULD BE                 ACTUAL                    RESULT                                                                          
 0                         0                        PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  -.000                                                                                                                             
? -.000                                                                                                                             
SHOULD BE                 ACTUAL                    RESULT                                                                          
 0                         0                        PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  1.23E9                                                                                                                            
? 1.23E9                                                                                                                            
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23000E+9                1230000000               PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  1.23E09                                                                                                                           
? 1.23E09                                                                                                                           
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23000E+9                1230000000               PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  1.23E+9                                                                                                                           
? 1.23E+9                                                                                                                           
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23000E+9                1230000000               PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  1.23E-9                                                                                                                           
? 1.23E-9                                                                                                                           
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23000E-9                1.2299999907483539E-09   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  1.23E-09                                                                                                                          
? 1.23E-09                                                                                                                          
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23000E-9                1.2299999907483539E-09   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  1.23E-0009                                                                                                                        
? 1.23E-0009                                                                                                                        
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23000E-9                1.2299999907483539E-09   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  000001.2300000E-000009                                                                                                            
? 000001.2300000E-000009                                                                                                            
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23000E-9                1.2299999907483539E-09   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  0E0                                                                                                                               
? 0E0                                                                                                                               
SHOULD BE                 ACTUAL                    RESULT                                                                          
 0                         0                        PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  000.000E22                                                                                                                        
? 000.000E22                                                                                                                        
SHOULD BE                 ACTUAL                    RESULT                                                                          
 0                         0                        PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  +000E55                                                                                                                           
? +000E55                                                                                                                           
SHOULD BE                 ACTUAL                    RESULT                                                                          
 0                         0                        PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  0.0E-000                                                                                                                          
? 0.0E-000                                                                                                                          
SHOULD BE                 ACTUAL                    RESULT                                                                          
 0                         0                        PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123E0                                                                                                                             
? 123E0                                                                                                                             
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123                       123                      PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123E000                                                                                                                           
? 123E000                                                                                                                           
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123                       123                      PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123E-00                                                                                                                           
? 123E-00                                                                                                                           
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123                       123                      PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123E+0                                                                                                                            
? 123E+0                                                                                                                            
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123                       123                      PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  12345678901234567890                                                                                                              
? 12345678901234567890                                                                                                              
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23457E+19               1.2345679395506094E+19   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123456E10                                                                                                                         
? 123456E10                                                                                                                         
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23456E+15               1234560029294592         PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  0.0000123456E-10                                                                                                                  
? 0.0000123456E-10                                                                                                                  
SHOULD BE                 ACTUAL                    RESULT                                                                          
 1.23456E-15               1.2345600497437994E-15   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123456000000000E-9                                                                                                                
? 123456000000000E-9                                                                                                                
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123456                    123456                   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  0.000000000123456E15                                                                                                              
? 0.000000000123456E15                                                                                                              
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123456                    123456                   PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  .00987654E40                                                                                                                      
? .00987654E40                                                                                                                      
SHOULD BE                 ACTUAL                    RESULT                                                                          
 9.87654E+37               9.876539638907785E+37    PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  987.654E-40                                                                                                                       
? 987.654E-40                                                                                                                       
SHOULD BE                 ACTUAL                    RESULT                                                                          
 9.87654E-38               9.876539911074916E-38    PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  123456.E-3                                                                                                                        
? 123456.E-3                                                                                                                        
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123.456                   123.45600128173828       PASS                                                                            
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  .123456E3                                                                                                                         
? .123456E3                                                                                                                         
SHOULD BE                 ACTUAL                    RESULT                                                                          
 123.456                   123.45600128173828       PASS                                                                            
                                                                                                                                    
                                                                                                                                    
***** TEST PASSED. *****                                                                                                            
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 107                                                                                                                     
