PROGRAM FILE 110: MIXED INPUT OF STRINGS AND NUMBERS.                                                                               
    ANSI STANDARD 13.2, 13.4                                                                                                        
                                                                                                                                    
SECTION 110.1: MIXED INPUT OF STRINGS AND NUMBERS.                                                                                  
                                                                                                                                    
PLEASE ENTER YOUR INPUT-REPLIES EXACTLY AS REQUESTED                                                                                
BY THE PROMPT, INCLUDING ALL SPACING, COMMAS AND OTHER                                                                              
PUNCTUATION.                                                                                                                        
                                                                                                                                    
 - EXCEPT - WHEREVER THE PROMPT CONTAINS AN EQUALS (=)                                                                              
SUBSTITUTE A BLANK SPACE, AND WHEREVER THE PROMPT                                                                                   
CONTAINS A NUMBER-SIGN (#) SUBSTITUTE A QUOTE.                                                                                      
THUS, THE PROMPT:                                                                                                                   
             ==#ER#==                                                                                                               
SHOULD CAUSE YOU TO STRIKE THE KEYS:                                                                                                
  1. SPACE                                                                                                                          
  2. SPACE                                                                                                                          
  3. QUOTE                                                                                                                          
  4. LETTER E                                                                                                                       
  5. LETTER R                                                                                                                       
  6. QUOTE                                                                                                                          
  7. SPACE                                                                                                                          
  8. SPACE                                                                                                                          
                                                                                                                                    
THESE CONVENTIONS ARE NECESSARY BECAUSE THE QUOTE IS                                                                                
UNPRINTABLE IN MINIMAL BASIC, AND SPACES ARE DIFFICULT                                                                              
TO COUNT ON A TERMINAL.                                                                                                             
                                                                                                                                    
PLEASE NOTE THAT THIS ROUTINE IS STRONGLY DEPENDENT                                                                                 
ON THE CORRECT OPERATION OF THE STRING COMPARISON                                                                                   
FEATURE. IF THAT FEATURE IS INCORRECT, THIS ROUTINE                                                                                 
WILL LIKELY GIVE INVALID RESULTS.                                                                                                   
                                                                                                                                    
ALL THE REPLIES PROMPTED FOR ARE VALID, THEREFORE                                                                                   
IF THE PROCESSOR REJECTS ANY OF THEM,                                                                                               
***  TEST FAILED  ***                                                                                                               
                                                                                                                                    
FOR USER CONVENIENCE, THE STRING TO BE ENTERED IS INDENTED                                                                          
TWO SPACES, SO THAT IF THE INPUT-PROMPT OCCUPIES TWO                                                                                
POSITIONS, AS RECOMMENDED, YOUR INPUT-REPLY WILL BE                                                                                 
ALIGNED WITH THE PROMPT STRING.                                                                                                     
                                                                                                                                    
               BEGIN TEST                                                                                                           
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  ==1==,==2==,==3==                                                                                                                 
?   1  ,  2  ,  3                                                                                                                   
SHOULD BE: *** 1  2  3 ***                                                                                                          
ACTUAL   : *** 1  2  3 ***                                                                                                          
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  ==+987999E32==,==-1.00000E-37==,==3.E37==                                                                                         
?   +987999E32  ,  -1.00000E-37  ,  3.E37                                                                                           
SHOULD BE: *** 9.879989676781366E+37 -9.99999991097579E-38  3.000000106909804E+37 ***                                               
ACTUAL   : *** 9.879989676781366E+37 -9.99999991097579E-38  3.000000106909804E+37 ***                                               
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  ===222222,111111==,==333333                                                                                                       
?    222222,111111  ,  333333                                                                                                       
SHOULD BE: *** 222222  111111  333333 ***                                                                                           
ACTUAL   : *** 222222  111111  333333 ***                                                                                           
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  5,6                                                                                                                               
? 5,6                                                                                                                               
SHOULD BE: *** 5  6 ***                                                                                                             
ACTUAL   : *** 5  6 ***                                                                                                             
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  -05.34,345.567E-11                                                                                                                
? -05.34,345.567E-11                                                                                                                
SHOULD BE: ***-5.340000152587891  3.4556699723964357E-09 ***                                                                        
ACTUAL   : ***-5.340000152587891  3.4556699723964357E-09 ***                                                                        
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  2E2,-3.45                                                                                                                         
? 2E2,-3.45                                                                                                                         
SHOULD BE: *** 200 -3.450000047683716 ***                                                                                           
ACTUAL   : *** 200 -3.450000047683716 ***                                                                                           
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  -0000.000123456E-11,+1E37                                                                                                         
? -0000.000123456E-11,+1E37                                                                                                         
SHOULD BE: ***-1.2345600497437994E-15  9.999999933815813E+36 ***                                                                    
ACTUAL   : ***-1.2345600497437994E-15  9.999999933815813E+36 ***                                                                    
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  -000.E-00,+.000,0E22                                                                                                              
? -000.E-00,+.000,0E22                                                                                                              
SHOULD BE: *** 0  0  0 ***                                                                                                          
ACTUAL   : *** 0  0  0 ***                                                                                                          
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  -999.E-00,+.999,9E22                                                                                                              
? -999.E-00,+.999,9E22                                                                                                              
SHOULD BE: ***-999  .9990000128746033  8.999999800376678E+22 ***                                                                    
ACTUAL   : ***-999  .9990000128746033  8.999999800376678E+22 ***                                                                    
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  ABC,##,#DEF#                                                                                                                      
? ABC,"","DEF"                                                                                                                      
SHOULD BE: ***ABCDEF***                                                                                                             
ACTUAL   : ***ABCDEF***                                                                                                             
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  ==4.56789E-11==,==MIDDLE=ITEM==,==9==                                                                                             
?   4.56789E-11  ,  MIDDLE ITEM  ,  9                                                                                               
SHOULD BE: *** 4.5678901633428026E-11 MIDDLE ITEM 9 ***                                                                             
ACTUAL   : *** 4.5678901633428026E-11 MIDDLE ITEM 9 ***                                                                             
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  ==987654===,===#==MIDDLE=ITEM==#==,==656565==                                                                                     
?   987654   ,   "  MIDDLE ITEM  "  ,  656565                                                                                       
SHOULD BE: *** 987654   MIDDLE ITEM   656565 ***                                                                                    
ACTUAL   : *** 987654   MIDDLE ITEM   656565 ***                                                                                    
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  ==AN=UNQUOTED=STRING===,==3.14159==,==#EQUALS=PI#==                                                                               
?   AN UNQUOTED STRING   ,  3.14159  ,  "EQUALS PI"                                                                                 
SHOULD BE: ***AN UNQUOTED STRING 3.141590118408203 EQUALS PI***                                                                     
ACTUAL   : ***AN UNQUOTED STRING 3.141590118408203 EQUALS PI***                                                                     
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  07676760000000E0000022===,==========X=========,X                                                                                  
? 07676760000000E0000022   ,          X         ,X                                                                                  
SHOULD BE: *** 7.676759822985962E+34 XX***                                                                                          
ACTUAL   : *** 7.676759822985962E+34 XX***                                                                                          
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  =====##=====,===5===,=====THIRD=ITEM=====                                                                                         
?      ""     ,   5   ,     THIRD ITEM                                                                                              
SHOULD BE: *** 5 THIRD ITEM***                                                                                                      
ACTUAL   : *** 5 THIRD ITEM***                                                                                                      
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  ==========#=#==,===0====,====##===                                                                                                
?           " "  ,   0    ,    ""                                                                                                   
SHOULD BE: ***  0 ***                                                                                                               
ACTUAL   : ***  0 ***                                                                                                               
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  ==+333.333E-33==,==+333.333E-33==                                                                                                 
?    +333.333E-33  ,  +333.333E-33                                                                                                  
SHOULD BE: *** 3.333330052519407E-31 +333.333E-33***                                                                                
ACTUAL   : *** 3.333330052519407E-31 +333.333E-33***                                                                                
TEST OK                                                                                                                             
                                                                                                                                    
                                                                                                                                    
PLEASE ENTER:                                                                                                                       
  1,2================3,4                                                                                                            
? 1,2                3,4                                                                                                            
SHOULD BE: *** 1 2                3 4 ***                                                                                           
ACTUAL   : *** 1 2                3 4 ***                                                                                           
TEST OK                                                                                                                             
                                                                                                                                    
***  TEST PASSED  ***                                                                                                               
                                                                                                                                    
                   END TEST                                                                                                         
                                                                                                                                    
END PROGRAM 110                                                                                                                     
