PROGRAM FILE 115: EVALUATION OF INT FUNCTION.                                                                                       
    ANSI STANDARD 8.4                                                                                                               
                                                                                                                                    
SECTION 115.1: EVALUATION OF INT FUNCTION.                                                                                          
                                                                                                                                    
THIS SECTION TESTS WHETHER THE INT NUMERIC-SUPPLIED-FUNCTION                                                                        
RETURNS THE GREATEST INTEGER LESS THAN OR EQUAL TO                                                                                  
THE VALUE OF THE ARGUMENT PASSED TO THE FUNCTION.                                                                                   
                                                                                                                                    
                BEGIN TEST                                                                                                          
                                                                                                                                    
                          CORRECT                   ACTUAL                    TEST                                                  
ARGUMENT                  VALUE                     VALUE                     RESULT                                                
                                                                                                                                    
 3                         3                         3                         OK                                                   
-3                        -3                        -3                         OK                                                   
 2.0999999046325684        2                         2                         OK                                                   
 2.9000000953674316        2                         2                         OK                                                   
-2.0999999046325684       -3                        -3                         OK                                                   
-2.9000000953674316       -3                        -3                         OK                                                   
 1                         1                         1                         OK                                                   
-1                        -1                        -1                         OK                                                   
 0                         0                         0                         OK                                                   
 .10000000149011612        0                         0                         OK                                                   
 .8999999761581421         0                         0                         OK                                                   
-.10000000149011612       -1                        -1                         OK                                                   
-.8999999761581421        -1                        -1                         OK                                                   
 1234.199951171875         1234                      1234                      OK                                                   
 1234.9000244140625        1234                      1234                      OK                                                   
-12345.599609375          -12346                    -12346                     OK                                                   
 3.9999899864196777        3                         3                         OK                                                   
-44.000099182128906       -45                       -45                        OK                                                   
-12300                    -12300                    -12300                     OK                                                   
-4.559999942779541        -5                        -5                         OK                                                   
 78.9999008178711          78                        78                        OK                                                   
 9.999999350456404E-39     0                         0                         OK                                                   
 .12345678359270096        0                         0                         OK                                                   
 1.2345600032152304E-31    0                         0                         OK                                                   
-9.999999350456404E-39    -1                        -1                         OK                                                   
-.12345678359270096       -1                        -1                         OK                                                   
-1.2345600032152304E-31   -1                        -1                         OK                                                   
                                                                                                                                    
*** TEST PASSED ***                                                                                                                 
                                                                                                                                    
                END TEST                                                                                                            
                                                                                                                                    
                                                                                                                                    
SECTION 115.2 EVALUATION OF INT FUNCTION FOR VALUES                                                                                 
        OF LARGE MAGNITUDE.                                                                                                         
                                                                                                                                    
THIS IS AN INFORMATIVE TEST TO EXAMINE THE BEHAVIOR OF                                                                              
THE INT FUNCTION WHEN THE RESULT DEPENDS ON CALCULATION                                                                             
BEYOND SIX DECIMAL DIGITS. THIS SECTION IS NOT CONSIDERED                                                                           
EITHER TO PASS OR FAIL.                                                                                                             
                                                                                                                                    
               BEGIN TEST                                                                                                           
                                                                                                                                    
                          CORRECT                   ACTUAL                                                                          
ARGUMENT                  VALUE                     VALUE                                                                           
                                                                                                                                    
987654.1                  987654                     987654                                                                         
987654.9                  987654                     987654                                                                         
1234567.9                 1234567                    1234567                                                                        
12345678.9                12345678                   12345679                                                                       
123456789.9               123456789                  123456792                                                                      
1234567890.9              1234567890                 1234567936                                                                     
-987654.1                 -987655                   -987655                                                                         
-987654.9                 -987655                   -987655                                                                         
-1234567.1                -1234568                  -1234568                                                                        
-12345678.1               -12345679                 -12345678                                                                       
-123456789.1              -123456790                -123456792                                                                      
-1234567890.1             -1234567891               -1234567936                                                                     
                                                                                                                                    
                END TEST                                                                                                            
                                                                                                                                    
END PROGRAM 115                                                                                                                     
