PROGRAM FILE 117: ACCURACY OF SQR FUNCTION.                                                                                         
    ANSI STANDARD 7.6, 8.4                                                                                                          
                                                                                                                                    
SECTION 117.1: ACCURACY OF SQR FUNCTION.                                                                                            
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
SQR FUNCTION FOR ACCURACY. THE INVOCATION MUST RETURN,                                                                              
ACCURATE TO SIX DIGITS, SOME VALUE ACTUALLY TAKEN ON BY                                                                             
THE FUNCTION WITHIN A DOMAIN BOUNDED BY THE ACTUAL ARGUMENT                                                                         
PLUS OR MINUS ONE IN THE SIXTH DIGIT. ALSO, AN                                                                                      
'ERROR MEASURE' IS COMPUTED AND REPORTED. THIS MEASURE                                                                              
IS JUST 2 * THE ABSOLUTE ERROR OVER THE SIZE OF THE RANGE;                                                                          
THUS, A VALUE JUST BARELY PASSING OR FAILING WILL USUALLY                                                                           
HAVE A MEASURE OF ABOUT 1. A VALUE 3 TIMES                                                                                          
AS INACCURATE AS EXPECTED WILL HAVE A MEASURE OF 3.                                                                                 
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ANSI STANDARD                                                                              
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
ARGUMENT                  TRUE                      COMPUTED                  ERROR                     OUTCOME                     
                          VALUE                     VALUE                     MEASURE                                               
                                                                                                                                    
 0                         0                         0                        RANGE ZERO                 OK  - EXACT                
 1.E-38                    1.E-19                    1.E-19                    0                         OK  - EXACT                
 9.99999E-38               3.16227608E-19            3.162276079029154E-19     1.4732114704331931E-04    OK                         
 9.E-38                    3.E-19                    3.E-19                    0                         OK  - EXACT                
 9.99999E-37               9.999995E-19              9.99999499999875E-19      3.845342359389994E-08     OK                         
 9.99999E-31               9.999995E-16              9.99999499999875E-16      1.2497196749657635E-07    OK                         
 1.23456E-20               1.11110756E-10            1.1111075555498667E-10    4.681886731834358E-04     OK                         
 .0000654321               .00808901106              .00808901106440089        3.934635114129651E-04     OK                         
 .5                        .707106781                .7071067811865476         1.5449072892267376E-04    OK                         
 1                         1                         1                         0                         OK  - EXACT                
 .999999                   .9999995                  .999999499999875          3.8459040939223074E-08    OK                         
 2                         1.41421356                1.4142135623730951        2.778799828821056E-04     OK                         
 3                         1.73205081                1.7320508075688772        3.0812710501627394E-04    OK                         
 4                         2                         2                         0                         OK  - EXACT                
 5                         2.23606798                2.23606797749979          3.4533290898613794E-04    OK                         
 9.99999                   3.16227608                3.162276079029154         1.4732103582597227E-04    OK                         
 10                        3.16227766                3.1622776601683795        8.08739349370113E-06      OK                         
 40000                     200                       200                       0                         OK  - EXACT                
 123456000                 11111.0756                11111.075555498666        4.681886778769599E-04     OK                         
 6.54321E+20               25579699000               25579698981.809772        2.6135384351357645E-04    OK                         
 9.99999E+31               9999995000000000          9999994999998750          1.249375312343828E-07     OK                         
 9.E+36                    3.E+18                    3.E+18                    0                         OK  - EXACT                
 1.E+38                    1.E+19                    1.E+19                    0                         OK  - EXACT                
                                                                                                                                    
*** INFORMATIVE TEST PASSED ***                                                                                                     
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 117                                                                                                                     
