PROGRAM FILE 119: ACCURACY OF ATN FUNCTION.                                                                                         
    ANSI STANDARD 7.6, 8.4                                                                                                          
                                                                                                                                    
SECTION 119.1: ACCURACY OF ATN FUNCTION.                                                                                            
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
ATN FUNCTION FOR ACCURACY. THE INVOCATION MUST RETURN,                                                                              
ACCURATE TO SIX DIGITS, SOME VALUE ACTUALLY TAKEN ON BY                                                                             
THE FUNCTION WITHIN A DOMAIN BOUNDED BY THE ACTUAL ARGUMENT                                                                         
PLUS OR MINUS ONE IN THE SIXTH DIGIT. ALSO, AN                                                                                      
'ERROR MEASURE' IS COMPUTED AND REPORTED. THIS MEASURE                                                                              
IS JUST 2 * THE ABSOLUTE ERROR OVER THE SIZE OF THE RANGE;                                                                          
THUS, A VALUE JUST BARELY PASSING OR FAILING WILL USUALLY                                                                           
HAVE A MEASURE OF ABOUT  1. A VALUE 3 TIMES                                                                                         
AS INACCURATE AS EXPECTED WILL HAVE A MEASURE OF 3-                                                                                 
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ANSI STANDARD                                                                              
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
ARGUMENT                  TRUE                      COMPUTED                  ERROR                     OUTCOME                     
                          VALUE                     VALUE                     MEASURE                                               
                                                                                                                                    
-1.E+38                   -1.57079633               -1.5707963267948966        6.403803228616708E-04     OK                         
-9.99999E+37              -1.57079633               -1.5707963267948966        6.403803228616708E-04     OK                         
-3.E+30                   -1.57079633               -1.5707963267948966        6.403803228616708E-04     OK                         
-2.E+20                   -1.57079633               -1.5707963267948966        6.403803228616708E-04     OK                         
-90000000000              -1.57079633               -1.5707963267837854        6.426003252653558E-04     OK                         
-900000                   -1.57079522               -1.5707952156837854        8.623805188656121E-04     OK                         
-300000                   -1.57079299               -1.5707929934615632        6.916210306202023E-04     OK                         
-200000                   -1.57079133               -1.5707913267948967        6.403802784971143E-04     OK                         
-100000                   -1.57078633               -1.570786326794897         6.403802341325579E-04     OK                         
-98765.4                  -1.5707862                -1.5707862017916063        3.5796332043485393E-04    OK                         
-9876.54                  -1.57069508               -1.5706950767623364        6.468858083226851E-04     OK                         
-987.6                    -1.56978377               -1.5697837714503808        2.8978639889516445E-04    OK                         
-98.7                     -1.56066496               -1.5606649611929762        2.3788158769984954E-04    OK                         
-9.8                      -1.46910748               -1.4691074750318196        9.731988857281084E-04     OK                         
-8.8                      -1.45764535               -1.457645345204412         9.33902225272553E-04      OK                         
-7.7                      -1.44164904               -1.4416490366668766        6.447047065559939E-04     OK                         
-6.6                      -1.4204249                -1.4204248987877621        2.3178544276326667E-04    OK                         
-5.5                      -1.39094283               -1.3909428270024184        5.629261063489488E-04     OK                         
-4.4                      -1.34731973               -1.3473197256542637        7.908528144331623E-04     OK                         
-3.3                      -1.27656176               -1.2765617616837088        2.8805966261660174E-04    OK                         
-2.2                      -1.14416883               -1.1441688336680205        5.462428226351711E-04     OK                         
-1.1                      -.832981267               -.8329812666744317         6.478325321581303E-05     OK                         
-.9                       -.732815102               -.7328151017865067         2.0274770572451493E-04    OK                         
-.6                       -.5404195                 -.5404195002705842         2.1891918339959706E-04    OK                         
-.1                       -.0996686525              -.09966865249116204        8.49681117445576E-06      OK                         
-.09                      -.0897581742              -.08975817418995052        6.733316677133371E-05     OK                         
-.009                     -.00899975701             -8.999757011809117E-03     1.2056761694831787E-04    OK                         
-.006                     -.005999928               -.00599992800155516        1.0364282001108132E-04    OK                         
-.003                     -.002999991               -2.9999910000485996E-03    3.2399719481590573E-06    OK                         
-.002                     -.00199999733             -1.9999973333397333E-03    2.2257470427819583E-04    OK                         
-.001                     -.000999999667            -9.999996666668668E-04     2.6124000984976792E-05    OK                         
-.0009                    -.000899999757            -8.99999757000118E-04      7.871307772120827E-08     OK                         
-.0004                    -.000399999979            -3.9999997866666876E-04    2.221467749899341E-04     OK                         
-.00009                   -.0000899999998           -8.999999975700001E-05     2.865710543655415E-04     OK                         
-.0000000009              -.0000000009              -.0000000009               0                         OK  - EXACT                
-9.E-20                   -9.E-20                   -9.E-20                    0                         OK  - EXACT                
-9.E-30                   -9.E-30                   -9.E-30                    0                         OK  - EXACT                
-9.E-38                   -9.E-38                   -9.E-38                    0                         OK  - EXACT                
 0                         0                         0                        RANGE ZERO                 OK  - EXACT                
 9.E-38                    9.E-38                    9.E-38                    0                         OK  - EXACT                
 9.E-30                    9.E-30                    9.E-30                    0                         OK  - EXACT                
 9.E-20                    9.E-20                    9.E-20                    0                         OK  - EXACT                
 .0000000009               .0000000009               .0000000009               0                         OK  - EXACT                
 .00009                    .0000899999998            8.999999975700001E-05     2.865710543655415E-04     OK                         
 .0004                     .000399999979             3.9999997866666876E-04    2.221467749899341E-04     OK                         
 .0009                     .000899999757             8.99999757000118E-04      7.871307772120827E-08     OK                         
 .001                      .000999999667             9.999996666668668E-04     2.6124000984976792E-05    OK                         
 .002                      .00199999733              1.9999973333397333E-03    2.2257470427819583E-04    OK                         
 .003                      .002999991                2.9999910000485996E-03    3.2399719481590573E-06    OK                         
 .006                      .005999928                .00599992800155516        1.0364282001108132E-04    OK                         
 .009                      .00899975701              8.999757011809117E-03     1.2056761694831787E-04    OK                         
 .09                       .0897581742               .08975817418995052        6.733316677133371E-05     OK                         
 .1                        .0996686525               .09966865249116204        8.49681117445576E-06      OK                         
 .6                        .5404195                  .5404195002705842         2.1891918339959706E-04    OK                         
 .9                        .732815102                .7328151017865067         2.0274770572451493E-04    OK                         
 1.1                       .832981267                .8329812666744317         6.478325321581303E-05     OK                         
 2.2                       1.14416883                1.1441688336680205        5.462428226351711E-04     OK                         
 3.3                       1.27656176                1.2765617616837088        2.8805966261660174E-04    OK                         
 4.4                       1.34731973                1.3473197256542637        7.908528144331623E-04     OK                         
 5.5                       1.39094283                1.3909428270024184        5.629261063489488E-04     OK                         
 6.6                       1.4204249                 1.4204248987877621        2.3178544276326667E-04    OK                         
 7.7                       1.44164904                1.4416490366668766        6.447047065559939E-04     OK                         
 8.8                       1.45764535                1.457645345204412         9.33902225272553E-04      OK                         
 9.9                       1.47012767                1.4701276746370677        9.083384170066858E-04     OK                         
 98.7                      1.56066496                1.5606649611929762        2.3788158769984954E-04    OK                         
 987.6                     1.56978377                1.5697837714503808        2.8978639889516445E-04    OK                         
 9876.54                   1.57069508                1.5706950767623364        6.468858083226851E-04     OK                         
 98765.4                   1.5707862                 1.5707862017916063        3.5796332043485393E-04    OK                         
 100000                    1.57078633                1.570786326794897         6.403802341325579E-04     OK                         
 200000                    1.57079133                1.5707913267948967        6.403802784971143E-04     OK                         
 300000                    1.57079299                1.5707929934615632        6.916210306202023E-04     OK                         
 900000                    1.57079522                1.5707952156837854        8.623805188656121E-04     OK                         
 90000000000               1.57079633                1.5707963267837854        6.426003252653558E-04     OK                         
 2.E+20                    1.57079633                1.5707963267948966        6.403803228616708E-04     OK                         
 3.E+30                    1.57079633                1.5707963267948966        6.403803228616708E-04     OK                         
 9.99999E+37               1.57079633                1.5707963267948966        6.403803228616708E-04     OK                         
 1.E+38                    1.57079633                1.5707963267948966        6.403803228616708E-04     OK                         
                                                                                                                                    
*** INFORMATIVE TEST PASSED ***                                                                                                     
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 119                                                                                                                     
