PROGRAM FILE 119: ACCURACY OF ATN FUNCTION.                                                                                         
    ANSI STANDARD 7.6, 8.4                                                                                                          
                                                                                                                                    
SECTION 119.1: ACCURACY OF ATN FUNCTION.                                                                                            
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
ATN FUNCTION FOR ACCURACY. THE INVOCATION MUST RETURN,                                                                              
ACCURATE TO SIX DIGITS, SOME VALUE ACTUALLY TAKEN ON BY                                                                             
THE FUNCTION WITHIN A DOMAIN BOUNDED BY THE ACTUAL ARGUMENT                                                                         
PLUS OR MINUS ONE IN THE SIXTH DIGIT. ALSO, AN                                                                                      
'ERROR MEASURE' IS COMPUTED AND REPORTED. THIS MEASURE                                                                              
IS JUST 2 * THE ABSOLUTE ERROR OVER THE SIZE OF THE RANGE;                                                                          
THUS, A VALUE JUST BARELY PASSING OR FAILING WILL USUALLY                                                                           
HAVE A MEASURE OF ABOUT  1. A VALUE 3 TIMES                                                                                         
AS INACCURATE AS EXPECTED WILL HAVE A MEASURE OF 3-                                                                                 
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ANSI STANDARD                                                                              
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
ARGUMENT                  TRUE                      COMPUTED                  ERROR                     OUTCOME                     
                          VALUE                     VALUE                     MEASURE                                               
                                                                                                                                    
-9.999999680285692E+37    -1.5707963705062866       -1.5707963705062866        0                         OK  - EXACT                
-9.99998953908089E+37     -1.5707963705062866       -1.5707963705062866        0                         OK  - EXACT                
-2.999999894026671E+30    -1.5707963705062866       -1.5707963705062866        0                         OK  - EXACT                
-2.0000000400817547E+20   -1.5707963705062866       -1.5707963705062866        0                         OK  - EXACT                
-89999998976              -1.5707963705062866       -1.5707963705062866        0                         OK  - EXACT                
-900000                   -1.5707951784133911       -1.5707951784133911        0                         OK  - EXACT                
-300000                   -1.5707930326461792       -1.5707930326461792        0                         OK  - EXACT                
-200000                   -1.5707913637161255       -1.5707913637161255        0                         OK  - EXACT                
-100000                   -1.5707863569259644       -1.5707863569259644        0                         OK  - EXACT                
-98765.3984375            -1.5707862377166748       -1.5707862377166748        0                         OK  - EXACT                
-9876.5400390625          -1.5706950426101685       -1.5706950426101685        0                         OK  - EXACT                
-987.5999755859375        -1.5697838068008423       -1.5697838068008423        0                         OK  - EXACT                
-98.69999694824219        -1.5606650114059448       -1.5606650114059448        0                         OK  - EXACT                
-9.800000190734863        -1.4691075086593628       -1.4691075086593628        0                         OK  - EXACT                
-8.800000190734863        -1.457645297050476        -1.457645297050476         0                         OK  - EXACT                
-7.699999809265137        -1.441649079322815        -1.441649079322815         0                         OK  - EXACT                
-6.599999904632568        -1.4204249382019043       -1.4204249382019043        0                         OK  - EXACT                
-5.5                      -1.3909428119659424       -1.3909428119659424        0                         OK  - EXACT                
-4.400000095367432        -1.3473197221755981       -1.3473197221755981        0                         OK  - EXACT                
-3.299999952316284        -1.2765617370605469       -1.2765617370605469        0                         OK  - EXACT                
-2.200000047683716        -1.1441688537597656       -1.1441688537597656        0                         OK  - EXACT                
-1.100000023841858        -.832981288433075         -.832981288433075          0                         OK  - EXACT                
-.8999999761581421        -.7328150868415833        -.7328150868415833         0                         OK  - EXACT                
-.6000000238418579        -.5404195189476013        -.5404195189476013         0                         OK  - EXACT                
-.10000000149011612       -.09966865181922913       -.09966865181922913        0                         OK  - EXACT                
-.09000000357627869       -.08975817263126373       -.08975818008184433        .05000000074505806        OK                         
-8.999999612569809E-03    -8.999757468700409E-03    -8.999756537377834E-03     .06060606241226196        OK                         
-6.000000052154064E-03    -5.9999278746545315E-03   -5.9999278746545315E-03    0                         OK  - EXACT                
-3.000000026077032E-03    -2.9999909456819296E-03   -2.9999909456819296E-03    0                         OK  - EXACT                
-2.0000000949949026E-03   -1.9999973010271788E-03   -1.9999975338578224E-03    .01550387591123581        OK                         
-1.0000000474974513E-03   -9.999996982514858E-04    -9.999996982514858E-04     0                         OK  - EXACT                
-8.999999845400453E-04    -8.999997517094016E-04    -8.999997517094016E-04     0                         OK  - EXACT                
-3.9999998989515007E-04   -3.9999998989515007E-04   -3.999999607913196E-04     1.9417475908994675E-02    OK                         
-9.000000136438757E-05    -9.000000136438757E-05    -9.000000136438757E-05     0                         OK  - EXACT                
-9.000000189551827E-10    -9.000000189551827E-10    -9.000000189551827E-10     0                         OK  - EXACT                
-8.999999714389703E-20    -8.999999714389703E-20    -8.999999714389703E-20     0                         OK  - EXACT                
-9.000000028539692E-30    -9.000000028539692E-30    -9.000000028539692E-30     0                         OK  - EXACT                
-9.000000256189842E-38    -9.000000256189842E-38    -9.000000256189842E-38     0                         OK  - EXACT                
 0                         0                         0                        RANGE ZERO                 OK  - EXACT                
 9.000000256189842E-38     9.000000256189842E-38     9.000000256189842E-38     0                         OK  - EXACT                
 9.000000028539692E-30     9.000000028539692E-30     9.000000028539692E-30     0                         OK  - EXACT                
 8.999999714389703E-20     8.999999714389703E-20     8.999999714389703E-20     0                         OK  - EXACT                
 9.000000189551827E-10     9.000000189551827E-10     9.000000189551827E-10     0                         OK  - EXACT                
 9.000000136438757E-05     9.000000136438757E-05     9.000000136438757E-05     0                         OK  - EXACT                
 3.9999998989515007E-04    3.9999998989515007E-04    3.999999607913196E-04     1.9417475908994675E-02    OK                         
 8.999999845400453E-04     8.999997517094016E-04     8.999997517094016E-04     0                         OK  - EXACT                
 1.0000000474974513E-03    9.999996982514858E-04     9.999996982514858E-04     0                         OK  - EXACT                
 2.0000000949949026E-03    1.9999973010271788E-03    1.9999975338578224E-03    .01550387591123581        OK                         
 3.000000026077032E-03     2.9999909456819296E-03    2.9999909456819296E-03    0                         OK  - EXACT                
 6.000000052154064E-03     5.9999278746545315E-03    5.9999278746545315E-03    0                         OK  - EXACT                
 8.999999612569809E-03     8.999757468700409E-03     8.999756537377834E-03     .06060606241226196        OK                         
 .09000000357627869        .08975817263126373        .08975818008184433        .05000000074505806        OK                         
 .10000000149011612        .09966865181922913        .09966865181922913        0                         OK  - EXACT                
 .6000000238418579         .5404195189476013         .5404195189476013         0                         OK  - EXACT                
 .8999999761581421         .7328150868415833         .7328150868415833         0                         OK  - EXACT                
 1.100000023841858         .832981288433075          .832981288433075          0                         OK  - EXACT                
 2.200000047683716         1.1441688537597656        1.1441688537597656        0                         OK  - EXACT                
 3.299999952316284         1.2765617370605469        1.2765617370605469        0                         OK  - EXACT                
 4.400000095367432         1.3473197221755981        1.3473197221755981        0                         OK  - EXACT                
 5.5                       1.3909428119659424        1.3909428119659424        0                         OK  - EXACT                
 6.599999904632568         1.4204249382019043        1.4204249382019043        0                         OK  - EXACT                
 7.699999809265137         1.441649079322815         1.441649079322815         0                         OK  - EXACT                
 8.800000190734863         1.457645297050476         1.457645297050476         0                         OK  - EXACT                
 9.899999618530273         1.4701277017593384        1.4701277017593384        0                         OK  - EXACT                
 98.69999694824219         1.5606650114059448        1.5606650114059448        0                         OK  - EXACT                
 987.5999755859375         1.5697838068008423        1.5697838068008423        0                         OK  - EXACT                
 9876.5400390625           1.5706950426101685        1.5706950426101685        0                         OK  - EXACT                
 98765.3984375             1.5707862377166748        1.5707862377166748        0                         OK  - EXACT                
 100000                    1.5707863569259644        1.5707863569259644        0                         OK  - EXACT                
 200000                    1.5707913637161255        1.5707913637161255        0                         OK  - EXACT                
 300000                    1.5707930326461792        1.5707930326461792        0                         OK  - EXACT                
 900000                    1.5707951784133911        1.5707951784133911        0                         OK  - EXACT                
 89999998976               1.5707963705062866        1.5707963705062866        0                         OK  - EXACT                
 2.0000000400817547E+20    1.5707963705062866        1.5707963705062866        0                         OK  - EXACT                
 2.999999894026671E+30     1.5707963705062866        1.5707963705062866        0                         OK  - EXACT                
 9.99998953908089E+37      1.5707963705062866        1.5707963705062866        0                         OK  - EXACT                
 9.999999680285692E+37     1.5707963705062866        1.5707963705062866        0                         OK  - EXACT                
                                                                                                                                    
*** INFORMATIVE TEST PASSED ***                                                                                                     
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 119                                                                                                                     
