PROGRAM FILE 121: ACCURACY OF EXP FUNCTION.                                                                                         
    ANSI STANDARD 7.6, 8.4                                                                                                          
                                                                                                                                    
SECTION 121.1: ACCURACY OF EXP FUNCTION.                                                                                            
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
EXP FUNCTION FOR ACCURACY. THE INVOCATION MUST RETURN,                                                                              
ACCURATE TO SIX DIGITS, SOME VALUE ACTUALLY TAKEN ON BY                                                                             
THE FUNCTION WITHIN A DOMAIN BOUNDED BY THE ACTUAL ARGUMENT                                                                         
PLUS OR MINUS ONE IN THE SIXTH DIGIT. ALSO, AN                                                                                      
'ERROR MEASURE' IS COMPUTED AND REPORTED. THIS MEASURE                                                                              
IS JUST 2 * THE ABSOLUTE ERROR OVER THE SIZE OF THE RANGE;                                                                          
THUS, A VALUE JUST BARELY PASSING OR FAILING WILL USUALLY                                                                           
HAVE A MEASURE OF ABOUT  1. A VALUE 3 TIMES                                                                                         
AS INACCURATE AS EXPECTED WILL HAVE A MEASURE OF 3.                                                                                 
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ANSI STANDARD                                                                              
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
ARGUMENT                  TRUE                      COMPUTED                  ERROR                     OUTCOME                     
                          VALUE                     VALUE                     MEASURE                                               
                                                                                                                                    
-87.4981                   1.00013354E-38            1.0001335426897735E-38    2.561201265205748E-05     OK                         
-85.9876                   4.52959954E-38            4.5295995397846797E-38    4.7016787475466183E-07    OK                         
-75                        2.67863696E-33            2.6786369618080778E-33    6.6262719184189615E-06    OK                         
-44.4444                   4.98933114E-20            4.989331135917826E-20     8.100515987483493E-06     OK                         
-23.4567                   6.49957001E-11            6.499570013436728E-11     5.247192380563262E-06     OK                         
-7.77777                   .000418945382             4.189453818997936E-04     2.1365972283634673E-05    OK                         
-2.22222                   .108368264                .10836826403999282        2.5247989024973275E-05    OK                         
-1                         .367879441                .36787944117144233        4.1024733263328866E-05    OK                         
-.999999                   .367879809                .36787980905106743        5.8833442470964E-05       OK                         
-.456789                   .633313955                .6333139552104154         1.85551554522702E-04      OK                         
-.0987654                  .90595522                 .9059552201895532         3.207330997925725E-04     OK                         
-.00987654                 .990172073                .990172072847307          2.991047392381781E-04     OK                         
-.000987654                .999012834                .999012833569682          8.580618213939074E-04     OK                         
-.0000987654               .999901239                .9999012394771416         9.533297672200797E-04     OK                         
-.00000987654              .999990124                .9999901235087728         9.814728672360988E-04     OK                         
-.000000987654             .999999012                .9999990123464877         6.922831716248986E-04     OK                         
-.0000000987654            .999999901                .9999999012346049         4.687410410977264E-04     OK                         
-.00000000987654           .99999999                 .9999999901234601         2.4667358842623947E-04    OK                         
-.000000000987654          .999999999                .999999999012346          2.4667358839888057E-05    OK                         
-9.87654E-15               1                         .9999999999999901         1.974222760851809E-08     OK                         
-9.87654E-20               1                         1                         0                         OK  - EXACT                
-9.87654E-30               1                         1                         0                         OK  - EXACT                
-9.87654E-38               1                         1                         0                         OK  - EXACT                
 0                         1                         1                        RANGE ZERO                 OK  - EXACT                
 9.87654E-38               1                         1                         0                         OK  - EXACT                
 9.87654E-30               1                         1                         0                         OK  - EXACT                
 9.87654E-20               1                         1                         0                         OK  - EXACT                
 9.87654E-15               1                         1.0000000000000098        1.9520404828564944E-09    OK                         
 .000000000987654          1                         1.000000000987654         1.973334582651073E-04     OK                         
 .00000000987654           1.00000001                1.00000000987654          2.4689512841455314E-05    OK                         
 .0000000987654            1.0000001                 1.000000098765405         2.4686964463310664E-04    OK                         
 .000000987654             1.00000099                1.0000009876544877        4.689617572507569E-04     OK                         
 .00000987654              1.00000988                1.0000098765887733        6.815637631360742E-04     OK                         
 .0000987654               1.00009877                1.0000987702774626        5.5437106786552296E-05    OK                         
 .000987654                1.00098814                1.000988141890821         3.777864246319309E-04     OK                         
 .00987654                 1.00992547                1.009925473988003         7.952149629031356E-04     OK                         
 .0987654                  1.10380732                1.1038073159849664        7.849528130778775E-04     OK                         
 .456789                   1.57899568                1.5789956810090424        1.5323347079646457E-04    OK                         
 .999999                   2.71827911                2.718279110178576         2.3131583005028456E-05    OK                         
 1                         2.71828183                2.7182818284590455        4.787059568568213E-05     OK                         
 2.22222                   9.22779385                9.227793845908193         4.2059988745873125E-05    OK                         
 7.77777                   2386.94599                2386.9459915402226        5.3341037445670753E-05    OK                         
 23.4567                   15385633200               15385633171.62019         1.7864104952791335E-05    OK                         
 44.4444                   2.00427667E+19            2.0042766710773592E+19    5.244409295623813E-06     OK                         
 75                        3.733242E+32              3.7332419967990015E+32    8.460975741159035E-06     OK                         
 85.9876                   2.20770068E+37            2.207700683507965E+37     1.553743806584884E-05     OK                         
 87.4981                   9.99866475E+37            9.998664751414954E+37     1.408095797992095E-06     OK                         
                                                                                                                                    
*** INFORMATIVE TEST PASSED ***                                                                                                     
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 121                                                                                                                     
