PROGRAM FILE 124: ACCURACY OF LOG FUNCTION.                                                                                         
    ANSI STANDARD 7.6, 8.4                                                                                                          
                                                                                                                                    
SECTION 124.1: ACCURACY OF LOG FUNCTION.                                                                                            
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
LOG FUNCTION FOR ACCURACY. THE INVOCATION MUST RETURN,                                                                              
ACCURATE TO SIX DIGITS, SOME VALUE ACTUALLY TAKEN ON BY                                                                             
THE FUNCTION WITHIN A DOMAIN BOUNDED BY THE ACTUAL ARGUMENT                                                                         
PLUS OR MINUS ONE IN THE SIXTH DIGIT. ALSO, AN                                                                                      
'ERROR MEASURE' IS COMPUTED AND REPORTED. THIS MEASURE                                                                              
IS JUST 2 * THE ABSOLUTE ERROR OVER THE SIZE OF THE RANGE;                                                                          
THUS, A VALUE JUST BARELY PASSING OR FAILING WILL USUALLY                                                                           
HAVE A MEASURE OF ABOUT 1. A VALUE 3 TIMES                                                                                          
AS INACCURATE AS EXPECTED WILL HAVE A MEASURE OF 3.                                                                                 
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ANSI STANDARD                                                                              
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
ARGUMENT                  TRUE                      COMPUTED                  ERROR                     OUTCOME                     
                          VALUE                     VALUE                     MEASURE                                               
                                                                                                                                    
 9.999999350456404E-39    -87.49822998046875        -87.49822998046875         0                         OK  - EXACT                
 1.0000100243945835E-38   -87.49822235107422        -87.49822235107422         0                         OK  - EXACT                
 9.876539911074916E-38    -85.20806884765625        -85.20806884765625         0                         OK  - EXACT                
 8.989889719613923E-37    -82.99954986572266        -82.99954986572266         0                         OK  - EXACT                
 7.878780302443745E-36    -80.82888793945312        -80.82888793945312         0                         OK  - EXACT                
 6.76766995256931E-35     -78.6783218383789         -78.6783218383789          0                         OK  - EXACT                
 5.656560066326376E-30    -67.34473419189453        -67.34473419189453         0                         OK  - EXACT                
 4.545450062471942E-25    -56.050498962402344       -56.050498962402344        0                         OK  - EXACT                
 3.434339842868518E-20    -44.81787872314453        -44.81787872314453         0                         OK  - EXACT                
 2.3232298975095966E-15   -33.69581604003906        -33.69581985473633         .06896551698446274        OK                         
 1.2121199877146438E-10   -22.833480834960938       -22.833480834960938        0                         OK  - EXACT                
 9.090899766306393E-07    -13.910821914672852       -13.910821914672852        0                         OK  - EXACT                
 8.888880256563425E-05    -9.328124046325684        -9.328124046325684         0                         OK  - EXACT                
 7.777769933454692E-04    -7.1590704917907715       -7.1590704917907715        0                         OK  - EXACT                
 6.666659843176603E-03    -5.010636329650879        -5.010636329650879         0                         OK  - EXACT                
 .05555550009012222       -2.8903727531433105       -2.8903727531433105        0                         OK  - EXACT                
 .12345600128173828       -2.0918705463409424       -2.0918705463409424        0                         OK  - EXACT                
 .29834699630737305       -1.2094980478286743       -1.2094980478286743        0                         OK  - EXACT                
 .5353530049324036        -.6248289346694946        -.6248289346694946         0                         OK  - EXACT                
 .8934810161590576        -.1126302108168602        -.11263018846511841        1.3793103396892548E-02    OK                         
 .9990000128746033        -1.0005002841353416E-03   -1.0004874784499407E-03    1.2758060358464718E-02    OK                         
 .9994999766349792        -5.001250538043678E-04    -5.001483950763941E-04     .02331802062690258        OK                         
 .9998999834060669        -1.0000500333262607E-04   -1.0002159251598641E-04    .01658296398818493        OK                         
 .9999499917030334        -5.00012502016034E-05     -5.0009548431262374E-05    8.297396823763847E-03     OK                         
 .9999899864196777        -1.0000049769587349E-05   -1.0013630344474223E-05    1.3580064289271832E-02    OK                         
 .9999949932098389        -5.000012606615201E-06    -5.006802894058637E-06     6.790220271795988E-03     OK                         
 .9999979734420776        -2.0000020413135644E-06   -2.0265599687263602E-06    2.6557743549346924E-02    OK                         
 .9999989867210388        -1.0000004522225936E-06   -1.0132795296158292E-06    1.0623232461512089E-02    OK                         
 1                         0                         0                         0                         OK  - EXACT                
 1.0000100135803223        9.999949725170154E-06     1.0013530300057027E-05    1.3580676168203354E-03    OK                         
 1.0000200271606445        1.9999799405923113E-05    2.002696055569686E-05     2.7161617763340473E-03    OK                         
 1.0000499486923218        4.9998750910162926E-05    4.994744449504651E-05     5.1308730617165565E-03    OK                         
 1.000100016593933         9.999499889090657E-05     1.0001159535022452E-04    1.6597661888226867E-03    OK                         
 1.0003000497817993        2.999550197273493E-04     3.000047872774303E-04     .00497799925506115        OK                         
 1.0010000467300415        9.995002765208483E-04     9.995469590649009E-04     .00467161787673831        OK                         
 1.003000020980835         2.9955089557915926E-03    2.9955299105495214E-03    2.1006932947784662E-03    OK                         
 1.0099999904632568        .00995033048093319        9.950321167707443E-03     9.401589049957693E-04     OK                         
 1.0299999713897705        2.9558802023530006E-02    2.9558774083852768E-02    .002863141708076          OK                         
 1.111109972000122         .1053595170378685         .10535948723554611        3.1372548546642065E-03    OK                         
 1.5432100296020508        .43386465311050415        .43386468291282654        4.264392424374819E-03     OK                         
 2                         .6931471824645996         .6931471824645996         0                         OK  - EXACT                
 2.323230028152466         .8429584503173828         .8429584503173828         0                         OK  - EXACT                
 2.718280076980591         .9999993443489075         .9999993443489075         0                         OK  - EXACT                
 4                         1.3862943649291992        1.3862943649291992        0                         OK  - EXACT                
 7.142859935760498         1.9661132097244263        1.9661132097244263        0                         OK  - EXACT                
 8                         2.079441547393799         2.079441547393799         0                         OK  - EXACT                
 53.67890167236328         3.983020067214966         3.983020067214966         0                         OK  - EXACT                
 482.28399658203125        6.17853307723999          6.17853307723999          0                         OK  - EXACT                
 9621.1201171875           9.17171573638916          9.17171573638916          0                         OK  - EXACT                
 86321.3984375             11.365832328796387        11.365832328796387        0                         OK  - EXACT                
 777777                    13.564194679260254        13.564194679260254        0                         OK  - EXACT                
 98765400                  18.40825843811035         18.40825843811035         0                         OK  - EXACT                
 89898901504               25.221952438354492        25.221952438354492        0                         OK  - EXACT                
 7979789927317504          36.61568832397461         36.61568832397461         0                         OK  - EXACT                
 6.969689859262775E+20     47.99327087402344         47.99327087402344         0                         OK  - EXACT                
 5.959590069061947E+25     59.34962844848633         59.34962844848633         0                         OK  - EXACT                
 4.94949009668374E+30      70.67683410644531         70.67683410644531         0                         OK  - EXACT                
 3.939389827068878E+35     81.96150207519531         81.96150207519531         0                         OK  - EXACT                
 9.876540272733085E+36     85.1832275390625          85.1832275390625          0                         OK  - EXACT                
 9.876539638907785E+37     87.48580932617188         87.48580932617188         0                         OK  - EXACT                
 9.999999680285692E+37     87.49822998046875         87.49822998046875         0                         OK  - EXACT                
                                                                                                                                    
*** INFORMATIVE TEST PASSED ***                                                                                                     
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 124                                                                                                                     
