PROGRAM FILE 127: ACCURACY OF SIN FUNCTION.                                                                                         
    ANSI STANDARD 7.6, 8.4                                                                                                          
                                                                                                                                    
SECTION 127.1: ACCURACY OF SIN FUNCTION.                                                                                            
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
SIN FUNCTION FOR ACCURACY. THE INVOCATION MUST RETURN,                                                                              
ACCURATE TO SIX DIGITS, SOME VALUE ACTUALLY TAKEN ON BY                                                                             
THE FUNCTION WITHIN A DOMAIN BOUNDED BY THE ACTUAL ARGUMENT                                                                         
PLUS OR MINUS ONE IN THE SIXTH DIGIT. ALSO, AN                                                                                      
'ERROR MEASURE' IS COMPUTED AND REPORTED. THIS MEASURE                                                                              
IS JUST 2 * THE ABSOLUTE ERROR OVER THE SIZE OF THE RANGE;                                                                          
THUS, A VALUE JUST BARELY PASSING OR FAILING WILL USUALLY                                                                           
HAVE A MEASURE OF ABOUT 1. A VALUE 3 TIMES                                                                                          
AS INACCURATE AS EXPECTED WILL HAVE A MEASURE OF 3.                                                                                 
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ANSI STANDARD                                                                              
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
ARGUMENT                  TRUE                      COMPUTED                  ERROR                     OUTCOME                     
                          VALUE                     VALUE                     MEASURE                                               
                                                                                                                                    
-98765.3984375            -1.0156269185245037E-02   -8.593838661909103E-03     1.5651140362024307E-02    OK                         
-98764.3984375             .8359401226043701         .8367966413497925         1.5632428228855133E-02    OK                         
-94268.203125             -1                        -.9999949932098389         2.002574736252427E-03     OK                         
-9427.919921875            4.465770034585148E-04     3.6845201975665987E-04    7.812608033418655E-03     OK                         
-9425.919921875           -.9094831943511963        -.9094507098197937         7.812836207449436E-03     OK                         
-9429.490234375            .9999999403953552         1                         2.2050717379897833E-03    OK                         
-986.4600219726562         9.322719415649772E-05     7.12545370333828E-05      2.1972600370645523E-02    OK                         
-999                       .02646075189113617        .02646075189113617        0                         OK  - EXACT                
-994.3140258789062        -1                        -1                         0                         OK  - EXACT                
-87.964599609375          -5.6994858823600225E-06   -5.308860636432655E-06     3.906241850927472E-03     OK                         
-99                        .9992068409919739         .9992068409919739         0                         OK  - EXACT                
-89.535400390625          -1                        -1                         0                         OK  - EXACT                
-50                        .2623748481273651         .2623748481273651         0                         OK  - EXACT                
-20                       -.9129452705383301        -.9129452705383301         0                         OK  - EXACT                
-5.900000095367432         .3738766610622406         .37387657165527344        9.146341122686863E-03     OK                         
-4.712389945983887         1                         1                         0                         OK  - EXACT                
-3.141590118408203        -2.653589717738214E-06    -2.5351816930196946E-06    .01184077002108097        OK                         
-2.299999952316284        -.7457051873207092        -.745705246925354          8.298755623400211E-03     OK                         
-1.5707999467849731       -1                        -1                         0                         OK  - EXACT                
-1.2000000476837158       -.9320390820503235        -.9320390820503235         0                         OK  - EXACT                
-1                        -.8414709568023682        -.8414709568023682         0                         OK  - EXACT                
-.9876539707183838        -.8347364664077759        -.8347364664077759         0                         OK  - EXACT                
-.7654320001602173        -.6928485631942749        -.6928485631942749         0                         OK  - EXACT                
-.09876540303230286       -.09860491007566452       -.09860491007566452        0                         OK  - EXACT                
-.07654319703578949       -.07646848261356354       -.07646847516298294        .04878048598766327        OK                         
-9.753189980983734E-03    -9.753035381436348E-03    -9.753035381436348E-03     0                         OK  - EXACT                
-3.4567799884825945E-03   -3.4567732363939285E-03   -3.456773003563285E-03     .01550387591123581        OK                         
-1.0000099427998066E-03   -1.0000098263844848E-03   -1.0000098263844848E-03    0                         OK  - EXACT                
-1.0000000474974513E-03   -9.999998146668077E-04    -9.999999310821295E-04     .00913241971284151        OK                         
-9.999989997595549E-04    -9.99998883344233E-04     -9.99998883344233E-04      0                         OK  - EXACT                
-9.876539843389764E-05    -9.876539843389764E-05    -9.876539843389764E-05     0                         OK  - EXACT                
-9.173590115096886E-06    -9.173590115096886E-06    -9.173590115096886E-06     0                         OK  - EXACT                
-8.999999749903509E-07    -8.999999749903509E-07    -8.999999749903509E-07     0                         OK  - EXACT                
-9.000000189551827E-10    -9.000000189551827E-10    -9.000000189551827E-10     0                         OK  - EXACT                
-8.999999714389703E-20    -8.999999714389703E-20    -8.999999714389703E-20     0                         OK  - EXACT                
-9.000000028539692E-30    -9.000000028539692E-30    -9.000000028539692E-30     0                         OK  - EXACT                
-9.000000256189842E-38    -9.000000256189842E-38    -9.000000256189842E-38     0                         OK  - EXACT                
 0                         0                         0                        RANGE ZERO                 OK  - EXACT                
 2.0000000102211272E-38    2.0000000102211272E-38    2.0000000102211272E-38    0                         OK  - EXACT                
 9.000000028539692E-30     9.000000028539692E-30     9.000000028539692E-30     0                         OK  - EXACT                
 8.999999714389703E-20     8.999999714389703E-20     8.999999714389703E-20     0                         OK  - EXACT                
 9.000000189551827E-10     9.000000189551827E-10     9.000000189551827E-10     0                         OK  - EXACT                
 8.999999749903509E-07     8.999999749903509E-07     8.999999749903509E-07     0                         OK  - EXACT                
 9.173590115096886E-06     9.173590115096886E-06     9.173590115096886E-06     0                         OK  - EXACT                
 9.876539843389764E-05     9.876539843389764E-05     9.876539843389764E-05     0                         OK  - EXACT                
 9.999989997595549E-04     9.99998883344233E-04      9.99998883344233E-04      0                         OK  - EXACT                
 1.0000000474974513E-03    9.999998146668077E-04     9.999999310821295E-04     .00913241971284151        OK                         
 1.0000099427998066E-03    1.0000098263844848E-03    1.0000098263844848E-03    0                         OK  - EXACT                
 3.4567799884825945E-03    3.4567732363939285E-03    3.456773003563285E-03     .01550387591123581        OK                         
 9.753189980983734E-03     9.753035381436348E-03     9.753035381436348E-03     0                         OK  - EXACT                
 .07654319703578949        .07646848261356354        .07646847516298294        .04878048598766327        OK                         
 .09876540303230286        .09860491007566452        .09860491007566452        0                         OK  - EXACT                
 .7654320001602173         .6928485631942749         .6928485631942749         0                         OK  - EXACT                
 .9876539707183838         .8347364664077759         .8347364664077759         0                         OK  - EXACT                
 1                         .8414709568023682         .8414709568023682         0                         OK  - EXACT                
 1.2000000476837158        .9320390820503235         .9320390820503235         0                         OK  - EXACT                
 1.5707999467849731        1                         1                         0                         OK  - EXACT                
 2.299999952316284         .7457051873207092         .745705246925354          8.298755623400211E-03     OK                         
 3.141590118408203         2.653589717738214E-06     2.5351816930196946E-06    1.1840710416436195E-02    OK                         
 3.9000000953674316       -.6877661347389221        -.6877662539482117         1.5325670130550861E-02    OK                         
 4.712389945983887        -1                        -1                         0                         OK  - EXACT                
 5.900000095367432        -.3738766610622406        -.37387657165527344        9.146341122686863E-03     OK                         
 20                        .9129452705383301         .9129452705383301         0                         OK  - EXACT                
 50                       -.2623748481273651        -.2623748481273651         0                         OK  - EXACT                
 89.535400390625           1                         1                         0                         OK  - EXACT                
 99                       -.9992068409919739        -.9992068409919739         0                         OK  - EXACT                
 87.964599609375           5.6994858823600225E-06    5.308860636432655E-06     3.906241850927472E-03     OK                         
 994.3140258789062         1                         1                         0                         OK  - EXACT                
 999.0999755859375         .07346989959478378        .07344555109739304        2.4413293227553368E-02    OK                         
 986.4600219726562        -9.322719415649772E-05    -7.12545370333828E-05      2.1972600370645523E-02    OK                         
 9429.490234375           -.9999999403953552        -1                         2.2050717379897833E-03    OK                         
 9425.919921875            .9094831943511963         .9094507098197937         7.812836207449436E-03     OK                         
 9427.919921875           -4.465770034585148E-04    -3.6845201975665987E-04    7.812608033418655E-03     OK                         
 94268.203125              1                         .9999949932098389         2.002574736252427E-03     OK                         
 98764.3984375            -.8359401226043701        -.8367966413497925         1.5632428228855133E-02    OK                         
 98765.3984375             1.0156269185245037E-02    8.593838661909103E-03     1.5651140362024307E-02    OK                         
                                                                                                                                    
*** INFORMATIVE TEST PASSED ***                                                                                                     
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 127                                                                                                                     
