PROGRAM FILE 128: ACCURACY OF TAN FUNCTION.                                                                                         
    ANSI STANDARD 7.6, 8.4                                                                                                          
                                                                                                                                    
SECTION 128.1: ACCURACY OF TAN FUNCTION.                                                                                            
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
TAN FUNCTION FOR ACCURACY. THE INVOCATION MUST RETURN,                                                                              
ACCURATE TO SIX DIGITS, SOME VALUE ACTUALLY TAKEN ON BY                                                                             
THE FUNCTION WITHIN A DOMAIN BOUNDED BY THE ACTUAL ARGUMENT                                                                         
PLUS OR MINUS ONE IN THE SIXTH DIGIT. ALSO, AN                                                                                      
'ERROR MEASURE' IS COMPUTED AND REPORTED. THIS MEASURE                                                                              
IS JUST 2 * THE ABSOLUTE ERROR OVER THE SIZE OF THE RANGE;                                                                          
THUS, A VALUE JUST BARELY PASSING OR FAILING WILL USUALLY                                                                           
HAVE A MEASURE OF ABOUT 1. A VALUE 3 TIMES                                                                                          
AS INACCURATE AS EXPECTED WILL HAVE A MEASURE OF 3.                                                                                 
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ANSI STANDARD                                                                              
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
ARGUMENT                  TRUE                      COMPUTED                  ERROR                     OUTCOME                     
                          VALUE                     VALUE                     MEASURE                                               
                                                                                                                                    
-98778.9                  -1.38017476               -1.3801747592153921        2.640320490405779E-09     OK                         
-9876.54                   .724991905                .7249919051157021         7.583073745447974E-09     OK                         
-987.654                  -2.52646135               -2.526461348060105         2.6257162385979235E-07    OK                         
-98.7654                  -5.0692105                -5.06921049535092          1.7381717705089334E-06    OK                         
-9.87654                  -.485230117               -.4852301165230945         3.709883431183319E-05     OK                         
-5.55555                   .890667992                .8906679923956184         2.146309111120003E-05     OK                         
-4.71239                   980762.048                980762.0481717478        RANGE SPLIT                OK                         
-4.56789                  -6.87223055               -6.872230549038705         1.972777547954274E-06     OK                         
-4                        -1.15782128               -1.1578212823495775        8.270247875796739E-05     OK                         
-3.14159                   .00000265358979           2.6535897933620727E-06    3.362063573039065E-10     OK                         
-2.87654                   .271439087                .27143908668415595        2.8106257896986164E-05    OK                         
-2                         2.18503986                2.185039863261519         5.19805411560359E-05      OK                         
-1.61616                   22.028947                 22.028946974255476        5.240348675975481E-06     OK                         
-1.57081                   73135.7419                73135.74194009067         3.486137686134292E-10     OK                         
-1.5708                    272241.808                272241.80840927624       RANGE SPLIT                OK                         
-1.57078                  -61249.0085               -61249.008531503045        5.247255772796246E-10     OK                         
-1.23456                  -2.86116592               -2.861165921594298         1.6458968945759637E-05    OK                         
-1                        -1.55740772               -1.5574077246549023        1.1856602754532898E-04    OK                         
-.87654                   -1.20117664               -1.2011766371269805        3.858991777006652E-04     OK                         
-.232323                  -.236595054               -.2365950543677824         2.3628807444775994E-04    OK                         
-.0767676                 -.0769187603              -.07691876026259492        2.482912647543305E-04     OK                         
-.0234567                 -.023461003               -2.3461003036984923E-02   RANGE SPLIT                OK                         
-.0123456                 -.0123462273              -1.2346227251672497E-02    3.220759977172506E-04     OK                         
-.00987654                -.00987686115             -.00987686115166061        1.1067050215772904E-04    OK                         
-.00345678                -.00345679377             -3.456793768798456E-03     8.007624608995246E-05     OK                         
-.000987654               -.000987654321            -9.87654321139255E-04      9.280582730922842E-05     OK                         
-.000345678               -.000345678014            -3.4567801376873326E-04    1.541264379772217E-04     OK                         
-.00009                   -.0000900000002           -.000090000000243          2.865711446985574E-04     OK                         
-.0000009                 -.0000009                 -9.00000000000243E-07      1.6194107080649884E-07    OK                         
-.0000000009              -.0000000009              -.0000000009               0                         OK - EXACT                 
-9.E-20                   -9.E-20                   -9.E-20                    0                         OK - EXACT                 
-9.E-30                   -9.E-30                   -9.E-30                    0                         OK - EXACT                 
-9.E-38                   -9.E-38                   -9.E-38                    0                         OK - EXACT                 
 0                         0                         0                        RANGE ZERO                 OK - EXACT                 
 9.E-38                    9.E-38                    9.E-38                    0                         OK - EXACT                 
 9.E-30                    9.E-30                    9.E-30                    0                         OK - EXACT                 
 9.E-20                    9.E-20                    9.E-20                    0                         OK - EXACT                 
 .0000000009               .0000000009               .0000000009               0                         OK - EXACT                 
 .0000009                  .0000009                  9.00000000000243E-07      1.6194107080649884E-07    OK                         
 .00009                    .0000900000002            .000090000000243          2.865711446985574E-04     OK                         
 .000345678                .000345678014             3.4567801376873326E-04    1.541264379772217E-04     OK                         
 .000987654                .000987654321             9.87654321139255E-04      9.280582730922842E-05     OK                         
 .00345678                 .00345679377              3.456793768798456E-03     8.007624608995246E-05     OK                         
 .00987654                 .00987686115              .00987686115166061        1.1067050215772904E-04    OK                         
 .0123456                  .0123462273               1.2346227251672497E-02    3.220759977172506E-04     OK                         
 .0234567                  .023461003                2.3461003036984923E-02    2.4640187920901726E-04    OK                         
 .0767676                  .0769187603               .07691876026259492        2.482912647543305E-04     OK                         
 .232323                   .236595054                .2365950543677824         2.3628807444775994E-04    OK                         
 .876543                   1.20118397                1.2011839656293297        5.870611511241013E-04     OK                         
 1                         1.55740772                1.5574077246549023        1.1856602754532898E-04    OK                         
 1.23456                   2.86116592                2.861165921594298         1.6458968945759637E-05    OK                         
 1.57078                   61249.0085                61249.008531503045        5.247255772796246E-10     OK                         
 1.5708                   -272241.808               -272241.80840927624       RANGE SPLIT                OK                         
 1.57081                  -73135.7419               -73135.74194009067         3.486137686134292E-10     OK                         
 1.61616                  -22.028947                -22.028946974255476        5.240348675975481E-06     OK                         
 2                        -2.18503986               -2.185039863261519         5.19805411560359E-05      OK                         
 2.87654                  -.271439087               -.27143908668415595        2.8106257896986164E-05    OK                         
 3.14159                  -.00000265358979          -2.6535897933620727E-06    3.362063573039065E-10     OK                         
 4                         1.15782128                1.1578212823495775        8.270247875796739E-05     OK                         
 4.56789                   6.87223055                6.872230549038705         1.972777547954274E-06     OK                         
 4.71239                  -980762.049               -980762.0481717478        RANGE SPLIT                OK                         
 5.55555                  -.890667992               -.8906679923956184         2.1461926758706167E-05    OK                         
 9.87654                   .485230117                .4852301165230945         3.709883431183319E-05     OK                         
 98.7654                   5.0692105                 5.06921049535092          1.7381717705089334E-06    OK                         
 987.654                   2.52646135                2.526461348060105         2.6257162385979235E-07    OK                         
 9876.54                  -.724991905               -.7249919051157021         7.583073745447974E-09     OK                         
 98778.9                   1.38017476                1.3801747592153921        2.640320490405779E-09     OK                         
                                                                                                                                    
*** INFORMATIVE TEST PASSED ***                                                                                                     
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 128                                                                                                                     
