PROGRAM FILE 129: EXCEPTION - OVERFLOW ON VALUE OF                                                                                  
        TAN FUNCTION.                                                                                                               
    ANSI STANDARD 8.5                                                                                                               
                                                                                                                                    
SECTION 129.1: EXCEPTION - OVERFLOW ON VALUE OF                                                                                     
        TAN FUNCTION.                                                                                                               
                                                                                                                                    
THE OBJECT OF THIS TEST IS TO SEE WHETHER THE PROCESSOR                                                                             
RECOGNIZES AN EXCEPTION OF THE VALUE RETURNED BY THE                                                                                
TAN FUNCTION EXCEEDS MACHINE INFINITY.                                                                                              
                                                                                                                                    
TO PASS THIS TEST:                                                                                                                  
                                                                                                                                    
    1) OVERFLOW MUST NOT OCCUR, OR                                                                                                  
                                                                                                                                    
    2) WHEN OVERFLOW OCCURS, THE PROCESSOR MUST DISPLAY A                                                                           
       MESSAGE IDENTIFYING THE EXCEPTION, SUPPLY MACHINE                                                                            
       INFINITY AND CONTINUE EXECUTION.                                                                                             
                                                                                                                                    
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
THE PROGRAM ATTEMPTS TO FORCE CONVERGENCE OF THE ARGUMENT                                                                           
TO PI/2, SO AS TO CAUSE OVERFLOW. IF OVERFLOW DOES NOT                                                                              
OCCUR, IT IS LIKELY THAT THIS SYSTEM HAS NO INTERNAL                                                                                
NUMERIC REPRESENTATION FOR WHICH THE TANGENT EXCEEDS                                                                                
MACHINE INFINITY.                                                                                                                   
                                                                                                                                    
ARGUMENT                  VALUE OF TAN                                                                                              
                                                                                                                                    
 1.57                      1255.7655915007897                                                                                       
 1.5750000000000002       -237.88578724186388                                                                                       
 1.5725000000000002       -586.9664613514889                                                                                        
 1.57125                  -2204.2296528524025                                                                                       
 1.5706250000000002        5836.79856277038                                                                                         
 1.5709375                -7083.497131227695                                                                                        
 1.57078125                66327.09450399467                                                                                        
 1.570859375              -15860.87973537248                                                                                        
 1.5708203125             -41691.49897819848                                                                                        
 1.57080078125            -224494.34931658028                                                                                       
 1.570791015625            188282.43484148546                                                                                       
 1.5707958984375           2334499.2000687425                                                                                       
 1.57079833984375         -496758.9327728906                                                                                        
 1.570797119140625        -1262075.334392561                                                                                        
 1.5707965087890625       -5494681.629286523                                                                                        
 1.5707962036132812        8118094.543914076                                                                                        
 1.5707963562011718       -34006347.13273816                                                                                        
 1.5707962799072264        21327568.519029997                                                                                       
 1.570796318054199         114407344.84806544                                                                                       
 1.5707963371276854       -96779293.64044484                                                                                        
 1.5707963275909422       -1256209423.408985                                                                                        
 1.5707963228225705        251741669.39627478                                                                                       
 1.5707963252067563        629667272.0244746                                                                                        
 1.5707963263988494        2524951212.6759706                                                                                       
 1.5707963269948957       -5000023321.675916                                                                                        
 1.5707963266968725        10201573443.914572                                                                                       
 1.5707963268458842       -19612612729.55018                                                                                        
 1.5707963267713785        42520373708.40596                                                                                        
 1.5707963268086313       -72808130260.17242                                                                                        
 1.570796326790005         204427746398.55426                                                                                       
 1.5707963267993181       -226166925953.20648                                                                                       
 1.5707963267946616        4255601207456.2607                                                                                       
 1.57079632679699         -477697428940.67194                                                                                       
 1.5707963267958258       -1076199858217.3717                                                                                       
 1.5707963267952438       -2880047216309.579                                                                                        
 1.5707963267949527       -17820212787200.06                                                                                        
 1.5707963267948073        11195304337582.15                                                                                        
 1.5707963267948801        60633499637034.25                                                                                        
 1.5707963267949165       -50193792955984.234                                                                                       
 1.5707963267948983       -583048052969231.1                                                                                        
 1.5707963267948892        135341726920089.66                                                                                       
 1.570796326794894         366869134531382.94                                                                                       
 1.5707963267948961        1978937966095219                                                                                         
 1.5707963267948972       -1653161781927094.8                                                                                       
 1.5707963267948966        16331239353195370                                                                                        
 1.570796326794897        -2611942160735615.5                                                                                       
 1.5707963267948968       -6218431163823738                                                                                         
 1.5707963267948966        16331239353195370                                                                                        
                                                                                                                                    
ARGUMENTS HAVE CONVERGED. IF OVERFLOW HAS OCCURRED,                                                                                 
PROCESSOR MUST HAVE REPORTED EXCEPTION AND SUPPLIED                                                                                 
MACHINE INFINITY, OTHERWISE,                                                                                                        
***  TEST FAILED  ***                                                                                                               
                                                                                                                                    
                                 END TEST                                                                                           
                                                                                                                                    
END PROGRAM 129                                                                                                                     
