PROGRAM FILE 133: CHI-SQUARE UNIFORMITY TEST FOR                                                                                    
        RND FUNCTION.                                                                                                               
    ANSI STANDARD 8.4                                                                                                               
                                                                                                                                    
SECTION 133.1: CHI-SQUARE UNIFORMITY TEST FOR                                                                                       
        RND FUNCTION.                                                                                                               
                                                                                                                                    
THIS PROGRAM RUNS A SERIES OF 60 EXPERIMENTS OF 1040 SAMPLES                                                                        
TO DETERMINE IF THE RANDOM NUMBERS ARE EQUALLY DISTRIBUTED                                                                          
AMONG 21 EQUAL-SIZE INTERVALS BETWEEN 0 AND 1.  CHI-SQUARE                                                                          
IS COMPUTED AND DISPLAYED FOR EACH OF THESE EXPERIMENTS.                                                                            
EACH CHI-SQUARE RESULT IS CATEGORIZED ACCORDING TO THE                                                                              
PERCENTILE RANGE INTO WHICH ITS VALUE FALLS:                                                                                        
                                                                                                                                    
CATEGORY     % RANGE                CATEGORY    % RANGE                                                                             
    1          0-1                      6        50-75                                                                              
    2          1-5                      7        75-90                                                                              
    3          5-10                     8        90-95                                                                              
    4         10-25                     9        95-99                                                                              
    5         25-50                    10        99-100                                                                             
                                                                                                                                    
THESE CATEGORICAL RESULTS ARE THEN EVALUATED AGAIN USING                                                                            
CHI-SQUARE (THE FIRST AND LAST THREE CATEGORIES ARE EACH                                                                            
CONSOLIDATED INTO ONE), AND IF THE DISTRIBUTION AMONG                                                                               
CATEGORIES IS SUFFICIENTLY IMPROBABLE (TOP OR BOTTOM 5%),                                                                           
THE TEST FAILS.                                                                                                                     
                                                                                                                                    
                    BEGIN TEST                                                                                                      
                                                                                                                                    
EXPERIMENT                CHI-SQUARE                CATEGORY                                                                        
                                                                                                                                    
 1                         17.920000000000073        5                                                                              
 2                         24.24000000000001         7                                                                              
 3                         22.920000000000073        6                                                                              
 4                         20.559999999999945        6                                                                              
 5                         17.24000000000001         5                                                                              
 6                         13.759999999999991        4                                                                              
 7                         17.200000000000045        5                                                                              
 8                         20.59999999999991         6                                                                              
 9                         25                        7                                                                              
 10                        16.88000000000011         5                                                                              
 11                        22.40000000000009         6                                                                              
 12                        19.960000000000036        6                                                                              
 13                        18.519999999999982        5                                                                              
 14                        29.079999999999927        8                                                                              
 15                        29.519999999999982        8                                                                              
 16                        20.88000000000011         6                                                                              
 17                        24.24000000000001         7                                                                              
 18                        24.3599999999999          7                                                                              
 19                        25.720000000000027        7                                                                              
 20                        28.519999999999982        8                                                                              
 21                        25.480000000000018        7                                                                              
 22                        20.440000000000055        6                                                                              
 23                        19.40000000000009         6                                                                              
 24                        17.559999999999945        5                                                                              
 25                        20.839999999999918        6                                                                              
 26                        17.799999999999955        5                                                                              
 27                        13.400000000000091        4                                                                              
 28                        16.279999999999973        5                                                                              
 29                        22.920000000000073        6                                                                              
 30                        13.400000000000091        4                                                                              
 31                        26.960000000000036        7                                                                              
 32                        26.6400000000001          7                                                                              
 33                        19.3599999999999          6                                                                              
 34                        26.88000000000011         7                                                                              
 35                        24.40000000000009         7                                                                              
 36                        15.160000000000082        4                                                                              
 37                        17.920000000000073        5                                                                              
 38                        19.519999999999982        6                                                                              
 39                        22.279999999999973        6                                                                              
 40                        31.279999999999973        8                                                                              
 41                        22.079999999999927        6                                                                              
 42                        12.200000000000045        3                                                                              
 43                        23.079999999999927        6                                                                              
 44                        15.200000000000045        4                                                                              
 45                        18.039999999999964        5                                                                              
 46                        23.279999999999973        6                                                                              
 47                        17.319999999999936        5                                                                              
 48                        28.24000000000001         7                                                                              
 49                        14.440000000000055        4                                                                              
 50                        10.160000000000082        2                                                                              
 51                        10.079999999999927        2                                                                              
 52                        14.799999999999955        4                                                                              
 53                        23.440000000000055        6                                                                              
 54                        20.839999999999918        6                                                                              
 55                        21.11999999999989         6                                                                              
 56                        11.960000000000036        3                                                                              
 57                        11.11999999999989         3                                                                              
 58                        19.160000000000082        5                                                                              
 59                        20.6400000000001          6                                                                              
 60                        33.799999999999955        9                                                                              
                                                                                                                                    
                                                                                                                                    
                                                                                                                                    
SUMMARY EVALUATION STATISTICS                                                                                                       
                                                                                                                                    
                          ACTUAL                    EXPECTED                                                                        
CATEGORY                  COUNT                     COUNT                                                                           
 1                         0                         .6                                                                             
 2                         2                         2.4                                                                            
 3                         3                         3                                                                              
 4                         7                         9                                                                              
 5                         12                        15                                                                             
 6                         20                        15                                                                             
 7                         11                        9                                                                              
 8                         4                         3                                                                              
 9                         1                         2.4                                                                            
 10                        0                         .6                                                                             
                                                                                                                                    
                                                                                                                                    
WILL CONSOLIDATE CATEGORIES 1-3 AND 8-10, SO THAT                                                                                   
EXPECTED VALUE IN EACH IS >= 5, AS REQUIRED BY                                                                                      
CHI-SQUARE TEST.                                                                                                                    
                                                                                                                                    
FOR FIVE D.F., SHOULD HAVE 1.145476 <= CHI-SQ <= 11.0705                                                                            
(5% TAIL AT EACH END.)                                                                                                              
                                                                                                                                    
ACTUAL CHI-SQ =  3.4888888888889014                                                                                                 
                                                                                                                                    
 ***  TEST PASSED  ***                                                                                                              
                                                                                                                                    
                    END TEST                                                                                                        
                                                                                                                                    
END PROGRAM 133                                                                                                                     
