#
# Written by John Gatewood Ham.  This file is in the Public Domain.
# Output maximum width is 83 columns data + newline
#
# as --64 -n --divide --size-check=error -o dumpregs.o dumpregs.s
        .att_syntax
        .att_mnemonic
        .arch core2,nojumps
        .code64

        .section .data,"aw",@progbits

.LITOXoutbuffer:
        .ascii "\n==============================< Begin Regi"
        .ascii "ster Dump >==============================\n"
.LGPREGS:
        .ascii "RAX="
.LRAX:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " RBX="
.LRBX:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " RCX="
.LRCX:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " RDX="
.LRDX:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii "\nRSI="
.LRSI:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " RDI="
.LRDI:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " RBP="
.LRBP:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " RSP="
.LRSP:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii "\n R8="
.LR8:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii "  R9="
.LR9:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " R10="
.LR10:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " R11="
.LR11:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii "\nR12="
.LR12:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " R13="
.LR13:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " R14="
.LR14:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii " R15="
.LR15:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii "\nRIP="
.LRIP:
        .ascii "FFFFFFFFFFFFFFFF"
        .ascii "                      FLAGS: "
.LFLAGS:
        .ascii "CF=? PF=? AF=? ZF=? SF=? DF=? OF=?\n"
        .ascii "CF - Carry       PF - Parity      AF - Auxilliary Carry   ZF - Zero   SF - Sign\n"
        .ascii "DF - Direction   OF - Overflow\n"

        .ascii "            High              Low       "
        .ascii "               High               Low\n"

        .ascii " XMM0="
.LXMM0H:
        .ascii "????????????????"
        .ascii "  "
.LXMM0L:
        .ascii "????????????????"
        .ascii "    XMM1="
.LXMM1H:
        .ascii "????????????????"
        .ascii "  "
.LXMM1L:
        .ascii "????????????????"
        .ascii "\n XMM2="
.LXMM2H:
        .ascii "????????????????"
        .ascii "  "
.LXMM2L:
        .ascii "????????????????"
        .ascii "    XMM3="
.LXMM3H:
        .ascii "????????????????"
        .ascii "  "
.LXMM3L:
        .ascii "????????????????"
        .ascii "\n XMM4="
.LXMM4H:
        .ascii "????????????????"
        .ascii "  "
.LXMM4L:
        .ascii "????????????????"
        .ascii "    XMM5="
.LXMM5H:
        .ascii "??? John Ham ???"
        .ascii "  "
.LXMM5L:
        .ascii "????????????????"
        .ascii "\n XMM6="
.LXMM6H:
        .ascii "?? wrote this ??"
        .ascii "  "
.LXMM6L:
        .ascii "????????????????"
        .ascii "    XMM7="
.LXMM7H:
        .ascii "???  public  ???"
        .ascii "  "
.LXMM7L:
        .ascii "????????????????"
        .ascii "\n XMM8="
.LXMM8H:
        .ascii "???  domain  ???"
        .ascii "  "
.LXMM8L:
        .ascii "????????????????"
        .ascii "    XMM9="
.LXMM9H:
        .ascii "????  code  ????"
        .ascii "  "
.LXMM9L:
        .ascii "????????????????"
        .ascii "\nXMM10="
.LXMM10H:
        .ascii "????????????????"
        .ascii "  "
.LXMM10L:
        .ascii "????????????????"
        .ascii "   XMM11="
.LXMM11H:
        .ascii "????????????????"
        .ascii "  "
.LXMM11L:
        .ascii "????????????????"
        .ascii "\nXMM12="
.LXMM12H:
        .ascii "????????????????"
        .ascii "  "
.LXMM12L:
        .ascii "????????????????"
        .ascii "   XMM13="
.LXMM13H:
        .ascii "????????????????"
        .ascii "  "
.LXMM13L:
        .ascii "????????????????"
        .ascii "\nXMM14="
.LXMM14H:
        .ascii "????????????????"
        .ascii "  "
.LXMM14L:
        .ascii "????????????????"
        .ascii "   XMM15="
.LXMM15H:
        .ascii "????????????????"
        .ascii "  "
.LXMM15L:
        .ascii "????????????????"
        .ascii "\nMXCSR: "
.LMXCSRFLAGS:
        .ascii "IE=? DE=? ZE=? OE=? UE=? PE=? "
        .ascii "DAZ=? IM=? DM=? ZM=? OM=? UM=? PM=? RC=? FTZ=?\n"
        .ascii "IE  - Invalid Operation     DE  - Denormal           ZE  - Divide By Zero\n"
        .ascii "OE  - Overflow              UE  - Underflow          PE  - Precision\n"
        .ascii "IM  - Invalid Operation     DM  - Denormal Operation ZM  - Divide By Zero\n"
        .ascii "OM  - Overflow              UM  - Underflow          PM  - Precision\n"
        .ascii "DAZ - Denormals Are Zero    FTZ - Flush To Zero\n"
        .ascii "RC  - Rounding Code: 0 to nearest, 1 down towards -INF, 2 up towards +INF,\n"
        .ascii "      3 towards zero\n"
        .ascii "===============================< End Regis"
        .ascii "ter Dump >===============================\n\n"
        .set .LITOXoutbuflen, .-.LITOXoutbuffer

        .section .rodata.str1.1,"aMS",@progbits,1

.LHEXTOASC:
        .ascii "0123456789ABCDEF"
        .byte 0

        .section .text,"ax",@progbits

        # first arg char *s is in rdi, must have >=17 bytes....
        # second arg const unsigned long int n is in rsi
        # this is a procedure, nothing is returned
        .local .Litox2
        .type  .Litox2, @function
.Litox2:
        pushq   %rax
        pushq   %rbx
        pushq   %rcx
        pushq   %rdx
        pushq   %r8
        pushq   %r9
        movabsq $.LHEXTOASC, %rcx  # rcx= pointer to array of hex digits
        movq    %rsi, %r9        # local variable j=n
        xorq    %r8, %r8         # local variable i=0
        movq    $15, %rbx        # rbx=15
0:
        movq    %rbx, %rdx       # rdx=15
        subq    %r8, %rdx        # rdx=15-i
        movq    %r9, %rax        # rax=j
        andq    %rbx, %rax       # rax=j&15
        movb    (%rcx,%rax,1), %al    # al=konvert[rax]
        movb    %al, (%rdi,%rdx,1)    # s[15-i]=konvert[rax]
        shrq    $4, %r9          # j>>=4
        incq    %r8              # i++
        cmpq    %rbx, %r8        # if i<=15 then
        jbe     0b               # goto 0
        # warning, does not terminate string!
        # movb    $0, 16(%rdi)     # s[16]=0
        popq    %r9
        popq    %r8
        popq    %rdx
        popq    %rcx
        popq    %rbx
        popq    %rax
        retq
        .size   .Litox2, .-.Litox2

        .globl  dumpregs
        .type   dumpregs, @function
dumpregs:
        pushq   %rsp
        pushfq
        pushq   %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %r11
        pushq   %r10
        pushq   %r9
        pushq   %r8
        pushq   %rdi
        pushq   %rsi
        pushq   %rdx
        pushq   %rcx
        pushq   %rbx
        pushq   %rax
        movabsq $.Litox2,%rax
        movabsq $.LRAX,%rdi
        movq    0(%rsp),%rsi    # rax
        callq   *%rax
        movabsq $.LRBX,%rdi
        movq    8(%rsp),%rsi    # rbx
        callq   *%rax
        movabsq $.LRCX,%rdi
        movq    16(%rsp),%rsi   # rcx
        callq   *%rax
        movabsq $.LRDX,%rdi
        movq    24(%rsp),%rsi   # rdx
        callq   *%rax
        movabsq $.LRSI,%rdi
        movq    32(%rsp),%rsi   # rsi
        callq   *%rax
        movabsq $.LRDI,%rdi
        movq    40(%rsp),%rsi   # rdi
        callq   *%rax
        movabsq $.LR8,%rdi
        movq    48(%rsp),%rsi   # r8
        callq   *%rax
        movabsq $.LR9,%rdi
        movq    56(%rsp),%rsi   # r9
        callq   *%rax
        movabsq $.LR10,%rdi
        movq    64(%rsp),%rsi   # r10
        callq   *%rax
        movabsq $.LR11,%rdi
        movq    72(%rsp),%rsi   # r11
        callq   *%rax
        movabsq $.LR12,%rdi
        movq    80(%rsp),%rsi   # r12
        callq   *%rax
        movabsq $.LR13,%rdi
        movq    88(%rsp),%rsi   # r13
        callq   *%rax
        movabsq $.LR14,%rdi
        movq    96(%rsp),%rsi   # r14
        callq   *%rax
        movabsq $.LR15,%rdi
        movq    104(%rsp),%rsi  # r15
        callq   *%rax
        movabsq $.LRBP,%rdi
        movq    112(%rsp),%rsi   # rbp
        callq   *%rax
        # skip 120 for now, it is flags
        movabsq $.LRSP,%rdi
        movq    128(%rsp),%rsi  # rsp
        addq    $8, %rsi        # adjust for return address
        callq   *%rax
        # ok, fill in RIP of the line dumpregs was called from
        movabsq $.LRIP,%rdi
        movq    136(%rsp),%rsi  # rip
        callq   *%rax

        # now the flags
        movabsq $.LFLAGS, %rdi  # buffer
        movq    120(%rsp),%r8   # rflags
        movb    $'N',%cl        # answer for flag not set (default)

        movb    $'Y',%dl        # answer for flag set
        addq    $3,%rdi         # move to CF location
        movl    $1,%ebx         # test CF (2^0 for bit zero)
        andl    %r8d,%ebx       # ebx = r8d & 2^0
        testl   %ebx,%ebx       # if CF is one
        cmovzw  %cx,%dx         # move 'N' into dl
        movb    %dl,(%rdi)      # either way, move dl into CF slot

        movb    $'Y',%dl        # answer for flag set
        addq    $5,%rdi         # move to DF location
        movl    $4,%ebx         # test PF (2^2 for bit 2)
        andl    %r8d,%ebx       # ebx = r8d & 2^2
        testl   %ebx,%ebx       # if DF is one
        cmovzw  %cx,%dx         # move 'N' into dl
        movb    %dl,(%rdi)      # either way, move dl into PF slot

        movb    $'Y',%dl        # answer for flag set
        addq    $5,%rdi         # move to AF location
        movl    $16,%ebx        # test AF (2^4 for bit 4)
        andl    %r8d,%ebx       # ebx = r8d & 2^4
        testl   %ebx,%ebx       # if AF is one
        cmovzw  %cx,%dx         # move 'N' into dl
        movb    %dl,(%rdi)      # either way, move dl into AF slot

        movb    $'Y',%dl        # answer for flag set
        addq    $5,%rdi         # move to ZF location
        movl    $64,%ebx        # test ZF (2^6 for bit 6)
        andl    %r8d,%ebx       # ebx = r8d & 2^6
        testl   %ebx,%ebx       # if ZF is one
        cmovzw  %cx,%dx         # move 'N' into dl
        movb    %dl,(%rdi)      # either way, move dl into ZF slot

        movb    $'Y',%dl        # answer for flag set
        addq    $5,%rdi         # move to SF location
        movl    $128,%ebx       # test SF (2^7 for bit 7)
        andl    %r8d,%ebx       # ebx = r8d & 2^7
        testl   %ebx,%ebx       # if SF is one
        cmovzw  %cx,%dx         # move 'N' into dl
        movb    %dl,(%rdi)      # either way, move dl into SF slot

        movb    $'Y',%dl        # answer for flag set
        addq    $5,%rdi         # move to DF location
        movl    $1024,%ebx      # test DF (2^10 for bit 10)
        andl    %r8d,%ebx       # ebx = r8d ^ 2^10
        testl   %ebx,%ebx       # if DF is one
        cmovzw  %cx,%dx         # if DF=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # either way, move dl into DF slot

        movb    $'Y',%dl        # answer for flag set
        addq    $5,%rdi         # move to OF location
        movl    $2048,%ebx      # test OF (2^11 for bit 11)
        andl    %r8d,%ebx       # ebx = r8d ^ 2^11
        testl   %ebx,%ebx       # if OF is one
        cmovzw  %cx,%dx         # if OF=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # either way, move dl into OF slot

        # AC is 2^18, ID is 2^21

        # SSE2 registers
        sub     $16,%rsp        # allocate memory for copy of xmm register

        movupd  %xmm0,(%rsp)
        movabsq $.LXMM0H,%rdi
        movq    8(%rsp),%rsi    # xmm0 high
        callq   *%rax
        movabsq $.LXMM0L,%rdi
        movq    (%rsp),%rsi     # xmm0 low
        callq   *%rax

        movupd  %xmm1,(%rsp)
        movabsq $.LXMM1H,%rdi
        movq    8(%rsp),%rsi    # xmm1 high
        callq   *%rax
        movabsq $.LXMM1L,%rdi
        movq    (%rsp),%rsi     # xmm1 low
        callq   *%rax

        movupd  %xmm2,(%rsp)
        movabsq $.LXMM2H,%rdi
        movq    8(%rsp),%rsi    # xmm2 high
        callq   *%rax
        movabsq $.LXMM2L,%rdi
        movq    (%rsp),%rsi     # xmm2 low
        callq   *%rax

        movupd  %xmm3,(%rsp)
        movabsq $.LXMM3H,%rdi
        movq    8(%rsp),%rsi    # xmm3 high
        callq   *%rax
        movabsq $.LXMM3L,%rdi
        movq    (%rsp),%rsi     # xmm3 low
        callq   *%rax

        movupd  %xmm4,(%rsp)
        movabsq $.LXMM4H,%rdi
        movq    8(%rsp),%rsi    # xmm4 high
        callq   *%rax
        movabsq $.LXMM4L,%rdi
        movq    (%rsp),%rsi     # xmm4 low
        callq   *%rax

        movupd  %xmm5,(%rsp)
        movabsq $.LXMM5H,%rdi
        movq    8(%rsp),%rsi    # xmm5 high
        callq   *%rax
        movabsq $.LXMM5L,%rdi
        movq    (%rsp),%rsi     # xmm5 low
        callq   *%rax

        movupd  %xmm6,(%rsp)
        movabsq $.LXMM6H,%rdi
        movq    8(%rsp),%rsi    # xmm6 high
        callq   *%rax
        movabsq $.LXMM6L,%rdi
        movq    (%rsp),%rsi     # xmm6 low
        callq   *%rax

        movupd  %xmm7,(%rsp)
        movabsq $.LXMM7H,%rdi
        movq    8(%rsp),%rsi    # xmm7 high
        callq   *%rax
        movabsq $.LXMM7L,%rdi
        movq    (%rsp),%rsi     # xmm7 low
        callq   *%rax

        movupd  %xmm8,(%rsp)
        movabsq $.LXMM8H,%rdi
        movq    8(%rsp),%rsi    # xmm8 high
        callq   *%rax
        movabsq $.LXMM8L,%rdi
        movq    (%rsp),%rsi     # xmm8 low
        callq   *%rax

        movupd  %xmm9,(%rsp)
        movabsq $.LXMM9H,%rdi
        movq    8(%rsp),%rsi    # xmm9 high
        callq   *%rax
        movabsq $.LXMM9L,%rdi
        movq    (%rsp),%rsi     # xmm9 low
        callq   *%rax

        movupd  %xmm10,(%rsp)
        movabsq $.LXMM10H,%rdi
        movq    8(%rsp),%rsi    # xmm10 high
        callq   *%rax
        movabsq $.LXMM10L,%rdi
        movq    (%rsp),%rsi     # xmm10 low
        callq   *%rax

        movupd  %xmm11,(%rsp)
        movabsq $.LXMM11H,%rdi
        movq    8(%rsp),%rsi    # xmm11 high
        callq   *%rax
        movabsq $.LXMM11L,%rdi
        movq    (%rsp),%rsi     # xmm11 low
        callq   *%rax

        movupd  %xmm12,(%rsp)
        movabsq $.LXMM12H,%rdi
        movq    8(%rsp),%rsi    # xmm12 high
        callq   *%rax
        movabsq $.LXMM12L,%rdi
        movq    (%rsp),%rsi     # xmm12 low
        callq   *%rax

        movupd  %xmm13,(%rsp)
        movabsq $.LXMM13H,%rdi
        movq    8(%rsp),%rsi    # xmm13 high
        callq   *%rax
        movabsq $.LXMM13L,%rdi
        movq    (%rsp),%rsi     # xmm13 low
        callq   *%rax

        movupd  %xmm14,(%rsp)
        movabsq $.LXMM14H,%rdi
        movq    8(%rsp),%rsi    # xmm14 high
        callq   *%rax
        movabsq $.LXMM14L,%rdi
        movq    (%rsp),%rsi     # xmm14 low
        callq   *%rax

        movupd  %xmm15,(%rsp)
        movabsq $.LXMM15H,%rdi
        movq    8(%rsp),%rsi    # xmm15 high
        callq   *%rax
        movabsq $.LXMM15L,%rdi
        movq    (%rsp),%rsi     # xmm15 low
        callq   *%rax

        # now for MXCSR, we need 32 bits so get 16 more
        subq    $16,%rsp
        stmxcsr (%rsp)
        movl    (%rsp),%r8d
        addq    $32,%rsp        # deallocate memory

        movabsq $.LMXCSRFLAGS, %rdi # buffer
        movb    $'N',%cl        # if condition is 1

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $3,%rdi         # move to IE location
        movl    $1,%ebx         # test IE
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if IE=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update IE flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to DE location
        movl    $2,%ebx         # test DE
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if DE=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update DE flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to ZE location
        movl    $4,%ebx         # test ZE
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if ZE=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update ZE flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to OE location
        movl    $8,%ebx         # test OE
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if OE=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update OE flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to UE location
        movl    $16,%ebx        # test UE
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if UE=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update UE flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to PE location
        movl    $32,%ebx        # test PE
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if PE=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update PE flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $6,%rdi         # move to DAZ location
        movl    $64,%ebx        # test DAZ
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if DAZ=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update DAZ flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to IM location
        movl    $128,%ebx       # test IM
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if IM=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update IM flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to DM location
        movl    $256,%ebx       # test DM
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if DM=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update DM flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to ZM location
        movl    $512,%ebx       # test ZM
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if ZM=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update ZM flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to OM location
        movl    $1024,%ebx      # test OM
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if OM=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update OM flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to UM location
        movl    $2048,%ebx      # test UM
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if UM=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update UM flag in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $5,%rdi         # move to PM location
        movl    $4096,%ebx      # test PM
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if PM=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update PM flag in buffer

        addq    $5,%rdi         # move to RC location
        movl    $0x6000,%ebx    # mask to get 2 RC bits
        andl    %r8d,%ebx       # get the 2 RC bits
        shrl    $13,%ebx        # convert it to an unsigned int
        addl    $48,%ebx        # convert it to a char
        movb    %bl,(%rdi)      # update RC value in buffer

        movb    $'Y',%dl        # assume condition is 0 (default)
        addq    $6,%rdi         # move to FTZ location
        movl    $32768,%ebx     # test FTZ
        andl    %r8d,%ebx
        testl   %ebx,%ebx
        cmovzw  %cx,%dx         # if FZ=1, mov 'Y' into dx
        movb    %dl,(%rdi)      # update FZ flag in buffer

        # now print the whole thing using 64bit x86-64 Linux-specific
        # system call (tested on kernel version 3.12.8)
        movabsq $.LITOXoutbuffer, %rsi
        movq    $.LITOXoutbuflen, %rdx
        movq    $2, %rdi        # STDERR
        movq    $1, %rax        # __NR_write
        syscall
        popq    %rax
        popq    %rbx
        popq    %rcx
        popq    %rdx
        popq    %rsi
        popq    %rdi
        popq    %r8
        popq    %r9
        popq    %r10
        popq    %r11
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        popfq
        popq    %rsp
        retq
        .size   dumpregs, .-dumpregs

