        # The author of this software is David M. Gay.
        #
        # Copyright (c) 1991, 2000, 2001 by Lucent Technologies.
        #
        # Permission to use, copy, modify, and distribute this software for any
        # purpose without fee is hereby granted, provided that this entire notice
        # is included in all copies of any software which is or includes a copy
        # or modification of this software and in all copies of the supporting
        # documentation for such software.
        #
        # THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED
        # WARRANTY.  IN PARTICULAR, NEITHER THE AUTHOR NOR LUCENT MAKES ANY
        # REPRESENTATION OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY
        # OF THIS SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.
        #
        # http://netlib.sandia.gov/fp/index.html
        #
        .section .text,"ax",@progbits

        .type   .Lhi0bits, @function
.Lhi0bits:
        pushq   %rbp
        xorl    %edx, %edx
        testl   $-65536, %edi
        movq    %rsp, %rbp
        jne     0f
        sall    $16, %edi
        movb    $16, %dl
0:
        testl   $-16777216, %edi
        jne     1f
        addl    $8, %edx
        sall    $8, %edi
1:
        testl   $-268435456, %edi
        jne     2f
        addl    $4, %edx
        sall    $4, %edi
2:
        testl   $-1073741824, %edi
        jne     3f
        addl    $2, %edx
        sall    $2, %edi
3:
        testl   %edi, %edi
        js      4f
        andl    $1073741824, %edi
        movl    $32, %eax
        je      5f
        leal    1(%rdx), %eax
        jmp     5f
4:
        movl    %edx, %eax
5:
        popq    %rbp
        retq
        .size   .Lhi0bits, .-.Lhi0bits

        .type   .Llo0bits, @function
.Llo0bits:
        movl    (%rdi), %edx
        pushq   %rbp
        movq    %rsp, %rbp
        testb   $7, %dl
        je      1f
        xorl    %eax, %eax
        testb   $1, %dl
        jne     7f
        testb   $2, %dl
        je      0f
        shrl    %edx
        movb    $1, %al
        movl    %edx, (%rdi)
        jmp     7f
0:
        shrl    $2, %edx
        movl    $2, %eax
        movl    %edx, (%rdi)
        jmp     7f
1:
        xorl    %ecx, %ecx
        testw   %dx, %dx
        jne     2f
        shrl    $16, %edx
        movb    $16, %cl
2:
        testb   %dl, %dl
        jne     3f
        addl    $8, %ecx
        shrl    $8, %edx
3:
        testb   $15, %dl
        jne     4f
        addl    $4, %ecx
        shrl    $4, %edx
4:
        testb   $3, %dl
        jne     5f
        addl    $2, %ecx
        shrl    $2, %edx
5:
        testb   $1, %dl
        jne     6f
        shrl    %edx
        movl    $32, %eax
        je      7f
        incl    %ecx
6:
        movl    %edx, (%rdi)
        movl    %ecx, %eax
7:
        popq    %rbp
        retq
        .size   .Llo0bits, .-.Llo0bits

        .type   .Lcmp, @function
.Lcmp:
        pushq   %rbp
        movslq  20(%rsi), %rdx
        movl    20(%rdi), %eax
        movq    %rsp, %rbp
        subl    %edx, %eax
        testl   %eax, %eax
        jne     2f
        salq    $2, %rdx
        addq    $24, %rdi
        leaq    (%rdi,%rdx), %rax
        leaq    24(%rsi,%rdx), %rdx
0:
        subq    $4, %rdx
        movl    (%rdx), %ecx
        subq    $4, %rax
        cmpl    %ecx, (%rax)
        je      1f
        sbbl    %eax, %eax
        orl     $1, %eax
        jmp     2f
1:
        cmpq    %rdi, %rax
        ja      0b
        xorl    %eax, %eax
2:
        popq    %rbp
        retq
        .size   .Lcmp, .-.Lcmp

        .type   .Lb2d, @function
.Lb2d:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        movq    %rsi, %r15
        pushq   %r14
        leaq    24(%rdi), %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        movslq  20(%rdi), %rax
        leaq    (%r14,%rax,4), %r13
        movabsq $.Lhi0bits, %rax
        movl    -4(%r13), %ebx
        leaq    -4(%r13), %r12
        movl    %ebx, %edi
        callq   *%rax
        movl    $32, %edx
        subl    %eax, %edx
        cmpl    $10, %eax
        movl    %edx, (%r15)
        jg      1f
        movl    $11, %ecx
        movl    %ebx, %edx
        xorl    %edi, %edi
        subl    %eax, %ecx
        shrl    %cl, %edx
        orl     $1072693248, %edx
        salq    $32, %rdx
        cmpq    %r14, %r12
        jbe     0f
        movl    -8(%r13), %edi
0:
        shrl    %cl, %edi
        leal    21(%rax), %ecx
        sall    %cl, %ebx
        orl     %ebx, %edi
        jmp     5f
1:
        xorl    %edx, %edx
        cmpq    %r14, %r12
        jbe     2f
        movl    -8(%r13), %edx
        leaq    -8(%r13), %r12
2:
        movl    %eax, %r8d
        subl    $11, %r8d
        je      4f
        movl    $43, %esi
        movb    %r8b, %cl
        movl    %edx, %edi
        subl    %eax, %esi
        sall    %cl, %ebx
        movb    %sil, %cl
        orl     $1072693248, %ebx
        shrl    %cl, %edi
        orl     %edi, %ebx
        xorl    %edi, %edi
        salq    $32, %rbx
        cmpq    %r14, %r12
        jbe     3f
        movl    -4(%r12), %edi
3:
        movb    %sil, %cl
        shrl    %cl, %edi
        movb    %r8b, %cl
        sall    %cl, %edx
        orl     %edx, %edi
        orq     %rbx, %rdi
        jmp     6f
4:
        movl    %ebx, %edi
        orl     $1072693248, %edi
        salq    $32, %rdi
5:
        orq     %rdx, %rdi
6:
        popq    %rbx
        movd    %rdi, %xmm0
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Lb2d, .-.Lb2d

        .type   .Lratio, @function
.Lratio:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r14
        movabsq $.Lb2d, %r14
        pushq   %r13
        movq    %rdi, %r13
        pushq   %r12
        movq    %rsi, %r12
        pushq   %rbx
        leaq    -40(%rbp), %rsi
        subq    $16, %rsp
        callq   *%r14
        leaq    -36(%rbp), %rsi
        movq    %r12, %rdi
        movd    %xmm0, %rbx
        callq   *%r14
        movl    20(%r13), %edx
        movl    -40(%rbp), %ecx
        movd    %xmm0, %rax
        subl    20(%r12), %edx
        subl    -36(%rbp), %ecx
        sall    $5, %edx
        addl    %ecx, %edx
        testl   %edx, %edx
        jle     0f
        movq    %rbx, %rcx
        sall    $20, %edx
        movl    %ebx, %ebx
        shrq    $32, %rcx
        addl    %ecx, %edx
        salq    $32, %rdx
        orq     %rdx, %rbx
        jmp     1f
0:
        movl    %edx, %ecx
        movd    %xmm0, %rdx
        movl    %eax, %eax
        sall    $20, %ecx
        shrq    $32, %rdx
        subl    %ecx, %edx
        salq    $32, %rdx
        orq     %rdx, %rax
1:
        movd    %rax, %xmm1
        popq    %rax
        movd    %rbx, %xmm0
        divsd   %xmm1, %xmm0
        popq    %rdx
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %rbp
        retq
        .size   .Lratio, .-.Lratio

        .type   .Lmatch, @function
.Lmatch:
        movq    (%rdi), %rdx
        pushq   %rbp
        movq    %rsp, %rbp
0:
        movsbl  (%rsi), %ecx
        leaq    1(%rdx), %rdx
        incq    %rsi
        testl   %ecx, %ecx
        je      1f
        movb    (%rdx), %r8b
        movsbl  %r8b, %eax
        subl    $65, %r8d
        leal    32(%rax), %r9d
        cmpb    $25, %r8b
        cmovbe  %r9d, %eax
        cmpl    %ecx, %eax
        je      0b
        xorl    %eax, %eax
        jmp     2f
1:
        movq    %rdx, (%rdi)
        movl    $1, %eax
2:
        popq    %rbp
        retq
        .size   .Lmatch, .-.Lmatch

        .type   .Lhexnan, @function
.Lhexnan:
        movq    (%rsi), %rax
0:
        movb    1(%rax), %dl
        leal    -1(%rdx), %ecx
        cmpb    $31, %cl
        ja      1f
        incq    %rax
        jmp     0b
1:
        pushq   %rbp
        cmpb    $48, %dl
        movq    %rsp, %rbp
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        jne     2f
        movb    2(%rax), %dl
        leaq    2(%rax), %rcx
        andl    $-33, %edx
        cmpb    $88, %dl
        cmove   %rcx, %rax
2:
        xorl    %edx, %edx
        xorl    %r8d, %r8d
        xorl    %r11d, %r11d
        movl    $1, %r10d
        xorl    %r9d, %r9d
        movl    $1, %ebx
        movabsq $.Lhexdig, %r12
        xorl    %r13d, %r13d
3:
        incq    %rax
        movzbl  (%rax), %ecx
        testl   %ecx, %ecx
        jne     4f
        {disp8} jmp 10f
4:
        movl    %ecx, %r14d
        movb    (%r12,%r14), %r14b
        testb   %r14b, %r14b
        je      5f
        andl    $15, %r14d
        xorl    %ecx, %ecx
        testl   %r11d, %r11d
        jne     8f
        movl    %edx, %ecx
        movl    %r8d, %edx
        jmp     8f
5:
        cmpl    $32, %ecx
        ja      7f
        testb   $1, %r9b
        je      3b
        testl   %r10d, %r10d
        cmovne  %ebx, %r11d
        setne   %cl
        testb   %cl, %cl
        cmovne  %r13d, %r10d
        cmovne  %ebx, %r9d
        jmp     3b
6:
        movsbl  (%rax), %ecx
        testl   %ecx, %ecx
        je      10f
7:
        leaq    1(%rax), %rax
        cmpl    $41, %ecx
        jne     6b
        movq    %rax, (%rsi)
        jmp     10f
8:
        testl   %r10d, %r10d
        je      9f
        sall    $4, %edx
        movl    %edx, %r8d
        movl    %ecx, %edx
        shrl    $28, %edx
        orl     %r8d, %edx
9:
        sall    $4, %ecx
        movl    %edx, %r8d
        xorl    %r11d, %r11d
        orl     %r14d, %ecx
        movl    $1, %r9d
        movl    %ecx, %edx
        jmp     3b
10:
        andl    $1048575, %r8d
        jne     11f
        testl   %edx, %edx
        je      12f
11:
        orl     $2146435072, %r8d
        movl    %edx, (%rdi)
        movl    %r8d, 4(%rdi)
12:
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %rbp
        retq
        .size   .Lhexnan, .-.Lhexnan

        .type   .Lrshift, @function
.Lrshift:
        movslq  20(%rdi), %rcx
        movl    %esi, %edx
        pushq   %rbp
        leaq    24(%rdi), %r8
        sarl    $5, %edx
        movq    %rsp, %rbp
        movq    %r8, %rax
        pushq   %rbx
        cmpl    %ecx, %edx
        jge     3f
        leaq    (%r8,%rcx,4), %rbx
        movslq  %edx, %rdx
        andl    $31, %esi
        leaq    (%r8,%rdx,4), %rdx
        je      2f
        leaq    4(%rdx), %r9
        movl    (%rdx), %edx
        movl    $32, %r11d
        movb    %sil, %cl
        subl    %esi, %r11d
        movq    %r8, %rax
        shrl    %cl, %edx
0:
        cmpq    %rbx, %r9
        jae     1f
        movl    (%r9), %r10d
        movb    %r11b, %cl
        addq    $4, %rax
        addq    $4, %r9
        sall    %cl, %r10d
        movb    %sil, %cl
        orl     %edx, %r10d
        movl    %r10d, -4(%rax)
        movl    -4(%r9), %edx
        shrl    %cl, %edx
        jmp     0b
1:
        leaq    4(%rax), %rcx
        testl   %edx, %edx
        movl    %edx, (%rax)
        cmovne  %rcx, %rax
        jmp     3f
2:
        cmpq    %rbx, %rdx
        jae     3f
        addq    $4, %rdx
        movl    -4(%rdx), %ecx
        addq    $4, %rax
        movl    %ecx, -4(%rax)
        jmp     2b
3:
        subq    %r8, %rax
        sarq    $2, %rax
        testl   %eax, %eax
        movl    %eax, 20(%rdi)
        jne     4f
        movl    $0, 24(%rdi)
4:
        popq    %rbx
        popq    %rbp
        retq
        .size   .Lrshift, .-.Lrshift

        .type   .Lany_on, @function
.Lany_on:
        pushq   %rbp
        leaq    24(%rdi), %r8
        movl    %esi, %edx
        movl    20(%rdi), %eax
        sarl    $5, %edx
        movq    %rsp, %rbp
        cmpl    %eax, %edx
        jg      0f
        jge     1f
        movl    %esi, %ecx
        andl    $31, %ecx
        je      1f
        movslq  %edx, %rax
        movl    (%r8,%rax,4), %r9d
        movl    $1, %eax
        movl    %r9d, %edi
        shrl    %cl, %edi
        sall    %cl, %edi
        cmpl    %r9d, %edi
        jne     4f
        jmp     1f
0:
        movl    %eax, %edx
1:
        movslq  %edx, %rdx
        leaq    (%r8,%rdx,4), %rax
2:
        cmpq    %r8, %rax
        jbe     3f
        subq    $4, %rax
        cmpl    $0, (%rax)
        je      2b
        movl    $1, %eax
        jmp     4f
3:
        xorl    %eax, %eax
4:
        popq    %rbp
        retq
        .size   .Lany_on, .-.Lany_on

        .type   .Ldshift, @function
.Ldshift:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %rbx
        movl    %esi, %ebx
        movl    20(%rdi), %eax
        decl    %eax
        cltq
        movl    24(%rdi,%rax,4), %edi
        movabsq $.Lhi0bits, %rax
        callq   *%rax
        subl    $4, %eax
        movl    %eax, %edx
        subl    %ebx, %edx
        testl   %ebx, %ebx
        popq    %rbx
        cmovg   %edx, %eax
        andl    $31, %eax
        popq    %rbp
        retq
        .size   .Ldshift, .-.Ldshift

        .type   .Lquorem, @function
.Lquorem:
        pushq   %rbp
        xorl    %eax, %eax
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        movq    %rdi, %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        subq    $16, %rsp
        movl    20(%rsi), %ebx
        cmpl    %ebx, 20(%rdi)
        jge     0f
        {disp8} jmp 11f
0:
        leaq    24(%rsi), %r13
        decl    %ebx
        xorl    %edx, %edx
        leaq    24(%rdi), %r12
        movslq  %ebx, %rcx
        salq    $2, %rcx
        leaq    0(%r13,%rcx), %r9
        addq    %r12, %rcx
        movl    (%r9), %eax
        leal    1(%rax), %edi
        movl    (%rcx), %eax
        divl    %edi
        testl   %eax, %eax
        movl    %eax, %r15d
        movl    %eax, -44(%rbp)
        je      5f
        movl    %r15d, %r8d
        movq    %r13, %rax
        movq    %r12, %rdx
        xorl    %r11d, %r11d
        xorl    %edi, %edi
        movq    %r8, -56(%rbp)
1:
        addq    $4, %rax
        movl    -4(%rax), %r10d
        addq    $4, %rdx
        movl    -4(%rdx), %r8d
        imulq   -56(%rbp), %r10
        addq    %r11, %r10
        movq    %r10, %r11
        movl    %r10d, %r10d
        subq    %r10, %r8
        shrq    $32, %r11
        subq    %rdi, %r8
        movq    %r8, %rdi
        movl    %r8d, -4(%rdx)
        shrq    $32, %rdi
        andl    $1, %edi
        cmpq    %r9, %rax
        jbe     1b
        cmpl    $0, (%rcx)
        jne     5f
2:
        subq    $4, %rcx
        cmpq    %r12, %rcx
        ja      4f
3:
        movl    %ebx, 20(%r14)
        jmp     5f
4:
        cmpl    $0, (%rcx)
        jne     3b
        decl    %ebx
        jmp     2b
5:
        movq    %r14, %rdi
        movq    %r9, -56(%rbp)
        movabsq $.Lcmp, %rax
        callq   *%rax
        testl   %eax, %eax
        js      10f
        movq    -56(%rbp), %r9
        leal    1(%r15), %eax
        movq    %r12, %rdx
        movl    %eax, -44(%rbp)
        xorl    %ecx, %ecx
6:
        addq    $4, %r13
        movl    (%rdx), %eax
        addq    $4, %rdx
        movl    -4(%r13), %esi
        subq    %rsi, %rax
        subq    %rcx, %rax
        movq    %rax, %rcx
        movl    %eax, -4(%rdx)
        shrq    $32, %rcx
        andl    $1, %ecx
        cmpq    %r9, %r13
        jbe     6b
        movslq  %ebx, %rax
        leaq    (%r12,%rax,4), %rax
        cmpl    $0, (%rax)
        jne     10f
7:
        subq    $4, %rax
        cmpq    %r12, %rax
        ja      9f
8:
        movl    %ebx, 20(%r14)
        jmp     10f
9:
        cmpl    $0, (%rax)
        jne     8b
        decl    %ebx
        jmp     7b
10:
        movl    -44(%rbp), %eax
11:
        popq    %rsi
        popq    %rdi
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Lquorem, .-.Lquorem

        .type   .LBalloc, @function
.LBalloc:
        pushq   %rbp
        cmpl    $7, %edi
        movq    %rsp, %rbp
        jg      0f
        movabsq $.Lfreelist, %rdx
        movslq  %edi, %rcx
        movq    (%rdx,%rcx,8), %r8
        testq   %r8, %r8
        je      0f
        movq    (%r8), %rsi
        movq    %rsi, (%rdx,%rcx,8)
        jmp     2f
0:
        movb    %dil, %cl
        movl    $1, %edx
        sall    %cl, %edx
        leal    -1(%rdx), %eax
        cltq
        leaq    39(,%rax,4), %rcx
        shrq    $3, %rcx
        cmpl    $7, %edi
        jg      1f
        movabsq $.Lpmem_next, %rax
        movl    %ecx, %esi
        movabsq $.Lprivate_mem, %rcx
        movq    (%rax), %r8
        movq    %r8, %rax
        subq    %rcx, %rax
        movq    %rax, %rcx
        sarq    $3, %rcx
        addq    %rsi, %rcx
        cmpq    $2048, %rcx
        ja      1f
        leaq    (%r8,%rsi,8), %rcx
        movl    %edi, 8(%r8)
        movq    %rcx, %rax
        movl    %edx, 12(%r8)
        movabsq %rax, .Lpmem_next
        jmp     2f
1:
        movabsq $.Lbadxit, %rax
        callq   *%rax
2:
        movl    $0, 20(%r8)
        movq    %r8, %rax
        movl    $0, 16(%r8)
        popq    %rbp
        retq
        .size   .LBalloc, .-.LBalloc

        .type   .Ld2b, @function
.Ld2b:
        movabsq $.LBalloc, %rax
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        movq    %rdi, %r15
        pushq   %r14
        movl    $1, %edi
        pushq   %r13
        movq    %rsi, %r13
        pushq   %r12
        movq    %rdx, %r12
        pushq   %rbx
        subq    $24, %rsp
        callq   *%rax
        movl    4(%r15), %r14d
        movq    %rax, %rbx
        movl    %r14d, %eax
        andl    $2147483647, %r14d
        andl    $1048575, %eax
        movl    %r14d, 4(%r15)
        shrl    $20, %r14d
        movl    %eax, -52(%rbp)
        je      0f
        orl     $1048576, %eax
        movl    %eax, -52(%rbp)
0:
        movl    (%r15), %eax
        testl   %eax, %eax
        movl    %eax, -56(%rbp)
        movabsq $.Llo0bits, %rax
        je      3f
        leaq    -56(%rbp), %rdi
        callq   *%rax
        testl   %eax, %eax
        je      1f
        movl    -52(%rbp), %edx
        movl    $32, %ecx
        subl    %eax, %ecx
        movl    %edx, %esi
        sall    %cl, %esi
        movl    -56(%rbp), %ecx
        orl     %esi, %ecx
        movl    %ecx, 24(%rbx)
        movb    %al, %cl
        shrl    %cl, %edx
        movl    %edx, -52(%rbp)
        jmp     2f
1:
        movl    -56(%rbp), %edx
        movl    %edx, 24(%rbx)
2:
        movl    -52(%rbp), %edx
        cmpl    $1, %edx
        movl    %edx, 28(%rbx)
        sbbl    %r15d, %r15d
        addl    $2, %r15d
        movl    %r15d, 20(%rbx)
        jmp     4f
3:
        leaq    -52(%rbp), %rdi
        movl    $1, %r15d
        callq   *%rax
        movl    -52(%rbp), %edx
        movl    $1, 20(%rbx)
        addl    $32, %eax
        movl    %edx, 24(%rbx)
4:
        testl   %r14d, %r14d
        je      5f
        leal    -1075(%rax,%r14), %edx
        movl    %edx, 0(%r13)
        movl    $53, %edx
        subl    %eax, %edx
        movl    %edx, (%r12)
        jmp     6f
5:
        subl    $1074, %eax
        movl    %eax, 0(%r13)
        movslq  %r15d, %rax
        sall    $5, %r15d
        movl    20(%rbx,%rax,4), %edi
        movabsq $.Lhi0bits, %rax
        callq   *%rax
        subl    %eax, %r15d
        movl    %r15d, (%r12)
6:
        addq    $24, %rsp
        movq    %rbx, %rax
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Ld2b, .-.Ld2b

        .type   .Li2b, @function
.Li2b:
        movabsq $.LBalloc, %rax
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %rbx
        movl    %edi, %ebx
        pushq   %r9
        movl    $1, %edi
        callq   *%rax
        movl    %ebx, 24(%rax)
        movl    $1, 20(%rax)
        popq    %r10
        popq    %rbx
        popq    %rbp
        retq
        .size   .Li2b, .-.Li2b

        .type   .Lmult, @function
.Lmult:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        movq    %rsi, %r13
        pushq   %r12
        pushq   %rbx
        pushq   %rbx
        movq    %rdi, %rbx
        movl    20(%rsi), %eax
        cmpl    %eax, 20(%rdi)
        jge     0f
        movq    %rsi, %rbx
        movq    %rdi, %r13
0:
        movslq  20(%rbx), %r15
        xorl    %edi, %edi
        movabsq $.LBalloc, %rax
        movslq  20(%r13), %r14
        leal    (%r15,%r14), %r12d
        cmpl    12(%rbx), %r12d
        setg    %dil
        addl    8(%rbx), %edi
        callq   *%rax
        movslq  %r12d, %rcx
        leaq    24(%rax), %rdx
        leaq    (%rdx,%rcx,4), %rcx
        movq    %rdx, %rsi
1:
        cmpq    %rcx, %rsi
        jae     2f
        movl    $0, (%rsi)
        addq    $4, %rsi
        jmp     1b
2:
        addq    $24, %rbx
        addq    $24, %r13
        leaq    (%rbx,%r15,4), %r11
        leaq    0(%r13,%r14,4), %r14
3:
        cmpq    %r14, %r13
        jae     8f
        addq    $4, %r13
        movl    -4(%r13), %r9d
        testl   %r9d, %r9d
        je      6f
        movq    %rdx, %rsi
        movq    %rbx, %rdi
        xorl    %r8d, %r8d
        movl    %r9d, %r15d
4:
        addq    $4, %rdi
        movl    -4(%rdi), %r10d
        movl    (%rsi), %r9d
        imulq   %r15, %r10
        addq    %r9, %r10
        leaq    4(%rsi), %r9
        addq    %r8, %r10
        movq    %r10, %r8
        movl    %r10d, (%rsi)
        shrq    $32, %r8
        cmpq    %r11, %rdi
        jae     5f
        movq    %r9, %rsi
        jmp     4b
5:
        movl    %r8d, 4(%rsi)
6:
        addq    $4, %rdx
        jmp     3b
7:
        subq    $4, %rcx
        cmpl    $0, (%rcx)
        jne     9f
        decl    %r12d
8:
        testl   %r12d, %r12d
        jg      7b
9:
        movl    %r12d, 20(%rax)
        popq    %r11
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Lmult, .-.Lmult

        .type   .Ldiff, @function
.Ldiff:
        movabsq $.Lcmp, %rax
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r13
        pushq   %r12
        movq    %rsi, %r12
        pushq   %rbx
        movq    %rdi, %rbx
        pushq   %r13
        callq   *%rax
        testl   %eax, %eax
        movabsq $.LBalloc, %rax
        jne     0f
        xorl    %edi, %edi
        callq   *%rax
        movl    $1, 20(%rax)
        movl    $0, 24(%rax)
        jmp     7f
0:
        js      1f
        xorl    %r13d, %r13d
        jmp     2f
1:
        movq    %rbx, %rdx
        movl    $1, %r13d
        movq    %r12, %rbx
        movq    %rdx, %r12
2:
        movl    8(%rbx), %edi
        callq   *%rax
        movl    20(%rbx), %r9d
        leaq    24(%rbx), %rdi
        leaq    24(%r12), %r8
        movl    %r13d, 16(%rax)
        xorl    %ecx, %ecx
        movslq  %r9d, %rdx
        leaq    (%rdi,%rdx,4), %r10
        movslq  20(%r12), %rdx
        leaq    (%r8,%rdx,4), %r11
        leaq    24(%rax), %rdx
3:
        addq    $4, %rdi
        addq    $4, %r8
        movl    -4(%rdi), %esi
        movl    -4(%r8), %ebx
        addq    $4, %rdx
        subq    %rbx, %rsi
        subq    %rcx, %rsi
        movq    %rsi, %rcx
        movl    %esi, -4(%rdx)
        shrq    $32, %rcx
        andl    $1, %ecx
        cmpq    %r11, %r8
        jb      3b
4:
        cmpq    %r10, %rdi
        jae     5f
        addq    $4, %rdi
        movl    -4(%rdi), %esi
        addq    $4, %rdx
        subq    %rcx, %rsi
        movq    %rsi, %rcx
        movl    %esi, -4(%rdx)
        shrq    $32, %rcx
        andl    $1, %ecx
        jmp     4b
5:
        subq    $4, %rdx
        cmpl    $0, (%rdx)
        jne     6f
        decl    %r9d
        jmp     5b
6:
        movl    %r9d, 20(%rax)
7:
        popq    %r12
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %rbp
        retq
        .size   .Ldiff, .-.Ldiff

        .type   .Lrv_alloc, @function
.Lrv_alloc:
        pushq   %rbp
        movl    $4, %eax
        movslq  %edi, %rdi
        movq    %rsp, %rbp
        pushq   %rbx
        xorl    %ebx, %ebx
        pushq   %rcx
0:
        movslq  %eax, %rdx
        addq    $24, %rdx
        cmpq    %rdi, %rdx
        ja      1f
        incl    %ebx
        addl    %eax, %eax
        jmp     0b
1:
        movabsq $.LBalloc, %rax
        movl    %ebx, %edi
        callq   *%rax
        movl    %ebx, (%rax)
        addq    $4, %rax
        movabsq %rax, .Ldtoa_result
        popq    %rdx
        popq    %rbx
        popq    %rbp
        retq
        .size   .Lrv_alloc, .-.Lrv_alloc

        .type   .Lnrv_alloc, @function
.Lnrv_alloc:
        movabsq $.Lrv_alloc, %rax
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r12
        movq    %rsi, %r12
        pushq   %rbx
        movq    %rdi, %rbx
        movl    %edx, %edi
        callq   *%rax
        movq    %rax, %rdx
0:
        incq    %rbx
        movb    -1(%rbx), %cl
        testb   %cl, %cl
        movb    %cl, (%rdx)
        je      1f
        incq    %rdx
        jmp     0b
1:
        testq   %r12, %r12
        je      2f
        movq    %rdx, (%r12)
2:
        popq    %rbx
        popq    %r12
        popq    %rbp
        retq
        .size   .Lnrv_alloc, .-.Lnrv_alloc

        .type   .LBfree, @function
.LBfree:
        testq   %rdi, %rdi
        je      1f
        movslq  8(%rdi), %rdx
        cmpl    $7, %edx
        jle     0f
        movabsq $.Lbadxit, %rax
        pushq   %rbp
        movq    %rsp, %rbp
        callq   *%rax
0:
        movabsq $.Lfreelist, %rax
        movq    (%rax,%rdx,8), %rcx
        movq    %rdi, (%rax,%rdx,8)
        movq    %rcx, (%rdi)
1:
        retq
        .size   .LBfree, .-.LBfree

        .type   .Llshift, @function
.Llshift:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        movl    %esi, %r14d
        pushq   %r13
        movl    %esi, %r13d
        pushq   %r12
        sarl    $5, %r13d
        pushq   %rbx
        movq    %rdi, %rbx
        subq    $24, %rsp
        movl    20(%rbx), %r15d
        movl    8(%rdi), %edi
        movl    12(%rbx), %eax
        addl    %r13d, %r15d
        leal    1(%r15), %r12d
0:
        cmpl    %eax, %r12d
        jle     1f
        incl    %edi
        addl    %eax, %eax
        jmp     0b
1:
        movabsq $.LBalloc, %rax
        callq   *%rax
        xorl    %edx, %edx
        leaq    24(%rax), %rcx
2:
        cmpl    %edx, %r13d
        jle     3f
        movl    $0, (%rcx,%rdx,4)
        incq    %rdx
        jmp     2b
3:
        xorl    %edx, %edx
        testl   %r13d, %r13d
        cmovns  %r13d, %edx
        andl    $31, %r14d
        movslq  %edx, %rdx
        leaq    (%rcx,%rdx,4), %rdi
        movslq  20(%rbx), %rcx
        leaq    24(%rbx), %rdx
        leaq    (%rdx,%rcx,4), %r10
        je      6f
        movl    $32, %esi
        xorl    %r8d, %r8d
        subl    %r14d, %esi
4:
        movl    (%rdx), %r9d
        movb    %r14b, %cl
        addq    $4, %rdx
        leaq    4(%rdi), %r11
        sall    %cl, %r9d
        movb    %sil, %cl
        orl     %r8d, %r9d
        movl    %r9d, (%rdi)
        movl    -4(%rdx), %r8d
        shrl    %cl, %r8d
        cmpq    %r10, %rdx
        jae     5f
        movq    %r11, %rdi
        jmp     4b
5:
        addl    $2, %r15d
        testl   %r8d, %r8d
        movl    %r8d, 4(%rdi)
        cmovne  %r15d, %r12d
        jmp     7f
6:
        addl    $2, %r15d
        addq    $4, %rdx
        movl    -4(%rdx), %ecx
        addq    $4, %rdi
        cmpq    %r10, %rdx
        movl    %ecx, -4(%rdi)
        jb      6b
7:
        addl    $2, %r15d
        decl    %r12d
        movq    %rbx, %rdi
        movq    %rax, -56(%rbp)
        movabsq $.LBfree, %rdx
        movl    %r12d, 20(%rax)
        callq   *%rdx
        movq    -56(%rbp), %rax
        addq    $24, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Llshift, .-.Llshift

        .type   .Lincrement, @function
.Lincrement:
        pushq   %rbp
        leaq    24(%rdi), %rax
        movq    %rsp, %rbp
        pushq   %r12
        pushq   %rbx
        movq    %rdi, %rbx
        movslq  20(%rdi), %rdx
        leaq    (%rax,%rdx,4), %rcx
0:
        movl    (%rax), %edx
        cmpl    $-1, %edx
        je      1f
        incl    %edx
        movl    %edx, (%rax)
        jmp     3f
1:
        addq    $4, %rax
        movl    $0, -4(%rax)
        cmpq    %rcx, %rax
        jb      0b
        movl    12(%rbx), %eax
        cmpl    %eax, 20(%rbx)
        jl      2f
        movl    8(%rbx), %eax
        leal    1(%rax), %edi
        movabsq $.LBalloc, %rax
        callq   *%rax
        leaq    16(%rbx), %rsi
        movq    %rax, %r12
        movslq  20(%rbx), %rax
        leaq    16(%r12), %rdi
        leaq    8(,%rax,4), %rdx
        movabsq $.Lmymemcpy, %rax
        callq   *%rax
        movq    %rbx, %rdi
        movq    %r12, %rbx
        movabsq $.LBfree, %rax
        callq   *%rax
2:
        movslq  20(%rbx), %rax
        leal    1(%rax), %edx
        movl    %edx, 20(%rbx)
        movl    $1, 24(%rbx,%rax,4)
3:
        movq    %rbx, %rax
        popq    %rbx
        popq    %r12
        popq    %rbp
        retq
        .size   .Lincrement, .-.Lincrement

        .type   .Lmultadd, @function
.Lmultadd:
        pushq   %rbp
        leaq    24(%rdi), %rcx
        xorl    %eax, %eax
        movq    %rsp, %rbp
        pushq   %r14
        movslq  %esi, %rsi
        pushq   %r13
        movslq  %edx, %r13
        pushq   %r12
        pushq   %rbx
        movq    %rdi, %rbx
        movl    20(%rdi), %r12d
0:
        movl    (%rcx,%rax,4), %edx
        imulq   %rsi, %rdx
        addq    %r13, %rdx
        movq    %rdx, %r13
        movl    %edx, (%rcx,%rax,4)
        incq    %rax
        shrq    $32, %r13
        cmpl    %eax, %r12d
        jg      0b
        testq   %r13, %r13
        je      2f
        cmpl    12(%rbx), %r12d
        jl      1f
        movl    8(%rbx), %eax
        leal    1(%rax), %edi
        movabsq $.LBalloc, %rax
        callq   *%rax
        leaq    16(%rbx), %rsi
        movq    %rax, %r14
        movslq  20(%rbx), %rax
        leaq    16(%r14), %rdi
        leaq    8(,%rax,4), %rdx
        movabsq $.Lmymemcpy, %rax
        callq   *%rax
        movq    %rbx, %rdi
        movq    %r14, %rbx
        movabsq $.LBfree, %rax
        callq   *%rax
1:
        movslq  %r12d, %rax
        incl    %r12d
        movl    %r13d, 24(%rbx,%rax,4)
        movl    %r12d, 20(%rbx)
2:
        movq    %rbx, %rax
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %rbp
        retq
        .size   .Lmultadd, .-.Lmultadd

        .type   .Ls2b, @function
.Ls2b:
        pushq   %rbp
        leal    8(%rdx), %eax
        movq    %rsp, %rbp
        pushq   %r15
        movq    %rdi, %r15
        pushq   %r14
        movl    %edx, %r14d
        cltd
        pushq   %r13
        xorl    %edi, %edi
        movl    %ecx, %r13d
        pushq   %r12
        movslq  %r8d, %r12
        pushq   %rbx
        movl    %esi, %ebx
        movl    $9, %esi
        idivl   %esi
        subq    $24, %rsp
        movb    $1, %sil
0:
        cmpl    %esi, %eax
        jle     1f
        addl    %esi, %esi
        incl    %edi
        jmp     0b
1:
        movabsq $.LBalloc, %rax
        callq   *%rax
        cmpl    $9, %ebx
        movl    %r13d, 24(%rax)
        movl    $1, 20(%rax)
        jle     3f
        leaq    9(%r15), %rcx
        xorl    %r13d, %r13d
        movabsq $.Lmultadd, %r8
2:
        movsbl  9(%r15,%r13), %edx
        movl    $10, %esi
        incq    %r13
        movq    %rax, %rdi
        movq    %rcx, -64(%rbp)
        movq    %r8, -56(%rbp)
        subl    $48, %edx
        callq   *%r8
        leal    9(%r13), %edx
        movq    -56(%rbp), %r8
        cmpl    %ebx, %edx
        movq    -64(%rbp), %rcx
        jl      2b
        leal    -10(%rbx), %edx
        leaq    1(%rcx,%rdx), %rdx
        addq    %rdx, %r12
        jmp     4f
3:
        leaq    9(%r15,%r12), %r12
        movl    $9, %ebx
4:
        subl    %r12d, %ebx
5:
        leal    (%rbx,%r12), %edx
        cmpl    %r14d, %edx
        jge     6f
        incq    %r12
        movsbl  -1(%r12), %edx
        movq    %rax, %rdi
        movabsq $.Lmultadd, %rax
        movl    $10, %esi
        subl    $48, %edx
        callq   *%rax
        jmp     5b
6:
        addq    $24, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Ls2b, .-.Ls2b

        .type   .Lpow5mult, @function
.Lpow5mult:
        pushq   %rbp
        movl    %esi, %edx
        movq    %rsp, %rbp
        pushq   %r15
        andl    $3, %edx
        pushq   %r14
        pushq   %r13
        movl    %esi, %r13d
        pushq   %r12
        movq    %rdi, %r12
        pushq   %rbx
        pushq   %r8
        je      0f
        movabsq $.Lp05.3208, %rax
        decl    %edx
        movslq  %edx, %rdx
        movl    (%rax,%rdx,4), %esi
        xorl    %edx, %edx
        movabsq $.Lmultadd, %rax
        callq   *%rax
        movq    %rax, %r12
0:
        sarl    $2, %r13d
        jne     1f
        {disp8} jmp 7f
1:
        movabsq $.Lp5s, %rax
        movq    (%rax), %rbx
        testq   %rbx, %rbx
        jne     2f
        movabsq $.Li2b, %rax
        movl    $625, %edi
        callq   *%rax
        movabsq %rax, .Lp5s
        movq    %rax, %rbx
        movq    $0, (%rbx)
2:
        movabsq $.Lmult, %r14
3:
        testb   $1, %r13b
        je      4f
        movq    %r12, %rdi
        movq    %rbx, %rsi
        callq   *%r14
        movq    %r12, %rdi
        movq    %rax, %r15
        movabsq $.LBfree, %rax
        callq   *%rax
        movq    %r15, %r12
4:
        sarl    %r13d
        je      7f
        movq    (%rbx), %rax
        testq   %rax, %rax
        je      6f
5:
        movq    %rax, %rbx
        jmp     3b
6:
        movq    %rbx, %rsi
        movq    %rbx, %rdi
        callq   *%r14
        movq    %rax, (%rbx)
        movq    $0, (%rax)
        jmp     5b
7:
        popq    %rsi
        movq    %r12, %rax
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Lpow5mult, .-.Lpow5mult

        .type   .Lulp.isra.0, @function
.Lulp.isra.0:
        andl    $2146435072, %edi
        pushq   %rbp
        subl    $54525952, %edi
        movq    %rsp, %rbp
        testl   %edi, %edi
        jg      0f
        negl    %edi
        sarl    $20, %edi
        cmpl    $19, %edi
        jg      1f
        movl    $524288, %eax
        movb    %dil, %cl
        movl    %eax, %edx
        sarl    %cl, %edx
        movq    %rdx, %rdi
0:
        salq    $32, %rdi
        jmp     3f
1:
        cmpl    $50, %edi
        movl    $1, %eax
        jg      2f
        movl    $51, %ecx
        subl    %edi, %ecx
        sall    %cl, %eax
2:
        movl    %eax, %edi
3:
        movd    %rdi, %xmm0
        popq    %rbp
        retq
        .size   .Lulp.isra.0, .-.Lulp.isra.0

        .type   .Lgethex, @function
.Lgethex:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        subq    $40, %rsp
        movl    %edx, -56(%rbp)
        movq    (%rdi), %rax
        movq    %rsi, -64(%rbp)
        movl    %ecx, -52(%rbp)
        leaq    2(%rax), %rdx
        movq    %rdx, %rbx
0:
        movq    %rbx, %r14
        movl    %ebx, %r9d
        leaq    1(%r14), %rbx
        movb    -1(%rbx), %al
        subl    %edx, %r9d
        cmpb    $48, %al
        je      0b
        movabsq $.Lhexdig, %rdx
        movzbl  %al, %ecx
        cmpb    $0, (%rdx,%rcx)
        je      2f
        incl    %r9d
        xorl    %r8d, %r8d
        xorl    %ebx, %ebx
1:
        movq    %r14, %r13
        {disp8} jmp 5f
2:
        cmpb    $46, %al
        movq    %r14, %r13
        jne     10f
        movzbl  1(%r14), %eax
        movq    %rbx, %r13
        cmpb    $0, (%rdx,%rax)
        je      10f
        movq    %rbx, %r14
3:
        movzbl  (%r14), %eax
        cmpb    $48, %al
        jne     4f
        incq    %r14
        {disp8} jmp 3b
4:
        xorl    %r8d, %r8d
        cmpb    $0, (%rdx,%rax)
        movl    $1, %r9d
        sete    %r8b
        {disp8} jmp 1b
5:
        movb    0(%r13), %al
        movzbl  %al, %ecx
        cmpb    $0, (%rdx,%rcx)
        je      6f
        incq    %r13
        {disp8} jmp 5b
6:
        cmpb    $46, %al
        jne     8f
        testq   %rbx, %rbx
        jne     9f
        leaq    1(%r13), %rbx
        movq    %rbx, %r13
7:
        movzbl  0(%r13), %eax
        cmpb    $0, (%rdx,%rax)
        je      8f
        incq    %r13
        {disp8} jmp 7b
8:
        testq   %rbx, %rbx
        je      11f
9:
        subl    %r13d, %ebx
        sall    $2, %ebx
        {disp8} jmp 12f
10:
        movl    $1, %r8d
11:
        xorl    %ebx, %ebx
12:
        movb    0(%r13), %al
        cmpb    $80, %al
        je      13f
        cmpb    $112, %al
        je      13f
        {disp8} jmp 20f
13:
        movb    1(%r13), %al
        cmpb    $43, %al
        je      14f
        cmpb    $45, %al
        je      15f
        leaq    1(%r13), %rax
        xorl    %ecx, %ecx
        {disp8} jmp 17f
14:
        xorl    %ecx, %ecx
        {disp8} jmp 16f
15:
        movl    $1, %ecx
16:
        leaq    2(%r13), %rax
17:
        movzbl  (%rax), %esi
        movzbl  (%rdx,%rsi), %edx
        leal    -1(%rdx), %esi
        cmpb    $24, %sil
        ja      21f
        subl    $16, %edx
        xorl    %esi, %esi
        movl    $1, %r15d
        movabsq $.Lhexdig, %r12
18:
        incq    %rax
        movzbl  (%rax), %r10d
        movb    (%r12,%r10), %r10b
        movzbl  %r10b, %r11d
        decl    %r10d
        cmpb    $24, %r10b
        ja      19f
        testl   $-134217728, %edx
        cmovne  %r15d, %esi
        imull   $10, %edx, %edx
        leal    -16(%r11,%rdx), %edx
        {disp8} jmp 18b
19:
        movl    %edx, %r10d
        negl    %r10d
        testl   %ecx, %ecx
        cmovne  %r10d, %edx
        addl    %edx, %ebx
        {disp8} jmp 23f
20:
        movq    %r13, %rax
        xorl    %ecx, %ecx
        {disp8} jmp 22f
21:
        movq    %r13, %rax
22:
        xorl    %esi, %esi
23:
        testl   %r9d, %r9d
        jne     24f
        leaq    -1(%r14), %rax
24:
        testl   %r8d, %r8d
        movq    %rax, (%rdi)
        je      25f
        {disp8} jmp 82f
25:
        testl   %esi, %esi
        jne     26f
        {disp8} jmp 50f
26:
        testl   %ecx, %ecx
        movl    -56(%rbp), %eax
        jne     27f
        {disp8} jmp 45f
27:
        cmpl    $2, %eax
        je      28f
        cmpl    $3, %eax
        je      30f
        {disp8} jmp 81f
28:
        cmpl    $0, -52(%rbp)
        je      29f
        {disp8} jmp 81f
29:
        {disp8} jmp 44f
30:
        cmpl    $0, -52(%rbp)
        jne     31f
        {disp8} jmp 81f
31:
        {disp8} jmp 44f
32:
        movabsq $.LBalloc, %rax
        callq   *%rax
        xorl    %ecx, %ecx
        xorl    %edi, %edi
        leaq    24(%rax), %r12
        movq    %rax, %r15
        movabsq $.Lhexdig, %r8
        movq    %r12, %rax
33:
        cmpq    %r14, %r13
        jbe     34f
        {disp8} jmp 53f
34:
        leaq    4(%rax), %r14
        movl    %edi, (%rax)
        movabsq $.Lhi0bits, %r13
        subq    %r12, %r14
        sarq    $2, %r14
        movl    %r14d, 20(%r15)
        sall    $5, %r14d
        callq   *%r13
        movq    %r13, -72(%rbp)
        subl    %eax, %r14d
        cmpl    $53, %r14d
        jg      35f
        {disp8} jmp 60f
35:
        leal    -53(%r14), %r13d
        movq    %r15, %rdi
        movabsq $.Lany_on, %r9
        movl    %r13d, %esi
        movq    %r9, -80(%rbp)
        callq   *%r9
        xorl    %r8d, %r8d
        movq    -80(%rbp), %r9
        testl   %eax, %eax
        je      36f
        {disp8} jmp 56f
36:
        movl    %r13d, %esi
        movq    %r15, %rdi
        movl    %r8d, -80(%rbp)
        movabsq $.Lrshift, %rax
        addl    %r13d, %ebx
        callq   *%rax
37:
        movl    -80(%rbp), %r8d
38:
        movabsq $.LBfree, %r13
        cmpl    $1023, %ebx
        jle     39f
        {disp8} jmp 75f
39:
        cmpl    $-1074, %ebx
        jl      40f
        {disp8} jmp 84f
40:
        movl    $-1074, %r9d
        subl    %ebx, %r9d
        cmpl    $52, %r9d
        jg      41f
        {disp8} jmp 62f
41:
        movl    -56(%rbp), %eax
        cmpl    $2, %eax
        je      42f
        {disp8} jmp 77f
42:
        cmpl    $0, -52(%rbp)
        je      43f
        {disp8} jmp 80f
43:
        movq    %r15, %rdi
        callq   *%r13
44:
        movabsq $.Lerrno, %rax
        movl    $34, (%rax)
        movq    -64(%rbp), %rax
        movl    $0, 4(%rax)
        movl    $1, (%rax)
        {disp8} jmp 94f
45:
        cmpl    $2, %eax
        je      46f
        cmpl    $3, %eax
        je      48f
        decl    %eax
        {disp8} jmp 47f
46:
        cmpl    $0, -52(%rbp)
47:
        jne     49f
        {disp8} jmp 76f
48:
        cmpl    $0, -52(%rbp)
        je      49f
        {disp8} jmp 76f
49:
        movq    -64(%rbp), %rax
        movl    $2146435071, 4(%rax)
        movl    $-1, (%rax)
        {disp8} jmp 94f
50:
        movq    %r13, %rax
        xorl    %edi, %edi
        subq    %r14, %rax
        decl    %eax
51:
        cmpl    $7, %eax
        jg      52f
        {disp8} jmp 32b
52:
        incl    %edi
        sarl    %eax
        {disp8} jmp 51b
53:
        decq    %r13
        cmpb    $46, 0(%r13)
        jne     54f
        {disp8} jmp 33b
54:
        cmpl    $32, %ecx
        jne     55f
        movl    %edi, (%rax)
        xorb    %cl, %cl
        addq    $4, %rax
        xorl    %edi, %edi
55:
        movzbl  0(%r13), %esi
        movb    (%r8,%rsi), %sil
        andl    $15, %esi
        sall    %cl, %esi
        addl    $4, %ecx
        orl     %esi, %edi
        {disp8} jmp 33b
56:
        leal    -54(%r14), %esi
        movl    $1, %eax
        movb    $1, %r8b
        movl    %esi, %edi
        movl    %esi, %ecx
        sarl    $5, %edi
        sall    %cl, %eax
        movslq  %edi, %rdi
        testl   %eax, (%r12,%rdi,4)
        jne     57f
        {disp8} jmp 36b
57:
        testl   %esi, %esi
        jne     59f
58:
        movl    $2, %r8d
        {disp8} jmp 36b
59:
        movq    %r15, %rdi
        callq   *%r9
        testl   %eax, %eax
        je      58b
        movl    $3, %r8d
        {disp8} jmp 36b
60:
        movl    $0, %r8d
        jne     61f
        {disp8} jmp 38b
61:
        movl    $53, %r12d
        movq    %r15, %rdi
        movl    %r8d, -80(%rbp)
        movabsq $.Llshift, %rax
        subl    %r14d, %r12d
        movl    %r12d, %esi
        subl    %r12d, %ebx
        callq   *%rax
        leaq    24(%rax), %r12
        movq    %rax, %r15
        {disp8} jmp 37b
62:
        movl    $-1075, %r14d
        subl    %ebx, %r14d
        testl   %r8d, %r8d
        je      63f
        {disp8} jmp 83f
63:
        testl   %r14d, %r14d
        je      64f
        movl    %r14d, %esi
        movq    %r15, %rdi
        movl    %r9d, -80(%rbp)
        movabsq $.Lany_on, %rax
        callq   *%rax
        movl    -80(%rbp), %r9d
        movl    %eax, %r8d
64:
        movl    %r14d, %esi
        movl    %r14d, %ecx
        movl    $1, %eax
        sarl    $5, %esi
        sall    %cl, %eax
        movl    %r8d, %ecx
        movslq  %esi, %rsi
        orl     $2, %ecx
        movq    %r15, %rdi
        testl   %eax, (%r12,%rsi,4)
        leal    1127(%rbx), %r14d
        movl    %r9d, %esi
        movabsq $.Lrshift, %rax
        movl    $-1074, %ebx
        cmovne  %ecx, %r8d
        movl    %r8d, -80(%rbp)
        callq   *%rax
        movl    -80(%rbp), %r8d
        movl    $1, %ecx
65:
        testl   %r8d, %r8d
        jne     66f
        {disp8} jmp 88f
66:
        movl    -56(%rbp), %eax
        cmpl    $2, %eax
        jne     67f
        {disp8} jmp 85f
67:
        cmpl    $3, %eax
        jne     68f
        {disp8} jmp 86f
68:
        decl    %eax
        je      69f
        {disp8} jmp 88f
69:
        testb   $2, %r8b
        jne     70f
        {disp8} jmp 88f
70:
        orl     (%r12), %r8d
        andb    $1, %r8b
71:
        jne     72f
        {disp8} jmp 88f
72:
        movq    %r15, %rdi
        movl    %ecx, -52(%rbp)
        movslq  20(%r15), %r12
        movabsq $.Lincrement, %rax
        callq   *%rax
        movl    -52(%rbp), %ecx
        movq    %rax, %r15
        testl   %ecx, %ecx
        je      73f
        {disp8} jmp 89f
73:
        cmpl    %r12d, 20(%rax)
        jg      74f
        {disp8} jmp 87f
74:
        movl    $1, %esi
        movq    %r15, %rdi
        incl    %ebx
        movabsq $.Lrshift, %rax
        callq   *%rax
        cmpl    $1024, %ebx
        je      75f
        {disp8} jmp 92f
75:
        movq    %r15, %rdi
        callq   *%r13
76:
        movabsq $.Lerrno, %rax
        movl    $34, (%rax)
        movq    -64(%rbp), %rax
        movl    $2146435072, 4(%rax)
        movl    $0, (%rax)
        {disp8} jmp 94f
77:
        cmpl    $3, %eax
        je      78f
        decl    %eax
        jne     80f
        cmpl    $53, %r9d
        jne     80f
        movl    $-1075, %esi
        movq    %r15, %rdi
        movabsq $.Lany_on, %rax
        subl    %ebx, %esi
        callq   *%rax
        testl   %eax, %eax
        {disp8} jmp 79f
78:
        cmpl    $0, -52(%rbp)
79:
        je      80f
        {disp8} jmp 43b
80:
        movq    %r15, %rdi
        callq   *%r13
81:
        movabsq $.Lerrno, %rax
        movl    $34, (%rax)
82:
        movq    -64(%rbp), %rax
        movq    $0, (%rax)
        {disp8} jmp 94f
83:
        movl    $1, %r8d
        {disp8} jmp 64b
84:
        movl    $53, %r14d
        xorl    %ecx, %ecx
        {disp8} jmp 65b
85:
        movl    $1, %eax
        subl    -52(%rbp), %eax
        movl    %eax, -52(%rbp)
86:
        cmpl    $0, -52(%rbp)
        {disp8} jmp 71b
87:
        andl    $31, %r14d
        je      92f
        movl    20(%rax,%r12,4), %edi
        movq    -72(%rbp), %rax
        callq   *%rax
        movl    $32, %ecx
        subl    %r14d, %ecx
        cmpl    %ecx, %eax
        jge     92f
        {disp8} jmp 74b
88:
        testl   %ecx, %ecx
        je      92f
89:
        cmpl    $1, 20(%r15)
        jle     90f
        movl    28(%r15), %eax
        andl    $-1048577, %eax
        {disp8} jmp 91f
90:
        xorl    %eax, %eax
91:
        movq    -64(%rbp), %rdx
        movl    %eax, 4(%rdx)
        {disp8} jmp 93f
92:
        movl    28(%r15), %eax
        addl    $1075, %ebx
        sall    $20, %ebx
        andl    $-1048577, %eax
        orl     %eax, %ebx
        movq    -64(%rbp), %rax
        movl    %ebx, 4(%rax)
93:
        movl    24(%r15), %eax
        movq    %r15, %rdi
        movq    -64(%rbp), %rdx
        movl    %eax, (%rdx)
        addq    $40, %rsp
        movq    %r13, %rax
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        jmpq    *%rax
94:
        addq    $40, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Lgethex, .-.Lgethex

        .section .rodata.str1.1,"aMS",@progbits,1

.LdtoaC4:
        .string "nf"
.LdtoaC5:
        .string "inity"
.LdtoaC6:
        .string "an"

        .section .text,"ax",@progbits

        .type   .Lstrtod, @function
.Lstrtod:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        pushq   %r12
        movq    %rdi, %r12
        pushq   %rbx
        subq    $136, %rsp
        movq    %rsi, -152(%rbp)
        movq    $0, -56(%rbp)
        movq    %rdi, -64(%rbp)
0:
        movq    -64(%rbp), %rdx
        movb    (%rdx), %al
        cmpb    $13, %al
        jg      1f
        cmpb    $9, %al
        jge     5f
        testb   %al, %al
        je      50f
        jmp     6f
1:
        cmpb    $43, %al
        je      3f
        cmpb    $45, %al
        je      2f
        cmpb    $32, %al
        jne     6f
        jmp     5f
2:
        movl    $1, -84(%rbp)
        jmp     4f
3:
        movl    $0, -84(%rbp)
4:
        leaq    1(%rdx), %rax
        movq    %rax, -64(%rbp)
        cmpb    $0, 1(%rdx)
        jne     7f
        jmp     50f
5:
        incq    %rdx
        movq    %rdx, -64(%rbp)
        jmp     0b
6:
        movl    $0, -84(%rbp)
7:
        movq    -64(%rbp), %rax
        movl    $0, -120(%rbp)
        cmpb    $48, (%rax)
        jne     10f
        movb    1(%rax), %al
        cmpb    $88, %al
        je      8f
        cmpb    $120, %al
        jne     9f
8:
        movl    -84(%rbp), %ecx
        leaq    -56(%rbp), %rsi
        movl    $1, %edx
        leaq    -64(%rbp), %rdi
        movabsq $.Lgethex, %rax
        callq   *%rax
        jmp     113f
9:
        movq    -64(%rbp), %rax
        leaq    1(%rax), %rdx
        movq    %rdx, -64(%rbp)
        movb    1(%rax), %al
        cmpb    $48, %al
        je      9b
        testb   %al, %al
        je      113f
        movl    $1, -120(%rbp)
10:
        movq    -64(%rbp), %rax
        xorl    %r13d, %r13d
        xorl    %ecx, %ecx
        xorl    %esi, %esi
        movq    %rax, -128(%rbp)
11:
        movq    -64(%rbp), %rdx
        movsbl  (%rdx), %eax
        leal    -48(%rax), %edi
        cmpb    $9, %dil
        ja      14f
        cmpl    $8, %esi
        jg      12f
        imull   $10, %ecx, %ecx
        leal    -48(%rcx,%rax), %ecx
        jmp     13f
12:
        cmpl    $16, %esi
        jg      13f
        imull   $10, %r13d, %r13d
        leal    -48(%r13,%rax), %r13d
13:
        incq    %rdx
        incl    %esi
        movq    %rdx, -64(%rbp)
        jmp     11b
14:
        movq    %rdx, %rdi
15:
        movl    %edi, %r11d
        subl    %edx, %r11d
        cmpq    -128(%rbp), %rdx
        ja      17f
16:
        cmpl    $46, %eax
        je      18f
        movl    $0, -136(%rbp)
        movl    %esi, %r14d
        xorl    %edx, %edx
        jmp     32f
17:
        decq    %rdx
        cmpb    $48, (%rdx)
        je      15b
        jmp     16b
18:
        leaq    1(%rdi), %rdx
        movl    %edx, %ebx
        movq    %rdx, -64(%rbp)
        xorl    %edx, %edx
        subl    %edi, %ebx
        testl   %esi, %esi
        movsbl  1(%rdi), %eax
        movl    %ebx, -136(%rbp)
        jne     29f
19:
        cmpl    $48, %eax
        jne     20f
        movq    -64(%rbp), %rax
        incl    %edx
        leaq    1(%rax), %rdi
        movq    %rdi, -64(%rbp)
        movsbl  1(%rax), %eax
        jmp     19b
20:
        leal    -49(%rax), %edi
        cmpl    $8, %edi
        ja      31f
        movq    -64(%rbp), %rbx
        movl    %edx, %edi
        xorl    %r14d, %r14d
        xorl    %edx, %edx
        movq    %rbx, -128(%rbp)
21:
        leal    1(%rdx), %r8d
        subl    $48, %eax
        je      28f
        leal    1(%r14), %r9d
        addl    %r8d, %edi
22:
        movl    %r9d, %r10d
        subl    %r14d, %r10d
        cmpl    %r8d, %r10d
        jge     25f
        leal    -1(%r9), %r10d
        cmpl    $8, %r10d
        jg      23f
        imull   $10, %ecx, %ecx
        jmp     24f
23:
        imull   $10, %r13d, %r10d
        cmpl    $17, %r9d
        cmovle  %r10, %r13
24:
        incl    %r9d
        jmp     22b
25:
        xorl    %r8d, %r8d
        testl   %edx, %edx
        cmovns  %edx, %r8d
        addl    %r14d, %r8d
        leal    1(%r8), %r14d
        cmpl    $8, %r8d
        jg      26f
        imull   $10, %ecx, %ecx
        addl    %eax, %ecx
        jmp     27f
26:
        cmpl    $17, %r14d
        jg      27f
        imull   $10, %r13d, %r13d
        addl    %eax, %r13d
27:
        xorl    %r11d, %r11d
        xorl    %r8d, %r8d
28:
        movq    -64(%rbp), %rax
        leaq    1(%rax), %rdx
        movq    %rdx, -64(%rbp)
        movl    %r8d, %edx
        movsbl  1(%rax), %eax
        jmp     30f
29:
        movl    %esi, %r14d
        xorl    %edx, %edx
        xorl    %edi, %edi
30:
        leal    -48(%rax), %r8d
        cmpl    $9, %r8d
        jbe     21b
        jmp     33f
31:
        xorl    %r14d, %r14d
32:
        xorl    %edi, %edi
33:
        movl    %eax, %r8d
        andl    $-33, %r8d
        cmpl    $69, %r8d
        jne     44f
        movl    %r14d, %eax
        orl     %edx, %eax
        orl     -120(%rbp), %eax
        je      50f
        movq    -64(%rbp), %r12
        leaq    1(%r12), %rax
        movq    %rax, -64(%rbp)
        movsbl  1(%r12), %eax
        cmpb    $43, %al
        je      34f
        cmpb    $45, %al
        je      35f
        xorl    %r9d, %r9d
        jmp     37f
34:
        xorl    %r9d, %r9d
        jmp     36f
35:
        movl    $1, %r9d
36:
        leaq    2(%r12), %rax
        movq    %rax, -64(%rbp)
        movsbl  2(%r12), %eax
37:
        leal    -48(%rax), %r8d
        cmpl    $9, %r8d
        ja      43f
38:
        cmpl    $48, %eax
        jne     39f
        movq    -64(%rbp), %rax
        leaq    1(%rax), %r8
        movq    %r8, -64(%rbp)
        movsbl  1(%rax), %eax
        jmp     38b
39:
        leal    -49(%rax), %r8d
        xorl    %ebx, %ebx
        cmpl    $8, %r8d
        ja      45f
        leal    -48(%rax), %r8d
        movq    -64(%rbp), %rax
        movq    %rax, -144(%rbp)
40:
        movq    -64(%rbp), %rax
        leaq    1(%rax), %r10
        movq    %r10, -64(%rbp)
        movb    1(%rax), %bl
        movsbl  %bl, %eax
        subl    $48, %ebx
        cmpb    $9, %bl
        ja      41f
        imull   $10, %r8d, %r8d
        leal    -48(%rax,%r8), %r8d
        jmp     40b
41:
        subq    -144(%rbp), %r10
        movl    $19999, %ebx
        cmpq    $8, %r10
        jg      42f
        cmpl    $19999, %r8d
        cmovle  %r8d, %ebx
42:
        movl    %ebx, %r8d
        negl    %r8d
        testl   %r9d, %r9d
        cmovne  %r8d, %ebx
        jmp     45f
43:
        movq    %r12, -64(%rbp)
44:
        xorl    %ebx, %ebx
45:
        testl   %r14d, %r14d
        jne     51f
        movl    -120(%rbp), %ecx
        orl     %edx, %ecx
        jne     113f
        cmpl    $0, -136(%rbp)
        jne     50f
        cmpl    $78, %eax
        je      49f
        jg      46f
        cmpl    $73, %eax
        je      47f
        jmp     50f
46:
        cmpl    $105, %eax
        je      47f
        cmpl    $110, %eax
        je      49f
        jmp     50f
47:
        movabsq $.LdtoaC4, %rsi
        movabsq $.Lmatch, %rbx
        leaq    -64(%rbp), %rdi
        callq   *%rbx
        testl   %eax, %eax
        je      50f
        decq    -64(%rbp)
        leaq    -64(%rbp), %rdi
        movabsq $.LdtoaC5, %rsi
        callq   *%rbx
        testl   %eax, %eax
        jne     48f
        incq    -64(%rbp)
48:
        movl    $2146435072, -52(%rbp)
        movl    $0, -56(%rbp)
        jmp     113f
49:
        movabsq $.LdtoaC6, %rsi
        movabsq $.Lmatch, %rax
        leaq    -64(%rbp), %rdi
        callq   *%rax
        testl   %eax, %eax
        je      50f
        movq    -64(%rbp), %rax
        movl    $2146959360, -52(%rbp)
        movl    $0, -56(%rbp)
        cmpb    $40, (%rax)
        jne     113f
        leaq    -64(%rbp), %rsi
        movabsq $.Lhexnan, %rax
        leaq    -56(%rbp), %rdi
        callq   *%rax
        jmp     113f
50:
        movq    %r12, -64(%rbp)
        jmp     55f
51:
        subl    %edi, %ebx
        movl    %ecx, %edx
        testl   %esi, %esi
        cmove   %r14d, %esi
        movl    $17, %eax
        cmpl    $17, %r14d
        cmovle  %r14d, %eax
        cvtsi2sdq       %rdx, %xmm0
        cmpl    $9, %eax
        movsd   %xmm0, -56(%rbp)
        jle     52f
        leal    -9(%rax), %edi
        movabsq $.Ltens, %rdx
        cvtsi2sdq       %r13, %xmm1
        movslq  %edi, %rdi
        mulsd   (%rdx,%rdi,8), %xmm0
        addsd   %xmm1, %xmm0
        movsd   %xmm0, -56(%rbp)
52:
        cmpl    $15, %r14d
        jg      60f
        cmpl    $0, %ebx
        je      113f
        jle     58f
        cmpl    $22, %ebx
        jg      56f
        cmpl    $0, -84(%rbp)
        je      53f
        movabsq $.LdtoaC7, %rax
        movsd   -56(%rbp), %xmm0
        movaps  (%rax), %xmm1
        xorps   %xmm1, %xmm0
        movsd   %xmm0, -56(%rbp)
53:
        movsd   -56(%rbp), %xmm0
        movslq  %ebx, %rbx
        movabsq $.Ltens, %rax
        mulsd   (%rax,%rbx,8), %xmm0
54:
        movsd   %xmm0, -56(%rbp)
55:
        movl    $0, -84(%rbp)
        jmp     113f
56:
        movl    $37, %edx
        subl    %r14d, %edx
        cmpl    %edx, %ebx
        jg      60f
        cmpl    $0, -84(%rbp)
        je      57f
        movabsq $.LdtoaC7, %rax
        movsd   -56(%rbp), %xmm0
        movaps  (%rax), %xmm1
        xorps   %xmm1, %xmm0
        movsd   %xmm0, -56(%rbp)
57:
        movl    $15, %eax
        movsd   -56(%rbp), %xmm0
        movabsq $.Ltens, %rdx
        subl    %r14d, %eax
        movslq  %eax, %rcx
        subl    %eax, %ebx
        mulsd   (%rdx,%rcx,8), %xmm0
        movslq  %ebx, %rbx
        mulsd   (%rdx,%rbx,8), %xmm0
        jmp     54b
58:
        cmpl    $-22, %ebx
        jl      60f
        cmpl    $0, -84(%rbp)
        je      59f
        movabsq $.LdtoaC7, %rax
        movsd   -56(%rbp), %xmm0
        movaps  (%rax), %xmm1
        xorps   %xmm1, %xmm0
        movsd   %xmm0, -56(%rbp)
59:
        negl    %ebx
        movsd   -56(%rbp), %xmm0
        movabsq $.Ltens, %rax
        movslq  %ebx, %rbx
        divsd   (%rax,%rbx,8), %xmm0
        jmp     54b
60:
        movl    %r14d, %edi
        subl    %eax, %edi
        movl    %edi, %eax
        addl    %ebx, %eax
        cmpl    $0, %eax
        jle     71f
        movl    %eax, %edi
        andl    $15, %edi
        je      61f
        movsd   -56(%rbp), %xmm0
        movslq  %edi, %rdi
        movabsq $.Ltens, %rdx
        mulsd   (%rdx,%rdi,8), %xmm0
        movsd   %xmm0, -56(%rbp)
61:
        andl    $-16, %eax
        je      81f
        cmpl    $308, %eax
        jle     66f
62:
        xorl    %r12d, %r12d
63:
        movl    $2146435072, -52(%rbp)
        movl    $0, -56(%rbp)
64:
        testq   %r12, %r12
        je      65f
        movabsq $.LBfree, %rbx
        movq    -104(%rbp), %rdi
        callq   *%rbx
        movq    -112(%rbp), %rdi
        callq   *%rbx
        movq    -96(%rbp), %rdi
        callq   *%rbx
        movq    %r12, %rdi
        callq   *%rbx
        movq    %r15, %rdi
        callq   *%rbx
65:
        movabsq $.Lerrno, %rax
        movl    $34, (%rax)
        jmp     113f
66:
        movsd   -56(%rbp), %xmm0
        sarl    $4, %eax
        xorl    %edx, %edx
        movabsq $.Lbigtens, %r8
67:
        cmpl    $1, %eax
        jle     69f
        testb   $1, %al
        je      68f
        mulsd   (%r8,%rdx,8), %xmm0
68:
        sarl    %eax
        incq    %rdx
        jmp     67b
69:
        movsd   %xmm0, -56(%rbp)
        movslq  %edx, %rdx
        movabsq $.Lbigtens, %rax
        subl    $55574528, -52(%rbp)
        movsd   -56(%rbp), %xmm0
        mulsd   (%rax,%rdx,8), %xmm0
        movsd   %xmm0, -56(%rbp)
        movl    -52(%rbp), %eax
        movl    %eax, %edx
        andl    $2146435072, %edx
        cmpl    $2090860544, %edx
        ja      62b
        cmpl    $2089811968, %edx
        jbe     70f
        movl    $2146435071, -52(%rbp)
        movl    $-1, -56(%rbp)
        jmp     81f
70:
        addl    $55574528, %eax
        movl    %eax, -52(%rbp)
        jmp     81f
71:
        je      81f
        negl    %eax
        movl    %eax, %edi
        andl    $15, %edi
        je      72f
        movsd   -56(%rbp), %xmm0
        movslq  %edi, %rdi
        movabsq $.Ltens, %rdx
        divsd   (%rdx,%rdi,8), %xmm0
        movsd   %xmm0, -56(%rbp)
72:
        sarl    $4, %eax
        je      81f
        cmpl    $31, %eax
        jg      76f
        movsd   -56(%rbp), %xmm0
        xorl    %edx, %edx
        movabsq $.Ltinytens, %r8
        jmp     75f
73:
        testb   $1, %al
        je      74f
        mulsd   (%r8,%rdx,8), %xmm0
74:
        sarl    %eax
        incq    %rdx
75:
        cmpl    $1, %eax
        jg      73b
        movslq  %edx, %rdx
        movapd  %xmm0, %xmm3
        xorps   %xmm1, %xmm1
        movabsq $.Ltinytens, %rax
        movsd   (%rax,%rdx,8), %xmm2
        mulsd   %xmm2, %xmm3
        ucomisd %xmm1, %xmm3
        movsd   %xmm3, -56(%rbp)
        jp      81f
        jne     81f
        addsd   %xmm0, %xmm0
        mulsd   %xmm2, %xmm0
        ucomisd %xmm1, %xmm0
        jp      80f
        jne     80f
76:
        xorl    %r12d, %r12d
        jmp     79f
77:
        callq   *%rax
        movsd   -120(%rbp), %xmm4
        xorps   %xmm1, %xmm1
        subsd   %xmm0, %xmm4
        ucomisd %xmm1, %xmm4
        movsd   %xmm4, -56(%rbp)
        jp      112f
        jne     112f
78:
        cmpl    %r14d, -144(%rbp)
        jg      112f
79:
        movq    $0, -56(%rbp)
        jmp     64b
80:
        movl    $0, -52(%rbp)
        movl    $1, -56(%rbp)
81:
        movl    -136(%rbp), %r8d
        movl    %r14d, %eax
        movl    %r14d, %edx
        movq    -128(%rbp), %rdi
        subl    %r11d, %eax
        movl    %eax, -144(%rbp)
        movabsq $.Ls2b, %rax
        callq   *%rax
        xorl    %ecx, %ecx
        movq    %rax, %r12
        movl    %ebx, %eax
        negl    %eax
        testl   %ebx, %ebx
        cmovns  %ecx, %eax
        movl    %eax, -120(%rbp)
82:
        movabsq $.LBalloc, %rax
        movl    8(%r12), %edi
        callq   *%rax
        leaq    16(%r12), %rsi
        movq    %rax, %rcx
        movq    %rax, -112(%rbp)
        movslq  20(%r12), %rax
        leaq    16(%rcx), %rdi
        leaq    8(,%rax,4), %rdx
        movabsq $.Lmymemcpy, %rax
        callq   *%rax
        leaq    -68(%rbp), %rdx
        movabsq $.Ld2b, %rax
        leaq    -72(%rbp), %rsi
        leaq    -56(%rbp), %rdi
        callq   *%rax
        movl    $1, %edi
        movq    %rax, -104(%rbp)
        movabsq $.Li2b, %rax
        callq   *%rax
        movl    -72(%rbp), %r15d
        xorl    %edx, %edx
        testl   %ebx, %ebx
        movq    %rax, -96(%rbp)
        cmovg   %ebx, %edx
        testl   %r15d, %r15d
        js      83f
        movl    -120(%rbp), %eax
        leal    (%rax,%r15), %r13d
        movl    %edx, %eax
        jmp     84f
83:
        movl    -120(%rbp), %r13d
        movl    %edx, %eax
        subl    %r15d, %eax
84:
        movl    -68(%rbp), %ecx
        leal    (%r15,%rcx), %esi
        addl    $1075, %r15d
        cmpl    $-1021, %esi
        jl      85f
        movl    $54, %r15d
        subl    %ecx, %r15d
85:
        leal    0(%r13,%r15), %ecx
        addl    %eax, %r15d
        cmpl    %r15d, %ecx
        movl    %r15d, %eax
        cmovle  %ecx, %eax
        cmpl    %r13d, %eax
        cmovg   %r13d, %eax
        testl   %eax, %eax
        jle     86f
        subl    %eax, %ecx
        subl    %eax, %r15d
        subl    %eax, %r13d
86:
        movl    -120(%rbp), %esi
        testl   %esi, %esi
        je      87f
        movq    -96(%rbp), %rdi
        movl    %edx, -160(%rbp)
        movabsq $.Lpow5mult, %rax
        movl    %ecx, -136(%rbp)
        callq   *%rax
        movq    -104(%rbp), %rsi
        movq    %rax, %rdi
        movq    %rax, -96(%rbp)
        movabsq $.Lmult, %rax
        callq   *%rax
        movq    -104(%rbp), %rdi
        movabsq $.LBfree, %rsi
        movq    %rax, -128(%rbp)
        callq   *%rsi
        movq    -128(%rbp), %rax
        movl    -160(%rbp), %edx
        movl    -136(%rbp), %ecx
        movq    %rax, -104(%rbp)
87:
        testl   %ecx, %ecx
        jle     88f
        movq    -104(%rbp), %rdi
        movl    %ecx, %esi
        movl    %edx, -128(%rbp)
        movabsq $.Llshift, %rax
        callq   *%rax
        movl    -128(%rbp), %edx
        movq    %rax, -104(%rbp)
88:
        testl   %edx, %edx
        je      89f
        movabsq $.Lpow5mult, %rax
        movq    -112(%rbp), %rdi
        movl    %edx, %esi
        callq   *%rax
        movq    %rax, -112(%rbp)
89:
        testl   %r15d, %r15d
        jle     90f
        movq    -112(%rbp), %rdi
        movl    %r15d, %esi
        movabsq $.Llshift, %rax
        callq   *%rax
        movq    %rax, -112(%rbp)
90:
        testl   %r13d, %r13d
        jle     91f
        movq    -96(%rbp), %rdi
        movl    %r13d, %esi
        movabsq $.Llshift, %rax
        callq   *%rax
        movq    %rax, -96(%rbp)
91:
        movabsq $.Ldiff, %rax
        movq    -112(%rbp), %rsi
        movq    -104(%rbp), %rdi
        callq   *%rax
        movq    -96(%rbp), %rsi
        movabsq $.Lcmp, %rdx
        movl    16(%rax), %r13d
        movq    %rax, %rdi
        movl    $0, 16(%rax)
        movq    %rdx, -128(%rbp)
        movq    %rax, %r15
        callq   *%rdx
        movq    -128(%rbp), %rdx
        testl   %eax, %eax
        jns     93f
        testl   %r13d, %r13d
        jne     112f
        movabsq $4503599627370495, %rax
        testq   %rax, -56(%rbp)
        jne     112f
        movl    -52(%rbp), %eax
        andl    $2146435072, %eax
        cmpl    $1048576, %eax
        jbe     112f
        cmpl    $0, 24(%r15)
        jne     92f
        cmpl    $1, 20(%r15)
        jle     112f
92:
        movq    %r15, %rdi
        movl    $1, %esi
        movq    %rdx, -120(%rbp)
        movabsq $.Llshift, %rax
        callq   *%rax
        movq    -96(%rbp), %rsi
        movq    -120(%rbp), %rdx
        movq    %rax, %rdi
        movq    %rax, %r15
        callq   *%rdx
        testl   %eax, %eax
        jg      95f
        jmp     112f
93:
        jne     97f
        movabsq $4503599627370495, %rax
        testl   %r13d, %r13d
        je      94f
        movq    -56(%rbp), %rcx
        movq    %rcx, %rsi
        andq    %rax, %rsi
        cmpq    %rax, %rsi
        jne     96f
        movabsq $9218868437227405311, %rax
        cmpq    %rax, %rcx
        je      63b
        movl    -52(%rbp), %eax
        movl    $0, -56(%rbp)
        andl    $2146435072, %eax
        addl    $1048576, %eax
        movl    %eax, -52(%rbp)
        jmp     112f
94:
        testq   %rax, -56(%rbp)
        jne     96f
95:
        movl    -52(%rbp), %eax
        movl    $-1, -56(%rbp)
        andl    $2146435072, %eax
        subl    $1048576, %eax
        orl     $1048575, %eax
        movl    %eax, -52(%rbp)
        jmp     112f
96:
        testb   $1, -56(%rbp)
        je      112f
        movsd   -56(%rbp), %xmm5
        testl   %r13d, %r13d
        movabsq $.Lulp.isra.0, %rax
        movl    -52(%rbp), %edi
        movsd   %xmm5, -120(%rbp)
        je      77b
        callq   *%rax
        addsd   -120(%rbp), %xmm0
        movsd   %xmm0, -56(%rbp)
        jmp     112f
97:
        movq    -96(%rbp), %rsi
        movq    %r15, %rdi
        movabsq $.Lratio, %rax
        callq   *%rax
        movabsq $.LdtoaC8, %rax
        movsd   (%rax), %xmm1
        ucomisd %xmm0, %xmm1
        jb      99f
        testl   %r13d, %r13d
        jne     101f
        movabsq $4503599627370495, %rcx
        movq    -56(%rbp), %rax
        testq   %rcx, %rax
        je      98f
        decq    %rax
        jne     102f
        jmp     78b
98:
        movabsq $.LdtoaC3, %rax
        movsd   (%rax), %xmm1
        movabsq $.LdtoaC1, %rax
        ucomisd %xmm0, %xmm1
        movsd   (%rax), %xmm1
        ja      100f
        mulsd   %xmm0, %xmm1
        jmp     100f
99:
        movabsq $.LdtoaC1, %rax
        testl   %r13d, %r13d
        movsd   (%rax), %xmm1
        mulsd   %xmm0, %xmm1
        movapd  %xmm1, %xmm2
        jne     103f
100:
        movabsq $.LdtoaC7, %rax
        movaps  (%rax), %xmm2
        xorps   %xmm1, %xmm2
        jmp     103f
101:
        movabsq $.LdtoaC3, %rax
        movsd   (%rax), %xmm2
        movapd  %xmm2, %xmm1
        jmp     103f
102:
        movabsq $.LdtoaC2, %rax
        movsd   (%rax), %xmm2
        movabsq $.LdtoaC3, %rax
        movsd   (%rax), %xmm1
103:
        movl    -52(%rbp), %edi
        movsd   -56(%rbp), %xmm6
        movsd   %xmm6, -136(%rbp)
        movl    %edi, %eax
        andl    $2146435072, %eax
        cmpl    $2145386496, %eax
        movl    %eax, -128(%rbp)
        jne     105f
        subl    $55574528, %edi
        movsd   %xmm2, -168(%rbp)
        movabsq $.Lulp.isra.0, %rax
        movsd   %xmm1, -160(%rbp)
        movl    %edi, -52(%rbp)
        callq   *%rax
        movsd   -168(%rbp), %xmm2
        movsd   -160(%rbp), %xmm1
        mulsd   %xmm2, %xmm0
        addsd   -56(%rbp), %xmm0
        movsd   %xmm0, -56(%rbp)
        movl    -52(%rbp), %eax
        movl    %eax, %ecx
        andl    $2146435072, %ecx
        cmpl    $2090860543, %ecx
        jbe     104f
        movq    -136(%rbp), %rdx
        movabsq $9218868437227405311, %rax
        cmpq    %rax, %rdx
        je      63b
        movl    $2146435071, -52(%rbp)
        movl    $-1, -56(%rbp)
        jmp     111f
104:
        addl    $55574528, %eax
        movl    %eax, -52(%rbp)
        jmp     107f
105:
        cmpl    $54525952, -128(%rbp)
        ja      106f
        movabsq $.LdtoaC3, %rax
        movsd   (%rax), %xmm0
        ucomisd %xmm0, %xmm1
        jbe     106f
        movabsq $.LdtoaC1, %rax
        testl   %r13d, %r13d
        movsd   (%rax), %xmm0
        addsd   %xmm1, %xmm0
        cvttsd2si       %xmm0, %eax
        cvtsi2sd        %eax, %xmm2
        jne     106f
        movabsq $.LdtoaC7, %rax
        movaps  (%rax), %xmm0
        xorps   %xmm0, %xmm2
106:
        movabsq $.Lulp.isra.0, %rax
        movsd   %xmm2, -168(%rbp)
        movsd   %xmm1, -160(%rbp)
        callq   *%rax
        movsd   -168(%rbp), %xmm2
        movsd   -160(%rbp), %xmm1
        mulsd   %xmm2, %xmm0
        addsd   -136(%rbp), %xmm0
        movsd   %xmm0, -56(%rbp)
107:
        cmpl    %r14d, -144(%rbp)
        movl    -52(%rbp), %eax
        jne     111f
        andl    $2146435072, %eax
        cmpl    %eax, -128(%rbp)
        jne     111f
        cvttsd2si       %xmm1, %eax
        testl   %r13d, %r13d
        cvtsi2sd        %eax, %xmm0
        subsd   %xmm0, %xmm1
        jne     108f
        movabsq $4503599627370495, %rax
        testq   %rax, -56(%rbp)
        je      109f
108:
        movabsq $.LdtoaC9, %rax
        movsd   (%rax), %xmm0
        ucomisd %xmm1, %xmm0
        ja      112f
        movabsq $.LdtoaC10, %rax
        ucomisd (%rax), %xmm1
        jmp     110f
109:
        movabsq $.LdtoaC11, %rax
        movsd   (%rax), %xmm0
        ucomisd %xmm1, %xmm0
110:
        ja      112f
111:
        movabsq $.LBfree, %r13
        movq    -104(%rbp), %rdi
        callq   *%r13
        movq    -112(%rbp), %rdi
        callq   *%r13
        movq    -96(%rbp), %rdi
        callq   *%r13
        movq    %r15, %rdi
        callq   *%r13
        jmp     82b
112:
        movabsq $.LBfree, %rbx
        movq    -104(%rbp), %rdi
        callq   *%rbx
        movq    -112(%rbp), %rdi
        callq   *%rbx
        movq    -96(%rbp), %rdi
        callq   *%rbx
        movq    %r12, %rdi
        callq   *%rbx
        movq    %r15, %rdi
        callq   *%rbx
113:
        movq    -152(%rbp), %rcx
        testq   %rcx, %rcx
        je      114f
        movq    -64(%rbp), %rax
        movq    %rax, (%rcx)
114:
        cmpl    $0, -84(%rbp)
        movsd   -56(%rbp), %xmm0
        je      115f
        movabsq $.LdtoaC7, %rax
        movaps  (%rax), %xmm1
        xorps   %xmm1, %xmm0
115:
        addq    $136, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Lstrtod, .-.Lstrtod

        .type   .Lfreedtoa, @function
.Lfreedtoa:
        pushq   %rbp
        movl    $1, %eax
        movq    %rsp, %rbp
        pushq   %rbx
        movq    %rdi, %rbx
        pushq   %r10
        leaq    -4(%rdi), %rdi
        movl    (%rdi), %ecx
        sall    %cl, %eax
        movl    %ecx, 8(%rdi)
        movl    %eax, 12(%rdi)
        movabsq $.LBfree, %rax
        callq   *%rax
        movabsq $.Ldtoa_result, %rax
        cmpq    (%rax), %rbx
        jne     0f
        movq    $0, (%rax)
0:
        popq    %r9
        popq    %rbx
        popq    %rbp
        retq
        .size   .Lfreedtoa, .-.Lfreedtoa

        .section .rodata.str1.1,"aMS",@progbits,1

.LdtoaC12:
        .string "INFINITY"
.LdtoaC13:
        .string "NAN"
.LdtoaC14:
        .string "0"

        .section .text,"ax",@progbits

        .type   .Ldtoa, @function
.Ldtoa:
        movabsq $.Ldtoa_result, %rax
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        pushq   %r12
        movq    %rcx, %r12
        pushq   %rbx
        subq    $120, %rsp
        movl    %edi, -96(%rbp)
        movq    (%rax), %rdi
        movl    %esi, -112(%rbp)
        movq    %rdx, -144(%rbp)
        movq    %r8, -136(%rbp)
        testq   %rdi, %rdi
        je      0f
        movabsq $.Lfreedtoa, %rax
        movsd   %xmm0, -72(%rbp)
        callq   *%rax
        movsd   -72(%rbp), %xmm0
        movabsq $.Ldtoa_result, %rax
        movq    $0, (%rax)
0:
        movsd   %xmm0, -56(%rbp)
        movl    -52(%rbp), %eax
        testl   %eax, %eax
        jns     1f
        andl    $2147483647, %eax
        movl    $1, (%r12)
        movl    %eax, -52(%rbp)
        jmp     2f
1:
        movl    $0, (%r12)
2:
        movl    -52(%rbp), %eax
        andl    $2146435072, %eax
        cmpl    $2146435072, %eax
        jne     4f
        movq    -144(%rbp), %rax
        movl    $9999, (%rax)
        movabsq $4503599627370495, %rax
        testq   %rax, -56(%rbp)
        movabsq $.Lnrv_alloc, %rax
        jne     3f
        movl    $8, %edx
        movq    -136(%rbp), %rsi
        movabsq $.LdtoaC12, %rdi
        jmp     5f
3:
        movl    $3, %edx
        movq    -136(%rbp), %rsi
        movabsq $.LdtoaC13, %rdi
        jmp     5f
4:
        xorps   %xmm2, %xmm2
        ucomisd -56(%rbp), %xmm2
        jp      6f
        jne     6f
        movq    -144(%rbp), %rax
        movl    $1, %edx
        movabsq $.LdtoaC14, %rdi
        movq    -136(%rbp), %rsi
        movl    $1, (%rax)
        movabsq $.Lnrv_alloc, %rax
5:
        callq   *%rax
        jmp     114f
6:
        leaq    -64(%rbp), %rdx
        movsd   %xmm2, -80(%rbp)
        movabsq $.Ld2b, %rax
        leaq    -60(%rbp), %rsi
        leaq    -56(%rbp), %rdi
        callq   *%rax
        movl    -52(%rbp), %edi
        movq    %rax, -72(%rbp)
        movl    -64(%rbp), %esi
        movsd   -80(%rbp), %xmm2
        movl    %edi, %eax
        shrl    $20, %eax
        andl    $2047, %eax
        movl    %eax, %edx
        je      7f
        movq    -56(%rbp), %rcx
        xorl    %r10d, %r10d
        movq    %rcx, %rax
        movl    %ecx, %ecx
        shrq    $32, %rax
        andl    $1048575, %eax
        orq     $1072693248, %rax
        salq    $32, %rax
        orq     %rax, %rcx
        leal    -1023(%rdx), %eax
        jmp     10f
7:
        movl    -60(%rbp), %eax
        movl    -56(%rbp), %edx
        addl    %esi, %eax
        cmpl    $-1041, %eax
        jl      8f
        leal    1042(%rax), %ecx
        shrl    %cl, %edx
        movl    $-1010, %ecx
        subl    %eax, %ecx
        sall    %cl, %edi
        orl     %edi, %edx
        jmp     9f
8:
        movl    $-1042, %ecx
        subl    %eax, %ecx
        sall    %cl, %edx
9:
        movl    %edx, %ecx
        decl    %eax
        movl    $1, %r10d
        cvtsi2sdq       %rcx, %xmm6
        movd    %xmm6, %rdx
        movd    %xmm6, %rcx
        shrq    $32, %rdx
        movl    %ecx, %ecx
        subl    $32505856, %edx
        salq    $32, %rdx
        orq     %rdx, %rcx
10:
        movabsq $.LdtoaC15, %rdx
        movd    %rcx, %xmm0
        subsd   (%rdx), %xmm0
        movabsq $.LdtoaC16, %rdx
        cvtsi2sd        %eax, %xmm1
        mulsd   (%rdx), %xmm0
        movabsq $.LdtoaC17, %rdx
        addsd   (%rdx), %xmm0
        movabsq $.LdtoaC18, %rdx
        mulsd   (%rdx), %xmm1
        addsd   %xmm1, %xmm0
        ucomisd %xmm0, %xmm2
        cvttsd2si       %xmm0, %r14d
        jbe     12f
        cvtsi2sd        %r14d, %xmm1
        ucomisd %xmm1, %xmm0
        jp      11f
        je      12f
11:
        decl    %r14d
12:
        cmpl    $22, %r14d
        movl    $1, -120(%rbp)
        ja      14f
        movabsq $.Ltens, %rdx
        movslq  %r14d, %rcx
        movsd   (%rdx,%rcx,8), %xmm0
        ucomisd -56(%rbp), %xmm0
        jbe     13f
        decl    %r14d
13:
        movl    $0, -120(%rbp)
14:
        subl    %eax, %esi
        movl    $0, -88(%rbp)
        decl    %esi
        movl    %esi, -104(%rbp)
        jns     15f
        movl    %esi, %eax
        movl    $0, -104(%rbp)
        negl    %eax
        movl    %eax, -88(%rbp)
15:
        testl   %r14d, %r14d
        js      16f
        addl    %r14d, -104(%rbp)
        movl    %r14d, -148(%rbp)
        xorl    %r12d, %r12d
        jmp     17f
16:
        subl    %r14d, -88(%rbp)
        movl    %r14d, %r12d
        movl    $0, -148(%rbp)
        negl    %r12d
17:
        cmpl    $9, -96(%rbp)
        movl    $1, %r15d
        ja      23f
        cmpl    $5, -96(%rbp)
        jle     18f
        subl    $4, -96(%rbp)
        xorb    %r15b, %r15b
18:
        cmpl    $3, -96(%rbp)
        je      21f
        jg      19f
        xorl    %r13d, %r13d
        cmpl    $2, -96(%rbp)
        je      20f
        jmp     24f
19:
        movl    -96(%rbp), %eax
        movl    $1, %r13d
        cmpl    $4, %eax
        je      20f
        cmpl    $5, %eax
        je      22f
        jmp     24f
20:
        movl    -112(%rbp), %eax
        testl   %eax, %eax
        jle     25f
        movl    %eax, -116(%rbp)
        movl    %eax, %edi
        movl    %eax, -84(%rbp)
        jmp     26f
21:
        xorl    %r13d, %r13d
22:
        movl    -112(%rbp), %eax
        movl    $1, %edi
        addl    %r14d, %eax
        movl    %eax, -116(%rbp)
        incl    %eax
        testl   %eax, %eax
        movl    %eax, -84(%rbp)
        cmovg   %eax, %edi
        jmp     26f
23:
        movl    $0, -96(%rbp)
24:
        orl     $-1, %eax
        movl    $1, %r13d
        movl    $18, %edi
        movl    %eax, -116(%rbp)
        movl    %eax, -84(%rbp)
        movl    $0, -112(%rbp)
        jmp     26f
25:
        movl    $1, -116(%rbp)
        movl    $1, %edi
        movl    $1, -84(%rbp)
        movl    $1, -112(%rbp)
26:
        movabsq $.Lrv_alloc, %rax
        movsd   %xmm2, -160(%rbp)
        movl    %r10d, -128(%rbp)
        callq   *%rax
        cmpl    $14, -84(%rbp)
        movq    %rax, -80(%rbp)
        movl    -128(%rbp), %r10d
        movsd   -160(%rbp), %xmm2
        ja      50f
        testl   %r15d, %r15d
        je      50f
        testl   %r14d, %r14d
        movsd   -56(%rbp), %xmm3
        jle     31f
        movabsq $.Ltens, %rax
        movl    %r14d, %edx
        andl    $15, %edx
        movsd   (%rax,%rdx,8), %xmm1
        movl    %r14d, %eax
        movl    $2, %edx
        sarl    $4, %eax
        testb   $16, %al
        je      27f
        movabsq $.LdtoaC19, %rdx
        movapd  %xmm3, %xmm0
        andl    $15, %eax
        divsd   (%rdx), %xmm0
        movl    $3, %edx
        movsd   %xmm0, -56(%rbp)
27:
        movabsq $.Lbigtens, %rcx
28:
        testl   %eax, %eax
        je      30f
        testb   $1, %al
        je      29f
        mulsd   (%rcx), %xmm1
        incl    %edx
29:
        sarl    %eax
        addq    $8, %rcx
        jmp     28b
30:
        movsd   -56(%rbp), %xmm0
        divsd   %xmm1, %xmm0
        jmp     34f
31:
        movl    %r14d, %ebx
        movl    $2, %edx
        negl    %ebx
        je      35f
        movabsq $.Ltens, %rsi
        movl    %ebx, %edi
        movl    %ebx, %eax
        movabsq $.Lbigtens, %rcx
        andl    $15, %edi
        sarl    $4, %eax
        movsd   (%rsi,%rdi,8), %xmm0
        mulsd   %xmm3, %xmm0
32:
        testl   %eax, %eax
        je      34f
        testb   $1, %al
        je      33f
        mulsd   (%rcx), %xmm0
        incl    %edx
33:
        sarl    %eax
        addq    $8, %rcx
        jmp     32b
34:
        movsd   %xmm0, -56(%rbp)
35:
        cmpl    $0, -120(%rbp)
        je      36f
        movabsq $.LdtoaC3, %rax
        movsd   -56(%rbp), %xmm0
        movsd   (%rax), %xmm1
        ucomisd %xmm0, %xmm1
        jbe     36f
        cmpl    $0, -84(%rbp)
        je      37f
        movl    -116(%rbp), %ecx
        testl   %ecx, %ecx
        jle     49f
        movabsq $.LdtoaC20, %rax
        incl    %edx
        mulsd   (%rax), %xmm0
        movl    %ecx, %eax
        leal    -1(%r14), %esi
        movsd   %xmm0, -56(%rbp)
        jmp     38f
36:
        movl    %r14d, %esi
        movl    -84(%rbp), %eax
        jmp     38f
37:
        movl    %r14d, %esi
        xorl    %eax, %eax
38:
        cvtsi2sd        %edx, %xmm1
        movsd   -56(%rbp), %xmm0
        movabsq $.LdtoaC21, %rdx
        mulsd   %xmm0, %xmm1
        addsd   (%rdx), %xmm1
        movsd   %xmm1, -128(%rbp)
        movq    -128(%rbp), %rdx
        movl    -128(%rbp), %ecx
        shrq    $32, %rdx
        subl    $54525952, %edx
        movq    %rcx, -128(%rbp)
        salq    $32, %rdx
        orq     %rdx, -128(%rbp)
        testl   %eax, %eax
        jne     39f
        movabsq $.LdtoaC22, %rax
        movsd   -128(%rbp), %xmm1
        subsd   (%rax), %xmm0
        ucomisd %xmm1, %xmm0
        movsd   %xmm0, -56(%rbp)
        ja      76f
        movabsq $.LdtoaC7, %rax
        movaps  (%rax), %xmm4
        xorps   %xmm4, %xmm1
        ucomisd %xmm0, %xmm1
        ja      74f
        jmp     49f
39:
        leal    -1(%rax), %ecx
        testl   %r13d, %r13d
        movabsq $.Ltens, %rdx
        movslq  %ecx, %rcx
        je      44f
        movabsq $.LdtoaC1, %rdi
        cmpl    $306, %ebx
        movsd   (%rdi), %xmm0
        divsd   (%rdx,%rcx,8), %xmm0
        subsd   -128(%rbp), %xmm0
        movsd   %xmm0, -128(%rbp)
        jle     42f
        movl    %r14d, %ecx
        shrl    $31, %ecx
        je      42f
        movabsq $.LdtoaC24, %r11
        movl    %ebx, %edi
        subl    $256, %ebx
        movabsq $.Lbigtens, %rcx
        andl    $15, %edi
        sarl    $4, %ebx
        movsd   (%rdx,%rdi,8), %xmm1
        mulsd   (%r11), %xmm1
40:
        testb   $1, %bl
        je      41f
        mulsd   (%rcx), %xmm1
41:
        addq    $8, %rcx
        sarl    %ebx
        jne     40b
        cmpnltsd        %xmm1, %xmm0
        movsd   -128(%rbp), %xmm4
        andps   %xmm0, %xmm4
        andnps  %xmm1, %xmm0
        orps    %xmm4, %xmm0
        movsd   %xmm0, -128(%rbp)
42:
        movabsq $.LdtoaC3, %rbx
        movq    -80(%rbp), %r15
        movabsq $.LdtoaC20, %rdi
        movsd   -128(%rbp), %xmm0
        movsd   (%rbx), %xmm5
43:
        movsd   -56(%rbp), %xmm1
        incq    %r15
        cvttsd2si       %xmm1, %edx
        cvtsi2sd        %edx, %xmm4
        addl    $48, %edx
        subsd   %xmm4, %xmm1
        movapd  %xmm5, %xmm4
        movsd   %xmm1, -56(%rbp)
        movb    %dl, -1(%r15)
        movsd   -56(%rbp), %xmm1
        subsd   %xmm1, %xmm4
        ucomisd %xmm4, %xmm0
        ja      55f
        ucomisd %xmm1, %xmm0
        ja      111f
        movl    %r15d, %edx
        subl    -80(%rbp), %edx
        cmpl    %eax, %edx
        jge     49f
        movsd   (%rdi), %xmm4
        mulsd   %xmm4, %xmm1
        mulsd   %xmm4, %xmm0
        movsd   %xmm1, -56(%rbp)
        jmp     43b
44:
        movq    -80(%rbp), %rbx
        xorps   %xmm1, %xmm1
        movabsq $.LdtoaC20, %r9
        movsd   -128(%rbp), %xmm4
        mulsd   (%rdx,%rcx,8), %xmm4
        movl    $1, %edx
        movq    %rbx, %r15
        subl    %ebx, %edx
45:
        movsd   -56(%rbp), %xmm0
        leal    (%rdx,%r15), %edi
        cvttsd2si       %xmm0, %r8d
        cvtsi2sd        %r8d, %xmm5
        subsd   %xmm5, %xmm0
        ucomisd %xmm2, %xmm0
        movsd   %xmm0, -56(%rbp)
        jp      46f
        ucomisd %xmm1, %xmm0
        cmove   %edi, %eax
46:
        incq    %r15
        addl    $48, %r8d
        cmpl    %eax, %edi
        movb    %r8b, -1(%r15)
        movsd   -56(%rbp), %xmm0
        jne     48f
        movabsq $.LdtoaC1, %rax
        movapd  %xmm4, %xmm5
        movsd   (%rax), %xmm1
        addsd   %xmm1, %xmm5
        ucomisd %xmm5, %xmm0
        ja      55f
        subsd   %xmm4, %xmm1
        ucomisd %xmm0, %xmm1
        jbe     49f
47:
        cmpb    $48, -1(%r15)
        leaq    -1(%r15), %rax
        jne     111f
        movq    %rax, %r15
        jmp     47b
48:
        mulsd   (%r9), %xmm0
        movsd   %xmm0, -56(%rbp)
        jmp     45b
49:
        movsd   %xmm3, -56(%rbp)
50:
        movl    -60(%rbp), %eax
        testl   %eax, %eax
        js      60f
        cmpl    $14, %r14d
        jg      60f
        cmpl    $0, -84(%rbp)
        movslq  %r14d, %rdx
        movabsq $.Ltens, %rax
        movsd   (%rax,%rdx,8), %xmm1
        jg      51f
        movl    -112(%rbp), %eax
        shrl    $31, %eax
        je      51f
        cmpl    $0, -84(%rbp)
        jne     74f
        movabsq $.LdtoaC22, %rax
        xorl    %r12d, %r12d
        xorl    %ebx, %ebx
        mulsd   (%rax), %xmm1
        ucomisd -56(%rbp), %xmm1
        jae     75f
        jmp     77f
51:
        movq    -80(%rbp), %r15
        xorps   %xmm4, %xmm4
        movabsq $.LdtoaC20, %rdx
52:
        movsd   -56(%rbp), %xmm0
        movapd  %xmm0, %xmm3
        divsd   %xmm1, %xmm3
        cvttsd2si       %xmm3, %eax
        cvtsi2sd        %eax, %xmm3
        mulsd   %xmm1, %xmm3
        subsd   %xmm3, %xmm0
        ucomisd %xmm0, %xmm2
        jbe     53f
        addsd   %xmm1, %xmm0
        decl    %eax
53:
        leal    48(%rax), %esi
        incq    %r15
        movsd   %xmm0, -56(%rbp)
        movb    %sil, -1(%r15)
        movsd   -56(%rbp), %xmm0
        ucomisd %xmm2, %xmm0
        jp      54f
        ucomisd %xmm4, %xmm0
        jne     54f
        {disp8} jmp 112f
54:
        movl    %r15d, %esi
        subl    -80(%rbp), %esi
        cmpl    -84(%rbp), %esi
        jne     59f
        addsd   %xmm0, %xmm0
        ucomisd %xmm1, %xmm0
        movsd   %xmm0, -56(%rbp)
        ja      56f
        jp      112f
        jne     112f
        testb   $1, %al
        jne     56f
        jmp     112f
55:
        movl    %esi, %r14d
56:
        cmpb    $57, -1(%r15)
        leaq    -1(%r15), %rax
        jne     58f
        cmpq    -80(%rbp), %rax
        je      57f
        movq    %rax, %r15
        jmp     56b
57:
        movq    -80(%rbp), %rbx
        incl    %r14d
        movb    $48, (%rbx)
58:
        incb    (%rax)
        jmp     112f
59:
        mulsd   (%rdx), %xmm0
        movsd   %xmm0, -56(%rbp)
        jmp     52b
60:
        testl   %r13d, %r13d
        je      62f
        addl    $1075, %eax
        testl   %r10d, %r10d
        jne     61f
        movl    $54, %eax
        subl    -64(%rbp), %eax
61:
        movl    -88(%rbp), %ebx
        movl    $1, %edi
        addl    %eax, -104(%rbp)
        leal    (%rbx,%rax), %r15d
        movabsq $.Li2b, %rax
        callq   *%rax
        movq    %rax, %rbx
        jmp     63f
62:
        movl    -88(%rbp), %r15d
        xorl    %ebx, %ebx
63:
        cmpl    $0, -104(%rbp)
        jle     64f
        cmpl    $0, -88(%rbp)
        jle     64f
        movl    -88(%rbp), %eax
        movl    -104(%rbp), %ecx
        cmpl    %eax, %ecx
        cmovle  %ecx, %eax
        subl    %eax, -88(%rbp)
        subl    %eax, %r15d
        subl    %eax, -104(%rbp)
64:
        testl   %r12d, %r12d
        je      66f
        movabsq $.Lpow5mult, %rax
        testl   %r13d, %r13d
        movl    %r12d, %esi
        je      65f
        movq    %rbx, %rdi
        callq   *%rax
        movq    -72(%rbp), %rsi
        movq    %rax, %rdi
        movq    %rax, %rbx
        movabsq $.Lmult, %rax
        callq   *%rax
        movq    -72(%rbp), %rdi
        movq    %rax, %r12
        movabsq $.LBfree, %rax
        callq   *%rax
        movq    %r12, -72(%rbp)
        jmp     66f
65:
        movq    -72(%rbp), %rdi
        callq   *%rax
        movq    %rax, -72(%rbp)
66:
        movabsq $.Li2b, %rax
        movl    $1, %edi
        callq   *%rax
        movl    -148(%rbp), %esi
        movq    %rax, %r12
        testl   %esi, %esi
        je      67f
        movq    %rax, %rdi
        movabsq $.Lpow5mult, %rax
        callq   *%rax
        movq    %rax, %r12
67:
        testl   %r13d, %r13d
        jne     68f
        cmpl    $1, -96(%rbp)
        movl    $0, -128(%rbp)
        jg      69f
68:
        movabsq $4503599627370495, %rax
        movl    $0, -128(%rbp)
        testq   %rax, -56(%rbp)
        jne     69f
        testl   $2145386496, -52(%rbp)
        je      69f
        incl    -104(%rbp)
        incl    %r15d
        movl    $1, -128(%rbp)
69:
        movabsq $.Ldshift, %rax
        movl    -104(%rbp), %esi
        movq    %r12, %rdi
        callq   *%rax
        leal    (%r15,%rax), %esi
        movl    -104(%rbp), %r15d
        movl    %eax, -148(%rbp)
        addl    %eax, %r15d
        testl   %esi, %esi
        jle     70f
        movabsq $.Llshift, %rax
        movq    -72(%rbp), %rdi
        callq   *%rax
        movq    %rax, -72(%rbp)
70:
        testl   %r15d, %r15d
        jle     71f
        movabsq $.Llshift, %rax
        movq    %r12, %rdi
        movl    %r15d, %esi
        callq   *%rax
        movq    %rax, %r12
71:
        cmpl    $0, -120(%rbp)
        je      72f
        movq    -72(%rbp), %rdi
        movq    %r12, %rsi
        movabsq $.Lcmp, %rax
        callq   *%rax
        testl   %eax, %eax
        jns     72f
        movq    -72(%rbp), %rdi
        xorl    %edx, %edx
        movl    $10, %esi
        movabsq $.Lmultadd, %r15
        decl    %r14d
        callq   *%r15
        testl   %r13d, %r13d
        movq    %rax, -72(%rbp)
        movl    -116(%rbp), %eax
        movl    %eax, -84(%rbp)
        je      72f
        movq    %rbx, %rdi
        xorl    %edx, %edx
        movl    $10, %esi
        callq   *%r15
        movq    %rax, %rbx
72:
        cmpl    $0, -84(%rbp)
        jg      78f
        cmpl    $5, -96(%rbp)
        je      73f
        cmpl    $3, -96(%rbp)
        jne     78f
73:
        cmpl    $0, -84(%rbp)
        jne     75f
        xorl    %edx, %edx
        movq    %r12, %rdi
        movl    $5, %esi
        movabsq $.Lmultadd, %rax
        callq   *%rax
        movq    -72(%rbp), %rdi
        movq    %rax, %rsi
        movq    %rax, %r12
        movabsq $.Lcmp, %rax
        callq   *%rax
        testl   %eax, %eax
        jg      77f
        jmp     75f
74:
        xorl    %r12d, %r12d
        xorl    %ebx, %ebx
75:
        movl    -112(%rbp), %r14d
        movq    -80(%rbp), %r15
        notl    %r14d
        jmp     108f
76:
        movl    %esi, %r14d
        xorl    %r12d, %r12d
        xorl    %ebx, %ebx
77:
        movq    -80(%rbp), %rax
        incl    %r14d
        leaq    1(%rax), %r15
        movb    $49, (%rax)
        jmp     108f
78:
        testl   %r13d, %r13d
        je      97f
        movl    -88(%rbp), %esi
        addl    -148(%rbp), %esi
        testl   %esi, %esi
        jle     79f
        movabsq $.Llshift, %rax
        movq    %rbx, %rdi
        callq   *%rax
        movq    %rax, %rbx
79:
        cmpl    $0, -128(%rbp)
        movq    %rbx, %rax
        je      80f
        movabsq $.LBalloc, %rax
        movl    8(%rbx), %edi
        callq   *%rax
        leaq    16(%rbx), %rsi
        movq    %rax, %r13
        movslq  20(%rbx), %rax
        leaq    16(%r13), %rdi
        leaq    8(,%rax,4), %rdx
        movabsq $.Lmymemcpy, %rax
        callq   *%rax
        movl    $1, %esi
        movq    %r13, %rdi
        movabsq $.Llshift, %rax
        callq   *%rax
80:
        movq    -80(%rbp), %r15
        movq    %rbx, %r13
81:
        movq    %rax, %rbx
82:
        movq    -72(%rbp), %rdi
        movq    %r12, %rsi
        movabsq $.Lquorem, %rax
        callq   *%rax
        movq    -72(%rbp), %rdi
        movq    %r13, %rsi
        leal    48(%rax), %edx
        movl    %eax, -88(%rbp)
        movabsq $.Lcmp, %r8
        movl    %edx, -112(%rbp)
        movq    %r8, -128(%rbp)
        callq   *%r8
        movq    %rbx, %rsi
        movq    %r12, %rdi
        movl    %eax, -104(%rbp)
        movabsq $.Ldiff, %rax
        callq   *%rax
        movl    -112(%rbp), %edx
        cmpl    $0, 16(%rax)
        movq    %rax, %r9
        jne     83f
        movq    -128(%rbp), %r8
        movq    %rax, %rsi
        movl    %edx, -116(%rbp)
        movq    -72(%rbp), %rdi
        movq    %rax, -112(%rbp)
        callq   *%r8
        movq    -112(%rbp), %r9
        movl    %eax, %r8d
        movl    -116(%rbp), %edx
        jmp     84f
83:
        movl    $1, %r8d
84:
        movabsq $.LBfree, %rax
        movq    %r9, %rdi
        movl    %edx, -112(%rbp)
        movl    %r8d, -116(%rbp)
        callq   *%rax
        cmpl    $1, -96(%rbp)
        movl    -116(%rbp), %r8d
        movl    -112(%rbp), %edx
        setne   %al
        testl   %r8d, %r8d
        jne     85f
        testb   %al, %al
        je      85f
        testb   $1, -56(%rbp)
        jne     85f
        cmpl    $57, %edx
        movq    %r15, %rax
        je      93f
        movl    -88(%rbp), %ecx
        addl    $49, %ecx
        cmpl    $0, -104(%rbp)
        cmovg   %ecx, %edx
        incq    %r15
        jmp     106f
85:
        cmpl    $0, -104(%rbp)
        jns     87f
86:
        movq    -72(%rbp), %rax
        movq    %r15, %rcx
        cmpl    $0, 24(%rax)
        je      88f
        jmp     89f
87:
        jne     92f
        testb   %al, %al
        je      92f
        testb   $1, -56(%rbp)
        jne     92f
        jmp     86b
88:
        movq    -72(%rbp), %rax
        cmpl    $1, 20(%rax)
        jle     91f
89:
        testl   %r8d, %r8d
        jle     91f
        movq    -72(%rbp), %rdi
        movl    $1, %esi
        movq    %rcx, -96(%rbp)
        movabsq $.Llshift, %rax
        movl    %edx, -84(%rbp)
        callq   *%rax
        movq    %r12, %rsi
        movq    %rax, -72(%rbp)
        movq    %rax, %rdi
        movabsq $.Lcmp, %rax
        callq   *%rax
        movl    -84(%rbp), %edx
        cmpl    $0, %eax
        movq    -96(%rbp), %rcx
        jg      90f
        jne     91f
        testb   $1, %dl
        je      91f
90:
        cmpl    $57, %edx
        je      93f
        movl    -88(%rbp), %edx
        addl    $49, %edx
91:
        incq    %r15
        movb    %dl, (%rcx)
        jmp     109f
92:
        leaq    1(%r15), %rax
        testl   %r8d, %r8d
        jle     95f
        cmpl    $57, %edx
        movq    %r15, %rsi
        jne     94f
93:
        movb    $57, (%r15)
        incq    %r15
        jmp     103f
94:
        incl    %edx
        movq    %rax, %r15
        movb    %dl, (%rsi)
        jmp     109f
95:
        movq    %rax, %r15
        movb    %dl, -1(%rax)
        subl    -80(%rbp), %eax
        cmpl    -84(%rbp), %eax
        je      101f
        movq    -72(%rbp), %rdi
        xorl    %edx, %edx
        movl    $10, %esi
        movabsq $.Lmultadd, %rcx
        movq    %rcx, -104(%rbp)
        callq   *%rcx
        xorl    %edx, %edx
        cmpq    %rbx, %r13
        movq    %rax, -72(%rbp)
        movl    $10, %esi
        movq    %r13, %rdi
        movq    -104(%rbp), %rcx
        jne     96f
        callq   *%rcx
        movq    %rax, %r13
        movq    %rax, %rbx
        jmp     82b
96:
        movq    %rcx, -104(%rbp)
        callq   *%rcx
        movq    -104(%rbp), %rcx
        xorl    %edx, %edx
        movl    $10, %esi
        movq    %rbx, %rdi
        movq    %rax, %r13
        callq   *%rcx
        jmp     81b
97:
        movabsq $.Lquorem, %r13
        movq    -80(%rbp), %r15
98:
        movq    -72(%rbp), %rdi
        movq    %r12, %rsi
        incq    %r15
        callq   *%r13
        leal    48(%rax), %edx
        movq    -72(%rbp), %rax
        movb    %dl, -1(%r15)
        cmpl    $0, 24(%rax)
        jne     99f
        cmpl    $1, 20(%rax)
        jg      99f
        {disp8} jmp 108f
99:
        movl    %r15d, %eax
        subl    -80(%rbp), %eax
        cmpl    -84(%rbp), %eax
        jge     100f
        movq    -72(%rbp), %rdi
        xorl    %edx, %edx
        movl    $10, %esi
        movabsq $.Lmultadd, %rax
        callq   *%rax
        movq    %rax, -72(%rbp)
        jmp     98b
100:
        xorl    %r13d, %r13d
101:
        movq    -72(%rbp), %rdi
        movl    $1, %esi
        movl    %edx, -84(%rbp)
        movabsq $.Llshift, %rax
        callq   *%rax
        movq    %r12, %rsi
        movq    %rax, -72(%rbp)
        movq    %rax, %rdi
        movabsq $.Lcmp, %rax
        callq   *%rax
        movl    -84(%rbp), %edx
        cmpl    $0, %eax
        jg      103f
        jne     107f
        andb    $1, %dl
        jne     103f
        jmp     107f
102:
        cmpq    -80(%rbp), %rax
        je      104f
        movq    %rax, %r15
103:
        movb    -1(%r15), %dl
        leaq    -1(%r15), %rax
        cmpb    $57, %dl
        je      102b
        jmp     105f
104:
        movq    -80(%rbp), %rax
        incl    %r14d
        movb    $49, (%rax)
        jmp     109f
105:
        incl    %edx
106:
        movb    %dl, (%rax)
        jmp     109f
107:
        cmpb    $48, -1(%r15)
        leaq    -1(%r15), %rax
        jne     109f
        movq    %rax, %r15
        jmp     107b
108:
        xorl    %r13d, %r13d
109:
        movq    %r12, %rdi
        movabsq $.LBfree, %r12
        callq   *%r12
        testq   %rbx, %rbx
        je      112f
        cmpq    %rbx, %r13
        je      110f
        testq   %r13, %r13
        je      110f
        movq    %r13, %rdi
        callq   *%r12
110:
        movq    %rbx, %rdi
        callq   *%r12
        jmp     112f
111:
        movl    %esi, %r14d
112:
        movabsq $.LBfree, %rax
        movq    -72(%rbp), %rdi
        callq   *%rax
        movq    -144(%rbp), %rbx
        leal    1(%r14), %eax
        movb    $0, (%r15)
        movl    %eax, (%rbx)
        movq    -136(%rbp), %rax
        testq   %rax, %rax
        je      113f
        movq    %r15, (%rax)
113:
        movq    -80(%rbp), %rax
114:
        addq    $120, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
        .size   .Ldtoa, .-.Ldtoa

        .section .rodata,"a",@progbits

        .align 8
        .type   .Lp05.3208, @object
        .size   .Lp05.3208, 12
.Lp05.3208:
        .long   5
        .long   25
        .long   125
        .local  .Ldtoa_result
        .comm   .Ldtoa_result,8,8
        .align 64
        .type   .Lhexdig, @object
        .size   .Lhexdig, 256
.Lhexdig:
        .rept 48
        .byte 0
        .endr
        .byte   16
        .byte   17
        .byte   18
        .byte   19
        .byte   20
        .byte   21
        .byte   22
        .byte   23
        .byte   24
        .byte   25
        .byte   0
        .byte   0
        .byte   0
        .byte   0
        .byte   0
        .byte   0
        .byte   0
        .byte   26
        .byte   27
        .byte   28
        .byte   29
        .byte   30
        .byte   31
        .rept 26
        .byte 0
        .endr
        .byte   26
        .byte   27
        .byte   28
        .byte   29
        .byte   30
        .byte   31
        .rept 153
        .byte 0
        .endr
        .align 16
        .type   .Ltinytens, @object
        .size   .Ltinytens, 40
.Ltinytens:
        .long   2547550652
        .long   1016910514
        .long   3584599859
        .long   961148451
        .long   1156884285
        .long   849678333
        .long   3482097565
        .long   626768392
        .long   1689022275
        .long   180880936
        .align 16
        .type   .Lbigtens, @object
        .size   .Lbigtens, 40
.Lbigtens:
        .long   937459712
        .long   1128383353
        .long   3037031959
        .long   1184086197
        .long   3913284085
        .long   1295535875
        .long   4180679986
        .long   1518499656
        .long   2138292028
        .long   1964330973
        .align 64
        .type   .Ltens, @object
        .size   .Ltens, 184
.Ltens:
        .long   0
        .long   1072693248
        .long   0
        .long   1076101120
        .long   0
        .long   1079574528
        .long   0
        .long   1083129856
        .long   0
        .long   1086556160
        .long   0
        .long   1090021888
        .long   0
        .long   1093567616
        .long   0
        .long   1097011920
        .long   0
        .long   1100470148
        .long   0
        .long   1104006501
        .long   536870912
        .long   1107468383
        .long   3892314112
        .long   1110919286
        .long   2717908992
        .long   1114446484
        .long   3846176768
        .long   1117925532
        .long   512753664
        .long   1121369284
        .long   640942080
        .long   1124887541
        .long   937459712
        .long   1128383353
        .long   2245566464
        .long   1131820119
        .long   1733216256
        .long   1135329645
        .long   1620131072
        .long   1138841828
        .long   2025163840
        .long   1142271773
        .long   3605196624
        .long   1145772772
        .long   105764242
        .long   1149300943
        .local  .Lp5s
        .comm   .Lp5s,8,8
        .local  .Lfreelist
        .comm   .Lfreelist,64,64

        .section .bss,"aw",@nobits

        .align 4
        .type   .Lerrno, @object
        .size   .Lerrno, 4
.Lerrno:
        .zero   4

        .section .data,"aw",@progbits

        .align 8
        .type   .Lpmem_next, @object
        .size   .Lpmem_next, 8
.Lpmem_next:
        .quad   .Lprivate_mem
        .local  .Lprivate_mem
        .comm   .Lprivate_mem,16384,64

        .section .rodata.cst8,"aM",@progbits,8

        .align 8
.LdtoaC1:
        .long   0
        .long   1071644672
        .align 8
.LdtoaC2:
        .long   0
        .long   -1074790400
        .align 8
.LdtoaC3:
        .long   0
        .long   1072693248

        .section .rodata.cst16,"aM",@progbits,16

        .align 16
.LdtoaC7:
        .long   0
        .long   -2147483648
        .long   0
        .long   0

        .section .rodata.cst8,"aM",@progbits,8

        .align 8
.LdtoaC8:
        .long   0
        .long   1073741824
        .align 8
.LdtoaC9:
        .long   2493527445
        .long   1071644671
        .align 8
.LdtoaC10:
        .long   900719925
        .long   1071644672
        .align 8
.LdtoaC11:
        .long   2493527445
        .long   1070596095
        .align 8
.LdtoaC15:
        .long   0
        .long   1073217536
        .align 8
.LdtoaC16:
        .long   1668236129
        .long   1070761895
        .align 8
.LdtoaC17:
        .long   2338375859
        .long   1069976104
        .align 8
.LdtoaC18:
        .long   1352628731
        .long   1070810131
        .align 8
.LdtoaC19:
        .long   2138292028
        .long   1964330973
        .align 8
.LdtoaC20:
        .long   0
        .long   1076101120
        .align 8
.LdtoaC21:
        .long   0
        .long   1075576832
        .align 8
.LdtoaC22:
        .long   0
        .long   1075052544
        .align 8
.LdtoaC24:
        .quad   3595427678142423661

        .section .text,"ax",@progbits

#
# char *g_fmt(register char *b,double x,signed long int digits_after_decimal,char digits_in_exponent)
# reg     arg
# ----    --------------------
# rdi     b
# xmm0    x
# esi     digits_after_decimal
# edx     digits_in_exponent
#
        .type   .Lg_fmt, @function
.Lg_fmt:
        pushq   %rbp
        xorps   %xmm1, %xmm1
        movq    %rsp, %rbp
        pushq   %r12
        movq    %rsi, %r12
        pushq   %rbx
        movq    %rdi, %rbx
        subq    $16, %rsp
        ucomisd %xmm1, %xmm0
        jp      0f
        jne     0f
        movb    $32, (%rdi)
        movb    $48, 1(%rdi)
        movb    $32, 2(%rdi)
        movb    $0, 3(%rdi)
        jmp     29f
0:
        leaq    -28(%rbp), %rcx
        movl    $4, %edi
        movl    %r12d, %esi
        leaq    -24(%rbp), %r8
        movabsq $.Ldtoa, %rax
        leaq    -32(%rbp), %rdx
        callq   *%rax
        cmpl    $0, -28(%rbp)
        leaq    1(%rbx), %rcx
        movq    %rax, %rdi
        movq    %rcx, %rax
        je      1f
        movb    $45, (%rbx)
        jmp     2f
1:
        movb    $32, (%rbx)
2:
        movl    -32(%rbp), %edx
        cmpl    $9999, %edx
        jne     4f
        movq    %rdi, %rdx
3:
        incq    %rdx
        movb    -1(%rdx), %cl
        testb   %cl, %cl
        movb    %cl, (%rax)
        je      27f
        incq    %rax
        jmp     3b
4:
        movslq  %edx, %r9
        cmpq    %r12, %r9
        jg      5f
        movq    -24(%rbp), %r8
        subq    %rdi, %r8
        movq    %r8, %rsi
        subq    %r12, %rsi
        cmpq    %rsi, %r9
        jl      5f
        {disp8} jmp 15f
5:
        movb    (%rdi), %al
        leaq    2(%rcx), %rsi
        movb    %al, (%rcx)
        cmpb    $0, 1(%rdi)
        je      7f
        leaq    1(%rdi), %rax
        movb    $46, 1(%rcx)
6:
        incq    %rax
        movb    -1(%rax), %cl
        testb   %cl, %cl
        movb    %cl, (%rsi)
        je      8f
        incq    %rsi
        jmp     6b
7:
        movb    $46, 1(%rcx)
8:
        movb    $69, (%rsi)
        leaq    2(%rsi), %r9
        decl    %edx
        testl   %edx, %edx
        movl    %edx, -32(%rbp)
        jns     9f
        negl    %edx
        movb    $45, 1(%rsi)
        movl    %edx, -32(%rbp)
        jmp     10f
9:
        movb    $43, 1(%rsi)
10:
        movl    -32(%rbp), %r8d
        movl    $2, %ecx
        movl    $10, %esi
11:
        imull   $10, %esi, %eax
        cmpl    %r8d, %eax
        jg      12f
        incl    %ecx
        movl    %eax, %esi
        jmp     11b
12:
        xorl    %r10d, %r10d
13:
        movl    %r8d, %eax
        cltd
        idivl   %esi
        leal    48(%rax), %edx
        movb    %dl, (%r9,%r10)
        incq    %r10
        cmpl    %r10d, %ecx
        je      14f
        imull   %esi, %eax
        subl    %eax, %r8d
        imull   $10, %r8d, %r8d
        jmp     13b
14:
        decl    %ecx
        movl    %r8d, -32(%rbp)
        movslq  %ecx, %rcx
        addq    %r9, %rcx
        movb    $32, 1(%rcx)
        movb    $0, 2(%rcx)
        jmp     28f
15:
        testl   %edx, %edx
        jle     16f
        movq    %rdi, %rcx
        jmp     22f
16:
        leaq    1(%rcx), %rax
        movb    $46, (%rcx)
17:
        testl   %edx, %edx
        jns     18f
        incq    %rax
        movb    $48, -1(%rax)
        incl    %edx
        jmp     17b
18:
        movl    %edx, -32(%rbp)
        movq    %rdi, %rdx
19:
        incq    %rdx
        movb    -1(%rdx), %cl
        testb   %cl, %cl
        movb    %cl, (%rax)
        je      27f
        incq    %rax
        jmp     19b
20:
        leaq    1(%rax), %rsi
        decl    %edx
        testl   %edx, %edx
        movl    %edx, -32(%rbp)
        je      23f
21:
        movq    %rsi, %rax
22:
        incq    %rcx
        movb    -1(%rcx), %dl
        testb   %dl, %dl
        movb    %dl, (%rax)
        movl    -32(%rbp), %edx
        jne     20b
        jmp     24f
23:
        cmpb    $0, (%rcx)
        je      21b
        leaq    2(%rax), %rsi
        movb    $46, 1(%rax)
        jmp     21b
24:
        xorl    %ecx, %ecx
25:
        movl    %edx, %esi
        subl    %ecx, %esi
        testl   %esi, %esi
        jle     26f
        movb    $48, (%rax,%rcx)
        incq    %rcx
        jmp     25b
26:
        testl   %edx, %edx
        movl    $0, %esi
        cmovns  %edx, %esi
        movslq  %esi, %rcx
        subl    %esi, %edx
        addq    %rcx, %rax
        movl    %edx, -32(%rbp)
27:
        movb    $32, (%rax)
        movb    $0, 1(%rax)
28:
        movabsq $.Lfreedtoa, %rax
        callq   *%rax
29:
        popq    %rdx
        movq    %rbx, %rax
        popq    %rcx
        popq    %rbx
        popq    %r12
        popq    %rbp
        retq
        .size   .Lg_fmt, .-.Lg_fmt
################################################################
#
# End of David M. Gay code copyrighted by Lucent.
#
################################################################
