        #
        # This prints a non-fatal exception
        # It's sole incoming argument is the address of an ASCIIZ buffer containing
        # the reason for the exception in rsi.  This is a procedure, so it has no
        # return value.  This code prints the error message and then appends
        # " ON LINE NUMBER " and the line number in the BASIC program where the
        # exception occurred, and finally a newline.  At that point it display the
        # error message.  Any required line breaking for a long message is taken
        # care of by the appendbuffer/flushoutputln routines.
        #
        .type .Lexception_non_fatal, @function
.Lexception_non_fatal:
        movq    %rsi, %rcx             # input buffer with exception message to display
        movabsq $.LEBUF,%rdi           # output error buffer variable address
        movabsq $.Lebuf_next,%rsi      # output error bufpos variable address
        movabsq $.Lcurezone,%rdx       # output error zonepos variable address
        movabsq $.Lappendbuffer, %rax  # call appendbuffer
        callq   *%rax
        movabsq $.Lon_line_number_msg, %rcx # input buffer with " ON LINE NUMBER "
        movabsq $.LEBUF,%rdi           # output error buffer variable address
        movabsq $.Lebuf_next,%rsi      # output error bufpos variable address
        movabsq $.Lcurezone,%rdx       # output error zonepos variable address
        movabsq $.Lappendbuffer, %rax  # call appendbuffer
        callq   *%rax
        movabsq $.LCURLINENO, %rax     # address of variable containing current BASIC line number
        movq    (%rax), %rdi
        movabsq $.LOUTBUFFER, %rsi     # address of buffer for ASCIIZ version of BASIC line number
        movabsq $.Lmyitoa, %rax        # call itoa(CURLINENO,OUTBUFFER)
        callq   *%rax
        movabsq $.LOUTBUFFER, %rcx     # input buffer containing contents to display
        movabsq $.LEBUF,%rdi           # output error buffer variable address
        movabsq $.Lebuf_next,%rsi      # output error bufpos variable address
        movabsq $.Lcurezone,%rdx       # output error zonepos variable address
        movabsq $.Lappendbuffer, %rax  # call appendbuffer
        callq   *%rax
        # flush error message to ensure it is printed NOW
        movabsq $.LEBUF,%rdi           # output error buffer variable address
        movabsq $.Lebuf_next,%rsi      # output error bufpos variable address
        movabsq $.Lcurezone,%rdx       # output error zonepos variable address
        movabsq $.Lflushoutputln,%rax  # call flushoutputln
        callq   *%rax
        retq
        .size .Lexception_non_fatal, .-.Lexception_non_fatal
