        .section .text,"ax",@progbits

#
# static unsigned long int fb_date_n(void);
# Implements ECMA-116 numeric DATE function
# returns YYDDD where YY are the last two digits
# of the year, and DDD is the day of the year
# (one-based), such as 21121, for the date of
# May 1, 2021.  Answer retruned in xmm0.
#
        .type   .Lfb_date_n, @function
.Lfb_date_n:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %rbx
        subq    $72, %rsp
        movl    $0, %edi
        movabsq $.Llinux_time, %rax
        call    *%rax
        movabsq $.Lts, %rdi
        movabsq $.Llocaltime, %rax
        call    *%rax
        movq    %rax, -24(%rbp)
        movq    -24(%rbp), %rax
        movq    (%rax), %rcx
        movq    8(%rax), %rbx
        movq    %rcx, -64(%rbp)
        movq    %rbx, -56(%rbp)
        movq    16(%rax), %rcx
        movq    24(%rax), %rbx
        movq    %rcx, -48(%rbp)
        movq    %rbx, -40(%rbp)
        movl    32(%rax), %eax
        movl    %eax, -32(%rbp)
        movl    -44(%rbp), %eax
        leal    1900(%rax), %edx
        movslq  %edx, %rax
        imulq   $1374389535, %rax, %rax
        shrq    $32, %rax
        sarl    $5, %eax
        movl    %edx, %ecx
        sarl    $31, %ecx
        subl    %ecx, %eax
        imull   $100, %eax, %ecx
        movl    %edx, %eax
        subl    %ecx, %eax
        imull   $1000, %eax, %edx
        movl    -36(%rbp), %eax
        addl    %edx, %eax
        addl    $1, %eax
        cltq
        movq    -8(%rbp), %rbx
        cvtsi2sd %rax, %xmm0
        movq %rbp,%rsp
        popq %rbp
        retq
        .size   .Lfb_date_n, .-.Lfb_date_n
