        .section .text,"ax",@progbits

#
# static unsigned long int fb_time_n(void);
# Implements ECMA-116 numeric TIME function
# returns number of seconds since the last
# midnight, such as 79602 for 22:06:42.
# Answer returned in xmm0.
#
        .type   .Lfb_time_n, @function
.Lfb_time_n:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %rbx
        subq    $72, %rsp
        movl    $0, %edi
        movabsq $.Llinux_time, %rax
        call    *%rax
        movabsq $.Lts, %rdi
        movabsq $.Llocaltime, %rax
        call    *%rax
        movq    %rax, -24(%rbp)
        movq    -24(%rbp), %rax
        movq    (%rax), %rcx
        movq    8(%rax), %rbx
        movq    %rcx, -64(%rbp)
        movq    %rbx, -56(%rbp)
        movq    16(%rax), %rcx
        movq    24(%rax), %rbx
        movq    %rcx, -48(%rbp)
        movq    %rbx, -40(%rbp)
        movl    32(%rax), %eax
        movl    %eax, -32(%rbp)
        movl    -56(%rbp), %eax
        imull   $3600, %eax, %edx
        movl    -60(%rbp), %eax
        imull   $60, %eax, %eax
        addl    %eax, %edx
        movl    -64(%rbp), %eax
        addl    %edx, %eax
        cltq
        movq    -8(%rbp), %rbx
        cvtsi2sd %rax, %xmm0
        movq %rbp,%rsp
        popq %rbp
        retq
        .size   .Lfb_time_n, .-.Lfb_time_n

