.Lgoodxit: # code jumps here to exit program successfully
        movabsq $.LEXIT_SUCCESS, %rdi  # return code indicates success
        {disp8} jmp .Lfinalxit         # goto finalxit
.Lbadxit_msg:
        movabsq $.LEBUF, %rdi         # arg 1 output buffer variable address
        movabsq $.Lebuf_next, %rsi    # arg 2 output bufpos variable address
        movabsq $.Lcurezone, %rdx     # arg 3 output zonepos variable address
        movabsq $.Lappendbuffer, %rax
        callq   *%rax
.Lbadxit:  # code jumps here to exit program with an error
        movabsq $.Lon_line_number_msg, %rcx # rcx = address of on_line_number_msg
        movabsq $.LEBUF,%rdi           # output error buffer variable address
        movabsq $.Lebuf_next,%rsi      # output error bufpos variable address
        movabsq $.Lcurezone,%rdx       # output error zonepos variable address
        movabsq $.Lappendbuffer, %rax  # call appendbuffer
        callq   *%rax
        # now we must convert the line number into ASCIIZ
        movabsq $.LCURLINENO, %rax     # line number
        movl    (%rax), %eax           # goes into
        movl    %eax, %edi             # rdi
        movabsq $.LOUTBUFFER, %rsi     # address of scratch buffer
        movabsq $.Lmyitoa, %rax        # call itoa(rdi,rsi)
        callq   *%rax
        movabsq $.LOUTBUFFER, %rcx     # input is OUTBUFFER filled by the call to itoa
        movabsq $.LEBUF,%rdi           # output error buffer variable address
        movabsq $.Lebuf_next,%rsi      # output error bufpos variable address
        movabsq $.Lcurezone,%rdx       # output error zonepos variable address
        movabsq $.Lappendbuffer, %rax  # call appendbuffer
        callq   *%rax
        # flush error buffer
        movabsq $.LEBUF,%rdi           # output error buffer variable address
        movabsq $.Lebuf_next,%rsi      # output error bufpos variable address
        movabsq $.Lcurezone,%rdx       # output error zonepos variable address
        movabsq $.Lflushoutputln,%rax  # call flushoutputln
        callq   *%rax
        # flush normal output buffer
        movabsq $.LOBUF,%rdi           # output buffer variable address
        movabsq $.Lobuf_next,%rsi      # output bufpox variable address
        movabsq $.Lcurzone,%rdx        # output zonepos variable address
        movabsq $.Lflushoutputln,%rax  # call flushoutputln
        callq   *%rax
        movabsq $.LEXIT_FAILURE, %rdi  # return code indicates failure
        # fall through intentionally
.Lfinalxit: # code jumps here from goodxit, or falls through from badxit
            # what follows is common code we need for any kind of exit.
