        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_asind2_u10sse2, @function
.LSleef_asind2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCASIN_0, %rax
        movapd  %xmm0, %xmm5
        movapd  (%rax), %xmm11
        movapd  %xmm5, %xmm1
        movabsq $.LCASIN_2, %rax
        movapd  (%rax), %xmm13
        mulpd   %xmm5, %xmm1
        movabsq $.LCASIN_3, %rax
        movapd  (%rax), %xmm12
        movapd  %xmm11, %xmm2
        andpd   %xmm11, %xmm5
        movabsq $.LCASIN_7, %rax
        andnpd  %xmm0, %xmm2
        movapd  (%rax), %xmm14
        movabsq $.LCASIN_297, %rax
        movapd  %xmm12, %xmm0
        movapd  %xmm2, %xmm3
        movapd  %xmm12, %xmm10
        subpd   %xmm2, %xmm0
        cmpltpd %xmm13, %xmm3
        mulpd   %xmm13, %xmm0
        movapd  %xmm3, %xmm4
        andpd   %xmm3, %xmm1
        andnpd  %xmm0, %xmm4
        orpd    %xmm4, %xmm1
        sqrtpd  %xmm1, %xmm4
        divpd   %xmm4, %xmm10
        movapd  %xmm4, %xmm0
        movapd  %xmm4, %xmm8
        mulpd   %xmm4, %xmm4
        andpd   %xmm14, %xmm0
        subpd   %xmm0, %xmm8
        movapd  %xmm0, %xmm7
        mulpd   %xmm8, %xmm7
        movaps  %xmm4, -104(%rsp)
        movaps  %xmm7, -88(%rsp)
        movapd  %xmm4, %xmm7
        xorpd   %xmm11, %xmm7
        movaps  %xmm7, -24(%rsp)
        movapd  %xmm4, %xmm7
        movapd  %xmm0, %xmm4
        addpd   %xmm1, %xmm7
        movapd  %xmm7, %xmm15
        subpd   %xmm1, %xmm15
        movaps  %xmm15, -72(%rsp)
        movapd  %xmm7, %xmm15
        movapd  %xmm10, %xmm6
        movapd  %xmm10, %xmm9
        andpd   %xmm14, %xmm6
        andpd   %xmm7, %xmm14
        subpd   %xmm14, %xmm15
        mulpd   %xmm6, %xmm4
        subpd   %xmm6, %xmm9
        movaps  %xmm14, -120(%rsp)
        movaps  %xmm15, -56(%rsp)
        movapd  %xmm10, %xmm15
        mulpd   %xmm7, %xmm15
        movaps  %xmm15, -40(%rsp)
        xorpd   %xmm11, %xmm15
        movapd  %xmm15, %xmm14
        movapd  %xmm4, %xmm15
        movapd  %xmm12, %xmm4
        subpd   %xmm15, %xmm4
        movapd  %xmm0, %xmm15
        mulpd   %xmm9, %xmm15
        mulpd   %xmm0, %xmm0
        addpd   -24(%rsp), %xmm0
        subpd   %xmm15, %xmm4
        movapd  %xmm8, %xmm15
        mulpd   %xmm6, %xmm15
        subpd   %xmm15, %xmm4
        movapd  %xmm8, %xmm15
        mulpd   %xmm9, %xmm15
        mulpd   %xmm8, %xmm8
        subpd   %xmm15, %xmm4
        movapd  -120(%rsp), %xmm15
        mulpd   %xmm6, %xmm15
        mulpd   %xmm10, %xmm4
        addpd   %xmm15, %xmm14
        movapd  -56(%rsp), %xmm15
        mulpd   %xmm7, %xmm4
        mulpd   %xmm15, %xmm6
        addpd   %xmm14, %xmm6
        movapd  -120(%rsp), %xmm14
        mulpd   %xmm9, %xmm14
        mulpd   %xmm15, %xmm9
        addpd   %xmm6, %xmm14
        movapd  -88(%rsp), %xmm6
        addpd   %xmm6, %xmm0
        addpd   %xmm9, %xmm14
        addpd   %xmm6, %xmm0
        movapd  -72(%rsp), %xmm6
        addpd   %xmm4, %xmm14
        movapd  -104(%rsp), %xmm4
        subpd   %xmm6, %xmm7
        addpd   %xmm0, %xmm8
        movapd  %xmm1, %xmm0
        subpd   %xmm6, %xmm4
        movapd  %xmm3, %xmm6
        subpd   %xmm7, %xmm0
        addpd   %xmm4, %xmm0
        movapd  %xmm3, %xmm4
        addpd   %xmm8, %xmm0
        movapd  %xmm1, %xmm8
        mulpd   %xmm1, %xmm8
        mulpd   %xmm0, %xmm10
        movapd  %xmm3, %xmm0
        andpd   %xmm2, %xmm0
        cmpeqpd %xmm12, %xmm2
        movapd  (%rax), %xmm12
        movabsq $.LCASIN_298, %rax
        mulpd   %xmm1, %xmm12
        addpd   (%rax), %xmm12
        movapd  %xmm2, %xmm7
        movabsq $.LCASIN_299, %rax
        addpd   %xmm10, %xmm14
        mulpd   %xmm8, %xmm12
        mulpd   %xmm13, %xmm14
        mulpd   -40(%rsp), %xmm13
        andnpd  %xmm14, %xmm4
        andnpd  %xmm13, %xmm6
        andnpd  %xmm4, %xmm7
        movapd  %xmm8, %xmm4
        mulpd   %xmm8, %xmm4
        orpd    %xmm6, %xmm0
        andnpd  %xmm0, %xmm2
        movapd  (%rax), %xmm0
        movabsq $.LCASIN_300, %rax
        mulpd   %xmm1, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCASIN_301, %rax
        movapd  (%rax), %xmm6
        movabsq $.LCASIN_302, %rax
        mulpd   %xmm1, %xmm6
        addpd   %xmm0, %xmm12
        addpd   (%rax), %xmm6
        movabsq $.LCASIN_303, %rax
        movapd  (%rax), %xmm0
        movabsq $.LCASIN_304, %rax
        mulpd   %xmm4, %xmm12
        mulpd   %xmm8, %xmm6
        mulpd   %xmm1, %xmm0
        addpd   (%rax), %xmm0
        mulpd   %xmm4, %xmm4
        movabsq $.LCASIN_305, %rax
        addpd   %xmm0, %xmm6
        movapd  (%rax), %xmm0
        movabsq $.LCASIN_306, %rax
        mulpd   %xmm1, %xmm0
        addpd   (%rax), %xmm0
        addpd   %xmm6, %xmm12
        movabsq $.LCASIN_307, %rax
        movapd  (%rax), %xmm6
        movabsq $.LCASIN_308, %rax
        mulpd   %xmm8, %xmm0
        mulpd   %xmm1, %xmm6
        addpd   (%rax), %xmm6
        mulpd   %xmm2, %xmm1
        movabsq $.LCASIN_141, %rax
        addpd   %xmm6, %xmm0
        movapd  (%rax), %xmm6
        movabsq $.LCASIN_309, %rax
        mulpd   %xmm4, %xmm0
        addpd   %xmm12, %xmm0
        mulpd   %xmm0, %xmm1
        movapd  %xmm6, %xmm0
        subpd   %xmm2, %xmm0
        subpd   %xmm0, %xmm6
        movapd  %xmm0, %xmm8
        subpd   %xmm1, %xmm8
        movapd  %xmm6, %xmm4
        subpd   %xmm2, %xmm4
        subpd   %xmm8, %xmm0
        addpd   (%rax), %xmm4
        addpd   %xmm1, %xmm2
        subpd   %xmm1, %xmm0
        subpd   %xmm7, %xmm4
        addpd   %xmm0, %xmm4
        movapd  %xmm3, %xmm0
        andpd   %xmm2, %xmm3
        addpd   %xmm8, %xmm4
        addpd   %xmm4, %xmm4
        andnpd  %xmm4, %xmm0
        orpd    %xmm0, %xmm3
        movapd  %xmm5, %xmm0
        pxor    %xmm3, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_asind2_u10sse2, .-.LSleef_asind2_u10sse2
        .set .Lxasin_u1, .LSleef_asind2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCASIN_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCASIN_2:
        .long   0
        .long   1071644672
        .long   0
        .long   1071644672
        .align 16
.LCASIN_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCASIN_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCASIN_141:
        .long   1413754136
        .long   1072243195
        .long   1413754136
        .long   1072243195
        .align 16
.LCASIN_297:
        .long   1221655407
        .long   1065935869
        .long   1221655407
        .long   1065935869
        .align 16
.LCASIN_298:
        .long   -133019140
        .long   1066168541
        .long   -133019140
        .long   1066168541
        .align 16
.LCASIN_299:
        .long   70174386
        .long   1066518197
        .long   70174386
        .long   1066518197
        .align 16
.LCASIN_300:
        .long   -2055686578
        .long   1066854559
        .long   -2055686578
        .long   1066854559
        .align 16
.LCASIN_301:
        .long   -973236806
        .long   1067392114
        .long   -973236806
        .long   1067392114
        .align 16
.LCASIN_302:
        .long   -1274559821
        .long   1067899757
        .long   -1274559821
        .long   1067899757
        .align 16
.LCASIN_303:
        .long   859266256
        .long   1068708659
        .long   859266256
        .long   1068708659
        .align 16
.LCASIN_304:
        .long   1431655156
        .long   1069897045
        .long   1431655156
        .long   1069897045
        .align 16
.LCASIN_305:
        .long   -951940537
        .long   1067462644
        .long   -951940537
        .long   1067462644
        .align 16
.LCASIN_306:
        .long   1556957928
        .long   -1081068825
        .long   1556957928
        .long   -1081068825
        .align 16
.LCASIN_307:
        .long   -2122410174
        .long   1066647776
        .long   -2122410174
        .long   1066647776
        .align 16
.LCASIN_308:
        .long   1802665598
        .long   1065029369
        .long   1802665598
        .long   1065029369
        .align 16
.LCASIN_309:
        .long   856972295
        .long   1015129638
        .long   856972295
        .long   1015129638
