        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_atand2_u10sse2, @function
.LSleef_atand2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCATAN_0, %rax
        subq    $96, %rsp
        pxor    %xmm1, %xmm1
        movapd  (%rax), %xmm6
        movaps  %xmm0, -8(%rsp)
        movabsq $.LCATAN_3, %rax
        movapd  (%rax), %xmm2
        movabsq $.LCATAN_314, %rax
        movapd  %xmm6, %xmm4
        movdqa  (%rax), %xmm8
        movapd  %xmm6, %xmm3
        movabsq $.LCATAN_7, %rax
        movapd  %xmm2, %xmm5
        andnpd  %xmm0, %xmm4
        movapd  %xmm2, %xmm12
        movapd  (%rax), %xmm10
        movabsq $.LCATAN_274, %rax
        cmpltpd %xmm1, %xmm5
        movapd  %xmm6, %xmm1
        movapd  %xmm5, %xmm0
        andpd   %xmm6, %xmm0
        pxor    %xmm0, %xmm8
        xorpd   %xmm0, %xmm3
        movapd  %xmm8, %xmm7
        xorpd   %xmm8, %xmm1
        cmpltpd %xmm4, %xmm7
        movapd  %xmm7, %xmm9
        andpd   %xmm7, %xmm1
        pshufd  $8, %xmm7, %xmm5
        andnpd  %xmm4, %xmm9
        andpd   %xmm7, %xmm3
        movapd  %xmm7, %xmm13
        orpd    %xmm9, %xmm1
        movapd  %xmm7, %xmm9
        andpd   %xmm4, %xmm7
        andnpd  %xmm8, %xmm9
        andnpd  %xmm0, %xmm13
        movapd  %xmm7, %xmm0
        orpd    %xmm9, %xmm0
        movapd  %xmm1, %xmm9
        movapd  %xmm1, %xmm14
        divpd   %xmm0, %xmm12
        movapd  %xmm0, %xmm11
        andpd   %xmm10, %xmm9
        andpd   %xmm10, %xmm11
        subpd   %xmm9, %xmm14
        movapd  %xmm11, %xmm15
        subpd   %xmm11, %xmm0
        mulpd   %xmm12, %xmm1
        movapd  %xmm12, %xmm7
        movapd  %xmm12, %xmm8
        andpd   %xmm10, %xmm7
        subpd   %xmm7, %xmm8
        mulpd   %xmm7, %xmm15
        mulpd   %xmm8, %xmm11
        mulpd   %xmm1, %xmm13
        subpd   %xmm15, %xmm2
        movapd  %xmm7, %xmm15
        mulpd   %xmm9, %xmm15
        mulpd   %xmm8, %xmm9
        subpd   %xmm11, %xmm2
        movapd  %xmm0, %xmm11
        mulpd   %xmm7, %xmm11
        subpd   %xmm13, %xmm3
        mulpd   %xmm8, %xmm0
        mulpd   %xmm14, %xmm7
        mulpd   %xmm14, %xmm8
        movapd  (%rax), %xmm14
        movabsq $.LCATAN_275, %rax
        mulpd   %xmm3, %xmm12
        movapd  %xmm1, %xmm3
        subpd   %xmm11, %xmm2
        mulpd   %xmm1, %xmm3
        subpd   %xmm0, %xmm2
        movapd  %xmm15, %xmm0
        subpd   %xmm1, %xmm0
        mulpd   %xmm1, %xmm2
        addpd   %xmm0, %xmm9
        addpd   %xmm9, %xmm7
        movapd  %xmm1, %xmm9
        andpd   %xmm10, %xmm9
        addpd   %xmm7, %xmm8
        movapd  %xmm1, %xmm7
        subpd   %xmm9, %xmm7
        addpd   %xmm2, %xmm8
        movapd  %xmm9, %xmm2
        addpd   %xmm9, %xmm2
        movapd  %xmm8, %xmm15
        movapd  %xmm6, %xmm8
        movapd  %xmm2, %xmm0
        movapd  %xmm9, %xmm2
        xorpd   %xmm3, %xmm8
        mulpd   %xmm9, %xmm2
        addpd   %xmm12, %xmm15
        mulpd   %xmm7, %xmm0
        addpd   %xmm8, %xmm2
        addpd   %xmm2, %xmm0
        movapd  %xmm7, %xmm2
        mulpd   %xmm7, %xmm2
        addpd   %xmm2, %xmm0
        movapd  %xmm15, %xmm2
        addpd   %xmm15, %xmm2
        mulpd   %xmm1, %xmm2
        addpd   %xmm2, %xmm0
        movapd  %xmm0, %xmm2
        movaps  %xmm0, -120(%rsp)
        addpd   %xmm3, %xmm2
        mulpd   %xmm2, %xmm14
        movapd  %xmm2, %xmm11
        subpd   %xmm2, %xmm3
        mulpd   %xmm2, %xmm11
        movapd  %xmm14, %xmm0
        addpd   (%rax), %xmm0
        movapd  %xmm6, %xmm14
        movabsq $.LCATAN_276, %rax
        movapd  (%rax), %xmm8
        movapd  %xmm11, %xmm12
        movabsq $.LCATAN_277, %rax
        mulpd   %xmm11, %xmm12
        mulpd   %xmm11, %xmm0
        mulpd   %xmm2, %xmm8
        addpd   (%rax), %xmm8
        movabsq $.LCATAN_278, %rax
        addpd   %xmm8, %xmm0
        movapd  (%rax), %xmm8
        movabsq $.LCATAN_279, %rax
        mulpd   %xmm2, %xmm8
        addpd   (%rax), %xmm8
        mulpd   %xmm12, %xmm0
        movabsq $.LCATAN_280, %rax
        movapd  (%rax), %xmm13
        movabsq $.LCATAN_281, %rax
        mulpd   %xmm11, %xmm8
        mulpd   %xmm2, %xmm13
        addpd   (%rax), %xmm13
        movabsq $.LCATAN_282, %rax
        addpd   %xmm13, %xmm8
        addpd   %xmm8, %xmm0
        movapd  %xmm12, %xmm8
        mulpd   %xmm12, %xmm8
        mulpd   %xmm8, %xmm0
        movapd  (%rax), %xmm8
        movabsq $.LCATAN_283, %rax
        mulpd   %xmm2, %xmm8
        addpd   (%rax), %xmm8
        movabsq $.LCATAN_284, %rax
        movapd  (%rax), %xmm13
        movabsq $.LCATAN_285, %rax
        mulpd   %xmm11, %xmm8
        mulpd   %xmm2, %xmm13
        addpd   (%rax), %xmm13
        movabsq $.LCATAN_286, %rax
        addpd   %xmm13, %xmm8
        mulpd   %xmm8, %xmm12
        movapd  (%rax), %xmm8
        movabsq $.LCATAN_287, %rax
        mulpd   %xmm2, %xmm8
        addpd   (%rax), %xmm8
        movabsq $.LCATAN_288, %rax
        mulpd   %xmm8, %xmm11
        movapd  (%rax), %xmm8
        movabsq $.LCATAN_289, %rax
        mulpd   %xmm2, %xmm8
        addpd   (%rax), %xmm8
        movabsq $.LCATAN_290, %rax
        addpd   %xmm8, %xmm11
        movapd  %xmm2, %xmm8
        andpd   %xmm10, %xmm8
        addpd   %xmm11, %xmm12
        movapd  %xmm1, %xmm11
        mulpd   %xmm2, %xmm11
        addpd   %xmm12, %xmm0
        movapd  %xmm2, %xmm12
        subpd   %xmm8, %xmm12
        mulpd   %xmm2, %xmm0
        xorpd   %xmm11, %xmm14
        movapd  %xmm11, %xmm13
        addpd   (%rax), %xmm0
        movaps  %xmm14, 8(%rsp)
        movabsq $.LCATAN_291, %rax
        movapd  %xmm11, %xmm14
        andpd   %xmm10, %xmm14
        movaps  %xmm12, -104(%rsp)
        subpd   %xmm14, %xmm13
        mulpd   %xmm2, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCATAN_292, %rax
        movaps  %xmm13, -88(%rsp)
        mulpd   %xmm2, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCATAN_293, %rax
        mulpd   %xmm2, %xmm0
        addpd   (%rax), %xmm0
        mulpd   %xmm15, %xmm2
        movabsq $.LCATAN_178, %rax
        mulpd   %xmm0, %xmm11
        movapd  %xmm0, %xmm13
        movapd  %xmm0, %xmm12
        andpd   %xmm10, %xmm13
        subpd   %xmm13, %xmm12
        movaps  %xmm13, 24(%rsp)
        movaps  %xmm12, -72(%rsp)
        movapd  %xmm11, %xmm12
        xorpd   %xmm6, %xmm11
        movaps  %xmm11, 40(%rsp)
        pand    (%rax), %xmm5
        movabsq $.LCATAN_268, %rax
        movapd  %xmm12, %xmm11
        addpd   %xmm1, %xmm11
        movaps  %xmm12, -56(%rsp)
        movapd  %xmm6, %xmm12
        addpd   -120(%rsp), %xmm3
        cvtdq2pd        %xmm5, %xmm5
        andpd   %xmm5, %xmm10
        movapd  %xmm10, %xmm13
        movapd  %xmm5, %xmm10
        subpd   %xmm13, %xmm10
        mulpd   %xmm1, %xmm3
        subpd   %xmm11, %xmm1
        movaps  %xmm10, -40(%rsp)
        movapd  (%rax), %xmm10
        movabsq $.LCATAN_152, %rax
        cmpeqpd (%rax), %xmm4
        movabsq $.LCATAN_294, %rax
        movaps  %xmm10, 56(%rsp)
        mulpd   %xmm5, %xmm10
        xorpd   %xmm10, %xmm12
        movaps  %xmm12, 72(%rsp)
        movapd  %xmm11, %xmm12
        addpd   %xmm10, %xmm12
        movaps  %xmm12, -24(%rsp)
        movapd  %xmm9, %xmm12
        mulpd   %xmm8, %xmm12
        mulpd   %xmm7, %xmm8
        addpd   8(%rsp), %xmm12
        addpd   %xmm12, %xmm8
        movapd  -104(%rsp), %xmm12
        mulpd   %xmm12, %xmm9
        mulpd   %xmm12, %xmm7
        addpd   %xmm9, %xmm8
        movapd  -88(%rsp), %xmm9
        addpd   %xmm7, %xmm8
        movapd  24(%rsp), %xmm7
        addpd   %xmm3, %xmm8
        movapd  %xmm14, %xmm3
        addpd   %xmm2, %xmm8
        movapd  %xmm7, %xmm2
        mulpd   %xmm9, %xmm7
        mulpd   %xmm14, %xmm2
        addpd   40(%rsp), %xmm2
        mulpd   %xmm8, %xmm0
        addpd   %xmm7, %xmm2
        movapd  -72(%rsp), %xmm7
        mulpd   %xmm7, %xmm3
        addpd   %xmm3, %xmm2
        movapd  %xmm9, %xmm3
        mulpd   %xmm7, %xmm3
        movapd  -40(%rsp), %xmm7
        addpd   %xmm3, %xmm2
        movapd  %xmm13, %xmm3
        addpd   %xmm0, %xmm2
        movapd  -56(%rsp), %xmm0
        addpd   %xmm1, %xmm0
        movapd  (%rax), %xmm1
        movabsq $.LCATAN_295, %rax
        mulpd   %xmm1, %xmm3
        addpd   %xmm15, %xmm0
        addpd   72(%rsp), %xmm3
        mulpd   %xmm7, %xmm1
        addpd   %xmm2, %xmm0
        movapd  (%rax), %xmm2
        movabsq $.LCATAN_296, %rax
        mulpd   (%rax), %xmm5
        mulpd   %xmm2, %xmm13
        mulpd   %xmm7, %xmm2
        addpd   %xmm13, %xmm3
        addpd   %xmm1, %xmm3
        movapd  -24(%rsp), %xmm1
        subpd   %xmm1, %xmm10
        addpd   %xmm2, %xmm3
        addpd   %xmm10, %xmm11
        addpd   %xmm3, %xmm5
        addpd   %xmm5, %xmm11
        movapd  %xmm4, %xmm5
        andpd   56(%rsp), %xmm4
        addpd   %xmm11, %xmm0
        addpd   %xmm0, %xmm1
        movapd  -8(%rsp), %xmm0
        addq    $96, %rsp
        andpd   %xmm6, %xmm0
        andnpd  %xmm1, %xmm5
        orpd    %xmm5, %xmm4
        pxor    %xmm4, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_atand2_u10sse2, .-.LSleef_atand2_u10sse2
        .set    .Lxatan_u1, .LSleef_atand2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCATAN_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCATAN_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCATAN_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCATAN_152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCATAN_178:
        .long   1
        .long   1
        .long   0
        .long   0
        .align 16
.LCATAN_268:
        .long   1413754136
        .long   1073291771
        .long   1413754136
        .long   1073291771
        .align 16
.LCATAN_274:
        .long   1040641650
        .long   1055279835
        .long   1040641650
        .long   1055279835
        .align 16
.LCATAN_275:
        .long   715642574
        .long   -1088391391
        .long   715642574
        .long   -1088391391
        .align 16
.LCATAN_276:
        .long   1302130072
        .long   1061625550
        .long   1302130072
        .long   1061625550
        .align 16
.LCATAN_277:
        .long   951651566
        .long   -1083923967
        .long   951651566
        .long   -1083923967
        .align 16
.LCATAN_278:
        .long   -1030840397
        .long   1064990862
        .long   -1030840397
        .long   1064990862
        .align 16
.LCATAN_279:
        .long   -365453899
        .long   -1081457246
        .long   -365453899
        .long   -1081457246
        .align 16
.LCATAN_280:
        .long   -856100064
        .long   1066749246
        .long   -856100064
        .long   1066749246
        .align 16
.LCATAN_281:
        .long   -407231513
        .long   -1080190971
        .long   -407231513
        .long   -1080190971
        .align 16
.LCATAN_282:
        .long   638262237
        .long   1067609030
        .long   638262237
        .long   1067609030
        .align 16
.LCATAN_283:
        .long   1382810999
        .long   -1079677651
        .long   1382810999
        .long   -1079677651
        .align 16
.LCATAN_284:
        .long   -78514010
        .long   1067981678
        .long   -78514010
        .long   1067981678
        .align 16
.LCATAN_285:
        .long   -779526354
        .long   -1079320537
        .long   -779526354
        .long   -1079320537
        .align 16
.LCATAN_286:
        .long   1677751931
        .long   1068374613
        .long   1677751931
        .long   1068374613
        .align 16
.LCATAN_287:
        .long   1105543894
        .long   -1078914876
        .long   1105543894
        .long   -1078914876
        .align 16
.LCATAN_288:
        .long   -206566128
        .long   1068740913
        .long   -206566128
        .long   1068740913
        .align 16
.LCATAN_289:
        .long   -1407914004
        .long   -1078508080
        .long   -1407914004
        .long   -1078508080
        .align 16
.LCATAN_290:
        .long   280197643
        .long   1069314503
        .long   280197643
        .long   1069314503
        .align 16
.LCATAN_291:
        .long   -1844334649
        .long   -1077786332
        .long   -1844334649
        .long   -1077786332
        .align 16
.LCATAN_292:
        .long   -1718059792
        .long   1070176665
        .long   -1718059792
        .long   1070176665
        .align 16
.LCATAN_293:
        .long   1431655482
        .long   -1076538027
        .long   1431655482
        .long   -1076538027
        .align 16
.LCATAN_294:
        .long   1342177280
        .long   1073291771
        .long   1342177280
        .long   1073291771
        .align 16
.LCATAN_295:
        .long   1610612736
        .long   1045500084
        .long   1610612736
        .long   1045500084
        .align 16
.LCATAN_296:
        .long   856972295
        .long   1016178214
        .long   856972295
        .long   1016178214
        .align 16
.LCATAN_314:
        .quad   4607182418800017408
        .quad   4607182418800017408
