        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_cosd2_u10sse2, @function
.LSleef_cosd2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCCOS0, %rax
        movapd  %xmm0, %xmm12
        movabsq $.LCCOS153, %rdx
        movapd  (%rax), %xmm0
        movapd  %xmm0, %xmm3
        andnpd  %xmm12, %xmm3
        movapd  %xmm3, %xmm1
        cmpltpd (%rdx), %xmm1
        pmovmskb        %xmm1, %edx
        cmpl    $65535, %edx
        jne     1f
        movabsq $.LCCOS154, %rdx
        movapd  %xmm12, %xmm2
        movabsq $.LCCOS197, %rcx
        movabsq $.LCCOS146, %rsi
        movapd  (%rdx), %xmm0
        movapd  (%rcx), %xmm3
        movabsq $.LCCOS100, %rdx
        movabsq $.LCCOS198, %rcx
        mulpd   %xmm12, %xmm0
        addpd   (%rdx), %xmm0
        movabsq $.LCCOS3, %rdx
        cvtpd2dq        %xmm0, %xmm0
        cvtdq2pd        %xmm0, %xmm0
        addpd   %xmm0, %xmm0
        addpd   (%rdx), %xmm0
        mulpd   %xmm0, %xmm3
        cvtpd2dq        %xmm0, %xmm11
        mulpd   (%rcx), %xmm0
        movabsq $.LCCOS7, %rcx
        addpd   %xmm3, %xmm2
        movapd  %xmm2, %xmm1
        movapd  %xmm2, %xmm4
        movapd  %xmm2, %xmm8
        subpd   %xmm12, %xmm1
        addpd   %xmm0, %xmm8
        subpd   %xmm1, %xmm4
        subpd   %xmm1, %xmm3
        subpd   %xmm8, %xmm2
        subpd   %xmm4, %xmm12
        addpd   %xmm2, %xmm0
        movdqa  %xmm8, %xmm2
        addpd   %xmm12, %xmm3
        movapd  %xmm3, %xmm1
        addpd   %xmm0, %xmm1
0:
        movapd  %xmm8, %xmm3
        movapd  (%rax), %xmm7
        pand    (%rsi), %xmm2
        movabsq $.LCCOS190, %rax
        mulpd   %xmm8, %xmm3
        movapd  (%rax), %xmm0
        movapd  %xmm8, %xmm6
        movabsq $.LCCOS191, %rax
        movapd  %xmm7, %xmm5
        subpd   %xmm2, %xmm6
        mulpd   %xmm3, %xmm0
        xorpd   %xmm3, %xmm5
        movapd  %xmm3, %xmm13
        movaps  %xmm5, -40(%rsp)
        movapd  %xmm3, %xmm5
        addpd   (%rax), %xmm0
        movabsq $.LCCOS192, %rax
        mulpd   %xmm3, %xmm5
        movapd  (%rax), %xmm4
        movabsq $.LCCOS193, %rax
        mulpd   %xmm3, %xmm4
        addpd   (%rax), %xmm4
        movabsq $.LCCOS194, %rax
        mulpd   %xmm5, %xmm0
        mulpd   %xmm5, %xmm5
        addpd   %xmm4, %xmm0
        movapd  (%rax), %xmm4
        movabsq $.LCCOS195, %rax
        mulpd   %xmm3, %xmm4
        addpd   (%rax), %xmm4
        movabsq $.LCCOS196, %rax
        mulpd   %xmm5, %xmm4
        addpd   %xmm4, %xmm0
        mulpd   %xmm3, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCCOS189, %rax
        movapd  (%rax), %xmm5
        movabsq $.LCCOS120, %rax
        movdqa  (%rax), %xmm14
        movabsq $.LCCOS145, %rax
        movapd  %xmm0, %xmm4
        mulpd   %xmm3, %xmm4
        pand    %xmm11, %xmm14
        pxor    %xmm11, %xmm11
        movapd  %xmm4, %xmm9
        movaps  %xmm4, -56(%rsp)
        movapd  (%rcx), %xmm4
        addpd   %xmm5, %xmm9
        movapd  %xmm9, %xmm12
        movapd  %xmm9, %xmm10
        movapd  %xmm9, %xmm0
        mulpd   %xmm3, %xmm12
        andpd   %xmm4, %xmm10
        subpd   %xmm9, %xmm5
        subpd   %xmm10, %xmm0
        addpd   -56(%rsp), %xmm5
        movaps  %xmm0, -88(%rsp)
        movapd  %xmm3, %xmm0
        xorpd   %xmm12, %xmm7
        andpd   %xmm4, %xmm0
        movapd  %xmm12, %xmm15
        movaps  %xmm7, -24(%rsp)
        movapd  (%rdx), %xmm7
        subpd   %xmm0, %xmm13
        mulpd   %xmm5, %xmm3
        addpd   %xmm7, %xmm15
        movaps  %xmm13, -72(%rsp)
        movapd  %xmm15, %xmm13
        movapd  %xmm4, %xmm15
        andpd   %xmm13, %xmm15
        movapd  %xmm13, %xmm4
        subpd   %xmm13, %xmm7
        subpd   %xmm15, %xmm4
        addpd   %xmm7, %xmm12
        movaps  %xmm4, -104(%rsp)
        movdqa  %xmm14, %xmm4
        movapd  %xmm2, %xmm14
        movapd  -104(%rsp), %xmm7
        addpd   %xmm2, %xmm14
        pcmpeqd %xmm11, %xmm4
        movapd  %xmm2, %xmm11
        mulpd   %xmm2, %xmm11
        addpd   -40(%rsp), %xmm11
        mulpd   %xmm6, %xmm14
        pshufd  $80, %xmm4, %xmm4
        addpd   %xmm14, %xmm11
        movapd  %xmm6, %xmm14
        mulpd   %xmm6, %xmm14
        addpd   %xmm11, %xmm14
        movapd  %xmm1, %xmm11
        addpd   %xmm1, %xmm11
        mulpd   %xmm15, %xmm1
        mulpd   %xmm8, %xmm11
        movapd  %xmm10, %xmm8
        mulpd   %xmm0, %xmm8
        addpd   -24(%rsp), %xmm8
        addpd   %xmm11, %xmm14
        movapd  -88(%rsp), %xmm11
        mulpd   %xmm11, %xmm0
        mulpd   %xmm9, %xmm14
        addpd   %xmm8, %xmm0
        movapd  -72(%rsp), %xmm8
        mulpd   %xmm8, %xmm10
        addpd   %xmm10, %xmm0
        movapd  %xmm11, %xmm10
        mulpd   %xmm8, %xmm10
        addpd   %xmm10, %xmm0
        addpd   %xmm14, %xmm0
        addpd   %xmm3, %xmm0
        addpd   %xmm12, %xmm0
        mulpd   %xmm2, %xmm0
        addpd   %xmm1, %xmm0
        movapd  %xmm7, %xmm1
        mulpd   %xmm6, %xmm1
        mulpd   %xmm2, %xmm7
        mulpd   %xmm15, %xmm6
        mulpd   %xmm15, %xmm2
        addpd   %xmm1, %xmm0
        addpd   %xmm7, %xmm0
        addpd   %xmm0, %xmm6
        movdqa  (%rax), %xmm0
        pand    %xmm4, %xmm0
        addpd   %xmm6, %xmm2
        pxor    %xmm2, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .p2align 4,,10
        .p2align 3
1:
        movabsq $.LCCOS157, %rdx
        movapd  %xmm3, %xmm1
        cmpltpd (%rdx), %xmm1
        pmovmskb        %xmm1, %edx
        cmpl    $65535, %edx
        jne     2f
        movabsq $.LCCOS199, %rdx
        movabsq $.LCCOS146, %rsi
        movabsq $.LCCOS7, %rcx
        movapd  (%rdx), %xmm0
        movabsq $.LCCOS200, %rdx
        mulpd   %xmm12, %xmm0
        addpd   (%rdx), %xmm0
        movabsq $.LCCOS201, %rdx
        movapd  (%rdx), %xmm8
        movabsq $.LCCOS100, %rdx
        cvttpd2dq       %xmm0, %xmm0
        cvtdq2pd        %xmm0, %xmm0
        mulpd   %xmm0, %xmm8
        addpd   (%rdx), %xmm8
        movabsq $.LCCOS154, %rdx
        movapd  (%rdx), %xmm1
        movabsq $.LCCOS159, %rdx
        mulpd   (%rdx), %xmm0
        movabsq $.LCCOS178, %rdx
        mulpd   %xmm12, %xmm1
        movapd  %xmm0, %xmm14
        movapd  %xmm0, %xmm13
        addpd   %xmm1, %xmm8
        movapd  %xmm0, %xmm1
        cvtpd2dq        %xmm8, %xmm8
        paddd   %xmm8, %xmm8
        paddd   (%rdx), %xmm8
        movabsq $.LCCOS202, %rdx
        movapd  (%rdx), %xmm6
        movabsq $.LCCOS203, %rdx
        movdqa  %xmm8, %xmm11
        cvtdq2pd        %xmm8, %xmm8
        movapd  (%rdx), %xmm10
        movabsq $.LCCOS204, %rdx
        mulpd   %xmm6, %xmm1
        movapd  (%rdx), %xmm9
        addpd   %xmm8, %xmm0
        movabsq $.LCCOS205, %rdx
        mulpd   %xmm8, %xmm6
        mulpd   %xmm10, %xmm14
        mulpd   %xmm8, %xmm10
        mulpd   %xmm9, %xmm13
        addpd   %xmm1, %xmm12
        mulpd   %xmm8, %xmm9
        mulpd   (%rdx), %xmm0
        movabsq $.LCCOS3, %rdx
        movapd  %xmm12, %xmm2
        addpd   %xmm6, %xmm2
        movapd  %xmm2, %xmm5
        movapd  %xmm2, %xmm15
        addpd   %xmm14, %xmm5
        subpd   %xmm12, %xmm15
        movapd  %xmm5, %xmm4
        movapd  %xmm5, %xmm7
        subpd   %xmm15, %xmm6
        addpd   %xmm10, %xmm4
        subpd   %xmm2, %xmm7
        movapd  %xmm4, %xmm3
        movaps  %xmm7, -72(%rsp)
        movapd  %xmm4, %xmm1
        addpd   %xmm13, %xmm3
        subpd   %xmm5, %xmm1
        movapd  %xmm3, %xmm7
        movaps  %xmm1, -56(%rsp)
        subpd   %xmm4, %xmm7
        movaps  %xmm7, -104(%rsp)
        movapd  %xmm3, %xmm7
        addpd   %xmm9, %xmm7
        movapd  %xmm7, %xmm1
        movapd  %xmm7, %xmm8
        subpd   %xmm3, %xmm1
        addpd   %xmm0, %xmm8
        movaps  %xmm1, -88(%rsp)
        movapd  %xmm2, %xmm1
        subpd   %xmm15, %xmm1
        movapd  -72(%rsp), %xmm15
        subpd   %xmm15, %xmm14
        subpd   %xmm1, %xmm12
        addpd   %xmm12, %xmm6
        movapd  %xmm5, %xmm12
        subpd   %xmm15, %xmm12
        movapd  %xmm4, %xmm15
        subpd   %xmm12, %xmm2
        addpd   %xmm14, %xmm2
        addpd   %xmm2, %xmm6
        movapd  -56(%rsp), %xmm2
        subpd   %xmm2, %xmm15
        subpd   %xmm2, %xmm10
        movapd  %xmm3, %xmm2
        subpd   %xmm15, %xmm5
        addpd   %xmm10, %xmm5
        addpd   %xmm6, %xmm5
        movapd  -104(%rsp), %xmm6
        subpd   %xmm6, %xmm2
        subpd   %xmm6, %xmm13
        movapd  -88(%rsp), %xmm6
        subpd   %xmm6, %xmm9
        subpd   %xmm2, %xmm4
        movdqa  %xmm8, %xmm2
        addpd   %xmm13, %xmm4
        addpd   %xmm5, %xmm4
        movapd  %xmm7, %xmm5
        subpd   %xmm8, %xmm7
        subpd   %xmm6, %xmm5
        addpd   %xmm7, %xmm0
        subpd   %xmm5, %xmm3
        addpd   %xmm9, %xmm3
        addpd   %xmm4, %xmm3
        movapd  %xmm3, %xmm1
        addpd   %xmm0, %xmm1
        {disp32} jmp 0b
        .p2align 4,,10
        .p2align 3
2:
        pshufd  $13, %xmm12, %xmm4
        movapd  %xmm0, %xmm10
        movabsq $.LCCOS149, %rdx
        movabsq $.LSleef_rempitabdp, %rcx
        movabsq $.LCCOS146, %rsi
        psrld   $20, %xmm4
        pand    (%rdx), %xmm4
        movabsq $.LCCOS164, %rdx
        paddd   (%rdx), %xmm4
        movdqa  (%rsi), %xmm7
        movabsq $.LCCOS165, %rdx
        movabsq $.LCCOS167, %r8
        movdqa  %xmm4, %xmm1
        movdqa  %xmm4, %xmm2
        psrad   $31, %xmm1
        pcmpgtd (%rdx), %xmm2
        movabsq $.LCCOS166, %rdx
        pandn   %xmm4, %xmm1
        pand    (%rdx), %xmm2
        movabsq $.LCCOS90, %rdx
        pslld   $2, %xmm1
        movd    %xmm1, %edi
        pshufd  $85, %xmm1, %xmm1
        pshufd  $115, %xmm2, %xmm2
        movslq  %edi, %rdi
        pand    (%rdx), %xmm2
        movd    %xmm1, %edx
        salq    $3, %rdi
        movslq  %edx, %rdx
        movsd   (%rcx,%rdi), %xmm1
        pslld   $20, %xmm2
        paddd   %xmm12, %xmm2
        cmpneqpd        %xmm12, %xmm12
        movhpd  (%rcx,%rdx,8), %xmm1
        pand    %xmm2, %xmm7
        movapd  %xmm2, %xmm4
        movabsq $.LCCOS7, %rcx
        movapd  %xmm1, %xmm6
        andpd   (%rcx), %xmm6
        movapd  %xmm1, %xmm5
        mulpd   %xmm2, %xmm5
        subpd   %xmm7, %xmm4
        movapd  %xmm1, %xmm8
        movapd  %xmm6, %xmm9
        subpd   %xmm6, %xmm8
        movapd  %xmm0, %xmm1
        mulpd   %xmm7, %xmm9
        mulpd   %xmm4, %xmm6
        xorpd   %xmm5, %xmm1
        addpd   %xmm1, %xmm9
        movapd  %xmm8, %xmm1
        mulpd   %xmm7, %xmm1
        mulpd   %xmm4, %xmm8
        addpd   %xmm6, %xmm9
        movdqa  (%r8), %xmm6
        movabsq $.LCCOS10, %r8
        movaps  %xmm6, -88(%rsp)
        movdqa  %xmm6, %xmm11
        addpd   %xmm1, %xmm9
        movapd  (%r8), %xmm1
        movabsq $.LCCOS168, %r8
        movapd  (%r8), %xmm6
        movabsq $.LCCOS169, %r8
        movapd  %xmm1, %xmm13
        movaps  %xmm1, -72(%rsp)
        mulpd   %xmm5, %xmm13
        addpd   %xmm8, %xmm9
        movapd  %xmm5, %xmm8
        andpd   %xmm0, %xmm8
        movapd  %xmm6, %xmm1
        pxor    %xmm8, %xmm11
        andnpd  %xmm13, %xmm10
        cmpltpd %xmm10, %xmm1
        movapd  %xmm13, %xmm10
        addpd   %xmm11, %xmm10
        movapd  %xmm1, %xmm14
        andpd   %xmm13, %xmm1
        subpd   %xmm11, %xmm10
        por     %xmm8, %xmm10
        andnpd  %xmm10, %xmm14
        movapd  %xmm6, %xmm10
        orpd    %xmm1, %xmm14
        movapd  %xmm0, %xmm1
        andnpd  %xmm5, %xmm1
        cmpltpd %xmm1, %xmm10
        movapd  %xmm5, %xmm1
        addpd   %xmm11, %xmm1
        subpd   %xmm11, %xmm1
        por     %xmm8, %xmm1
        movapd  %xmm10, %xmm8
        andnpd  %xmm1, %xmm8
        movapd  %xmm10, %xmm1
        movapd  (%r8), %xmm10
        movabsq $.LCCOS170, %r8
        andpd   %xmm5, %xmm1
        orpd    %xmm8, %xmm1
        movapd  (%r8), %xmm8
        movaps  %xmm10, -40(%rsp)
        movabsq $.LSleef_rempitabdp+8, %r8
        mulpd   %xmm10, %xmm1
        movapd  %xmm8, %xmm15
        addpd   %xmm14, %xmm1
        mulpd   %xmm8, %xmm14
        movsd   (%r8,%rdi), %xmm8
        movhpd  (%r8,%rdx,8), %xmm8
        addq    $8, %r8
        cvttpd2dq       %xmm1, %xmm1
        movaps  %xmm1, -56(%rsp)
        movapd  %xmm8, %xmm13
        addpd   %xmm5, %xmm14
        movapd  %xmm9, %xmm5
        addpd   %xmm14, %xmm5
        movapd  %xmm14, %xmm1
        movapd  (%rcx), %xmm14
        andpd   %xmm8, %xmm14
        mulpd   %xmm2, %xmm8
        subpd   %xmm14, %xmm13
        movapd  %xmm14, %xmm11
        movapd  %xmm0, %xmm14
        subpd   %xmm5, %xmm1
        addpd   %xmm9, %xmm1
        xorpd   %xmm8, %xmm14
        movaps  %xmm14, -24(%rsp)
        movapd  %xmm5, %xmm14
        addpd   %xmm8, %xmm14
        movapd  %xmm14, %xmm10
        subpd   %xmm5, %xmm14
        movaps  %xmm14, -104(%rsp)
        movapd  %xmm11, %xmm14
        movapd  -104(%rsp), %xmm9
        mulpd   %xmm4, %xmm11
        mulpd   %xmm7, %xmm14
        subpd   %xmm9, %xmm8
        addpd   -24(%rsp), %xmm14
        addpd   %xmm14, %xmm11
        movapd  %xmm13, %xmm14
        mulpd   %xmm7, %xmm14
        mulpd   %xmm4, %xmm13
        addpd   %xmm14, %xmm11
        addpd   %xmm13, %xmm11
        addpd   %xmm1, %xmm11
        movapd  %xmm10, %xmm1
        subpd   %xmm9, %xmm1
        movapd  %xmm10, %xmm9
        andpd   %xmm0, %xmm9
        movapd  %xmm11, %xmm14
        movdqa  -88(%rsp), %xmm11
        subpd   %xmm1, %xmm5
        movapd  %xmm6, %xmm1
        pxor    %xmm9, %xmm11
        addpd   %xmm8, %xmm5
        movapd  %xmm9, %xmm8
        movapd  %xmm0, %xmm9
        addpd   %xmm5, %xmm14
        movapd  -72(%rsp), %xmm5
        mulpd   %xmm10, %xmm5
        movaps  %xmm14, -104(%rsp)
        andnpd  %xmm5, %xmm9
        cmpltpd %xmm9, %xmm1
        movapd  %xmm5, %xmm9
        addpd   %xmm11, %xmm9
        movapd  %xmm1, %xmm13
        andpd   %xmm1, %xmm5
        subpd   %xmm11, %xmm9
        por     %xmm8, %xmm9
        andnpd  %xmm9, %xmm13
        movapd  %xmm14, %xmm9
        orpd    %xmm5, %xmm13
        movapd  %xmm0, %xmm5
        andnpd  %xmm10, %xmm5
        cmpltpd %xmm5, %xmm6
        movapd  %xmm10, %xmm5
        addpd   %xmm11, %xmm5
        movapd  %xmm5, %xmm1
        movapd  %xmm6, %xmm5
        andpd   %xmm10, %xmm6
        subpd   %xmm11, %xmm1
        movapd  %xmm0, %xmm11
        por     %xmm1, %xmm8
        andnpd  %xmm8, %xmm5
        movapd  %xmm5, %xmm1
        orpd    %xmm6, %xmm1
        movsd   (%r8,%rdi), %xmm6
        mulpd   -40(%rsp), %xmm1
        movhpd  (%r8,%rdx,8), %xmm6
        addpd   %xmm13, %xmm1
        mulpd   %xmm15, %xmm13
        cvttpd2dq       %xmm1, %xmm1
        movapd  %xmm13, %xmm5
        movapd  %xmm6, %xmm13
        addpd   %xmm10, %xmm5
        movapd  (%rcx), %xmm10
        andpd   %xmm6, %xmm10
        subpd   %xmm10, %xmm13
        mulpd   %xmm2, %xmm6
        movapd  %xmm10, %xmm15
        mulpd   %xmm7, %xmm15
        addpd   %xmm5, %xmm9
        mulpd   %xmm4, %xmm10
        movapd  %xmm13, %xmm14
        mulpd   %xmm14, %xmm7
        movapd  %xmm9, %xmm8
        subpd   %xmm9, %xmm5
        mulpd   %xmm14, %xmm4
        xorpd   %xmm6, %xmm11
        addpd   %xmm6, %xmm8
        addpd   %xmm15, %xmm11
        movapd  %xmm8, %xmm13
        addpd   %xmm7, %xmm11
        subpd   %xmm9, %xmm13
        movapd  %xmm8, %xmm7
        addpd   %xmm10, %xmm11
        subpd   %xmm13, %xmm6
        addpd   %xmm4, %xmm11
        movsd   8(%r8,%rdi), %xmm4
        addq    $8, %r8
        addpd   -104(%rsp), %xmm5
        movapd  (%rcx), %xmm15
        movhpd  (%r8,%rdx,8), %xmm4
        movabsq $.LCCOS171, %rdx
        mulpd   %xmm2, %xmm4
        addpd   %xmm11, %xmm4
        addpd   %xmm4, %xmm5
        movapd  %xmm8, %xmm4
        subpd   %xmm13, %xmm4
        subpd   %xmm4, %xmm9
        movapd  %xmm0, %xmm4
        addpd   %xmm9, %xmm6
        movapd  (%rdx), %xmm9
        movabsq $.LCCOS172, %rdx
        addpd   %xmm5, %xmm6
        movapd  %xmm0, %xmm5
        andnpd  %xmm2, %xmm5
        cmpltpd (%rdx), %xmm5
        movabsq $.LCCOS173, %rdx
        addpd   %xmm6, %xmm7
        movapd  %xmm5, %xmm13
        andpd   %xmm5, %xmm2
        movapd  %xmm7, %xmm14
        andpd   %xmm7, %xmm15
        movapd  %xmm7, %xmm10
        mulpd   %xmm9, %xmm14
        subpd   %xmm15, %xmm10
        movapd  %xmm15, %xmm11
        subpd   %xmm7, %xmm8
        addpd   %xmm8, %xmm6
        andnpd  %xmm14, %xmm13
        xorpd   %xmm14, %xmm4
        movapd  %xmm15, %xmm14
        orpd    %xmm13, %xmm2
        movapd  (%rdx), %xmm13
        movabsq $.LCCOS174, %rdx
        mulpd   %xmm9, %xmm6
        mulpd   %xmm13, %xmm14
        mulpd   %xmm10, %xmm13
        addpd   %xmm14, %xmm4
        addpd   %xmm13, %xmm4
        movapd  (%rdx), %xmm13
        movabsq $.LCCOS175, %rdx
        mulpd   %xmm13, %xmm11
        mulpd   %xmm13, %xmm10
        addpd   %xmm11, %xmm4
        addpd   %xmm10, %xmm4
        movapd  (%rdx), %xmm10
        movabsq $.LCCOS206, %rdx
        mulpd   %xmm7, %xmm10
        addpd   %xmm10, %xmm4
        addpd   %xmm4, %xmm6
        pandn   %xmm6, %xmm5
        movdqa  -56(%rsp), %xmm6
        paddd   %xmm1, %xmm6
        pxor    %xmm1, %xmm1
        cmpltpd %xmm2, %xmm1
        pshufd  $8, %xmm1, %xmm7
        movdqa  %xmm7, %xmm11
        pandn   (%rdx), %xmm11
        movabsq $.LCCOS176, %rdx
        movdqa  (%rdx), %xmm4
        movabsq $.LCCOS207, %rdx
        pand    (%rdx), %xmm7
        movabsq $.LCCOS4, %rdx
        andnpd  (%rdx), %xmm1
        pand    %xmm6, %xmm4
        movabsq $.LCCOS177, %rdx
        movdqa  (%rdx), %xmm8
        por     %xmm7, %xmm11
        movapd  %xmm2, %xmm7
        paddd   %xmm4, %xmm4
        andpd   %xmm1, %xmm0
        paddd   %xmm11, %xmm4
        movabsq $.LCCOS119, %rdx
        pxor    %xmm0, %xmm8
        pand    (%rdx), %xmm6
        movapd  %xmm2, %xmm1
        movabsq $.LCCOS179, %rdx
        addpd   %xmm8, %xmm7
        psrad   $1, %xmm4
        pxor    (%rdx), %xmm0
        movabsq $.LCCOS152, %rdx
        movdqa  %xmm4, %xmm11
        cmpeqpd (%rdx), %xmm3
        pxor    %xmm4, %xmm4
        movabsq $.LCCOS3, %rdx
        pcmpeqd %xmm4, %xmm6
        movapd  %xmm7, %xmm9
        movapd  %xmm7, %xmm10
        subpd   %xmm2, %xmm9
        orpd    %xmm3, %xmm12
        pshufd  $80, %xmm6, %xmm4
        movapd  %xmm4, %xmm6
        subpd   %xmm9, %xmm10
        subpd   %xmm9, %xmm8
        andnpd  %xmm5, %xmm6
        addpd   %xmm0, %xmm5
        subpd   %xmm10, %xmm1
        addpd   %xmm8, %xmm1
        addpd   %xmm5, %xmm1
        andpd   %xmm4, %xmm1
        orpd    %xmm6, %xmm1
        movapd  %xmm1, %xmm0
        movapd  %xmm4, %xmm1
        andpd   %xmm7, %xmm4
        andnpd  %xmm2, %xmm1
        movapd  %xmm0, %xmm2
        orpd    %xmm4, %xmm1
        addpd   %xmm1, %xmm2
        subpd   %xmm2, %xmm1
        por     %xmm12, %xmm2
        movapd  %xmm2, %xmm8
        addpd   %xmm0, %xmm1
        {disp32} jmp 0b
        .size   .LSleef_cosd2_u10sse2, .-.LSleef_cosd2_u10sse2
        .set .Lxcos_u1, .LSleef_cosd2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCCOS0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCCOS3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCCOS4:
        .long   0
        .long   -1074790400
        .long   0
        .long   -1074790400
        .align 16
.LCCOS7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCCOS10:
        .long   0
        .long   1074790400
        .long   0
        .long   1074790400
        .align 16
.LCCOS90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCCOS100:
        .long   0
        .long   -1075838976
        .long   0
        .long   -1075838976
        .align 16
.LCCOS119:
        .quad   4294967297
        .quad   0
        .align 16
.LCCOS120:
        .quad   8589934594
        .quad   0
        .align 16
.LCCOS145:
        .quad   -9223372036854775808
        .quad   -9223372036854775808
        .align 16
.LCCOS146:
        .quad   -134217728
        .quad   -134217728
        .align 16
.LCCOS149:
        .quad   8791798056959
        .quad   0
        .align 16
.LCCOS152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCCOS153:
        .long   0
        .long   1076756480
        .long   0
        .long   1076756480
        .align 16
.LCCOS154:
        .long   1841940611
        .long   1070882608
        .long   1841940611
        .long   1070882608
        .align 16
.LCCOS157:
        .long   512753664
        .long   1121369284
        .long   512753664
        .long   1121369284
        .align 16
.LCCOS159:
        .long   0
        .long   1097859072
        .long   0
        .long   1097859072
        .align 16
.LCCOS164:
        .long   -1078
        .long   -1078
        .long   0
        .long   0
        .align 16
.LCCOS165:
        .long   645
        .long   645
        .long   0
        .long   0
        .align 16
.LCCOS166:
        .quad   -270582939712
        .quad   0
        .align 16
.LCCOS167:
        .quad   4841369599423283200
        .quad   4841369599423283200
        .align 16
.LCCOS168:
        .long   0
        .long   1127219200
        .long   0
        .long   1127219200
        .align 16
.LCCOS169:
        .long   0
        .long   -1072693248
        .long   0
        .long   -1072693248
        .align 16
.LCCOS170:
        .long   0
        .long   -1076887552
        .long   0
        .long   -1076887552
        .align 16
.LCCOS171:
        .long   1413754136
        .long   1075388923
        .long   1413754136
        .long   1075388923
        .align 16
.LCCOS172:
        .long   1717986918
        .long   1072064102
        .long   1717986918
        .long   1072064102
        .align 16
.LCCOS173:
        .long   1342177280
        .long   1075388923
        .long   1342177280
        .long   1075388923
        .align 16
.LCCOS174:
        .long   1610612736
        .long   1047597236
        .long   1610612736
        .long   1047597236
        .align 16
.LCCOS175:
        .long   856972295
        .long   1018275366
        .long   856972295
        .long   1018275366
        .align 16
.LCCOS176:
        .quad   12884901891
        .quad   0
        .align 16
.LCCOS177:
        .quad   -4613618979930100456
        .quad   -4613618979930100456
        .align 16
.LCCOS178:
        .long   1
        .long   1
        .long   0
        .long   0
        .align 16
.LCCOS179:
        .quad   -4858919839960114169
        .quad   -4858919839960114169
        .align 16
.LCCOS189:
        .long   1431655765
        .long   -1077586603
        .long   1431655765
        .long   -1077586603
        .align 16
.LCCOS190:
        .long   1953521511
        .long   1038488124
        .long   1953521511
        .long   1038488124
        .align 16
.LCCOS191:
        .long   1269442905
        .long   -1101339067
        .long   1269442905
        .long   -1101339067
        .align 16
.LCCOS192:
        .long   -1524237331
        .long   1053236707
        .long   -1524237331
        .long   1053236707
        .align 16
.LCCOS193:
        .long   436290085
        .long   -1087766112
        .long   436290085
        .long   -1087766112
        .align 16
.LCCOS194:
        .long   62042397
        .long   1021870362
        .long   62042397
        .long   1021870362
        .align 16
.LCCOS195:
        .long   -1137601712
        .long   -1117068254
        .long   -1137601712
        .long   -1117068254
        .align 16
.LCCOS196:
        .long   286331065
        .long   1065423121
        .long   286331065
        .long   1065423121
        .align 16
.LCCOS197:
        .long   1413754136
        .long   -1074191877
        .long   1413754136
        .long   -1074191877
        .align 16
.LCCOS198:
        .long   856972295
        .long   -1131305434
        .long   856972295
        .long   -1131305434
        .align 16
.LCCOS199:
        .long   1841940611
        .long   1046765360
        .long   1841940611
        .long   1046765360
        .align 16
.LCCOS200:
        .long   1841940611
        .long   -1101766864
        .long   1841940611
        .long   -1101766864
        .align 16
.LCCOS201:
        .long   0
        .long   -1050673152
        .long   0
        .long   -1050673152
        .align 16
.LCCOS202:
        .long   1342177280
        .long   -1074191877
        .long   1342177280
        .long   -1074191877
        .align 16
.LCCOS203:
        .long   1610612736
        .long   -1101983564
        .long   1610612736
        .long   -1101983564
        .align 16
.LCCOS204:
        .long   805306368
        .long   -1131305434
        .long   805306368
        .long   -1131305434
        .align 16
.LCCOS205:
        .long   923219018
        .long   -1159159072
        .long   923219018
        .long   -1159159072
        .align 16
.LCCOS206:
        .quad   30064771079
        .quad   0
        .align 16
.LCCOS207:
        .quad   34359738376
        .quad   0
