        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_coshd2_u10sse2, @function
.LSleef_coshd2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCCOSH_0, %rax
        subq    $336, %rsp
        pxor    %xmm5, %xmm5
        movapd  (%rax), %xmm8
        movaps  %xmm0, 152(%rsp)
        movabsq $.LCCOSH_328, %rax
        movapd  %xmm8, %xmm10
        movapd  %xmm8, %xmm12
        andnpd  %xmm0, %xmm10
        movapd  %xmm10, %xmm7
        movapd  %xmm10, %xmm4
        addpd   %xmm5, %xmm7
        movapd  %xmm7, %xmm1
        mulpd   (%rax), %xmm1
        movabsq $.LCCOSH_329, %rax
        movapd  (%rax), %xmm3
        movabsq $.LCCOSH_330, %rax
        movapd  (%rax), %xmm2
        movabsq $.LCCOSH_7, %rax
        cvtpd2dq        %xmm1, %xmm1
        cvtdq2pd        %xmm1, %xmm1
        mulpd   %xmm1, %xmm3
        cvtpd2dq        %xmm1, %xmm6
        mulpd   %xmm1, %xmm2
        movaps  %xmm6, -56(%rsp)
        movapd  %xmm3, %xmm7
        addpd   %xmm10, %xmm7
        movapd  %xmm7, %xmm9
        movapd  %xmm7, %xmm0
        addpd   %xmm2, %xmm7
        subpd   %xmm10, %xmm9
        movapd  %xmm0, %xmm11
        movapd  %xmm7, %xmm1
        subpd   %xmm0, %xmm7
        subpd   %xmm9, %xmm11
        subpd   %xmm9, %xmm3
        subpd   %xmm7, %xmm2
        subpd   %xmm11, %xmm4
        movapd  %xmm8, %xmm11
        addpd   %xmm3, %xmm4
        movapd  %xmm1, %xmm3
        subpd   %xmm7, %xmm3
        movapd  %xmm1, %xmm7
        mulpd   %xmm1, %xmm7
        addpd   %xmm5, %xmm4
        movapd  %xmm1, %xmm5
        subpd   %xmm3, %xmm0
        movapd  (%rax), %xmm3
        movabsq $.LCCOSH_374, %rax
        addpd   %xmm2, %xmm0
        movapd  %xmm1, %xmm2
        xorpd   %xmm7, %xmm11
        andpd   %xmm3, %xmm2
        movapd  %xmm7, %xmm14
        movapd  %xmm7, %xmm15
        movapd  %xmm2, %xmm6
        movapd  %xmm2, %xmm9
        subpd   %xmm2, %xmm5
        addpd   %xmm2, %xmm6
        mulpd   %xmm2, %xmm9
        addpd   %xmm0, %xmm4
        mulpd   %xmm7, %xmm14
        movapd  %xmm6, %xmm0
        mulpd   %xmm5, %xmm0
        addpd   %xmm11, %xmm9
        movapd  (%rax), %xmm11
        movabsq $.LCCOSH_375, %rax
        xorpd   %xmm14, %xmm12
        movaps  %xmm12, 184(%rsp)
        mulpd   %xmm1, %xmm11
        addpd   %xmm9, %xmm0
        movapd  %xmm5, %xmm9
        mulpd   %xmm5, %xmm9
        addpd   %xmm9, %xmm0
        movapd  %xmm4, %xmm9
        addpd   %xmm4, %xmm9
        movapd  %xmm0, %xmm6
        movapd  %xmm11, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCCOSH_376, %rax
        movapd  (%rax), %xmm13
        mulpd   %xmm1, %xmm9
        movabsq $.LCCOSH_377, %rax
        mulpd   %xmm1, %xmm13
        mulpd   %xmm7, %xmm0
        addpd   %xmm9, %xmm6
        movapd  %xmm13, %xmm9
        addpd   (%rax), %xmm9
        movabsq $.LCCOSH_378, %rax
        movapd  (%rax), %xmm11
        movaps  %xmm6, -24(%rsp)
        movapd  %xmm7, %xmm6
        movabsq $.LCCOSH_379, %rax
        andpd   %xmm3, %xmm6
        mulpd   %xmm1, %xmm11
        addpd   %xmm9, %xmm0
        subpd   %xmm6, %xmm15
        movaps  %xmm6, 168(%rsp)
        mulpd   %xmm14, %xmm0
        movaps  %xmm15, -8(%rsp)
        movapd  %xmm11, %xmm9
        addpd   (%rax), %xmm9
        movabsq $.LCCOSH_380, %rax
        movapd  (%rax), %xmm11
        movabsq $.LCCOSH_381, %rax
        mulpd   %xmm1, %xmm11
        addpd   (%rax), %xmm11
        mulpd   %xmm7, %xmm9
        movabsq $.LCCOSH_382, %rax
        movapd  (%rax), %xmm13
        movabsq $.LCCOSH_383, %rax
        mulpd   %xmm1, %xmm13
        addpd   %xmm11, %xmm9
        movapd  %xmm14, %xmm11
        mulpd   %xmm14, %xmm11
        addpd   %xmm9, %xmm0
        movapd  %xmm13, %xmm9
        addpd   (%rax), %xmm9
        movabsq $.LCCOSH_384, %rax
        movapd  (%rax), %xmm13
        movabsq $.LCCOSH_2, %rax
        movaps  %xmm13, 200(%rsp)
        mulpd   %xmm11, %xmm9
        movapd  %xmm8, %xmm11
        mulpd   %xmm1, %xmm13
        addpd   %xmm9, %xmm0
        xorpd   %xmm13, %xmm11
        movaps  %xmm11, 216(%rsp)
        movaps  %xmm0, -120(%rsp)
        movapd  %xmm13, %xmm0
        movapd  (%rax), %xmm13
        movabsq $.LCCOSH_3, %rax
        movaps  %xmm0, 8(%rsp)
        movapd  %xmm13, %xmm9
        movaps  %xmm13, -88(%rsp)
        addpd   %xmm0, %xmm9
        movapd  (%rax), %xmm0
        movabsq $.LCCOSH_89, %rax
        movapd  %xmm9, %xmm12
        movapd  %xmm9, %xmm11
        andpd   %xmm3, %xmm12
        subpd   %xmm12, %xmm11
        movapd  %xmm12, %xmm15
        movaps  %xmm11, 24(%rsp)
        movapd  %xmm1, %xmm11
        mulpd   %xmm9, %xmm11
        movapd  %xmm11, %xmm13
        xorpd   %xmm8, %xmm13
        movaps  %xmm13, 232(%rsp)
        movaps  %xmm11, 40(%rsp)
        addpd   %xmm0, %xmm11
        movapd  %xmm11, %xmm12
        movapd  %xmm11, %xmm6
        andpd   %xmm3, %xmm12
        movaps  %xmm12, 248(%rsp)
        subpd   %xmm12, %xmm6
        movapd  %xmm1, %xmm12
        mulpd   %xmm11, %xmm12
        movaps  %xmm6, 56(%rsp)
        movapd  %xmm14, %xmm6
        andpd   %xmm3, %xmm6
        movaps  %xmm6, 280(%rsp)
        movapd  %xmm12, %xmm13
        movaps  %xmm12, 72(%rsp)
        addpd   %xmm0, %xmm12
        xorpd   %xmm8, %xmm13
        movaps  %xmm13, 264(%rsp)
        movapd  %xmm14, %xmm13
        subpd   %xmm6, %xmm13
        movapd  -120(%rsp), %xmm6
        movaps  %xmm12, 88(%rsp)
        movaps  %xmm13, 104(%rsp)
        movapd  %xmm6, %xmm13
        andpd   %xmm3, %xmm13
        movaps  %xmm13, -72(%rsp)
        movapd  %xmm6, %xmm13
        subpd   -72(%rsp), %xmm6
        mulpd   %xmm13, %xmm14
        movaps  %xmm6, 120(%rsp)
        movapd  %xmm8, %xmm6
        xorpd   %xmm14, %xmm6
        movapd  %xmm14, %xmm8
        movapd  %xmm12, %xmm14
        movdqa  (%rax), %xmm12
        movaps  %xmm6, 296(%rsp)
        movdqa  -56(%rsp), %xmm6
        addpd   %xmm8, %xmm14
        movabsq $.LCCOSH_90, %rax
        movaps  %xmm8, 136(%rsp)
        movdqa  %xmm6, %xmm8
        paddd   %xmm12, %xmm6
        psrad   $1, %xmm8
        movaps  %xmm14, -104(%rsp)
        movdqa  (%rax), %xmm14
        movabsq $.LCCOSH_342, %rax
        psubd   %xmm8, %xmm6
        paddd   %xmm12, %xmm8
        pshufd  $115, %xmm6, %xmm6
        pshufd  $115, %xmm8, %xmm8
        pand    %xmm14, %xmm6
        pand    %xmm14, %xmm8
        movapd  %xmm10, %xmm14
        movdqa  %xmm6, %xmm13
        pslld   $20, %xmm8
        movapd  -104(%rsp), %xmm6
        movaps  %xmm8, -40(%rsp)
        pslld   $20, %xmm13
        cmpltpd (%rax), %xmm14
        movabsq $.LCCOSH_385, %rax
        mulpd   -40(%rsp), %xmm6
        movaps  %xmm13, -56(%rsp)
        movapd  8(%rsp), %xmm13
        mulpd   -56(%rsp), %xmm6
        movaps  %xmm14, 312(%rsp)
        movdqa  %xmm14, %xmm8
        movapd  %xmm2, %xmm14
        pandn   %xmm6, %xmm8
        movapd  (%rax), %xmm6
        movabsq $.LCCOSH_386, %rax
        movdqa  %xmm8, %xmm12
        movapd  %xmm2, %xmm8
        mulpd   %xmm6, %xmm8
        addpd   216(%rsp), %xmm8
        mulpd   %xmm5, %xmm6
        addpd   %xmm6, %xmm8
        movapd  (%rax), %xmm6
        movabsq $.LCCOSH_146, %rax
        mulpd   %xmm6, %xmm14
        mulpd   %xmm5, %xmm6
        addpd   %xmm8, %xmm14
        movapd  200(%rsp), %xmm8
        mulpd   %xmm4, %xmm8
        addpd   %xmm14, %xmm6
        movapd  %xmm8, %xmm14
        movapd  -88(%rsp), %xmm8
        addpd   %xmm6, %xmm14
        subpd   %xmm9, %xmm8
        mulpd   %xmm4, %xmm9
        mulpd   %xmm11, %xmm4
        addpd   %xmm8, %xmm13
        movapd  %xmm2, %xmm8
        mulpd   %xmm15, %xmm8
        addpd   232(%rsp), %xmm8
        mulpd   %xmm5, %xmm15
        addpd   %xmm14, %xmm13
        movapd  24(%rsp), %xmm14
        movapd  %xmm14, %xmm6
        mulpd   %xmm2, %xmm6
        mulpd   %xmm5, %xmm14
        mulpd   %xmm1, %xmm13
        addpd   %xmm6, %xmm8
        movapd  %xmm15, %xmm6
        movapd  %xmm14, %xmm15
        addpd   %xmm8, %xmm6
        addpd   %xmm6, %xmm15
        addpd   %xmm9, %xmm15
        movapd  %xmm0, %xmm9
        subpd   %xmm11, %xmm9
        addpd   40(%rsp), %xmm9
        movapd  56(%rsp), %xmm14
        movapd  264(%rsp), %xmm6
        movapd  104(%rsp), %xmm11
        addpd   %xmm15, %xmm13
        movapd  248(%rsp), %xmm15
        movapd  %xmm15, %xmm8
        mulpd   %xmm2, %xmm8
        addpd   %xmm13, %xmm9
        mulpd   %xmm14, %xmm2
        mulpd   %xmm5, %xmm15
        mulpd   %xmm14, %xmm5
        movapd  %xmm0, %xmm14
        mulpd   %xmm9, %xmm1
        addpd   %xmm8, %xmm6
        addpd   %xmm6, %xmm2
        movapd  %xmm11, %xmm6
        addpd   %xmm15, %xmm2
        movapd  -8(%rsp), %xmm15
        addpd   %xmm5, %xmm2
        movapd  88(%rsp), %xmm5
        subpd   %xmm5, %xmm14
        addpd   72(%rsp), %xmm14
        addpd   %xmm4, %xmm2
        subpd   -104(%rsp), %xmm5
        movapd  168(%rsp), %xmm4
        addpd   %xmm2, %xmm1
        movapd  %xmm4, %xmm2
        addpd   %xmm4, %xmm2
        mulpd   %xmm4, %xmm4
        addpd   184(%rsp), %xmm4
        addpd   %xmm14, %xmm1
        movapd  136(%rsp), %xmm14
        mulpd   %xmm15, %xmm2
        mulpd   %xmm15, %xmm15
        addpd   %xmm5, %xmm14
        movapd  -72(%rsp), %xmm5
        addpd   %xmm14, %xmm1
        addpd   %xmm2, %xmm4
        movapd  %xmm15, %xmm2
        addpd   %xmm4, %xmm2
        movapd  -24(%rsp), %xmm4
        addpd   %xmm4, %xmm4
        mulpd   %xmm7, %xmm4
        movapd  120(%rsp), %xmm7
        mulpd   %xmm7, %xmm6
        addpd   %xmm2, %xmm4
        mulpd   -120(%rsp), %xmm4
        movapd  280(%rsp), %xmm2
        movapd  %xmm2, %xmm8
        mulpd   %xmm5, %xmm8
        addpd   296(%rsp), %xmm8
        mulpd   %xmm11, %xmm5
        mulpd   %xmm7, %xmm2
        movapd  -40(%rsp), %xmm7
        addpd   %xmm5, %xmm8
        movdqa  312(%rsp), %xmm5
        addpd   %xmm2, %xmm8
        addpd   %xmm6, %xmm8
        movapd  -56(%rsp), %xmm6
        addpd   %xmm4, %xmm8
        movdqa  (%rax), %xmm4
        movabsq $.LCCOSH_387, %rax
        pand    %xmm12, %xmm4
        addpd   %xmm8, %xmm1
        mulpd   %xmm1, %xmm7
        mulpd   %xmm7, %xmm6
        movapd  %xmm0, %xmm7
        divpd   %xmm12, %xmm7
        pandn   %xmm6, %xmm5
        movapd  %xmm12, %xmm6
        subpd   %xmm4, %xmm6
        andpd   %xmm7, %xmm3
        movapd  %xmm7, %xmm1
        movapd  %xmm3, %xmm15
        subpd   %xmm3, %xmm7
        movapd  %xmm1, %xmm2
        mulpd   %xmm4, %xmm15
        addpd   %xmm12, %xmm2
        mulpd   %xmm6, %xmm3
        mulpd   %xmm7, %xmm4
        mulpd   %xmm7, %xmm6
        subpd   %xmm15, %xmm0
        subpd   %xmm4, %xmm0
        subpd   %xmm3, %xmm0
        movapd  %xmm1, %xmm3
        mulpd   %xmm5, %xmm3
        subpd   %xmm6, %xmm0
        subpd   %xmm3, %xmm0
        movapd  %xmm12, %xmm3
        subpd   %xmm2, %xmm3
        mulpd   %xmm1, %xmm0
        addpd   %xmm3, %xmm1
        addpd   %xmm1, %xmm5
        addpd   %xmm5, %xmm0
        addpd   %xmm2, %xmm0
        mulpd   -88(%rsp), %xmm0
        movapd  (%rax), %xmm2
        movabsq $.LCCOSH_152, %rax
        cmpltpd %xmm10, %xmm2
        movapd  %xmm0, %xmm3
        cmpneqpd        %xmm0, %xmm3
        movapd  %xmm3, %xmm1
        movapd  (%rax), %xmm3
        orpd    %xmm2, %xmm1
        movapd  %xmm1, %xmm2
        andpd   %xmm1, %xmm3
        movapd  152(%rsp), %xmm1
        addq    $336, %rsp
        andnpd  %xmm0, %xmm2
        movapd  %xmm3, %xmm0
        cmpneqpd        %xmm1, %xmm1
        orpd    %xmm2, %xmm0
        orpd    %xmm1, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_coshd2_u10sse2, .-.LSleef_coshd2_u10sse2
        .set .Lxcosh_u1, .LSleef_coshd2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCCOSH_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCCOSH_2:
        .long   0
        .long   1071644672
        .long   0
        .long   1071644672
        .align 16
.LCCOSH_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCCOSH_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCCOSH_89:
        .long   1023
        .long   1023
        .long   0
        .long   0
        .align 16
.LCCOSH_90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCCOSH_146:
        .quad   -134217728
        .quad   -134217728
        .align 16
.LCCOSH_152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCCOSH_328:
        .long   1697350398
        .long   1073157447
        .long   1697350398
        .long   1073157447
        .align 16
.LCCOSH_329:
        .long   -17158144
        .long   -1075433918
        .long   -17158144
        .long   -1075433918
        .align 16
.LCCOSH_330:
        .long   -226956058
        .long   -1118577046
        .long   -226956058
        .long   -1118577046
        .align 16
.LCCOSH_342:
        .long   0
        .long   -1064353792
        .long   0
        .long   -1064353792
        .align 16
.LCCOSH_374:
        .long   -401589578
        .long   1046144594
        .long   -401589578
        .long   1046144594
        .align 16
.LCCOSH_375:
        .long   -1784056228
        .long   1049787980
        .long   -1784056228
        .long   1049787980
        .align 16
.LCCOSH_376:
        .long   -1591904682
        .long   1053236707
        .long   -1591904682
        .long   1053236707
        .align 16
.LCCOSH_377:
        .long   452391095
        .long   1056571808
        .long   452391095
        .long   1056571808
        .align 16
.LCCOSH_378:
        .long   436391938
        .long   1059717536
        .long   436391938
        .long   1059717536
        .align 16
.LCCOSH_379:
        .long   381765068
        .long   1062650220
        .long   381765068
        .long   1062650220
        .align 16
.LCCOSH_380:
        .long   286331161
        .long   1065423121
        .long   286331161
        .long   1065423121
        .align 16
.LCCOSH_381:
        .long   1431655770
        .long   1067799893
        .long   1431655770
        .long   1067799893
        .align 16
.LCCOSH_382:
        .long   -1467541172
        .long   1038485042
        .long   -1467541172
        .long   1038485042
        .align 16
.LCCOSH_383:
        .long   -179820068
        .long   1042413802
        .long   -179820068
        .long   1042413802
        .align 16
.LCCOSH_384:
        .long   1431655765
        .long   1069897045
        .long   1431655765
        .long   1069897045
        .align 16
.LCCOSH_385:
        .long   1342177280
        .long   1069897045
        .long   1342177280
        .long   1069897045
        .align 16
.LCCOSH_386:
        .long   1409286144
        .long   1042634069
        .long   1409286144
        .long   1042634069
        .align 16
.LCCOSH_387:
        .long   0
        .long   1082535936
        .long   0
        .long   1082535936
