        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_expd2_u10sse2, @function
.LSleef_expd2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCEXP_328, %rax
        movapd  %xmm0, %xmm2
        movapd  (%rax), %xmm1
        movabsq $.LCEXP_329, %rax
        mulpd   %xmm0, %xmm1
        movapd  (%rax), %xmm0
        movabsq $.LCEXP_330, %rax
        cvtpd2dq        %xmm1, %xmm1
        cvtdq2pd        %xmm1, %xmm1
        mulpd   %xmm1, %xmm0
        cvtpd2dq        %xmm1, %xmm4
        mulpd   (%rax), %xmm1
        movabsq $.LCEXP_89, %rax
        addpd   %xmm2, %xmm0
        movapd  %xmm0, %xmm6
        movdqa  (%rax), %xmm0
        movabsq $.LCEXP_90, %rax
        addpd   %xmm1, %xmm6
        movdqa  %xmm4, %xmm1
        movdqa  (%rax), %xmm5
        movabsq $.LCEXP_331, %rax
        psrad   $1, %xmm1
        paddd   %xmm0, %xmm4
        movapd  (%rax), %xmm3
        movabsq $.LCEXP_332, %rax
        psubd   %xmm1, %xmm4
        paddd   %xmm0, %xmm1
        movapd  %xmm6, %xmm7
        pshufd  $115, %xmm1, %xmm0
        movapd  (%rax), %xmm1
        movabsq $.LCEXP_333, %rax
        mulpd   %xmm6, %xmm7
        pand    %xmm5, %xmm0
        pshufd  $115, %xmm4, %xmm4
        mulpd   %xmm6, %xmm1
        cmpltpd %xmm2, %xmm3
        pand    %xmm5, %xmm4
        addpd   (%rax), %xmm1
        pslld   $20, %xmm4
        movdqa  %xmm0, %xmm5
        movabsq $.LCEXP_334, %rax
        movapd  (%rax), %xmm0
        pslld   $20, %xmm5
        movabsq $.LCEXP_335, %rax
        mulpd   %xmm7, %xmm1
        movapd  %xmm7, %xmm8
        mulpd   %xmm6, %xmm0
        addpd   (%rax), %xmm0
        mulpd   %xmm7, %xmm8
        movabsq $.LCEXP_336, %rax
        addpd   %xmm0, %xmm1
        movapd  (%rax), %xmm0
        movabsq $.LCEXP_337, %rax
        mulpd   %xmm6, %xmm0
        addpd   (%rax), %xmm0
        mulpd   %xmm8, %xmm1
        movabsq $.LCEXP_338, %rax
        movapd  (%rax), %xmm9
        mulpd   %xmm8, %xmm8
        movabsq $.LCEXP_339, %rax
        mulpd   %xmm7, %xmm0
        mulpd   %xmm6, %xmm9
        addpd   (%rax), %xmm9
        movabsq $.LCEXP_340, %rax
        addpd   %xmm9, %xmm0
        addpd   %xmm0, %xmm1
        movapd  (%rax), %xmm0
        movabsq $.LCEXP_341, %rax
        mulpd   %xmm6, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCEXP_2, %rax
        mulpd   %xmm8, %xmm0
        addpd   %xmm1, %xmm0
        movapd  %xmm3, %xmm1
        mulpd   %xmm6, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCEXP_3, %rax
        mulpd   %xmm7, %xmm0
        addpd   %xmm6, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCEXP_152, %rax
        andpd   (%rax), %xmm3
        movabsq $.LCEXP_342, %rax
        cmpltpd (%rax), %xmm2
        mulpd   %xmm5, %xmm0
        mulpd   %xmm4, %xmm0
        andnpd  %xmm0, %xmm1
        movapd  %xmm2, %xmm0
        orpd    %xmm1, %xmm3
        pandn   %xmm3, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_expd2_u10sse2, .-.LSleef_expd2_u10sse2
        .set .Lxexp_u1, .LSleef_expd2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCEXP_2:
        .long   0
        .long   1071644672
        .long   0
        .long   1071644672
        .align 16
.LCEXP_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCEXP_89:
        .long   1023
        .long   1023
        .long   0
        .long   0
        .align 16
.LCEXP_90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCEXP_152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCEXP_328:
        .long   1697350398
        .long   1073157447
        .long   1697350398
        .long   1073157447
        .align 16
.LCEXP_329:
        .long   -17158144
        .long   -1075433918
        .long   -17158144
        .long   -1075433918
        .align 16
.LCEXP_330:
        .long   -226956058
        .long   -1118577046
        .long   -226956058
        .long   -1118577046
        .align 16
.LCEXP_331:
        .long   -32494461
        .long   1082535490
        .long   -32494461
        .long   1082535490
        .align 16
.LCEXP_332:
        .long   -520301197
        .long   1049787986
        .long   -520301197
        .long   1049787986
        .align 16
.LCEXP_333:
        .long   371844814
        .long   1053236703
        .long   371844814
        .long   1053236703
        .align 16
.LCEXP_334:
        .long   394299294
        .long   1056571808
        .long   394299294
        .long   1056571808
        .align 16
.LCEXP_335:
        .long   456524789
        .long   1059717536
        .long   456524789
        .long   1059717536
        .align 16
.LCEXP_336:
        .long   381815712
        .long   1062650220
        .long   381815712
        .long   1062650220
        .align 16
.LCEXP_337:
        .long   286321465
        .long   1065423121
        .long   286321465
        .long   1065423121
        .align 16
.LCEXP_338:
        .long   1431655742
        .long   1067799893
        .long   1431655742
        .long   1067799893
        .align 16
.LCEXP_339:
        .long   1431655772
        .long   1069897045
        .long   1431655772
        .long   1069897045
        .align 16
.LCEXP_340:
        .long   -991111307
        .long   1042411748
        .long   -991111307
        .long   1042411748
        .align 16
.LCEXP_341:
        .long   684490762
        .long   1046148746
        .long   684490762
        .long   1046148746
        .align 16
.LCEXP_342:
        .long   0
        .long   -1064353792
        .long   0
        .long   -1064353792
