        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_log10d2_u10sse2, @function
.LSleef_log10d2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        subq    $160, %rsp
        movapd  %xmm0, %xmm13
        movabsq $.LCLOG10_315, %rax
        cmpltpd (%rax), %xmm13
        movabsq $.LCLOG10_316, %rax
        movapd  %xmm13, %xmm1
        andnpd  %xmm0, %xmm1
        mulpd   (%rax), %xmm0
        movabsq $.LCLOG10_83, %rax
        movapd  (%rax), %xmm6
        movabsq $.LCLOG10_149, %rax
        andpd   %xmm13, %xmm0
        pshufd  $8, %xmm13, %xmm13
        orpd    %xmm1, %xmm0
        movdqa  %xmm13, %xmm1
        mulpd   %xmm0, %xmm6
        pshufd  $13, %xmm6, %xmm6
        psrld   $20, %xmm6
        pand    (%rax), %xmm6
        movabsq $.LCLOG10_89, %rax
        movdqa  (%rax), %xmm3
        movabsq $.LCLOG10_90, %rax
        psubd   %xmm6, %xmm3
        pshufd  $115, %xmm3, %xmm3
        pand    (%rax), %xmm3
        movabsq $.LCLOG10_317, %rax
        movdqa  (%rax), %xmm2
        movabsq $.LCLOG10_3, %rax
        movapd  (%rax), %xmm5
        pslld   $20, %xmm3
        movabsq $.LCLOG10_4, %rax
        paddd   %xmm0, %xmm3
        movapd  (%rax), %xmm4
        paddd   %xmm6, %xmm2
        movabsq $.LCLOG10_7, %rax
        movapd  %xmm5, %xmm7
        movapd  %xmm5, %xmm12
        movapd  (%rax), %xmm15
        pandn   %xmm2, %xmm1
        addpd   %xmm3, %xmm7
        movapd  %xmm4, %xmm8
        movaps  %xmm4, 40(%rsp)
        movabsq $.LCLOG10_318, %rax
        paddd   (%rax), %xmm6
        addpd   %xmm3, %xmm8
        movapd  %xmm4, %xmm2
        movabsq $.LCLOG10_436, %rax
        divpd   %xmm7, %xmm12
        pand    %xmm13, %xmm6
        movapd  %xmm7, %xmm9
        por     %xmm1, %xmm6
        movapd  %xmm8, %xmm11
        andpd   %xmm15, %xmm9
        cvtdq2pd        %xmm6, %xmm1
        movapd  %xmm1, %xmm6
        movapd  %xmm1, %xmm13
        addpd   %xmm7, %xmm2
        andpd   %xmm15, %xmm6
        addpd   %xmm5, %xmm11
        subpd   %xmm6, %xmm13
        movaps  %xmm6, 72(%rsp)
        movaps  %xmm2, 24(%rsp)
        movaps  %xmm11, 8(%rsp)
        movapd  %xmm7, %xmm11
        movaps  %xmm13, -40(%rsp)
        movapd  (%rax), %xmm13
        subpd   %xmm9, %xmm11
        movabsq $.LCLOG10_0, %rax
        movapd  (%rax), %xmm6
        movabsq $.LCLOG10_437, %rax
        mulpd   %xmm1, %xmm13
        movaps  %xmm11, -24(%rsp)
        movaps  %xmm13, -120(%rsp)
        xorpd   %xmm6, %xmm13
        movaps  %xmm13, 88(%rsp)
        movapd  %xmm12, %xmm14
        movapd  %xmm12, %xmm4
        movapd  %xmm12, %xmm10
        mulpd   %xmm8, %xmm4
        andpd   %xmm15, %xmm14
        subpd   %xmm14, %xmm10
        movapd  %xmm14, %xmm2
        movapd  %xmm8, %xmm14
        movapd  %xmm10, %xmm11
        movapd  %xmm8, %xmm10
        andpd   %xmm15, %xmm10
        movapd  %xmm4, %xmm13
        andpd   %xmm4, %xmm15
        subpd   %xmm10, %xmm14
        subpd   %xmm15, %xmm13
        movaps  %xmm15, 104(%rsp)
        movapd  (%rax), %xmm15
        movabsq $.LCLOG10_438, %rax
        movaps  %xmm10, 56(%rsp)
        movaps  %xmm15, 120(%rsp)
        mulpd   %xmm4, %xmm15
        movaps  %xmm14, -8(%rsp)
        movapd  %xmm4, %xmm14
        mulpd   %xmm4, %xmm14
        movaps  %xmm13, -104(%rsp)
        xorpd   %xmm15, %xmm6
        movaps  %xmm15, -56(%rsp)
        addpd   -120(%rsp), %xmm15
        movaps  %xmm6, 136(%rsp)
        movapd  (%rax), %xmm6
        movabsq $.LCLOG10_439, %rax
        movapd  %xmm14, %xmm10
        mulpd   %xmm10, %xmm6
        addpd   (%rax), %xmm6
        mulpd   %xmm14, %xmm14
        movaps  %xmm15, -88(%rsp)
        movabsq $.LCLOG10_440, %rax
        movapd  %xmm6, %xmm13
        movapd  (%rax), %xmm6
        movabsq $.LCLOG10_441, %rax
        mulpd   %xmm14, %xmm6
        addpd   %xmm13, %xmm6
        movapd  %xmm14, %xmm13
        mulpd   %xmm14, %xmm13
        mulpd   %xmm13, %xmm6
        movapd  (%rax), %xmm13
        movabsq $.LCLOG10_442, %rax
        mulpd   %xmm10, %xmm13
        addpd   (%rax), %xmm13
        movabsq $.LCLOG10_443, %rax
        mulpd   %xmm13, %xmm14
        movapd  (%rax), %xmm13
        movabsq $.LCLOG10_444, %rax
        mulpd   %xmm10, %xmm13
        addpd   (%rax), %xmm13
        mulpd   %xmm4, %xmm10
        movabsq $.LCLOG10_152, %rax
        addpd   %xmm13, %xmm14
        movapd  (%rax), %xmm13
        movabsq $.LCLOG10_445, %rax
        addpd   %xmm6, %xmm14
        movapd  %xmm9, %xmm6
        mulpd   %xmm2, %xmm6
        mulpd   %xmm11, %xmm9
        mulpd   %xmm10, %xmm14
        movapd  %xmm14, %xmm10
        movapd  %xmm15, %xmm14
        movapd  %xmm6, %xmm15
        movapd  %xmm5, %xmm6
        addpd   %xmm10, %xmm14
        movaps  %xmm10, -72(%rsp)
        movapd  %xmm0, %xmm10
        subpd   %xmm15, %xmm6
        movapd  -24(%rsp), %xmm15
        cmpeqpd %xmm13, %xmm10
        subpd   %xmm9, %xmm6
        movapd  %xmm15, %xmm9
        mulpd   %xmm2, %xmm9
        subpd   %xmm9, %xmm6
        movapd  %xmm15, %xmm9
        mulpd   %xmm11, %xmm9
        subpd   %xmm9, %xmm6
        movapd  56(%rsp), %xmm9
        movapd  %xmm9, %xmm15
        mulpd   %xmm2, %xmm15
        mulpd   %xmm11, %xmm9
        mulpd   %xmm4, %xmm6
        subpd   %xmm4, %xmm15
        addpd   %xmm15, %xmm9
        movapd  -8(%rsp), %xmm15
        mulpd   %xmm15, %xmm2
        mulpd   %xmm15, %xmm11
        addpd   %xmm2, %xmm9
        addpd   %xmm11, %xmm9
        movapd  8(%rsp), %xmm11
        subpd   %xmm11, %xmm8
        addpd   %xmm6, %xmm9
        movapd  40(%rsp), %xmm6
        subpd   %xmm8, %xmm6
        movapd  %xmm3, %xmm8
        subpd   %xmm11, %xmm8
        movapd  136(%rsp), %xmm11
        movapd  %xmm6, %xmm2
        movapd  %xmm8, %xmm6
        movapd  -104(%rsp), %xmm8
        addpd   %xmm2, %xmm6
        movapd  24(%rsp), %xmm2
        subpd   %xmm2, %xmm7
        subpd   %xmm2, %xmm3
        movapd  (%rax), %xmm2
        movabsq $.LCLOG10_446, %rax
        subpd   %xmm7, %xmm5
        movapd  -88(%rsp), %xmm7
        addpd   %xmm3, %xmm5
        mulpd   %xmm4, %xmm5
        subpd   %xmm5, %xmm6
        movapd  (%rax), %xmm5
        movabsq $.LCLOG10_447, %rax
        mulpd   (%rax), %xmm4
        movabsq $.LCLOG10_448, %rax
        mulpd   %xmm12, %xmm6
        movapd  104(%rsp), %xmm12
        movapd  %xmm12, %xmm3
        mulpd   %xmm2, %xmm3
        mulpd   %xmm8, %xmm2
        addpd   %xmm9, %xmm6
        mulpd   %xmm5, %xmm12
        movapd  120(%rsp), %xmm9
        mulpd   %xmm8, %xmm5
        addpd   %xmm3, %xmm11
        mulpd   %xmm6, %xmm9
        movapd  %xmm12, %xmm15
        movapd  %xmm11, %xmm6
        addpd   %xmm2, %xmm6
        movapd  (%rax), %xmm2
        movabsq $.LCLOG10_449, %rax
        addpd   %xmm6, %xmm15
        movapd  -40(%rsp), %xmm6
        addpd   %xmm5, %xmm15
        movapd  72(%rsp), %xmm5
        movapd  %xmm5, %xmm3
        mulpd   %xmm2, %xmm3
        addpd   %xmm15, %xmm4
        movapd  88(%rsp), %xmm15
        mulpd   %xmm6, %xmm2
        addpd   %xmm4, %xmm9
        addpd   %xmm3, %xmm15
        movapd  (%rax), %xmm3
        movabsq $.LCLOG10_450, %rax
        mulpd   (%rax), %xmm1
        movabsq $.LCLOG10_326, %rax
        mulpd   %xmm3, %xmm5
        mulpd   %xmm6, %xmm3
        addpd   %xmm5, %xmm15
        movapd  -120(%rsp), %xmm5
        subpd   %xmm7, %xmm5
        subpd   %xmm14, %xmm7
        addpd   %xmm2, %xmm15
        pxor    %xmm2, %xmm2
        addpd   %xmm3, %xmm15
        movapd  %xmm0, %xmm3
        cmpltpd %xmm2, %xmm3
        addpd   %xmm15, %xmm1
        movapd  -56(%rsp), %xmm15
        addpd   %xmm5, %xmm15
        addpd   %xmm15, %xmm1
        addpd   %xmm1, %xmm9
        movapd  -72(%rsp), %xmm1
        addpd   %xmm7, %xmm1
        addpd   %xmm1, %xmm9
        movapd  %xmm10, %xmm1
        andpd   %xmm13, %xmm10
        addpd   %xmm9, %xmm14
        andnpd  %xmm14, %xmm1
        orpd    %xmm1, %xmm10
        movapd  %xmm0, %xmm1
        cmpneqpd        %xmm0, %xmm1
        cmpeqpd %xmm2, %xmm0
        orpd    %xmm3, %xmm1
        movapd  %xmm0, %xmm2
        movapd  %xmm1, %xmm3
        andpd   (%rax), %xmm1
        movabsq $.LCLOG10_327, %rax
        andnpd  %xmm10, %xmm3
        andpd   (%rax), %xmm0
        addq    $160, %rsp
        orpd    %xmm3, %xmm1
        andnpd  %xmm1, %xmm2
        orpd    %xmm2, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_log10d2_u10sse2, .-.LSleef_log10d2_u10sse2
        .set .Lxlog10_u1, .LSleef_log10d2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCLOG10_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCLOG10_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCLOG10_4:
        .long   0
        .long   -1074790400
        .long   0
        .long   -1074790400
        .align 16
.LCLOG10_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCLOG10_83:
        .long   1431655765
        .long   1073042773
        .long   1431655765
        .long   1073042773
        .align 16
.LCLOG10_89:
        .long   1023
        .long   1023
        .long   0
        .long   0
        .align 16
.LCLOG10_90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCLOG10_149:
        .quad   8791798056959
        .quad   0
        .align 16
.LCLOG10_152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCLOG10_315:
        .long   0
        .long   1048576
        .long   0
        .long   1048576
        .align 16
.LCLOG10_316:
        .long   0
        .long   1139802112
        .long   0
        .long   1139802112
        .align 16
.LCLOG10_317:
        .long   -1023
        .long   -1023
        .long   0
        .long   0
        .align 16
.LCLOG10_318:
        .long   -1087
        .long   -1087
        .long   0
        .long   0
        .align 16
.LCLOG10_326:
        .long   0
        .long   2146959360
        .long   0
        .long   2146959360
        .align 16
.LCLOG10_327:
        .long   0
        .long   -1048576
        .long   0
        .long   -1048576
        .align 16
.LCLOG10_436:
        .long   1352628735
        .long   1070810131
        .long   1352628735
        .long   1070810131
        .align 16
.LCLOG10_437:
        .long   354870542
        .long   1072417659
        .long   354870542
        .long   1072417659
        .align 16
.LCLOG10_438:
        .long   -760917614
        .long   1068561979
        .long   -760917614
        .long   1068561979
        .align 16
.LCLOG10_439:
        .long   737500488
        .long   1068775450
        .long   737500488
        .long   1068775450
        .align 16
.LCLOG10_440:
        .long   -202730346
        .long   1068566677
        .long   -202730346
        .long   1068566677
        .align 16
.LCLOG10_441:
        .long   -1836507276
        .long   1069069529
        .long   -1836507276
        .long   1069069529
        .align 16
.LCLOG10_442:
        .long   1869445153
        .long   1069532154
        .long   1869445153
        .long   1069532154
        .align 16
.LCLOG10_443:
        .long   2001312648
        .long   1069956194
        .long   2001312648
        .long   1069956194
        .align 16
.LCLOG10_444:
        .long   1668236656
        .long   1070761895
        .long   1668236656
        .long   1070761895
        .align 16
.LCLOG10_445:
        .long   268435456
        .long   1072417659
        .long   268435456
        .long   1072417659
        .align 16
.LCLOG10_446:
        .long   939524096
        .long   1044683668
        .long   939524096
        .long   1044683668
        .align 16
.LCLOG10_447:
        .long   -921308273
        .long   1013603101
        .long   -921308273
        .long   1013603101
        .align 16
.LCLOG10_448:
        .long   1342177280
        .long   1070810131
        .long   1342177280
        .long   1070810131
        .align 16
.LCLOG10_449:
        .long   -536870912
        .long   1040445247
        .long   -536870912
        .long   1040445247
        .align 16
.LCLOG10_450:
        .long   -1449853663
        .long   -1136010211
        .long   -1449853663
        .long   -1136010211
