        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_logd2_u10sse2, @function
.LSleef_logd2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        subq    $96, %rsp
        movapd  %xmm0, %xmm5
        movabsq $.LCLOG_315, %rax
        cmpltpd (%rax), %xmm5
        movabsq $.LCLOG_316, %rax
        movapd  %xmm5, %xmm1
        andnpd  %xmm0, %xmm1
        mulpd   (%rax), %xmm0
        movabsq $.LCLOG_83, %rax
        movapd  (%rax), %xmm3
        movabsq $.LCLOG_149, %rax
        andpd   %xmm5, %xmm0
        pshufd  $8, %xmm5, %xmm5
        orpd    %xmm1, %xmm0
        movdqa  %xmm5, %xmm13
        mulpd   %xmm0, %xmm3
        pshufd  $13, %xmm3, %xmm3
        psrld   $20, %xmm3
        pand    (%rax), %xmm3
        movabsq $.LCLOG_89, %rax
        movdqa  (%rax), %xmm1
        movabsq $.LCLOG_90, %rax
        psubd   %xmm3, %xmm1
        pshufd  $115, %xmm1, %xmm1
        pand    (%rax), %xmm1
        movabsq $.LCLOG_317, %rax
        pslld   $20, %xmm1
        movdqa  %xmm1, %xmm12
        movdqa  (%rax), %xmm1
        movabsq $.LCLOG_3, %rax
        movapd  (%rax), %xmm4
        paddd   %xmm0, %xmm12
        movabsq $.LCLOG_4, %rax
        movapd  %xmm12, %xmm8
        movapd  (%rax), %xmm9
        movaps  %xmm12, -120(%rsp)
        paddd   %xmm3, %xmm1
        addpd   %xmm4, %xmm8
        movapd  %xmm4, %xmm6
        pandn   %xmm1, %xmm13
        movabsq $.LCLOG_7, %rax
        movaps  %xmm9, 8(%rsp)
        movapd  %xmm9, %xmm15
        addpd   -120(%rsp), %xmm9
        divpd   %xmm8, %xmm6
        movapd  %xmm8, %xmm10
        movapd  %xmm8, %xmm2
        movapd  %xmm9, %xmm7
        addpd   %xmm8, %xmm15
        movapd  %xmm9, %xmm14
        addpd   %xmm4, %xmm7
        movaps  %xmm15, -8(%rsp)
        movaps  %xmm7, -24(%rsp)
        movapd  (%rax), %xmm7
        movabsq $.LCLOG_318, %rax
        paddd   (%rax), %xmm3
        movabsq $.LCLOG_99, %rax
        andpd   %xmm7, %xmm10
        subpd   %xmm10, %xmm2
        pand    %xmm5, %xmm3
        por     %xmm13, %xmm3
        movapd  %xmm2, %xmm15
        movapd  %xmm9, %xmm2
        andpd   %xmm7, %xmm2
        subpd   %xmm2, %xmm14
        movaps  %xmm2, 24(%rsp)
        cvtdq2pd        %xmm3, %xmm2
        movapd  %xmm2, %xmm3
        movaps  %xmm14, -40(%rsp)
        movapd  %xmm6, %xmm1
        movaps  %xmm6, -56(%rsp)
        movapd  %xmm6, %xmm12
        mulpd   %xmm9, %xmm6
        andpd   %xmm7, %xmm1
        andpd   %xmm2, %xmm7
        subpd   %xmm7, %xmm3
        movaps  %xmm7, 40(%rsp)
        subpd   %xmm1, %xmm12
        movaps  %xmm3, -88(%rsp)
        movapd  (%rax), %xmm3
        movabsq $.LCLOG_0, %rax
        movapd  %xmm6, %xmm13
        movapd  %xmm6, %xmm11
        movapd  (%rax), %xmm5
        movabsq $.LCLOG_343, %rax
        mulpd   %xmm2, %xmm3
        addpd   %xmm6, %xmm13
        mulpd   %xmm6, %xmm11
        movaps  %xmm13, -104(%rsp)
        addpd   %xmm3, %xmm13
        xorpd   %xmm3, %xmm5
        movaps  %xmm3, -72(%rsp)
        movapd  %xmm11, %xmm14
        movaps  %xmm5, 56(%rsp)
        mulpd   %xmm11, %xmm14
        movapd  %xmm13, %xmm7
        movapd  (%rax), %xmm13
        movabsq $.LCLOG_344, %rax
        mulpd   %xmm11, %xmm13
        addpd   (%rax), %xmm13
        movabsq $.LCLOG_345, %rax
        movapd  %xmm13, %xmm3
        movapd  (%rax), %xmm13
        movabsq $.LCLOG_346, %rax
        movapd  (%rax), %xmm5
        movabsq $.LCLOG_347, %rax
        mulpd   %xmm14, %xmm13
        mulpd   %xmm11, %xmm5
        addpd   (%rax), %xmm5
        movabsq $.LCLOG_348, %rax
        addpd   %xmm3, %xmm13
        mulpd   %xmm14, %xmm5
        movapd  %xmm14, %xmm3
        mulpd   %xmm14, %xmm3
        movapd  (%rax), %xmm14
        movabsq $.LCLOG_349, %rax
        mulpd   %xmm11, %xmm14
        mulpd   %xmm6, %xmm11
        mulpd   %xmm3, %xmm13
        movapd  %xmm14, %xmm3
        addpd   (%rax), %xmm3
        movabsq $.LCLOG_152, %rax
        addpd   %xmm5, %xmm3
        movapd  %xmm10, %xmm5
        mulpd   %xmm1, %xmm5
        mulpd   %xmm12, %xmm10
        addpd   %xmm13, %xmm3
        movapd  (%rax), %xmm13
        movabsq $.LCLOG_108, %rax
        mulpd   %xmm11, %xmm3
        movapd  %xmm7, %xmm11
        addpd   %xmm3, %xmm11
        movapd  %xmm11, %xmm14
        movapd  %xmm0, %xmm11
        cmpeqpd %xmm13, %xmm11
        movaps  %xmm11, 72(%rsp)
        movapd  %xmm4, %xmm11
        subpd   %xmm5, %xmm11
        movapd  %xmm11, %xmm5
        movapd  %xmm15, %xmm11
        mulpd   %xmm1, %xmm11
        subpd   %xmm10, %xmm5
        movapd  24(%rsp), %xmm10
        subpd   %xmm11, %xmm5
        movapd  %xmm15, %xmm11
        movapd  %xmm10, %xmm15
        mulpd   %xmm1, %xmm15
        mulpd   %xmm12, %xmm10
        mulpd   %xmm12, %xmm11
        subpd   %xmm6, %xmm15
        subpd   %xmm11, %xmm5
        addpd   %xmm15, %xmm10
        movapd  -40(%rsp), %xmm15
        mulpd   %xmm15, %xmm1
        mulpd   %xmm15, %xmm12
        movapd  -24(%rsp), %xmm15
        mulpd   %xmm6, %xmm5
        subpd   %xmm15, %xmm9
        addpd   %xmm1, %xmm10
        movapd  8(%rsp), %xmm1
        subpd   %xmm9, %xmm1
        addpd   %xmm12, %xmm10
        movdqa  -120(%rsp), %xmm12
        movapd  %xmm12, %xmm11
        subpd   %xmm15, %xmm11
        movapd  -8(%rsp), %xmm15
        addpd   %xmm5, %xmm10
        subpd   %xmm15, %xmm8
        movapd  %xmm11, %xmm5
        addpd   %xmm1, %xmm5
        movapd  %xmm12, %xmm1
        subpd   %xmm15, %xmm1
        subpd   %xmm8, %xmm4
        addpd   %xmm1, %xmm4
        movapd  (%rax), %xmm1
        movabsq $.LCLOG_109, %rax
        mulpd   %xmm6, %xmm4
        movapd  40(%rsp), %xmm6
        subpd   %xmm4, %xmm5
        mulpd   -56(%rsp), %xmm5
        movapd  %xmm6, %xmm4
        mulpd   %xmm1, %xmm4
        addpd   56(%rsp), %xmm4
        addpd   %xmm5, %xmm10
        movapd  (%rax), %xmm5
        movabsq $.LCLOG_110, %rax
        mulpd   (%rax), %xmm2
        movabsq $.LCLOG_326, %rax
        mulpd   %xmm5, %xmm6
        addpd   %xmm10, %xmm10
        addpd   %xmm6, %xmm4
        movapd  -88(%rsp), %xmm6
        mulpd   %xmm6, %xmm1
        mulpd   %xmm6, %xmm5
        addpd   %xmm1, %xmm4
        addpd   %xmm5, %xmm4
        movapd  -72(%rsp), %xmm5
        subpd   %xmm7, %xmm5
        addpd   -104(%rsp), %xmm5
        addpd   %xmm4, %xmm2
        subpd   %xmm14, %xmm7
        addpd   %xmm5, %xmm2
        addpd   %xmm7, %xmm3
        movapd  72(%rsp), %xmm7
        movapd  %xmm7, %xmm1
        andpd   %xmm13, %xmm7
        addpd   %xmm2, %xmm10
        movapd  %xmm7, %xmm11
        pxor    %xmm2, %xmm2
        addpd   %xmm3, %xmm10
        movapd  %xmm0, %xmm3
        cmpltpd %xmm2, %xmm3
        addpd   %xmm10, %xmm14
        andnpd  %xmm14, %xmm1
        orpd    %xmm1, %xmm11
        movapd  %xmm0, %xmm1
        cmpneqpd        %xmm0, %xmm1
        cmpeqpd %xmm2, %xmm0
        orpd    %xmm3, %xmm1
        movapd  %xmm0, %xmm2
        movapd  %xmm1, %xmm3
        andpd   (%rax), %xmm1
        movabsq $.LCLOG_327, %rax
        andnpd  %xmm11, %xmm3
        andpd   (%rax), %xmm0
        addq    $96, %rsp
        orpd    %xmm3, %xmm1
        andnpd  %xmm1, %xmm2
        orpd    %xmm2, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_logd2_u10sse2, .-.LSleef_logd2_u10sse2
        .set    .Lxlog_u1, .LSleef_logd2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCLOG_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCLOG_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCLOG_4:
        .long   0
        .long   -1074790400
        .long   0
        .long   -1074790400
        .align 16
.LCLOG_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCLOG_83:
        .long   1431655765
        .long   1073042773
        .long   1431655765
        .long   1073042773
        .align 16
.LCLOG_89:
        .long   1023
        .long   1023
        .long   0
        .long   0
        .align 16
.LCLOG_90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCLOG_99:
        .long   -17155601
        .long   1072049730
        .long   -17155601
        .long   1072049730
        .align 16
.LCLOG_108:
        .long   -134217728
        .long   1072049730
        .long   -134217728
        .long   1072049730
        .align 16
.LCLOG_109:
        .long   -1140850688
        .long   1045162215
        .long   -1140850688
        .long   1045162215
        .align 16
.LCLOG_110:
        .long   993624127
        .long   1014676638
        .long   993624127
        .long   1014676638
        .align 16
.LCLOG_149:
        .quad   8791798056959
        .quad   0
        .align 16
.LCLOG_152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCLOG_315:
        .long   0
        .long   1048576
        .long   0
        .long   1048576
        .align 16
.LCLOG_316:
        .long   0
        .long   1139802112
        .long   0
        .long   1139802112
        .align 16
.LCLOG_317:
        .long   -1023
        .long   -1023
        .long   0
        .long   0
        .align 16
.LCLOG_318:
        .long   -1087
        .long   -1087
        .long   0
        .long   0
        .align 16
.LCLOG_326:
        .long   0
        .long   2146959360
        .long   0
        .long   2146959360
        .align 16
.LCLOG_327:
        .long   0
        .long   -1048576
        .long   0
        .long   -1048576
        .align 16
.LCLOG_343:
        .long   1744735876
        .long   1069778734
        .long   1744735876
        .long   1069778734
        .align 16
.LCLOG_344:
        .long   978346037
        .long   1070024501
        .long   978346037
        .long   1070024501
        .align 16
.LCLOG_345:
        .long   1409767038
        .long   1069784143
        .long   1409767038
        .long   1069784143
        .align 16
.LCLOG_346:
        .long   -1503736434
        .long   1070363072
        .long   -1503736434
        .long   1070363072
        .align 16
.LCLOG_347:
        .long   -1704418747
        .long   1070745892
        .long   -1704418747
        .long   1070745892
        .align 16
.LCLOG_348:
        .long   -1718643990
        .long   1071225241
        .long   -1718643990
        .long   1071225241
        .align 16
.LCLOG_349:
        .long   1431656366
        .long   1071994197
        .long   1431656366
        .long   1071994197
