        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_powd2_u10sse2, @function
.LSleef_powd2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCPOW_234, %rax
        subq    $448, %rsp
        movapd  %xmm0, %xmm11
        movapd  (%rax), %xmm0
        movaps  %xmm1, -120(%rsp)
        movabsq $.LCPOW_150, %rax
        movaps  %xmm11, 200(%rsp)
        mulpd   %xmm1, %xmm0
        cvttpd2dq       %xmm0, %xmm0
        cvtdq2pd        %xmm0, %xmm0
        mulpd   (%rax), %xmm0
        movabsq $.LCPOW_0, %rax
        movapd  (%rax), %xmm14
        movabsq $.LCPOW_273, %rax
        movapd  (%rax), %xmm3
        movabsq $.LCPOW_119, %rax
        movapd  %xmm14, %xmm5
        movapd  %xmm14, %xmm13
        andnpd  %xmm1, %xmm5
        movapd  %xmm3, %xmm4
        andnpd  %xmm11, %xmm13
        addpd   %xmm1, %xmm0
        cmpltpd %xmm5, %xmm4
        movaps  %xmm13, 280(%rsp)
        movaps  %xmm5, 216(%rsp)
        cvttpd2dq       %xmm0, %xmm1
        cvtdq2pd        %xmm1, %xmm2
        cmpeqpd %xmm2, %xmm0
        pand    (%rax), %xmm1
        movabsq $.LCPOW_178, %rax
        pcmpeqd (%rax), %xmm1
        movabsq $.LCPOW_315, %rax
        orpd    %xmm4, %xmm0
        movaps  %xmm0, 232(%rsp)
        movapd  %xmm5, %xmm0
        cmpltpd %xmm3, %xmm0
        pshufd  $80, %xmm1, %xmm3
        movaps  %xmm3, 264(%rsp)
        movaps  %xmm0, 248(%rsp)
        movapd  %xmm13, %xmm0
        cmpltpd (%rax), %xmm0
        movabsq $.LCPOW_316, %rax
        movapd  (%rax), %xmm3
        movabsq $.LCPOW_83, %rax
        movapd  (%rax), %xmm1
        movabsq $.LCPOW_149, %rax
        mulpd   %xmm13, %xmm3
        movapd  %xmm0, %xmm2
        movdqa  (%rax), %xmm6
        movabsq $.LCPOW_89, %rax
        andnpd  %xmm13, %xmm2
        pshufd  $8, %xmm0, %xmm12
        andpd   %xmm0, %xmm3
        orpd    %xmm3, %xmm2
        mulpd   %xmm2, %xmm1
        pshufd  $13, %xmm1, %xmm1
        psrld   $20, %xmm1
        pand    %xmm1, %xmm6
        movdqa  %xmm6, %xmm13
        movdqa  (%rax), %xmm6
        movabsq $.LCPOW_90, %rax
        movdqa  (%rax), %xmm4
        movabsq $.LCPOW_317, %rax
        movdqa  %xmm6, %xmm3
        movaps  %xmm6, -40(%rsp)
        psubd   %xmm13, %xmm3
        movaps  %xmm4, -24(%rsp)
        pshufd  $115, %xmm3, %xmm3
        pand    %xmm4, %xmm3
        pslld   $20, %xmm3
        paddd   %xmm2, %xmm3
        movdqa  (%rax), %xmm2
        movabsq $.LCPOW_3, %rax
        movapd  (%rax), %xmm4
        movabsq $.LCPOW_4, %rax
        movapd  (%rax), %xmm6
        paddd   %xmm13, %xmm2
        movabsq $.LCPOW_7, %rax
        movapd  %xmm4, %xmm5
        movapd  %xmm4, %xmm10
        movdqa  %xmm2, %xmm0
        movaps  %xmm4, -72(%rsp)
        addpd   %xmm3, %xmm5
        movdqa  %xmm12, %xmm2
        movapd  %xmm6, %xmm7
        movaps  %xmm6, -8(%rsp)
        pandn   %xmm0, %xmm2
        movapd  %xmm6, %xmm0
        addpd   %xmm3, %xmm0
        movaps  %xmm2, 8(%rsp)
        divpd   %xmm5, %xmm10
        addpd   %xmm5, %xmm7
        movapd  %xmm5, %xmm9
        movapd  %xmm5, %xmm1
        movapd  %xmm0, %xmm6
        movaps  %xmm7, -104(%rsp)
        movapd  %xmm4, %xmm7
        movapd  %xmm6, %xmm2
        addpd   %xmm0, %xmm7
        movapd  (%rax), %xmm0
        movabsq $.LCPOW_350, %rax
        andpd   %xmm0, %xmm9
        subpd   %xmm9, %xmm1
        movaps  %xmm7, -88(%rsp)
        movapd  %xmm1, %xmm11
        movapd  %xmm10, %xmm1
        movapd  %xmm10, %xmm8
        andpd   %xmm0, %xmm1
        subpd   %xmm1, %xmm8
        movapd  %xmm1, %xmm7
        movapd  %xmm6, %xmm1
        andpd   %xmm0, %xmm1
        movapd  %xmm1, %xmm15
        subpd   %xmm1, %xmm2
        movapd  %xmm9, %xmm1
        mulpd   %xmm7, %xmm1
        mulpd   %xmm8, %xmm9
        movaps  %xmm2, -56(%rsp)
        movapd  %xmm6, %xmm2
        mulpd   %xmm10, %xmm2
        subpd   %xmm1, %xmm4
        movapd  %xmm15, %xmm1
        mulpd   %xmm8, %xmm1
        subpd   %xmm9, %xmm4
        movapd  %xmm11, %xmm9
        mulpd   %xmm7, %xmm9
        mulpd   %xmm8, %xmm11
        subpd   %xmm9, %xmm4
        movapd  %xmm7, %xmm9
        mulpd   %xmm15, %xmm9
        subpd   %xmm11, %xmm4
        movapd  %xmm14, %xmm11
        subpd   %xmm2, %xmm9
        mulpd   %xmm2, %xmm4
        addpd   %xmm9, %xmm1
        movapd  -56(%rsp), %xmm9
        mulpd   %xmm9, %xmm7
        mulpd   %xmm9, %xmm8
        movapd  %xmm2, %xmm9
        mulpd   %xmm2, %xmm9
        addpd   %xmm7, %xmm1
        movapd  -88(%rsp), %xmm7
        subpd   %xmm7, %xmm6
        addpd   %xmm8, %xmm1
        movapd  %xmm3, %xmm8
        subpd   %xmm7, %xmm8
        movapd  -104(%rsp), %xmm7
        addpd   %xmm1, %xmm4
        movapd  -8(%rsp), %xmm1
        subpd   %xmm7, %xmm5
        subpd   %xmm7, %xmm3
        movapd  %xmm14, %xmm7
        subpd   %xmm6, %xmm1
        movapd  %xmm8, %xmm6
        movapd  %xmm2, %xmm8
        andpd   %xmm0, %xmm8
        xorpd   %xmm9, %xmm7
        addpd   %xmm1, %xmm6
        movapd  -72(%rsp), %xmm1
        subpd   %xmm5, %xmm1
        movapd  %xmm8, %xmm5
        movapd  %xmm2, %xmm8
        subpd   %xmm5, %xmm8
        addpd   %xmm1, %xmm3
        mulpd   %xmm2, %xmm3
        subpd   %xmm3, %xmm6
        movapd  %xmm9, %xmm3
        movapd  %xmm5, %xmm9
        addpd   %xmm5, %xmm9
        mulpd   %xmm10, %xmm6
        movapd  %xmm4, %xmm10
        addpd   %xmm6, %xmm10
        movapd  %xmm9, %xmm6
        movapd  %xmm5, %xmm9
        mulpd   %xmm5, %xmm9
        mulpd   %xmm8, %xmm6
        addpd   %xmm7, %xmm9
        movapd  %xmm3, %xmm7
        mulpd   %xmm3, %xmm7
        movapd  %xmm9, %xmm1
        movapd  %xmm8, %xmm9
        mulpd   %xmm8, %xmm9
        addpd   %xmm6, %xmm1
        movapd  %xmm7, %xmm6
        mulpd   %xmm7, %xmm6
        addpd   %xmm9, %xmm1
        movapd  %xmm10, %xmm9
        addpd   %xmm10, %xmm9
        mulpd   %xmm3, %xmm10
        movaps  %xmm9, 296(%rsp)
        movapd  %xmm9, %xmm4
        movapd  %xmm1, %xmm9
        mulpd   %xmm2, %xmm4
        addpd   %xmm4, %xmm9
        movaps  %xmm9, -56(%rsp)
        movapd  (%rax), %xmm9
        movabsq $.LCPOW_351, %rax
        mulpd   %xmm3, %xmm9
        movapd  %xmm9, %xmm4
        addpd   (%rax), %xmm4
        movabsq $.LCPOW_352, %rax
        movapd  (%rax), %xmm9
        movabsq $.LCPOW_353, %rax
        mulpd   %xmm3, %xmm9
        mulpd   %xmm7, %xmm4
        movapd  %xmm9, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCPOW_354, %rax
        movapd  (%rax), %xmm9
        movabsq $.LCPOW_355, %rax
        mulpd   %xmm3, %xmm9
        addpd   %xmm1, %xmm4
        mulpd   %xmm6, %xmm4
        mulpd   %xmm6, %xmm6
        movapd  %xmm9, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCPOW_356, %rax
        mulpd   %xmm7, %xmm1
        movapd  (%rax), %xmm7
        movabsq $.LCPOW_357, %rax
        mulpd   %xmm3, %xmm7
        addpd   (%rax), %xmm7
        movabsq $.LCPOW_358, %rax
        mulpd   (%rax), %xmm6
        movabsq $.LCPOW_318, %rax
        addpd   %xmm7, %xmm1
        movdqa  (%rax), %xmm7
        movabsq $.LCPOW_99, %rax
        paddd   %xmm13, %xmm7
        addpd   %xmm4, %xmm1
        movapd  %xmm1, %xmm9
        movdqa  %xmm7, %xmm1
        movapd  (%rax), %xmm7
        movabsq $.LCPOW_359, %rax
        pand    %xmm12, %xmm1
        por     8(%rsp), %xmm1
        addpd   %xmm6, %xmm9
        cvtdq2pd        %xmm1, %xmm1
        movapd  %xmm1, %xmm6
        movapd  %xmm1, %xmm12
        mulpd   %xmm1, %xmm7
        andpd   %xmm0, %xmm6
        movaps  %xmm9, -88(%rsp)
        subpd   %xmm6, %xmm12
        movapd  %xmm6, %xmm15
        movapd  %xmm2, %xmm6
        mulpd   %xmm3, %xmm6
        movaps  %xmm12, 72(%rsp)
        movapd  %xmm14, %xmm12
        xorpd   %xmm7, %xmm12
        movaps  %xmm12, 328(%rsp)
        movapd  %xmm2, %xmm12
        addpd   %xmm2, %xmm12
        mulpd   -56(%rsp), %xmm2
        xorpd   %xmm6, %xmm11
        movapd  %xmm11, %xmm9
        movapd  %xmm5, %xmm11
        movaps  %xmm12, 88(%rsp)
        movapd  %xmm12, %xmm4
        movapd  %xmm3, %xmm12
        andpd   %xmm0, %xmm12
        addpd   %xmm7, %xmm4
        movapd  %xmm12, %xmm13
        movapd  %xmm3, %xmm12
        subpd   %xmm13, %xmm12
        mulpd   %xmm13, %xmm11
        subpd   %xmm4, %xmm7
        mulpd   %xmm12, %xmm5
        movaps  %xmm12, 104(%rsp)
        addpd   %xmm11, %xmm9
        movapd  %xmm8, %xmm11
        mulpd   %xmm13, %xmm11
        mulpd   %xmm12, %xmm8
        addpd   %xmm9, %xmm5
        movapd  %xmm14, %xmm9
        addpd   %xmm5, %xmm11
        movapd  %xmm6, %xmm5
        addpd   %xmm8, %xmm11
        addpd   %xmm10, %xmm11
        movapd  %xmm6, %xmm10
        andpd   %xmm0, %xmm10
        movapd  %xmm11, %xmm8
        movapd  (%rax), %xmm11
        movabsq $.LCPOW_146, %rax
        addpd   %xmm2, %xmm8
        movapd  %xmm6, %xmm2
        mulpd   %xmm11, %xmm5
        subpd   %xmm10, %xmm2
        movaps  %xmm8, 120(%rsp)
        movaps  %xmm2, 136(%rsp)
        movapd  %xmm4, %xmm2
        movapd  %xmm5, %xmm12
        movapd  %xmm14, %xmm5
        xorpd   %xmm12, %xmm5
        addpd   %xmm12, %xmm2
        movaps  %xmm5, 344(%rsp)
        movapd  %xmm3, %xmm5
        mulpd   %xmm6, %xmm5
        subpd   %xmm2, %xmm4
        addpd   %xmm4, %xmm12
        xorpd   %xmm5, %xmm9
        movapd  %xmm5, %xmm8
        movaps  %xmm9, 360(%rsp)
        andpd   %xmm0, %xmm8
        movapd  %xmm5, %xmm9
        movaps  %xmm8, 376(%rsp)
        subpd   %xmm8, %xmm9
        movaps  %xmm9, 152(%rsp)
        movapd  -88(%rsp), %xmm9
        movapd  344(%rsp), %xmm4
        movaps  %xmm15, 312(%rsp)
        addpd   88(%rsp), %xmm7
        mulpd   %xmm9, %xmm5
        movapd  %xmm9, %xmm8
        andpd   %xmm0, %xmm8
        movaps  %xmm8, 8(%rsp)
        movapd  %xmm9, %xmm8
        subpd   8(%rsp), %xmm8
        movaps  %xmm5, 184(%rsp)
        movapd  %xmm5, %xmm9
        addpd   %xmm2, %xmm5
        movaps  %xmm8, 168(%rsp)
        xorpd   %xmm14, %xmm9
        movaps  %xmm9, 392(%rsp)
        movapd  %xmm5, %xmm9
        movapd  %xmm5, %xmm8
        subpd   %xmm5, %xmm2
        andpd   %xmm0, %xmm9
        movaps  %xmm9, 408(%rsp)
        subpd   %xmm9, %xmm8
        movapd  -120(%rsp), %xmm9
        movaps  %xmm8, 40(%rsp)
        movdqa  (%rax), %xmm8
        movabsq $.LCPOW_108, %rax
        pand    %xmm9, %xmm8
        movaps  %xmm8, 24(%rsp)
        movapd  -120(%rsp), %xmm8
        subpd   24(%rsp), %xmm9
        mulpd   %xmm5, %xmm8
        movaps  %xmm9, 56(%rsp)
        movapd  %xmm8, %xmm9
        movaps  %xmm8, -104(%rsp)
        movapd  %xmm15, %xmm8
        movapd  328(%rsp), %xmm15
        xorpd   %xmm14, %xmm9
        movaps  %xmm9, 424(%rsp)
        movapd  (%rax), %xmm9
        movabsq $.LCPOW_109, %rax
        mulpd   %xmm9, %xmm8
        addpd   %xmm8, %xmm15
        movapd  312(%rsp), %xmm8
        movaps  %xmm15, 328(%rsp)
        movapd  (%rax), %xmm15
        movabsq $.LCPOW_110, %rax
        mulpd   (%rax), %xmm1
        movabsq $.LCPOW_360, %rax
        movaps  %xmm15, 312(%rsp)
        mulpd   %xmm15, %xmm8
        movapd  72(%rsp), %xmm15
        addpd   328(%rsp), %xmm8
        mulpd   %xmm15, %xmm9
        addpd   %xmm9, %xmm8
        movapd  312(%rsp), %xmm9
        mulpd   %xmm15, %xmm9
        movapd  %xmm10, %xmm15
        addpd   %xmm9, %xmm8
        movapd  136(%rsp), %xmm9
        addpd   %xmm1, %xmm8
        movapd  (%rax), %xmm1
        movabsq $.LCPOW_361, %rax
        mulpd   %xmm1, %xmm15
        mulpd   %xmm9, %xmm1
        addpd   %xmm7, %xmm8
        addpd   296(%rsp), %xmm8
        addpd   %xmm8, %xmm12
        addpd   %xmm15, %xmm4
        movapd  %xmm10, %xmm15
        addpd   %xmm1, %xmm4
        movapd  (%rax), %xmm1
        movapd  120(%rsp), %xmm8
        movabsq $.LCPOW_362, %rax
        addpd   184(%rsp), %xmm2
        movapd  104(%rsp), %xmm7
        mulpd   %xmm1, %xmm15
        mulpd   %xmm9, %xmm1
        mulpd   %xmm8, %xmm11
        mulpd   %xmm8, %xmm3
        movapd  56(%rsp), %xmm8
        addpd   %xmm15, %xmm4
        movapd  (%rax), %xmm15
        movabsq $.LCPOW_328, %rax
        mulpd   %xmm6, %xmm15
        addpd   %xmm4, %xmm1
        mulpd   -56(%rsp), %xmm6
        addpd   %xmm15, %xmm1
        movapd  %xmm10, %xmm15
        mulpd   %xmm7, %xmm15
        mulpd   %xmm9, %xmm7
        addpd   %xmm11, %xmm1
        addpd   %xmm12, %xmm1
        movapd  -104(%rsp), %xmm12
        movapd  %xmm7, %xmm4
        movapd  376(%rsp), %xmm7
        addpd   %xmm2, %xmm1
        movapd  %xmm13, %xmm2
        mulpd   %xmm10, %xmm2
        movapd  152(%rsp), %xmm10
        addpd   360(%rsp), %xmm2
        addpd   %xmm15, %xmm2
        movapd  %xmm13, %xmm15
        mulpd   %xmm9, %xmm15
        movapd  %xmm12, %xmm9
        addpd   %xmm15, %xmm2
        addpd   %xmm2, %xmm4
        movapd  %xmm7, %xmm2
        addpd   %xmm3, %xmm4
        movapd  168(%rsp), %xmm3
        addpd   %xmm6, %xmm4
        movapd  8(%rsp), %xmm6
        mulpd   -88(%rsp), %xmm4
        mulpd   %xmm6, %xmm2
        addpd   392(%rsp), %xmm2
        mulpd   %xmm10, %xmm6
        mulpd   %xmm3, %xmm10
        addpd   %xmm6, %xmm2
        movapd  %xmm7, %xmm6
        movapd  %xmm12, %xmm7
        mulpd   %xmm3, %xmm6
        addpd   %xmm6, %xmm2
        movapd  408(%rsp), %xmm6
        addpd   %xmm10, %xmm2
        movapd  40(%rsp), %xmm10
        addpd   %xmm4, %xmm2
        movdqa  24(%rsp), %xmm4
        movapd  %xmm4, %xmm15
        mulpd   %xmm10, %xmm15
        addpd   %xmm2, %xmm1
        movapd  %xmm6, %xmm2
        mulpd   %xmm4, %xmm2
        addpd   424(%rsp), %xmm2
        mulpd   %xmm8, %xmm6
        mulpd   %xmm8, %xmm10
        movapd  %xmm12, %xmm8
        mulpd   -120(%rsp), %xmm1
        addpd   %xmm15, %xmm2
        addpd   %xmm6, %xmm2
        movapd  %xmm10, %xmm3
        addpd   %xmm2, %xmm3
        addpd   %xmm3, %xmm1
        addpd   %xmm1, %xmm7
        mulpd   (%rax), %xmm7
        movabsq $.LCPOW_329, %rax
        movapd  (%rax), %xmm2
        movabsq $.LCPOW_330, %rax
        cvtpd2dq        %xmm7, %xmm7
        cvtdq2pd        %xmm7, %xmm7
        mulpd   %xmm7, %xmm2
        cvtpd2dq        %xmm7, %xmm3
        mulpd   (%rax), %xmm7
        movabsq $.LCPOW_363, %rax
        addpd   %xmm2, %xmm9
        movapd  %xmm9, %xmm15
        subpd   %xmm12, %xmm15
        movapd  %xmm15, %xmm4
        movapd  %xmm9, %xmm15
        addpd   %xmm7, %xmm15
        subpd   %xmm4, %xmm2
        movapd  %xmm15, %xmm6
        movapd  %xmm15, %xmm10
        movapd  %xmm9, %xmm15
        subpd   %xmm4, %xmm15
        subpd   %xmm9, %xmm10
        subpd   %xmm15, %xmm8
        subpd   %xmm10, %xmm7
        addpd   %xmm8, %xmm2
        movapd  %xmm6, %xmm8
        addpd   %xmm2, %xmm1
        movapd  %xmm6, %xmm2
        subpd   %xmm10, %xmm2
        subpd   %xmm2, %xmm9
        movapd  %xmm6, %xmm2
        addpd   %xmm7, %xmm9
        addpd   %xmm9, %xmm1
        addpd   %xmm1, %xmm2
        movapd  %xmm2, %xmm15
        subpd   %xmm2, %xmm8
        mulpd   %xmm2, %xmm15
        addpd   %xmm1, %xmm8
        movapd  %xmm15, %xmm7
        movapd  %xmm15, %xmm4
        mulpd   %xmm15, %xmm7
        movapd  (%rax), %xmm15
        movapd  %xmm4, %xmm10
        movabsq $.LCPOW_364, %rax
        andpd   %xmm0, %xmm10
        mulpd   %xmm2, %xmm15
        movapd  %xmm15, %xmm6
        addpd   (%rax), %xmm6
        movabsq $.LCPOW_365, %rax
        movapd  (%rax), %xmm15
        movabsq $.LCPOW_366, %rax
        mulpd   %xmm2, %xmm15
        mulpd   %xmm4, %xmm6
        movapd  %xmm15, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCPOW_367, %rax
        movapd  (%rax), %xmm15
        movabsq $.LCPOW_368, %rax
        mulpd   %xmm2, %xmm15
        addpd   %xmm1, %xmm6
        mulpd   %xmm7, %xmm6
        mulpd   %xmm7, %xmm7
        movapd  %xmm15, %xmm5
        addpd   (%rax), %xmm5
        movabsq $.LCPOW_369, %rax
        movapd  (%rax), %xmm15
        movabsq $.LCPOW_370, %rax
        mulpd   %xmm2, %xmm15
        mulpd   %xmm4, %xmm5
        movapd  %xmm15, %xmm1
        addpd   (%rax), %xmm1
        movabsq $.LCPOW_371, %rax
        movapd  (%rax), %xmm9
        movabsq $.LCPOW_372, %rax
        mulpd   %xmm2, %xmm9
        addpd   %xmm5, %xmm1
        addpd   (%rax), %xmm9
        movabsq $.LCPOW_342, %rax
        cmpltpd (%rax), %xmm12
        movabsq $.LCPOW_331, %rax
        addpd   %xmm1, %xmm6
        mulpd   %xmm9, %xmm7
        movapd  -72(%rsp), %xmm9
        movapd  %xmm6, %xmm15
        addpd   %xmm2, %xmm9
        addpd   %xmm7, %xmm15
        movapd  %xmm4, %xmm7
        movapd  %xmm9, %xmm13
        subpd   %xmm10, %xmm7
        movapd  %xmm15, %xmm1
        movapd  %xmm2, %xmm15
        andpd   %xmm0, %xmm15
        movaps  %xmm7, -88(%rsp)
        andpd   %xmm1, %xmm0
        movapd  %xmm1, %xmm7
        movapd  %xmm15, %xmm6
        movapd  %xmm2, %xmm15
        subpd   %xmm0, %xmm7
        subpd   %xmm6, %xmm15
        movapd  %xmm7, %xmm11
        movapd  %xmm14, %xmm7
        movapd  %xmm15, %xmm5
        movapd  %xmm14, %xmm15
        xorpd   %xmm4, %xmm15
        mulpd   %xmm1, %xmm4
        xorpd   %xmm4, %xmm7
        addpd   %xmm4, %xmm13
        movaps  %xmm7, -56(%rsp)
        movdqa  %xmm3, %xmm7
        paddd   -40(%rsp), %xmm3
        psrad   $1, %xmm7
        psubd   %xmm7, %xmm3
        paddd   -40(%rsp), %xmm7
        movaps  %xmm12, -40(%rsp)
        movapd  %xmm6, %xmm12
        addpd   %xmm6, %xmm12
        mulpd   %xmm6, %xmm6
        pshufd  $115, %xmm3, %xmm3
        pshufd  $115, %xmm7, %xmm7
        pand    -24(%rsp), %xmm7
        pand    -24(%rsp), %xmm3
        mulpd   %xmm5, %xmm12
        pslld   $20, %xmm7
        mulpd   %xmm5, %xmm5
        pslld   $20, %xmm3
        addpd   %xmm15, %xmm6
        movapd  %xmm8, %xmm15
        addpd   %xmm8, %xmm15
        addpd   %xmm12, %xmm6
        movapd  -72(%rsp), %xmm12
        addpd   %xmm5, %xmm6
        movapd  %xmm15, %xmm5
        mulpd   %xmm2, %xmm5
        addpd   %xmm5, %xmm6
        movapd  -56(%rsp), %xmm5
        mulpd   %xmm6, %xmm1
        movapd  %xmm10, %xmm6
        mulpd   %xmm0, %xmm6
        mulpd   %xmm11, %xmm10
        addpd   %xmm6, %xmm5
        movapd  -88(%rsp), %xmm6
        mulpd   %xmm6, %xmm0
        mulpd   %xmm11, %xmm6
        addpd   %xmm5, %xmm0
        addpd   %xmm10, %xmm0
        movapd  -120(%rsp), %xmm10
        addpd   %xmm6, %xmm0
        movdqa  -40(%rsp), %xmm6
        addpd   %xmm0, %xmm1
        movapd  %xmm12, %xmm0
        subpd   %xmm9, %xmm0
        subpd   %xmm13, %xmm9
        addpd   %xmm2, %xmm0
        addpd   %xmm4, %xmm9
        movapd  (%rax), %xmm4
        movabsq $.LCPOW_152, %rax
        cmpltpd -104(%rsp), %xmm4
        addpd   %xmm8, %xmm0
        addpd   %xmm9, %xmm0
        addpd   %xmm1, %xmm0
        addpd   %xmm0, %xmm13
        movapd  (%rax), %xmm0
        movabsq $.LCPOW_326, %rax
        mulpd   %xmm13, %xmm7
        movapd  -8(%rsp), %xmm13
        movapd  %xmm13, %xmm2
        mulpd   %xmm7, %xmm3
        movapd  232(%rsp), %xmm7
        movapd  %xmm7, %xmm1
        andnpd  (%rax), %xmm1
        movabsq $.LCPOW_145, %rax
        pandn   %xmm3, %xmm6
        movdqa  264(%rsp), %xmm3
        pand    248(%rsp), %xmm3
        movdqa  %xmm6, %xmm11
        movapd  %xmm4, %xmm6
        andpd   %xmm0, %xmm4
        pand    %xmm7, %xmm3
        andnpd  %xmm11, %xmm6
        movapd  200(%rsp), %xmm11
        orpd    %xmm6, %xmm4
        movapd  %xmm3, %xmm6
        andpd   %xmm3, %xmm2
        andnpd  %xmm12, %xmm6
        orpd    %xmm6, %xmm2
        andpd   %xmm7, %xmm2
        orpd    %xmm1, %xmm2
        pxor    %xmm1, %xmm1
        movapd  %xmm1, %xmm7
        cmpltpd %xmm11, %xmm7
        movapd  %xmm7, %xmm5
        andpd   %xmm12, %xmm7
        andnpd  %xmm2, %xmm5
        movapd  %xmm13, %xmm2
        movapd  280(%rsp), %xmm13
        orpd    %xmm5, %xmm7
        movdqa  (%rax), %xmm5
        movabsq $.LCPOW_373, %rax
        addpd   %xmm13, %xmm2
        mulpd   %xmm7, %xmm4
        pand    %xmm10, %xmm5
        pxor    %xmm5, %xmm2
        movapd  %xmm2, %xmm8
        cmpltpd %xmm1, %xmm2
        cmpeqpd %xmm1, %xmm8
        movapd  %xmm8, %xmm5
        andpd   %xmm12, %xmm8
        andnpd  %xmm0, %xmm5
        orpd    %xmm5, %xmm8
        movdqa  %xmm2, %xmm5
        movapd  216(%rsp), %xmm2
        pandn   %xmm8, %xmm5
        cmpeqpd %xmm0, %xmm2
        cmpeqpd %xmm13, %xmm0
        movapd  %xmm2, %xmm7
        andpd   %xmm2, %xmm5
        andnpd  %xmm4, %xmm7
        movapd  %xmm11, %xmm4
        cmpeqpd %xmm1, %xmm4
        orpd    %xmm7, %xmm5
        movapd  %xmm14, %xmm7
        xorpd   %xmm10, %xmm7
        movapd  %xmm4, %xmm2
        andpd   %xmm4, %xmm7
        orpd    %xmm0, %xmm4
        andnpd  %xmm10, %xmm2
        movapd  %xmm11, %xmm0
        orpd    %xmm2, %xmm7
        cmpeqpd %xmm12, %xmm0
        movapd  %xmm14, %xmm2
        cmpltpd %xmm1, %xmm7
        pandn   (%rax), %xmm7
        andpd   %xmm11, %xmm2
        movabsq $.LCPOW_314, %rax
        pxor    (%rax), %xmm2
        cmpeqpd %xmm10, %xmm1
        addq    $448, %rsp
        andpd   %xmm2, %xmm3
        movapd  %xmm4, %xmm2
        orpd    %xmm6, %xmm3
        andnpd  %xmm5, %xmm2
        orpd    %xmm1, %xmm0
        mulpd   %xmm7, %xmm3
        movapd  %xmm0, %xmm1
        andpd   %xmm12, %xmm0
        andpd   %xmm3, %xmm4
        movapd  %xmm11, %xmm3
        orpd    %xmm2, %xmm4
        cmpneqpd        %xmm11, %xmm3
        movapd  %xmm10, %xmm2
        cmpneqpd        %xmm10, %xmm2
        orpd    %xmm3, %xmm2
        por     %xmm2, %xmm4
        andnpd  %xmm4, %xmm1
        orpd    %xmm1, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_powd2_u10sse2, .-.LSleef_powd2_u10sse2
        .set .Lxpow_u1, .LSleef_powd2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCPOW_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCPOW_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCPOW_4:
        .long   0
        .long   -1074790400
        .long   0
        .long   -1074790400
        .align 16
.LCPOW_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCPOW_83:
        .long   1431655765
        .long   1073042773
        .long   1431655765
        .long   1073042773
        .align 16
.LCPOW_89:
        .long   1023
        .long   1023
        .long   0
        .long   0
        .align 16
.LCPOW_90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCPOW_99:
        .long   -17155601
        .long   1072049730
        .long   -17155601
        .long   1072049730
        .align 16
.LCPOW_108:
        .long   -134217728
        .long   1072049730
        .long   -134217728
        .long   1072049730
        .align 16
.LCPOW_109:
        .long   -1140850688
        .long   1045162215
        .long   -1140850688
        .long   1045162215
        .align 16
.LCPOW_110:
        .long   993624127
        .long   1014676638
        .long   993624127
        .long   1014676638
        .align 16
.LCPOW_119:
        .quad   4294967297
        .quad   0
        .align 16
.LCPOW_145:
        .quad   -9223372036854775808
        .quad   -9223372036854775808
        .align 16
.LCPOW_146:
        .quad   -134217728
        .quad   -134217728
        .align 16
.LCPOW_149:
        .quad   8791798056959
        .quad   0
        .align 16
.LCPOW_150:
        .long   0
        .long   -1042284544
        .long   0
        .long   -1042284544
        .align 16
.LCPOW_152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCPOW_178:
        .long   1
        .long   1
        .long   0
        .long   0
        .align 16
.LCPOW_234:
        .long   0
        .long   1040187392
        .long   0
        .long   1040187392
        .align 16
.LCPOW_273:
        .long   0
        .long   1128267776
        .long   0
        .long   1128267776
        .align 16
.LCPOW_314:
        .quad   4607182418800017408
        .quad   4607182418800017408
        .align 16
.LCPOW_315:
        .long   0
        .long   1048576
        .long   0
        .long   1048576
        .align 16
.LCPOW_316:
        .long   0
        .long   1139802112
        .long   0
        .long   1139802112
        .align 16
.LCPOW_317:
        .long   -1023
        .long   -1023
        .long   0
        .long   0
        .align 16
.LCPOW_318:
        .long   -1087
        .long   -1087
        .long   0
        .long   0
        .align 16
.LCPOW_326:
        .long   0
        .long   2146959360
        .long   0
        .long   2146959360
        .align 16
.LCPOW_328:
        .long   1697350398
        .long   1073157447
        .long   1697350398
        .long   1073157447
        .align 16
.LCPOW_329:
        .long   -17158144
        .long   -1075433918
        .long   -17158144
        .long   -1075433918
        .align 16
.LCPOW_330:
        .long   -226956058
        .long   -1118577046
        .long   -226956058
        .long   -1118577046
        .align 16
.LCPOW_331:
        .long   -32494461
        .long   1082535490
        .long   -32494461
        .long   1082535490
        .align 16
.LCPOW_342:
        .long   0
        .long   -1064353792
        .long   0
        .long   -1064353792
        .align 16
.LCPOW_350:
        .long   1830722833
        .long   1069182442
        .long   1830722833
        .long   1069182442
        .align 16
.LCPOW_351:
        .long   -547386102
        .long   1069425965
        .long   -547386102
        .long   1069425965
        .align 16
.LCPOW_352:
        .long   -2069789092
        .long   1069617395
        .long   -2069789092
        .long   1069617395
        .align 16
.LCPOW_353:
        .long   -1324814383
        .long   1069789499
        .long   -1324814383
        .long   1069789499
        .align 16
.LCPOW_354:
        .long   1917377265
        .long   1070024145
        .long   1917377265
        .long   1070024145
        .align 16
.LCPOW_355:
        .long   477501823
        .long   1070363079
        .long   477501823
        .long   1070363079
        .align 16
.LCPOW_356:
        .long   -1840700928
        .long   1070745892
        .long   -1840700928
        .long   1070745892
        .align 16
.LCPOW_357:
        .long   -1717986917
        .long   1071225241
        .long   -1717986917
        .long   1071225241
        .align 16
.LCPOW_358:
        .long   166139091
        .long   1069400812
        .long   166139091
        .long   1069400812
        .align 16
.LCPOW_359:
        .long   1431655765
        .long   1071994197
        .long   1431655765
        .long   1071994197
        .align 16
.LCPOW_360:
        .long   1342177280
        .long   1071994197
        .long   1342177280
        .long   1071994197
        .align 16
.LCPOW_361:
        .long   1409286144
        .long   1044731221
        .long   1409286144
        .long   1044731221
        .align 16
.LCPOW_362:
        .long   0
        .long   1015410688
        .long   0
        .long   1015410688
        .align 16
.LCPOW_363:
        .long   -763550114
        .long   1053236703
        .long   -763550114
        .long   1053236703
        .align 16
.LCPOW_364:
        .long   -328447717
        .long   1056571801
        .long   -328447717
        .long   1056571801
        .align 16
.LCPOW_365:
        .long   450937661
        .long   1059717536
        .long   450937661
        .long   1059717536
        .align 16
.LCPOW_366:
        .long   405335163
        .long   1062650220
        .long   405335163
        .long   1062650220
        .align 16
.LCPOW_367:
        .long   286325608
        .long   1065423121
        .long   286325608
        .long   1065423121
        .align 16
.LCPOW_368:
        .long   1431637648
        .long   1067799893
        .long   1431637648
        .long   1067799893
        .align 16
.LCPOW_369:
        .long   1431655768
        .long   1069897045
        .long   1431655768
        .long   1069897045
        .align 16
.LCPOW_370:
        .long   9
        .long   1071644672
        .long   9
        .long   1071644672
        .align 16
.LCPOW_371:
        .long   -720087367
        .long   1046148441
        .long   -720087367
        .long   1046148441
        .align 16
.LCPOW_372:
        .long   1768797613
        .long   1049791119
        .long   1768797613
        .long   1049791119
        .align 16
.LCPOW_373:
        .quad   9218868437227405312
        .quad   9218868437227405312
