        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_sind2_u10sse2, @function
.LSleef_sind2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCSIN0, %rax
        subq    $16, %rsp
        movapd  %xmm0, %xmm15
        movabsq $.LCSIN153, %rdx
        movapd  (%rax), %xmm0
        movapd  %xmm0, %xmm2
        andnpd  %xmm15, %xmm2
        movapd  %xmm2, %xmm1
        cmpltpd (%rdx), %xmm1
        pmovmskb        %xmm1, %edx
        cmpl    $65535, %edx
        jne     2f
        movabsq $.LCSIN154, %rdx
        movapd  (%rdx), %xmm0
        movabsq $.LCSIN155, %rdx
        movapd  (%rdx), %xmm1
        movabsq $.LCSIN156, %rdx
        mulpd   %xmm15, %xmm0
        cvtpd2dq        %xmm0, %xmm0
        cvtdq2pd        %xmm0, %xmm0
        mulpd   %xmm0, %xmm1
        cvtpd2dq        %xmm0, %xmm11
        mulpd   (%rdx), %xmm0
        addpd   %xmm15, %xmm1
        movapd  %xmm1, %xmm8
        addpd   %xmm0, %xmm8
        subpd   %xmm8, %xmm1
        addpd   %xmm0, %xmm1
0:
        movabsq $.LCSIN146, %rdi
        movdqa  %xmm8, %xmm4
        movabsq $.LCSIN7, %rsi
        movabsq $.LCSIN119, %rcx
        movabsq $.LCSIN178, %rdx
1:
        movapd  %xmm8, %xmm2
        movapd  (%rax), %xmm5
        movdqa  (%rcx), %xmm14
        movabsq $.LCSIN190, %rax
        mulpd   %xmm8, %xmm2
        movapd  (%rax), %xmm0
        pand    (%rdi), %xmm4
        movabsq $.LCSIN191, %rax
        movapd  %xmm5, %xmm7
        pand    %xmm11, %xmm14
        movapd  %xmm8, %xmm6
        subpd   %xmm4, %xmm6
        movapd  %xmm4, %xmm11
        mulpd   %xmm4, %xmm11
        mulpd   %xmm2, %xmm0
        xorpd   %xmm2, %xmm7
        movapd  %xmm2, %xmm13
        movaps  %xmm7, -40(%rsp)
        movapd  %xmm2, %xmm7
        addpd   (%rax), %xmm0
        movabsq $.LCSIN192, %rax
        mulpd   %xmm2, %xmm7
        movapd  (%rax), %xmm3
        addpd   -40(%rsp), %xmm11
        movabsq $.LCSIN193, %rax
        mulpd   %xmm2, %xmm3
        addpd   (%rax), %xmm3
        movabsq $.LCSIN194, %rax
        mulpd   %xmm7, %xmm0
        mulpd   %xmm7, %xmm7
        addpd   %xmm3, %xmm0
        movapd  (%rax), %xmm3
        movabsq $.LCSIN195, %rax
        mulpd   %xmm2, %xmm3
        addpd   (%rax), %xmm3
        movabsq $.LCSIN196, %rax
        mulpd   %xmm7, %xmm3
        addpd   %xmm3, %xmm0
        mulpd   %xmm2, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCSIN189, %rax
        movapd  (%rax), %xmm3
        movabsq $.LCSIN3, %rax
        movapd  %xmm0, %xmm7
        movaps  %xmm3, -24(%rsp)
        mulpd   %xmm2, %xmm7
        movapd  %xmm7, %xmm9
        movaps  %xmm7, -56(%rsp)
        movapd  (%rax), %xmm7
        movabsq $.LCSIN145, %rax
        addpd   %xmm3, %xmm9
        movapd  (%rsi), %xmm3
        movapd  %xmm9, %xmm10
        movapd  %xmm9, %xmm12
        movapd  %xmm9, %xmm0
        mulpd   %xmm2, %xmm12
        andpd   %xmm3, %xmm10
        subpd   %xmm10, %xmm0
        movaps  %xmm0, -88(%rsp)
        movapd  %xmm2, %xmm0
        andpd   %xmm3, %xmm0
        xorpd   %xmm12, %xmm5
        subpd   %xmm0, %xmm13
        movaps  %xmm5, -8(%rsp)
        movapd  %xmm12, %xmm5
        addpd   %xmm7, %xmm5
        movaps  %xmm13, -72(%rsp)
        movapd  %xmm3, %xmm13
        andpd   %xmm5, %xmm13
        movapd  %xmm5, %xmm3
        movaps  %xmm5, -104(%rsp)
        subpd   -104(%rsp), %xmm7
        subpd   %xmm13, %xmm3
        pxor    %xmm5, %xmm5
        cmpeqpd %xmm15, %xmm5
        addpd   %xmm7, %xmm12
        movaps  %xmm3, -120(%rsp)
        movdqa  %xmm14, %xmm3
        movapd  %xmm4, %xmm14
        movapd  -120(%rsp), %xmm7
        addpd   %xmm4, %xmm14
        pcmpeqd (%rdx), %xmm3
        mulpd   %xmm6, %xmm14
        pshufd  $80, %xmm3, %xmm3
        pand    (%rax), %xmm3
        addpd   %xmm14, %xmm11
        movapd  %xmm6, %xmm14
        mulpd   %xmm6, %xmm14
        addpd   %xmm11, %xmm14
        movapd  %xmm1, %xmm11
        addpd   %xmm1, %xmm11
        mulpd   %xmm13, %xmm1
        mulpd   %xmm8, %xmm11
        movapd  %xmm10, %xmm8
        mulpd   %xmm0, %xmm8
        addpd   -8(%rsp), %xmm8
        addpd   %xmm11, %xmm14
        movapd  -88(%rsp), %xmm11
        mulpd   %xmm11, %xmm0
        mulpd   %xmm9, %xmm14
        addpd   %xmm8, %xmm0
        movapd  -72(%rsp), %xmm8
        mulpd   %xmm8, %xmm10
        addpd   %xmm10, %xmm0
        movapd  %xmm11, %xmm10
        mulpd   %xmm8, %xmm10
        addpd   %xmm10, %xmm0
        addpd   %xmm14, %xmm0
        movapd  -24(%rsp), %xmm14
        subpd   %xmm9, %xmm14
        addpd   -56(%rsp), %xmm14
        addq    $16, %rsp
        mulpd   %xmm14, %xmm2
        addpd   %xmm2, %xmm0
        addpd   %xmm0, %xmm12
        mulpd   %xmm4, %xmm12
        addpd   %xmm12, %xmm1
        movapd  %xmm7, %xmm12
        mulpd   %xmm6, %xmm12
        mulpd   %xmm4, %xmm7
        mulpd   %xmm13, %xmm6
        mulpd   %xmm13, %xmm4
        addpd   %xmm12, %xmm1
        addpd   %xmm7, %xmm1
        addpd   %xmm1, %xmm6
        movapd  %xmm5, %xmm1
        andpd   %xmm15, %xmm5
        movapd  %xmm5, %xmm0
        addpd   %xmm6, %xmm4
        pxor    %xmm3, %xmm4
        andnpd  %xmm4, %xmm1
        orpd    %xmm1, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .p2align 4,,10
        .p2align 3
2:
        movabsq $.LCSIN157, %rdx
        movapd  %xmm2, %xmm1
        cmpltpd (%rdx), %xmm1
        pmovmskb        %xmm1, %edx
        cmpl    $65535, %edx
        jne     3f
        movabsq $.LCSIN158, %rdx
        movapd  (%rdx), %xmm2
        movabsq $.LCSIN159, %rdx
        mulpd   %xmm15, %xmm2
        cvttpd2dq       %xmm2, %xmm2
        cvtdq2pd        %xmm2, %xmm2
        mulpd   (%rdx), %xmm2
        movabsq $.LCSIN154, %rdx
        movapd  (%rdx), %xmm1
        movabsq $.LCSIN160, %rdx
        movapd  (%rdx), %xmm3
        movabsq $.LCSIN161, %rdx
        mulpd   %xmm15, %xmm1
        movapd  (%rdx), %xmm9
        movabsq $.LCSIN162, %rdx
        movapd  %xmm2, %xmm0
        movapd  %xmm2, %xmm10
        movapd  %xmm2, %xmm12
        mulpd   %xmm3, %xmm0
        mulpd   %xmm9, %xmm10
        subpd   %xmm2, %xmm1
        cvtpd2dq        %xmm1, %xmm1
        cvtdq2pd        %xmm1, %xmm1
        mulpd   %xmm1, %xmm3
        movapd  %xmm0, %xmm6
        addpd   %xmm15, %xmm6
        mulpd   %xmm1, %xmm9
        addpd   %xmm1, %xmm2
        cvtpd2dq        %xmm1, %xmm11
        movaps  %xmm6, -72(%rsp)
        movapd  %xmm3, %xmm13
        movaps  %xmm3, -56(%rsp)
        addpd   %xmm6, %xmm13
        movapd  %xmm9, %xmm4
        movapd  %xmm13, %xmm5
        addpd   %xmm10, %xmm5
        addpd   %xmm5, %xmm4
        movapd  %xmm5, %xmm6
        movapd  %xmm5, %xmm0
        subpd   %xmm13, %xmm6
        movapd  %xmm4, %xmm7
        movapd  %xmm4, %xmm8
        subpd   %xmm5, %xmm7
        movaps  %xmm6, -120(%rsp)
        subpd   -120(%rsp), %xmm0
        subpd   -120(%rsp), %xmm10
        movaps  %xmm7, -104(%rsp)
        movapd  (%rdx), %xmm7
        movabsq $.LCSIN163, %rdx
        mulpd   (%rdx), %xmm2
        mulpd   %xmm7, %xmm12
        mulpd   %xmm1, %xmm7
        movapd  %xmm13, %xmm1
        subpd   %xmm0, %xmm1
        movapd  -72(%rsp), %xmm0
        subpd   %xmm13, %xmm0
        addpd   -56(%rsp), %xmm0
        addpd   %xmm1, %xmm10
        movapd  -104(%rsp), %xmm1
        addpd   %xmm12, %xmm8
        subpd   %xmm1, %xmm9
        addpd   %xmm0, %xmm10
        movapd  %xmm4, %xmm0
        movapd  %xmm8, %xmm3
        subpd   %xmm1, %xmm0
        subpd   %xmm4, %xmm8
        movapd  %xmm3, %xmm6
        addpd   %xmm7, %xmm6
        subpd   %xmm0, %xmm5
        movaps  %xmm8, -88(%rsp)
        movapd  %xmm3, %xmm0
        movapd  %xmm6, %xmm14
        movapd  %xmm6, %xmm8
        subpd   %xmm3, %xmm14
        addpd   %xmm2, %xmm8
        addpd   %xmm9, %xmm5
        subpd   %xmm14, %xmm7
        addpd   %xmm5, %xmm10
        movapd  -88(%rsp), %xmm5
        subpd   %xmm5, %xmm0
        subpd   %xmm5, %xmm12
        subpd   %xmm0, %xmm4
        movapd  %xmm6, %xmm0
        subpd   %xmm8, %xmm6
        subpd   %xmm14, %xmm0
        addpd   %xmm12, %xmm4
        addpd   %xmm6, %xmm2
        subpd   %xmm0, %xmm3
        addpd   %xmm10, %xmm4
        addpd   %xmm7, %xmm3
        addpd   %xmm4, %xmm3
        movapd  %xmm3, %xmm1
        addpd   %xmm2, %xmm1
        {disp32} jmp 0b
        .p2align 4,,10
        .p2align 3
3:
        movabsq $.LCSIN149, %rdx
        pshufd  $13, %xmm15, %xmm4
        movabsq $.LSleef_rempitabdp, %rsi
        movabsq $.LCSIN146, %rdi
        psrld   $20, %xmm4
        pand    (%rdx), %xmm4
        movdqa  (%rdi), %xmm7
        movabsq $.LCSIN164, %rdx
        paddd   (%rdx), %xmm4
        movapd  %xmm0, %xmm10
        movabsq $.LCSIN165, %rdx
        movabsq $.LCSIN167, %r8
        movdqa  %xmm4, %xmm3
        movdqa  %xmm4, %xmm1
        psrad   $31, %xmm3
        pcmpgtd (%rdx), %xmm1
        movabsq $.LCSIN166, %rdx
        pandn   %xmm4, %xmm3
        pand    (%rdx), %xmm1
        movabsq $.LCSIN90, %rdx
        pslld   $2, %xmm3
        movd    %xmm3, %ecx
        pshufd  $85, %xmm3, %xmm3
        pshufd  $115, %xmm1, %xmm1
        movslq  %ecx, %rcx
        pand    (%rdx), %xmm1
        movd    %xmm3, %edx
        salq    $3, %rcx
        movslq  %edx, %rdx
        movsd   (%rsi,%rcx), %xmm3
        pslld   $20, %xmm1
        paddd   %xmm15, %xmm1
        movhpd  (%rsi,%rdx,8), %xmm3
        pand    %xmm1, %xmm7
        movapd  %xmm1, %xmm4
        movabsq $.LCSIN7, %rsi
        movapd  %xmm3, %xmm6
        andpd   (%rsi), %xmm6
        movapd  %xmm3, %xmm5
        mulpd   %xmm1, %xmm5
        subpd   %xmm7, %xmm4
        movapd  %xmm3, %xmm8
        movapd  %xmm6, %xmm9
        subpd   %xmm6, %xmm8
        movapd  %xmm0, %xmm3
        mulpd   %xmm7, %xmm9
        mulpd   %xmm4, %xmm6
        xorpd   %xmm5, %xmm3
        addpd   %xmm3, %xmm9
        movapd  %xmm8, %xmm3
        mulpd   %xmm7, %xmm3
        mulpd   %xmm4, %xmm8
        addpd   %xmm6, %xmm9
        movdqa  (%r8), %xmm6
        movabsq $.LCSIN10, %r8
        movaps  %xmm6, -104(%rsp)
        movdqa  %xmm6, %xmm11
        addpd   %xmm3, %xmm9
        movapd  (%r8), %xmm3
        movabsq $.LCSIN168, %r8
        movapd  (%r8), %xmm6
        movabsq $.LCSIN169, %r8
        movapd  %xmm3, %xmm12
        movaps  %xmm3, -88(%rsp)
        mulpd   %xmm5, %xmm12
        addpd   %xmm8, %xmm9
        movapd  %xmm5, %xmm8
        andpd   %xmm0, %xmm8
        movapd  %xmm6, %xmm3
        pxor    %xmm8, %xmm11
        andnpd  %xmm12, %xmm10
        cmpltpd %xmm10, %xmm3
        movapd  %xmm12, %xmm10
        addpd   %xmm11, %xmm10
        movapd  %xmm3, %xmm13
        andpd   %xmm12, %xmm3
        subpd   %xmm11, %xmm10
        por     %xmm8, %xmm10
        andnpd  %xmm10, %xmm13
        movapd  %xmm6, %xmm10
        orpd    %xmm3, %xmm13
        movapd  %xmm0, %xmm3
        andnpd  %xmm5, %xmm3
        cmpltpd %xmm3, %xmm10
        movapd  %xmm5, %xmm3
        addpd   %xmm11, %xmm3
        subpd   %xmm11, %xmm3
        por     %xmm8, %xmm3
        movapd  %xmm10, %xmm8
        andnpd  %xmm3, %xmm8
        movapd  %xmm10, %xmm3
        movapd  (%r8), %xmm10
        movabsq $.LCSIN170, %r8
        andpd   %xmm5, %xmm3
        orpd    %xmm8, %xmm3
        movaps  %xmm10, -56(%rsp)
        mulpd   %xmm10, %xmm3
        addpd   %xmm13, %xmm3
        cvttpd2dq       %xmm3, %xmm3
        movaps  %xmm3, -72(%rsp)
        movapd  (%r8), %xmm3
        movabsq $.LSleef_rempitabdp+8, %r8
        movsd   (%r8,%rcx), %xmm8
        mulpd   %xmm3, %xmm13
        movapd  %xmm3, %xmm14
        movhpd  (%r8,%rdx,8), %xmm8
        addq    $8, %r8
        addpd   %xmm5, %xmm13
        movapd  %xmm9, %xmm5
        addpd   %xmm13, %xmm5
        movapd  %xmm13, %xmm3
        movapd  (%rsi), %xmm13
        andpd   %xmm8, %xmm13
        movapd  %xmm13, %xmm11
        movapd  %xmm8, %xmm13
        subpd   %xmm5, %xmm3
        mulpd   %xmm1, %xmm8
        subpd   %xmm11, %xmm13
        addpd   %xmm9, %xmm3
        movapd  %xmm13, %xmm12
        movapd  %xmm0, %xmm13
        xorpd   %xmm8, %xmm13
        movaps  %xmm13, -40(%rsp)
        movapd  %xmm5, %xmm13
        addpd   %xmm8, %xmm13
        movapd  %xmm13, %xmm10
        subpd   %xmm5, %xmm13
        movaps  %xmm13, -120(%rsp)
        movapd  %xmm11, %xmm13
        movapd  -120(%rsp), %xmm9
        mulpd   %xmm4, %xmm11
        mulpd   %xmm7, %xmm13
        subpd   %xmm9, %xmm8
        addpd   -40(%rsp), %xmm13
        addpd   %xmm13, %xmm11
        movapd  %xmm12, %xmm13
        mulpd   %xmm7, %xmm13
        mulpd   %xmm4, %xmm12
        addpd   %xmm13, %xmm11
        movapd  %xmm10, %xmm13
        subpd   %xmm9, %xmm13
        movapd  %xmm0, %xmm9
        addpd   %xmm12, %xmm11
        movapd  %xmm6, %xmm12
        subpd   %xmm13, %xmm5
        addpd   %xmm3, %xmm11
        addpd   %xmm8, %xmm5
        movapd  %xmm10, %xmm8
        andpd   %xmm0, %xmm8
        movapd  %xmm11, %xmm13
        movdqa  -104(%rsp), %xmm11
        addpd   %xmm5, %xmm13
        movapd  -88(%rsp), %xmm5
        pxor    %xmm8, %xmm11
        mulpd   %xmm10, %xmm5
        movaps  %xmm13, -120(%rsp)
        andnpd  %xmm5, %xmm9
        cmpltpd %xmm9, %xmm12
        movapd  %xmm5, %xmm9
        addpd   %xmm11, %xmm9
        movapd  %xmm12, %xmm3
        subpd   %xmm11, %xmm9
        andpd   %xmm3, %xmm5
        por     %xmm8, %xmm9
        andnpd  %xmm9, %xmm12
        movapd  %xmm13, %xmm9
        orpd    %xmm5, %xmm12
        movapd  %xmm0, %xmm5
        andnpd  %xmm10, %xmm5
        cmpltpd %xmm5, %xmm6
        movapd  %xmm10, %xmm5
        addpd   %xmm11, %xmm5
        movapd  %xmm5, %xmm3
        movapd  %xmm6, %xmm5
        andpd   %xmm10, %xmm6
        subpd   %xmm11, %xmm3
        movapd  %xmm0, %xmm11
        por     %xmm3, %xmm8
        andnpd  %xmm8, %xmm5
        movapd  %xmm5, %xmm3
        orpd    %xmm6, %xmm3
        movsd   (%r8,%rcx), %xmm6
        mulpd   -56(%rsp), %xmm3
        movhpd  (%r8,%rdx,8), %xmm6
        addpd   %xmm12, %xmm3
        mulpd   %xmm14, %xmm12
        cvttpd2dq       %xmm3, %xmm3
        movapd  %xmm12, %xmm5
        movapd  %xmm6, %xmm12
        addpd   %xmm10, %xmm5
        movapd  (%rsi), %xmm10
        andpd   %xmm6, %xmm10
        subpd   %xmm10, %xmm12
        mulpd   %xmm1, %xmm6
        movapd  %xmm10, %xmm14
        mulpd   %xmm7, %xmm14
        addpd   %xmm5, %xmm9
        mulpd   %xmm4, %xmm10
        movapd  %xmm12, %xmm13
        mulpd   %xmm13, %xmm7
        movapd  %xmm9, %xmm8
        subpd   %xmm9, %xmm5
        mulpd   %xmm13, %xmm4
        xorpd   %xmm6, %xmm11
        addpd   %xmm6, %xmm8
        addpd   %xmm14, %xmm11
        movapd  %xmm0, %xmm13
        movapd  %xmm8, %xmm12
        addpd   %xmm7, %xmm11
        subpd   %xmm9, %xmm12
        movapd  %xmm8, %xmm7
        addpd   %xmm10, %xmm11
        subpd   %xmm12, %xmm6
        addpd   %xmm4, %xmm11
        movsd   8(%r8,%rcx), %xmm4
        addq    $8, %r8
        addpd   -120(%rsp), %xmm5
        movabsq $.LCSIN119, %rcx
        paddd   -72(%rsp), %xmm3
        movhpd  (%r8,%rdx,8), %xmm4
        movabsq $.LCSIN171, %rdx
        movabsq $.LCSIN179, %r8
        mulpd   %xmm1, %xmm4
        addpd   %xmm11, %xmm4
        movapd  (%rsi), %xmm11
        addpd   %xmm4, %xmm5
        movapd  %xmm8, %xmm4
        subpd   %xmm12, %xmm4
        subpd   %xmm4, %xmm9
        addpd   %xmm9, %xmm6
        movapd  (%rdx), %xmm9
        movabsq $.LCSIN172, %rdx
        addpd   %xmm5, %xmm6
        movapd  %xmm0, %xmm5
        andnpd  %xmm1, %xmm5
        cmpltpd (%rdx), %xmm5
        movabsq $.LCSIN173, %rdx
        addpd   %xmm6, %xmm7
        movapd  %xmm5, %xmm4
        andpd   %xmm5, %xmm1
        movapd  %xmm7, %xmm12
        andpd   %xmm7, %xmm11
        movapd  %xmm7, %xmm10
        mulpd   %xmm9, %xmm12
        subpd   %xmm11, %xmm10
        subpd   %xmm7, %xmm8
        addpd   %xmm8, %xmm6
        xorpd   %xmm12, %xmm13
        andnpd  %xmm12, %xmm4
        movapd  (%rdx), %xmm12
        movabsq $.LCSIN174, %rdx
        mulpd   %xmm9, %xmm6
        orpd    %xmm1, %xmm4
        movapd  %xmm11, %xmm1
        mulpd   %xmm12, %xmm1
        andpd   %xmm4, %xmm0
        mulpd   %xmm10, %xmm12
        addpd   %xmm13, %xmm1
        addpd   %xmm12, %xmm1
        movapd  (%rdx), %xmm12
        movabsq $.LCSIN175, %rdx
        mulpd   %xmm12, %xmm11
        mulpd   %xmm12, %xmm10
        addpd   %xmm11, %xmm1
        addpd   %xmm10, %xmm1
        movapd  (%rdx), %xmm10
        movabsq $.LCSIN176, %rdx
        movdqa  (%rdx), %xmm11
        movabsq $.LCSIN120, %rdx
        mulpd   %xmm7, %xmm10
        pand    %xmm3, %xmm11
        paddd   %xmm11, %xmm11
        addpd   %xmm10, %xmm1
        addpd   %xmm1, %xmm6
        movdqa  (%rcx), %xmm1
        pandn   %xmm6, %xmm5
        pxor    %xmm6, %xmm6
        cmpltpd %xmm4, %xmm6
        pshufd  $8, %xmm6, %xmm6
        movdqa  %xmm6, %xmm7
        pand    (%rdx), %xmm6
        movabsq $.LCSIN177, %rdx
        movdqa  (%rdx), %xmm8
        pandn   %xmm1, %xmm7
        movabsq $.LCSIN178, %rdx
        por     %xmm7, %xmm6
        movapd  %xmm4, %xmm7
        pxor    %xmm0, %xmm8
        paddd   %xmm6, %xmm11
        movdqa  %xmm1, %xmm6
        addpd   %xmm8, %xmm7
        pand    %xmm3, %xmm6
        movapd  %xmm4, %xmm1
        pcmpeqd (%rdx), %xmm6
        psrad   $2, %xmm11
        pxor    (%r8), %xmm0
        movabsq $.LCSIN152, %r8
        cmpeqpd (%r8), %xmm2
        movapd  %xmm7, %xmm9
        movapd  %xmm7, %xmm10
        subpd   %xmm4, %xmm9
        pshufd  $80, %xmm6, %xmm3
        movapd  %xmm3, %xmm6
        andnpd  %xmm5, %xmm6
        addpd   %xmm0, %xmm5
        subpd   %xmm9, %xmm10
        subpd   %xmm9, %xmm8
        subpd   %xmm10, %xmm1
        addpd   %xmm8, %xmm1
        addpd   %xmm5, %xmm1
        andpd   %xmm3, %xmm1
        orpd    %xmm6, %xmm1
        movapd  %xmm1, %xmm0
        movapd  %xmm3, %xmm1
        andpd   %xmm7, %xmm3
        andnpd  %xmm4, %xmm1
        movapd  %xmm15, %xmm4
        orpd    %xmm3, %xmm1
        cmpneqpd        %xmm15, %xmm4
        movapd  %xmm0, %xmm3
        addpd   %xmm1, %xmm3
        orpd    %xmm4, %xmm2
        subpd   %xmm3, %xmm1
        movdqa  %xmm2, %xmm4
        por     %xmm3, %xmm4
        movapd  %xmm4, %xmm8
        addpd   %xmm0, %xmm1
        {disp32} jmp 1b
        .size   .LSleef_sind2_u10sse2, .-.LSleef_sind2_u10sse2
        .set .Lxsin_u1, .LSleef_sind2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCSIN0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCSIN3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCSIN7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCSIN10:
        .long   0
        .long   1074790400
        .long   0
        .long   1074790400
        .align 16
.LCSIN90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCSIN119:
        .quad   4294967297
        .quad   0
        .align 16
.LCSIN120:
        .quad   8589934594
        .quad   0
        .align 16
.LCSIN145:
        .quad   -9223372036854775808
        .quad   -9223372036854775808
        .align 16
.LCSIN146:
        .quad   -134217728
        .quad   -134217728
        .align 16
.LCSIN149:
        .quad   8791798056959
        .quad   0
        .align 16
.LCSIN152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCSIN153:
        .long   0
        .long   1076756480
        .long   0
        .long   1076756480
        .align 16
.LCSIN154:
        .long   1841940611
        .long   1070882608
        .long   1841940611
        .long   1070882608
        .align 16
.LCSIN155:
        .long   1413754136
        .long   -1073143301
        .long   1413754136
        .long   -1073143301
        .align 16
.LCSIN156:
        .long   856972295
        .long   -1130256858
        .long   856972295
        .long   -1130256858
        .align 16
.LCSIN157:
        .long   512753664
        .long   1121369284
        .long   512753664
        .long   1121369284
        .align 16
.LCSIN158:
        .long   1841940611
        .long   1045716784
        .long   1841940611
        .long   1045716784
        .align 16
.LCSIN159:
        .long   0
        .long   1097859072
        .long   0
        .long   1097859072
        .align 16
.LCSIN160:
        .long   1342177280
        .long   -1073143301
        .long   1342177280
        .long   -1073143301
        .align 16
.LCSIN161:
        .long   1610612736
        .long   -1100934988
        .long   1610612736
        .long   -1100934988
        .align 16
.LCSIN162:
        .long   805306368
        .long   -1130256858
        .long   805306368
        .long   -1130256858
        .align 16
.LCSIN163:
        .long   923219018
        .long   -1158110496
        .long   923219018
        .long   -1158110496
        .align 16
.LCSIN164:
        .long   -1078
        .long   -1078
        .long   0
        .long   0
        .align 16
.LCSIN165:
        .long   645
        .long   645
        .long   0
        .long   0
        .align 16
.LCSIN166:
        .quad   -270582939712
        .quad   0
        .align 16
.LCSIN167:
        .quad   4841369599423283200
        .quad   4841369599423283200
        .align 16
.LCSIN168:
        .long   0
        .long   1127219200
        .long   0
        .long   1127219200
        .align 16
.LCSIN169:
        .long   0
        .long   -1072693248
        .long   0
        .long   -1072693248
        .align 16
.LCSIN170:
        .long   0
        .long   -1076887552
        .long   0
        .long   -1076887552
        .align 16
.LCSIN171:
        .long   1413754136
        .long   1075388923
        .long   1413754136
        .long   1075388923
        .align 16
.LCSIN172:
        .long   1717986918
        .long   1072064102
        .long   1717986918
        .long   1072064102
        .align 16
.LCSIN173:
        .long   1342177280
        .long   1075388923
        .long   1342177280
        .long   1075388923
        .align 16
.LCSIN174:
        .long   1610612736
        .long   1047597236
        .long   1610612736
        .long   1047597236
        .align 16
.LCSIN175:
        .long   856972295
        .long   1018275366
        .long   856972295
        .long   1018275366
        .align 16
.LCSIN176:
        .quad   12884901891
        .quad   0
        .align 16
.LCSIN177:
        .quad   -4613618979930100456
        .quad   -4613618979930100456
        .align 16
.LCSIN178:
        .long   1
        .long   1
        .long   0
        .long   0
        .align 16
.LCSIN179:
        .quad   -4858919839960114169
        .quad   -4858919839960114169
        .align 16
.LCSIN189:
        .long   1431655765
        .long   -1077586603
        .long   1431655765
        .long   -1077586603
        .align 16
.LCSIN190:
        .long   1953521511
        .long   1038488124
        .long   1953521511
        .long   1038488124
        .align 16
.LCSIN191:
        .long   1269442905
        .long   -1101339067
        .long   1269442905
        .long   -1101339067
        .align 16
.LCSIN192:
        .long   -1524237331
        .long   1053236707
        .long   -1524237331
        .long   1053236707
        .align 16
.LCSIN193:
        .long   436290085
        .long   -1087766112
        .long   436290085
        .long   -1087766112
        .align 16
.LCSIN194:
        .long   62042397
        .long   1021870362
        .long   62042397
        .long   1021870362
        .align 16
.LCSIN195:
        .long   -1137601712
        .long   -1117068254
        .long   -1137601712
        .long   -1117068254
        .align 16
.LCSIN196:
        .long   286331065
        .long   1065423121
        .long   286331065
        .long   1065423121
