        #
        # Generated from Naoki Shibata's SLEEF 3.5.1
        # Copyright (C) Naoki Shibata and contributors 2010 - 2020.
        #
        # SLEEF 3.5.1 is distributed under the Boost Software License,
        # Version 1.0. (http://www.boost.org/LICENSE_1_0.txt)
        #
        .section .text,"ax",@progbits

        # The argument is passed in xmm0, and the result is returned in xmm0
        .p2align 4,0x90
        .type   .LSleef_sinhd2_u10sse2, @function
.LSleef_sinhd2_u10sse2:
        # begin added prologue
        pushq   %rbp
        movq    %rsp, %rbp
        andq    $-16, %rsp      # force align the stack on 16-byte
        # save total FPU status
        subq    $512,%rsp       # allocate 512 byte FPU save area
        fxsave64 (%rsp)
        subq    $8, %rsp        # re-misalign stack by 8 bytes for SLEEF
        # end added prologue
        movabsq $.LCSINH_0, %rax
        subq    $352, %rsp
        pxor    %xmm7, %xmm7
        movapd  (%rax), %xmm6
        movaps  %xmm0, 168(%rsp)
        movabsq $.LCSINH_328, %rax
        movapd  %xmm6, %xmm10
        andnpd  %xmm0, %xmm10
        movapd  %xmm10, %xmm1
        addpd   %xmm7, %xmm1
        mulpd   (%rax), %xmm1
        movabsq $.LCSINH_329, %rax
        movapd  (%rax), %xmm4
        movabsq $.LCSINH_330, %rax
        cvtpd2dq        %xmm1, %xmm1
        cvtdq2pd        %xmm1, %xmm1
        mulpd   %xmm1, %xmm4
        cvtpd2dq        %xmm1, %xmm5
        mulpd   (%rax), %xmm1
        movabsq $.LCSINH_7, %rax
        movapd  %xmm4, %xmm3
        addpd   %xmm10, %xmm3
        movapd  %xmm1, %xmm2
        movapd  %xmm3, %xmm9
        movapd  %xmm3, %xmm1
        movapd  %xmm3, %xmm11
        subpd   %xmm10, %xmm9
        addpd   %xmm2, %xmm1
        movapd  %xmm3, %xmm0
        subpd   %xmm9, %xmm11
        movapd  %xmm1, %xmm8
        subpd   %xmm9, %xmm4
        subpd   %xmm3, %xmm8
        movapd  %xmm10, %xmm3
        movapd  %xmm6, %xmm9
        subpd   %xmm11, %xmm3
        subpd   %xmm8, %xmm2
        addpd   %xmm4, %xmm3
        movapd  %xmm1, %xmm4
        subpd   %xmm8, %xmm4
        addpd   %xmm7, %xmm3
        movapd  %xmm1, %xmm7
        subpd   %xmm4, %xmm0
        mulpd   %xmm1, %xmm7
        movapd  %xmm1, %xmm4
        addpd   %xmm2, %xmm0
        movapd  %xmm1, %xmm2
        xorpd   %xmm7, %xmm9
        movapd  %xmm7, %xmm11
        movapd  %xmm7, %xmm12
        addpd   %xmm0, %xmm3
        mulpd   %xmm7, %xmm12
        movapd  %xmm3, %xmm15
        movapd  (%rax), %xmm3
        movabsq $.LCSINH_374, %rax
        movapd  (%rax), %xmm14
        movaps  %xmm15, -104(%rsp)
        movabsq $.LCSINH_375, %rax
        andpd   %xmm3, %xmm2
        movapd  %xmm2, %xmm13
        movapd  %xmm2, %xmm8
        subpd   %xmm2, %xmm4
        addpd   %xmm2, %xmm13
        mulpd   %xmm2, %xmm8
        mulpd   %xmm1, %xmm14
        movapd  %xmm13, %xmm0
        mulpd   %xmm4, %xmm0
        addpd   %xmm9, %xmm8
        addpd   %xmm8, %xmm0
        movapd  %xmm4, %xmm8
        mulpd   %xmm4, %xmm8
        addpd   %xmm8, %xmm0
        movapd  %xmm15, %xmm8
        addpd   %xmm15, %xmm8
        movapd  %xmm0, %xmm13
        movapd  %xmm7, %xmm0
        mulpd   %xmm1, %xmm8
        andpd   %xmm3, %xmm0
        subpd   %xmm0, %xmm11
        movaps  %xmm0, 184(%rsp)
        movapd  %xmm14, %xmm0
        addpd   (%rax), %xmm0
        movabsq $.LCSINH_376, %rax
        movapd  (%rax), %xmm14
        movabsq $.LCSINH_377, %rax
        mulpd   %xmm7, %xmm0
        movaps  %xmm11, 8(%rsp)
        mulpd   %xmm1, %xmm14
        addpd   %xmm8, %xmm13
        movapd  %xmm12, %xmm8
        movapd  %xmm6, %xmm12
        xorpd   %xmm8, %xmm12
        movaps  %xmm12, 200(%rsp)
        movaps  %xmm13, -8(%rsp)
        movapd  %xmm8, %xmm13
        movapd  %xmm14, %xmm9
        addpd   (%rax), %xmm9
        andpd   %xmm3, %xmm13
        movabsq $.LCSINH_378, %rax
        movapd  (%rax), %xmm14
        movabsq $.LCSINH_379, %rax
        mulpd   %xmm1, %xmm14
        addpd   %xmm9, %xmm0
        mulpd   %xmm8, %xmm0
        movapd  %xmm14, %xmm9
        addpd   (%rax), %xmm9
        movabsq $.LCSINH_380, %rax
        movapd  (%rax), %xmm14
        movabsq $.LCSINH_381, %rax
        mulpd   %xmm1, %xmm14
        mulpd   %xmm7, %xmm9
        movapd  %xmm14, %xmm11
        addpd   (%rax), %xmm11
        movapd  %xmm8, %xmm14
        movabsq $.LCSINH_382, %rax
        mulpd   %xmm8, %xmm14
        addpd   %xmm11, %xmm9
        movapd  %xmm1, %xmm11
        addpd   %xmm9, %xmm0
        movapd  (%rax), %xmm9
        movabsq $.LCSINH_383, %rax
        mulpd   %xmm1, %xmm9
        addpd   (%rax), %xmm9
        movabsq $.LCSINH_384, %rax
        movapd  (%rax), %xmm12
        movabsq $.LCSINH_2, %rax
        movaps  %xmm12, 216(%rsp)
        mulpd   %xmm14, %xmm9
        movapd  %xmm12, %xmm14
        movapd  %xmm6, %xmm12
        mulpd   %xmm1, %xmm14
        addpd   %xmm9, %xmm0
        xorpd   %xmm14, %xmm12
        movaps  %xmm14, 24(%rsp)
        movaps  %xmm12, 232(%rsp)
        movapd  (%rax), %xmm12
        movabsq $.LCSINH_3, %rax
        movaps  %xmm0, -120(%rsp)
        movapd  (%rax), %xmm0
        movabsq $.LCSINH_89, %rax
        movapd  %xmm12, %xmm9
        movaps  %xmm12, -72(%rsp)
        addpd   %xmm14, %xmm9
        mulpd   %xmm9, %xmm11
        movapd  %xmm9, %xmm14
        andpd   %xmm3, %xmm14
        movapd  %xmm14, %xmm15
        movapd  %xmm9, %xmm14
        subpd   %xmm15, %xmm14
        movapd  %xmm11, %xmm12
        xorpd   %xmm6, %xmm12
        movaps  %xmm14, 40(%rsp)
        movaps  %xmm12, 248(%rsp)
        movaps  %xmm11, 56(%rsp)
        addpd   %xmm0, %xmm11
        movaps  %xmm13, 296(%rsp)
        movapd  %xmm11, %xmm14
        movapd  %xmm11, %xmm12
        andpd   %xmm3, %xmm14
        movaps  %xmm14, 264(%rsp)
        subpd   %xmm14, %xmm12
        movaps  %xmm12, 72(%rsp)
        movapd  %xmm1, %xmm12
        mulpd   %xmm11, %xmm12
        movapd  %xmm12, %xmm14
        movaps  %xmm12, 88(%rsp)
        addpd   %xmm0, %xmm12
        xorpd   %xmm6, %xmm14
        movaps  %xmm14, 280(%rsp)
        movapd  %xmm8, %xmm14
        subpd   %xmm13, %xmm14
        movapd  -120(%rsp), %xmm13
        movaps  %xmm12, 104(%rsp)
        movaps  %xmm14, 120(%rsp)
        movapd  %xmm13, %xmm14
        andpd   %xmm3, %xmm14
        movaps  %xmm14, -56(%rsp)
        movapd  %xmm13, %xmm14
        subpd   -56(%rsp), %xmm13
        mulpd   %xmm14, %xmm8
        movapd  %xmm12, %xmm14
        movdqa  (%rax), %xmm12
        movabsq $.LCSINH_90, %rax
        movaps  %xmm13, 136(%rsp)
        addpd   %xmm8, %xmm14
        movapd  %xmm8, %xmm13
        movaps  %xmm8, 152(%rsp)
        movdqa  %xmm5, %xmm8
        psrad   $1, %xmm8
        paddd   %xmm12, %xmm5
        xorpd   %xmm6, %xmm13
        movaps  %xmm13, 312(%rsp)
        psubd   %xmm8, %xmm5
        paddd   %xmm12, %xmm8
        movaps  %xmm14, -88(%rsp)
        movdqa  (%rax), %xmm14
        pshufd  $115, %xmm5, %xmm5
        movabsq $.LCSINH_342, %rax
        pshufd  $115, %xmm8, %xmm8
        pand    %xmm14, %xmm5
        pand    %xmm14, %xmm8
        pslld   $20, %xmm5
        pslld   $20, %xmm8
        movdqa  %xmm5, %xmm13
        movapd  %xmm10, %xmm5
        movaps  %xmm8, -24(%rsp)
        cmpltpd (%rax), %xmm5
        movaps  %xmm13, -40(%rsp)
        movapd  %xmm2, %xmm13
        movabsq $.LCSINH_385, %rax
        movapd  %xmm5, %xmm12
        movapd  -88(%rsp), %xmm5
        mulpd   -24(%rsp), %xmm5
        movdqa  %xmm12, %xmm8
        movaps  %xmm12, 328(%rsp)
        mulpd   -40(%rsp), %xmm5
        pandn   %xmm5, %xmm8
        movapd  (%rax), %xmm5
        movabsq $.LCSINH_386, %rax
        movdqa  %xmm8, %xmm12
        movapd  %xmm2, %xmm8
        mulpd   %xmm5, %xmm8
        addpd   232(%rsp), %xmm8
        mulpd   %xmm4, %xmm5
        addpd   %xmm5, %xmm8
        movapd  (%rax), %xmm5
        movabsq $.LCSINH_146, %rax
        mulpd   %xmm5, %xmm13
        mulpd   %xmm4, %xmm5
        movapd  %xmm13, %xmm14
        movapd  216(%rsp), %xmm13
        addpd   %xmm8, %xmm14
        mulpd   -104(%rsp), %xmm13
        movapd  -72(%rsp), %xmm8
        subpd   %xmm9, %xmm8
        addpd   %xmm14, %xmm5
        movapd  %xmm13, %xmm14
        movapd  24(%rsp), %xmm13
        addpd   %xmm5, %xmm14
        movapd  %xmm2, %xmm5
        mulpd   %xmm15, %xmm5
        addpd   %xmm8, %xmm13
        movapd  248(%rsp), %xmm8
        addpd   %xmm14, %xmm13
        movapd  40(%rsp), %xmm14
        addpd   %xmm5, %xmm8
        movapd  %xmm14, %xmm5
        mulpd   %xmm2, %xmm5
        mulpd   %xmm1, %xmm13
        addpd   %xmm5, %xmm8
        movapd  %xmm15, %xmm5
        movapd  %xmm14, %xmm15
        mulpd   %xmm4, %xmm5
        mulpd   %xmm4, %xmm15
        addpd   %xmm8, %xmm5
        movapd  -104(%rsp), %xmm8
        movapd  88(%rsp), %xmm14
        mulpd   %xmm8, %xmm9
        addpd   %xmm5, %xmm15
        movapd  280(%rsp), %xmm5
        addpd   %xmm9, %xmm15
        movapd  %xmm0, %xmm9
        subpd   %xmm11, %xmm9
        addpd   56(%rsp), %xmm9
        mulpd   %xmm8, %xmm11
        addpd   %xmm15, %xmm13
        addpd   %xmm13, %xmm9
        mulpd   %xmm9, %xmm1
        movapd  264(%rsp), %xmm9
        movapd  %xmm9, %xmm15
        mulpd   %xmm2, %xmm15
        mulpd   %xmm4, %xmm9
        addpd   %xmm15, %xmm5
        movapd  72(%rsp), %xmm15
        mulpd   %xmm15, %xmm2
        mulpd   %xmm15, %xmm4
        movapd  %xmm0, %xmm15
        addpd   %xmm5, %xmm2
        movapd  -56(%rsp), %xmm5
        addpd   %xmm9, %xmm2
        movdqa  328(%rsp), %xmm9
        addpd   %xmm4, %xmm2
        movapd  104(%rsp), %xmm4
        subpd   %xmm4, %xmm15
        subpd   -88(%rsp), %xmm4
        addpd   %xmm11, %xmm2
        movapd  8(%rsp), %xmm11
        addpd   %xmm15, %xmm14
        movapd  296(%rsp), %xmm15
        addpd   %xmm2, %xmm1
        addpd   %xmm14, %xmm1
        movapd  152(%rsp), %xmm14
        addpd   %xmm4, %xmm14
        movapd  184(%rsp), %xmm4
        movapd  %xmm4, %xmm2
        addpd   %xmm4, %xmm2
        mulpd   %xmm4, %xmm4
        addpd   %xmm14, %xmm1
        addpd   200(%rsp), %xmm4
        mulpd   %xmm11, %xmm2
        addpd   %xmm2, %xmm4
        movapd  %xmm11, %xmm2
        mulpd   %xmm11, %xmm2
        movapd  120(%rsp), %xmm11
        addpd   %xmm4, %xmm2
        movapd  -8(%rsp), %xmm4
        addpd   %xmm4, %xmm4
        mulpd   %xmm7, %xmm4
        movapd  136(%rsp), %xmm7
        addpd   %xmm2, %xmm4
        mulpd   -120(%rsp), %xmm4
        movapd  %xmm15, %xmm2
        mulpd   %xmm5, %xmm2
        addpd   312(%rsp), %xmm2
        mulpd   %xmm11, %xmm5
        mulpd   %xmm7, %xmm15
        addpd   %xmm5, %xmm2
        movapd  -40(%rsp), %xmm5
        movapd  %xmm15, %xmm8
        addpd   %xmm2, %xmm8
        movapd  %xmm11, %xmm2
        mulpd   %xmm7, %xmm2
        addpd   %xmm2, %xmm8
        movapd  %xmm0, %xmm2
        divpd   %xmm12, %xmm2
        addpd   %xmm4, %xmm8
        movapd  -24(%rsp), %xmm4
        addpd   %xmm8, %xmm1
        mulpd   %xmm1, %xmm4
        movdqa  (%rax), %xmm1
        movabsq $.LCSINH_387, %rax
        pand    %xmm12, %xmm1
        movdqa  %xmm1, %xmm8
        mulpd   %xmm4, %xmm5
        movapd  %xmm12, %xmm4
        pandn   %xmm5, %xmm9
        movapd  %xmm12, %xmm5
        subpd   %xmm1, %xmm5
        movapd  %xmm12, %xmm1
        andpd   %xmm2, %xmm3
        movapd  %xmm2, %xmm7
        subpd   %xmm2, %xmm4
        movapd  %xmm3, %xmm11
        subpd   %xmm3, %xmm7
        mulpd   %xmm8, %xmm11
        mulpd   %xmm5, %xmm3
        subpd   %xmm4, %xmm1
        mulpd   %xmm7, %xmm8
        mulpd   %xmm7, %xmm5
        movapd  168(%rsp), %xmm7
        subpd   %xmm2, %xmm1
        subpd   %xmm11, %xmm0
        addpd   %xmm9, %xmm1
        mulpd   %xmm2, %xmm9
        subpd   %xmm8, %xmm0
        subpd   %xmm3, %xmm0
        subpd   %xmm5, %xmm0
        subpd   %xmm9, %xmm0
        mulpd   %xmm2, %xmm0
        movapd  (%rax), %xmm2
        movabsq $.LCSINH_152, %rax
        cmpltpd %xmm10, %xmm2
        subpd   %xmm0, %xmm1
        addpd   %xmm4, %xmm1
        mulpd   -72(%rsp), %xmm1
        movapd  %xmm1, %xmm3
        cmpneqpd        %xmm1, %xmm3
        movapd  %xmm3, %xmm0
        orpd    %xmm2, %xmm0
        movapd  %xmm0, %xmm2
        andpd   (%rax), %xmm0
        addq    $352, %rsp
        andnpd  %xmm1, %xmm2
        movapd  %xmm0, %xmm1
        orpd    %xmm2, %xmm1
        movapd  %xmm7, %xmm2
        cmpneqpd        %xmm7, %xmm2
        andpd   %xmm6, %xmm7
        movapd  %xmm7, %xmm0
        pxor    %xmm1, %xmm0
        por     %xmm2, %xmm0
        # begin added epilogue
        movq    %xmm0,%rax
        addq    $8, %rsp        # remove our mis-alignment padding
        # restore total FPU status
        fxrstor64 (%rsp)
        # 512 byte FPU save area gets deallocated as part of the stack frame
        movq    %rax,%xmm0
        movq    %rbp, %rsp
        popq    %rbp
        # end added epilogue
        retq
        .size   .LSleef_sinhd2_u10sse2, .-.LSleef_sinhd2_u10sse2
        .set .Lxsinh_u1, .LSleef_sinhd2_u10sse2

        .section .rodata,"a",@progbits

        .align 16
.LCSINH_0:
        .long   0
        .long   -2147483648
        .long   0
        .long   -2147483648
        .align 16
.LCSINH_2:
        .long   0
        .long   1071644672
        .long   0
        .long   1071644672
        .align 16
.LCSINH_3:
        .long   0
        .long   1072693248
        .long   0
        .long   1072693248
        .align 16
.LCSINH_7:
        .long   -134217728
        .long   -1
        .long   -134217728
        .long   -1
        .align 16
.LCSINH_89:
        .long   1023
        .long   1023
        .long   0
        .long   0
        .align 16
.LCSINH_90:
        .quad   -4294967296
        .quad   -4294967296
        .align 16
.LCSINH_146:
        .quad   -134217728
        .quad   -134217728
        .align 16
.LCSINH_152:
        .long   0
        .long   2146435072
        .long   0
        .long   2146435072
        .align 16
.LCSINH_328:
        .long   1697350398
        .long   1073157447
        .long   1697350398
        .long   1073157447
        .align 16
.LCSINH_329:
        .long   -17158144
        .long   -1075433918
        .long   -17158144
        .long   -1075433918
        .align 16
.LCSINH_330:
        .long   -226956058
        .long   -1118577046
        .long   -226956058
        .long   -1118577046
        .align 16
.LCSINH_342:
        .long   0
        .long   -1064353792
        .long   0
        .long   -1064353792
        .align 16
.LCSINH_374:
        .long   -401589578
        .long   1046144594
        .long   -401589578
        .long   1046144594
        .align 16
.LCSINH_375:
        .long   -1784056228
        .long   1049787980
        .long   -1784056228
        .long   1049787980
        .align 16
.LCSINH_376:
        .long   -1591904682
        .long   1053236707
        .long   -1591904682
        .long   1053236707
        .align 16
.LCSINH_377:
        .long   452391095
        .long   1056571808
        .long   452391095
        .long   1056571808
        .align 16
.LCSINH_378:
        .long   436391938
        .long   1059717536
        .long   436391938
        .long   1059717536
        .align 16
.LCSINH_379:
        .long   381765068
        .long   1062650220
        .long   381765068
        .long   1062650220
        .align 16
.LCSINH_380:
        .long   286331161
        .long   1065423121
        .long   286331161
        .long   1065423121
        .align 16
.LCSINH_381:
        .long   1431655770
        .long   1067799893
        .long   1431655770
        .long   1067799893
        .align 16
.LCSINH_382:
        .long   -1467541172
        .long   1038485042
        .long   -1467541172
        .long   1038485042
        .align 16
.LCSINH_383:
        .long   -179820068
        .long   1042413802
        .long   -179820068
        .long   1042413802
        .align 16
.LCSINH_384:
        .long   1431655765
        .long   1069897045
        .long   1431655765
        .long   1069897045
        .align 16
.LCSINH_385:
        .long   1342177280
        .long   1069897045
        .long   1342177280
        .long   1069897045
        .align 16
.LCSINH_386:
        .long   1409286144
        .long   1042634069
        .long   1409286144
        .long   1042634069
        .align 16
.LCSINH_387:
        .long   0
        .long   1082535936
        .long   0
        .long   1082535936
