10 REM RECURSIVE QUICKSORT
20 OPTION BASE 1
30 REM B IS STACK POINTER IN L/H/P STACKS, 0 IS EMPTY STACK
40 REM M IS NUMBER OF ELEMENTS USED IN ARRAY A
50 REM ARRAY A HAS THE DATA TO SORT
60 REM ARRAY L HAS THE LOW INDEX, H HAS THE HIGH INDEX
70 REM ARRAY P HAS THE PIVOT INDEX
80 LET B=0
90 RANDOMIZE
100 LET M=1000
110 DIM A(1000),L(50),H(50),P(50)
120 FOR I=1 TO M STEP 1
130 LET A(I)=INT(RND*100000)
140 NEXT I
150 PRINT "UNSORTED LIST"
160 GOSUB 400
170 LET B=B+1
180 LET L(B)=1
190 LET H(B)=M
200 GOSUB 1000
210 PRINT "SORTED LIST"
220 GOSUB 500
230 STOP
400 REM SUBROUTINE TO PRINT ARRAY A CONTENTS
410 FOR I=1 TO M STEP 1
420 PRINT "A(";I;")=";A(I)
430 NEXT I
440 RETURN
500 REM SUBROUTINE TO PRINT ARRAY A CONTENTS
510 REM AND CHECK THEY ARE SORTED
520 FOR I=1 TO M-1 STEP 1
530 IF A(I)<=A(I+1) THEN 550
540 PRINT "SORT ERROR AT THIS SLOT ";
550 PRINT "A(";I;")=";A(I)
560 NEXT I
570 PRINT "A(";M;")=";A(M)
580 RETURN
1000 REM SUBROUTINE TO SORT ARRAY A CONTENTS
1010 IF L(B)>=H(B) THEN 5000
1020 GOSUB 6000
1030 LET B=B+1
1032 IF B<=50 THEN 1040
1034 PRINT "STACK FULL"
1036 STOP
1040 LET L(B)=L(B-1)
1050 LET H(B)=P(B-1)-1
1060 GOSUB 1000
1070 REM RECYCLE STACK SLOTS SO NO CHANGE FOR B
1080 LET L(B)=P(B-1)+1
1090 LET H(B)=H(B-1)
1100 GOSUB 1000
1110 LET B=B-1
5000 RETURN
6000 REM PARTITION ARRAY A FROM L(B) TO H(B) INTO LOW AND HIGH WITH
6010 REM PIVOT IN POSITION P(B)
6020 REM CHOOSE PIVOT INDEX P1 MEDIAN OF 3
6030 LET X1=L(B)
6040 LET X2=L(B)+(H(B)-L(B))/2
6050 LET X3=H(B)
6060 IF X1<=X2 THEN 6100
6070 LET T=X1
6080 LET X1=X2
6090 LET X2=T
6100 IF X2<=X3 THEN 6140
6110 LET T=X2
6120 LET X2=X3
6130 LET X3=T
6140 IF X2>=X1 THEN 6180
6150 LET T=X1
6160 LET X1=X2
6170 LET X2=T
6180 LET P1=X2
6190 REM CHOOSE PIVOT VALUE P2
6200 LET P2=A(P1)
6210 REM PUT CHOSEN PIVOT AT A(H)
6220 LET T=A(P1)
6230 LET A(P1)=A(H(B))
6240 LET A(H(B))=T
6250 REM STORE INDEX VALUE P
6260 LET P(B)=L(B)
6270 FOR I=L(B) TO H(B)-1 STEP 1
6280 IF A(I)>=P2 THEN 6330
6290 LET T=A(I)
6300 LET A(I)=A(P(B))
6310 LET A(P(B))=T
6320 LET P(B)=P(B)+1
6330 NEXT I
6340 LET T=A(P(B))
6350 LET A(P(B))=A(H(B))
6360 LET A(H(B))=T
6370 RETURN
9999 END
