PROGRAM FILE 389: ACCURACY OF LOG2 FUNCTION.                                    
    ECMA-116 STANDARD                                                           
                                                                                
SECTION 389.1: ACCURACY OF LOG2 FUNCTION.                                       
                                                                                
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                        
LOG2 FUNCTION FOR ACCURACY.                                                     
                                                                                
THIS TEST IS INFORMATIVE ONLY, SINCE THE ECMA-116 STANDARD                      
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                           
                                                                                
              BEGIN TEST                                                        
                                                                                
  ARGUMENT        TRUE         COMPUTED         ACTUAL                          
   VALUE         ANSWER         ANSWER          ERROR                           
------------   ------------   ------------   ------------                       
 1.E-38        -126.233       -126.233           EXACT      OK                  
 1.00001E-38   -126.233       -126.233           EXACT      OK                  
 9.87654E-38   -122.929       -122.929           EXACT      OK                  
 8.98989E-37   -119.743       -119.743           EXACT      OK                  
 7.87878E-36   -116.611       -116.611           EXACT      OK                  
 6.76767E-35   -113.509       -113.509           EXACT      OK                  
 5.65656E-30   -97.1579       -97.1579           EXACT      OK                  
 4.54545E-25   -80.8638       -80.8638           EXACT      OK                  
 3.43434E-20   -64.6585       -64.6585           EXACT      OK                  
 2.32323E-15   -48.6128       -48.6128           EXACT      OK                  
 1.21212E-10   -32.9417       -32.9417           EXACT      OK                  
 9.0909E-07    -20.0691       -20.0691           EXACT      OK                  
 8.88888E-05   -13.4576       -13.4576           EXACT      OK                  
 7.77777E-04   -10.3284       -10.3284           EXACT      OK                  
 6.66666E-03   -7.22882       -7.22882           EXACT      OK                  
 5.55555E-02   -4.16993       -4.16993           EXACT      OK                  
 .123456       -3.01793       -3.01793           EXACT      OK                  
 .298347       -1.74494       -1.74494           EXACT      OK                  
 .535353       -.901438       -.901438           EXACT      OK                  
 .893481       -.162491       -.162491        1.49012E-08   OK                  
 .999          -1.44342E-03   -1.4434E-03     1.851E-08     OK                  
 .9995         -7.21528E-04   -7.21562E-04    3.37604E-08   OK                  
 .9999         -1.44277E-04   -1.44301E-04    2.39379E-08   OK                  
 .99995        -7.21366E-05   -7.21485E-05    1.1969E-08    OK                  
 .99999        -1.4427E-05    -1.44466E-05    1.95923E-08   OK                  
 .999995       -7.21349E-06   -7.22329E-06    9.79617E-09   OK                  
 .999998       -2.88539E-06   -2.92371E-06    3.83152E-08   OK                  
 .999999       -1.4427E-06    -1.46185E-06    1.91575E-08   OK                  
 1              0              0                 EXACT      OK                  
 1.00001        1.44269E-05    1.44465E-05    1.95923E-08   OK                  
 1.00002        2.88536E-05    2.88928E-05    3.91847E-08   OK                  
 1.00005        7.21329E-05    7.20589E-05    7.40183E-08   OK                  
 1.0001         1.44262E-04    1.44286E-04    2.39379E-08   OK                  
 1.0003         4.32744E-04    4.32815E-04    7.17991E-08   OK                  
 1.001          1.44197E-03    1.44204E-03    6.72881E-08   OK                  
 1.003          4.32161E-03    4.32164E-03    3.0268E-08    OK                  
 1.01           1.43553E-02    1.43553E-02    1.30385E-08   OK                  
 1.03           4.26443E-02    4.26443E-02    4.09782E-08   OK                  
 1.11111        .152002        .152002        2.98023E-08   OK                  
 1.54321        .625934        .625934           EXACT      OK                  
 2              1              1                 EXACT      OK                  
 2.32323        1.21613        1.21613           EXACT      OK                  
 2.71828        1.44269        1.44269           EXACT      OK                  
 4              2              2                 EXACT      OK                  
 7.14286        2.8365         2.8365            EXACT      OK                  
 8              3              3                 EXACT      OK                  
 53.6789        5.74628        5.74628           EXACT      OK                  
 482.284        8.91374        8.91374           EXACT      OK                  
 9621.12        13.232         13.232            EXACT      OK                  
 86321.4        16.3974        16.3974           EXACT      OK                  
 777777         19.569         19.569            EXACT      OK                  
 9.87654E+07    26.5575        26.5575           EXACT      OK                  
 8.98989E+10    36.3876        36.3876           EXACT      OK                  
 7.97979E+15    52.8253        52.8253           EXACT      OK                  
 6.96969E+20    69.2397        69.2397           EXACT      OK                  
 5.95959E+25    85.6234        85.6234           EXACT      OK                  
 4.94949E+30    101.965        101.965           EXACT      OK                  
 3.93939E+35    118.245        118.245           EXACT      OK                  
 9.87654E+36    122.893        122.893           EXACT      OK                  
 9.87654E+37    126.215        126.215           EXACT      OK                  
 1.E+38         126.233        126.233           EXACT      OK                  
                                                                                
          *** TEST PASSED ***                                                   
                                                                                
               END TEST                                                         
                                                                                
