PROGRAM FILE 6: PRINT-SEPARATORS, TABS,                                                                                             
        AND STRING VARIABLES.                                                                                                       
    ANSI STANDARD 6.2, 6.4, 9.4, 12.2, 12.4                                                                                         
                                                                                                                                    
SECTION 6.1: SEMICOLON SEPARATOR WITH QUOTED STRINGS.                                                                               
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
                                1. 123                                                                                              
                                2. 123                                                                                              
                                3. 123                                                                                              
                                4. 123                                                                                              
                                5. 123                                                                                              
                                                                                                                                    
*** TEST PASSED IF THERE ARE EXACTLY FIVE NUMBERED LINES                                                                            
    ABOVE, EACH CONTAINING THE ADJACENT DIGITS '123', AND                                                                           
    IF THEY ARE LINED UP IN A COLUMN ***                                                                                            
                                                                                                                                    
                                END TEST.                                                                                           
                                                                                                                                    
SECTION 6.2: THE COMMA SEPARATOR WITH QUOTED STRINGS.                                                                               
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
THE PRINT LINE SHOULD BE DIVIDED INTO EQUAL ZONES WHICH                                                                             
ENABLE THE COMMA SEPARATOR TO ACT AS A TAB WHEN PRINTING                                                                            
A SERIES OF COMMA-SEPARATED ITEMS.                                                                                                  
                                                                                                                                    
000000000111111111122222222223333333333444444444455555555556                                                                        
123456789012345678901234567890123456789012345678901234567890                                                                        
XYZ                       XYZ                       XYZ                                                                             
                                                                                                                                    
*** TEST PASSED IF 3 SETS OF THE CHARACTERS 'XYZ' ARE EVENLY                                                                        
    SPACED ON A SINGLE LINE IN THE ABOVE TEST AND WIDTH                                                                             
    OF A PRINT ZONE IS AS DOCUMENTED ***                                                                                            
                                                                                                                                    
                                  END TEST.                                                                                         
                                                                                                                                    
SECTION 6.3: TABBING QUOTED STRINGS.                                                                                                
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
000000000111111111122222222223333333333444444444455555555556                                                                        
123456789012345678901234567890123456789012345678901234567890                                                                        
                       1                                                                                                            
                                               2                                                                                    
                                                          3                                                                         
                                                                                                                                    
*** TEST PASSED IF A '1' IS PRINTED BELOW COLUMN HEADING 24.                                                                        
    A '2' BELOW 48 AND A '3' BELOW 59 IN THE ABOVE TEST  ***                                                                        
                                                                                                                                    
                                END TEST.                                                                                           
                                                                                                                                    
SECTION 6.4: THE ASSIGNMENT OF QUOTED STRINGS.                                                                                      
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
THIS TEST ASSIGNS THE SAME QUOTED STRING TO ALL LEGAL STRING                                                                        
VARIABLES: A$ THROUGH Z$, USING A SERIES OF LET-STATEMENTS.                                                                         
A$ IS ASSIGNED THE QUOTED STRING, THEN B$ IS ASSIGNED A$ ...                                                                        
THROUGH Z$ ASSIGNED Y$.                                                                                                             
                                                                                                                                    
                   Z$ = 18 CHARACTERS LONG                                                                                          
                                                                                                                                    
*** TEST PASSED IF 'Z$ = 18 CHARACTERS LONG' IS PRINTED                                                                             
    IN THE ABOVE TEST  ***                                                                                                          
                                                                                                                                    
                                END TEST.                                                                                           
                                                                                                                                    
SECTION 6.5: SEMICOLON SEPARATOR WITH ASSIGNED STRINGS                                                                              
        AND CONSTANTS.                                                                                                              
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
                              1.123                                                                                                 
                              2.123                                                                                                 
                              3.123                                                                                                 
                              4.123                                                                                                 
                              5.123                                                                                                 
                                                                                                                                    
*** TEST PASSED IF THERE ARE EXACTLY FIVE NUMBERED LINES                                                                            
    ABOVE, EACH CONTAINING THE ADJACENT DIGITS '123', AND                                                                           
    IF THEY ARE LINED UP IN A COLUMN ***                                                                                            
                                                                                                                                    
                                END TEST.                                                                                           
                                                                                                                                    
SECTION 6.6: COMMA SEPARATOR - ASSIGNED STRINGS                                                                                     
        AND CONSTANTS.                                                                                                              
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
000000000111111111122222222223333333333444444444455555555556                                                                        
123456789012345678901234567890123456789012345678901234567890                                                                        
XYZ                       XYZ                       XYZ                                                                             
                                                                                                                                    
*** TEST PASSED IF 3 SETS OF THE CHARACTERS 'XYZ' ARE                                                                               
    EVENLY SPACED ON A SINGLE LINE IN THE ABOVE TEST AND                                                                            
    WIDTH OF PRINT ZONE IS AS DOCUMENTED ***                                                                                        
                                                                                                                                    
                                END TEST.                                                                                           
                                                                                                                                    
SECTION 6.7: TABBING ASSIGNED STRINGS AND CONSTANTS.                                                                                
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
000000000111111111122222222223333333333444444444455555555556                                                                        
123456789012345678901234567890123456789012345678901234567890                                                                        
                       1                                                                                                            
                                               2                                                                                    
                                                          3                                                                         
                                                                                                                                    
*** TEST PASSED IF A '1' PRINTS BELOW COLUMN HEADING 24,                                                                            
    A '2' BELOW 48, AND A '3' BELOW 59   ***                                                                                        
                                                                                                                                    
                                END TEST.                                                                                           
                                                                                                                                    
SECTION 6.8: NULL PRINT ITEMS.                                                                                                      
                                                                                                                                    
THIS TEST DETERMINES WHETHER THE PROCESSOR RECOGNIZES                                                                               
CONSECUTIVE COMMAS IN A PRINT-STATEMENT AS TAB POSITIONS.                                                                           
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
000000000111111111122222222223333333333444444444455555555556                                                                        
123456789012345678901234567890123456789012345678901234567890                                                                        
PRINT-ZONE IDENTIFIERS:                                                                                                             
1                         2                         3                         4                                                     
                                                                              A                                                     
                                                                                                                                    
*** TEST PASSED IF AN 'A' IS IN THE BEGINNING COLUMN OF THE                                                                         
    FOURTH PRINT ZONE FOR THIS SYSTEM  ***                                                                                          
                                                                                                                                    
                               END TEST.                                                                                            
                                                                                                                                    
END PROGRAM 6                                                                                                                       
