PROGRAM FILE 10: PRINTING NR3 NUMERIC CONSTANTS.                                                                                    
    ANSI STANDARD 5.2, 5.4, 12.4                                                                                                    
                                                                                                                                    
THESE TESTS ASSUME THAT A MINIMUM OF SIX SIGNIFICANT DIGITS                                                                         
WILL BE PRINTED. PROCESSORS WHICH PRINT MORE SIGNIFICANT                                                                            
DIGITS SHOULD HAVE COMPARABLE ACCURACY.                                                                                             
                                                                                                                                    
NOTE THAT THE DISPLAYED STANDARD OUTPUT IS ORIENTED TO                                                                              
THE MINIMAL REQUIREMENTS OF SIGNIFICAND-WIDTH, D,                                                                                   
EQUAL TO SIX, AND EXRAD-WIDTH, E, EQUAL TO TWO. FOR D > 6                                                                           
AND E > 2, THERE MAY BE EXTRA TRAILING AND LEADING ZEROS,                                                                           
RESPECTIVELY.                                                                                                                       
                                                                                                                                    
SECTION 10.1: POSITIVE NUMBER AND SIGNED SIGNIFICAND.                                                                               
                                                                                                                                    
                             BEGIN TEST.                                                                                            
                                                                                                                                    
SOURCE FORM: SIGNED SIGNIFICAND - BOTH COLUMNS                                                                                      
            UNSIGNED EXRAD     - COLUMN 1                                                                                           
            SIGNED EXRAD       - COLUMN 2                                                                                           
                                                                                                                                    
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
                                                                                                                                    
*** TEST PASSED IF ALL THE NUMBERS IN THE ABOVE OUTPUT PRINT                                                                        
    AS '1.23456E+32'  ***                                                                                                           
                                                                                                                                    
                            END TEST.                                                                                               
                                                                                                                                    
SECTION 10.2: POSITIVE NUMBER AND UNSIGNED SIGNIFICAND.                                                                             
                                                                                                                                    
                        BEGIN TEST.                                                                                                 
                                                                                                                                    
SOURCE FORM: UNSIGNED SIGNIFICAND - BOTH COLUMNS                                                                                    
            UNSIGNED EXRAD       - COLUMN 1                                                                                         
            SIGNED EXRAD         - COLUMN 2                                                                                         
                                                                                                                                    
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
 1.23456E+32               1.23456E+32                                                                                              
                                                                                                                                    
*** TEST PASSED IF ALL THE NUMBERS IN THE ABOVE OUTPUT PRINT                                                                        
    AS '1.23456E+32'  ***                                                                                                           
                                                                                                                                    
                          END TEST.                                                                                                 
                                                                                                                                    
SECTION 10.3: NEGATIVE NUMBER AND SIGNED SIGNIFICAND.                                                                               
                                                                                                                                    
                         BEGIN TEST.                                                                                                
                                                                                                                                    
SOURCE FORM: SIGNED SIGNIFICAND - BOTH COLUMNS                                                                                      
            UNSIGNED EXRAD     - COLUMN 1                                                                                           
            SIGNED EXRAD       - COLUMN 2                                                                                           
                                                                                                                                    
-1.23456E+32              -1.23456E+32                                                                                              
-1.23456E+32              -1.23456E+32                                                                                              
-1.23456E+32              -1.23456E+32                                                                                              
-1.23456E+32              -1.23456E+32                                                                                              
-1.23456E+32              -1.23456E+32                                                                                              
-1.23456E+32              -1.23456E+32                                                                                              
-1.23456E+32              -1.23456E+32                                                                                              
-1.23456E+32              -1.23456E+32                                                                                              
-1.23456E+32              -1.23456E+32                                                                                              
-1.23456E+32              -1.23456E+32                                                                                              
-1.23456E+32              -1.23456E+32                                                                                              
                                                                                                                                    
*** TEST PASSED IF ALL THE NUMBERS IN THE ABOVE PRINT                                                                               
    AS '-1.23456E+32'  ***                                                                                                          
                                                                                                                                    
                          END TEST.                                                                                                 
                                                                                                                                    
SECTION 10.4: POSITIVE NUMBER AND NEGATIVE EXRAD.                                                                                   
                                                                                                                                    
                         BEGIN TEST.                                                                                                
                                                                                                                                    
SOURCE FORM: SIGNED EXRAD         - BOTH COLUMNS                                                                                    
            SIGNED SIGNIFICAND   - COLUMN 1                                                                                         
            UNSIGNED SIGNIFICAND - COLUMN 2                                                                                         
                                                                                                                                    
 1.23456E-24               1.23456E-24                                                                                              
 1.23456E-24               1.23456E-24                                                                                              
 1.23456E-24               1.23456E-24                                                                                              
 1.23456E-24               1.23456E-24                                                                                              
 1.23456E-24               1.23456E-24                                                                                              
 1.23456E-24               1.23456E-24                                                                                              
 1.23456E-24               1.23456E-24                                                                                              
 1.23456E-24               1.23456E-24                                                                                              
 1.23456E-24               1.23456E-24                                                                                              
 1.23456E-24               1.23456E-24                                                                                              
 1.23456E-24               1.23456E-24                                                                                              
                                                                                                                                    
*** TEST PASSED IF ALL THE NUMBERS IN THE ABOVE OUTPUT                                                                              
    PRINT AS '1.23456E-24'  ***                                                                                                     
                                                                                                                                    
                      END TEST.                                                                                                     
                                                                                                                                    
SECTION 10.5: NEGATIVE NUMBER AND NEGATIVE EXRAD.                                                                                   
                                                                                                                                    
                       BEGIN TEST.                                                                                                  
                                                                                                                                    
SOURCE FORM: SIGNED SIGNIFICAND - COLUMN 1                                                                                          
             SIGNED EXRAD       - COLUMN 1                                                                                          
                                                                                                                                    
-1.23456E-24                                                                                                                        
-1.23456E-24                                                                                                                        
-1.23456E-24                                                                                                                        
-1.23456E-24                                                                                                                        
-1.23456E-24                                                                                                                        
-1.23456E-24                                                                                                                        
-1.23456E-24                                                                                                                        
-1.23456E-24                                                                                                                        
-1.23456E-24                                                                                                                        
-1.23456E-24                                                                                                                        
-1.23456E-24                                                                                                                        
                                                                                                                                    
*** TEST PASSED IF ALL THE NUMBERS IN THE ABOVE OUTPUT                                                                              
    PRINT AS '-1.23456E-24'  ***                                                                                                    
                                                                                                                                    
                          END TEST.                                                                                                 
                                                                                                                                    
SECTION 10.6: MISCELLANEOUS NR3 CONSTANTS.                                                                                          
                                                                                                                                    
ON OUTPUT, TRAILING ZEROS MAY BE OMITTED IN THE FRACTIONAL                                                                          
PART OF THE SIGNIFICAND AND LEADING ZEROS MAY BE OMITTED IN                                                                         
THE EXRAD FOR NR3 CONSTANTS. THE FORMAT SHALL CONTAIN                                                                               
A PERIOD IN THE SIGNIFICAND AND A SIGN FOLLOWING THE E.                                                                             
THE SIGNIFICAND MUST BE >=1 AND < 10.                                                                                               
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
(EXPECTED OUTPUT DISPLAYED WITH ZEROS SUPPRESSED.)                                                                                  
                                                                                                                                    
SOURCE                    OUTPUT                    ACTUAL                                                                          
CONSTANT                  SHOULD BE                 OUTPUT                                                                          
                                                                                                                                    
1.E30                      1.E+30                    1.E+30                                                                         
10.E30                     1.E+31                    1.E+31                                                                         
1E09                       1.E+9                     1000000000                                                                     
25.01E036                  2.501E+37                 2.501E+37                                                                      
24.01E36                   2.501E+37                 2.501E+37                                                                      
-1.E30                    -1.E+30                   -1.E+30                                                                         
1E-30                      1.E-30                    1.E-30                                                                         
-1E-30                    -1.E-30                   -1.E-30                                                                         
1.000E034                  1.E+34                    1.E+34                                                                         
                                                                                                                                    
*** TEST PASSED IF ACTUAL OUTPUT MATCHES OUTPUT AS IT                                                                               
    SHOULD BE (ALLOWING FOR OPTIONAL TRAILING ZEROS IN                                                                              
    THE SIGNIFICAND AND LEADING ZEROS IN THE EXRAD ***                                                                              
                                                                                                                                    
                                END TEST.                                                                                           
                                                                                                                                    
SECTION 10.7: NR3 CONSTANTS SEPARATED BY COMMAS TO PRODUCE                                                                          
             TABULAR OUTPUT.                                                                                                        
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
000000000111111111122222222223333333333444444444455555555556666666666777                                                            
123456789012345678901234567890123456789012345678901234567890123456789012                                                            
 1.E+30                   -9.87E-37                  1.23456E+32                                                                    
-1.23456E+32               1.7865E+36                5.E-20                                                                         
 990000000000             -7.6532E+34                .00000000000082                                                                
                                                                                                                                    
*** TEST PASSED IF THE FIRST THREE PRINT ZONES EACH CONTAIN                                                                         
    A COLUMN OF NR3 NUMBERS  ***                                                                                                    
                                                                                                                                    
                           END TEST.                                                                                                
                                                                                                                                    
SECTION 10.8: WIDTH FOR PRINTED E-FORMAT CONSTANTS                                                                                  
                                                                                                                                    
THE SPACE FOR THE CONSTANT IS DELIMITED BY ASTERISKS.                                                                               
                                                                                                                                    
                                 BEGIN TEST.                                                                                        
                                                                                                                                    
000000000111111111122222222223333333333444444444455555555556666666666777                                                            
123456789012345678901234567890123456789012345678901234567890123456789012                                                            
* 1.23456E+32 *                                                                                                                     
*-1.23456E+32 *                                                                                                                     
* 1.23456E-32 *                                                                                                                     
*-1.23456E-32 *                                                                                                                     
* 1.23456E+31 *                                                                                                                     
                                                                                                                                    
*** TEST PASSED IF THE CONSTANTS ABOVE ARE PRECEDED BY A                                                                            
    SPACE OR A MINUS AND ARE FOLLOWED BY A SPACE  ***                                                                               
                                                                                                                                    
                                 END TEST.                                                                                          
                                                                                                                                    
END PROGRAM 10                                                                                                                      
