PROGRAM FILE 121: ACCURACY OF EXP FUNCTION.                                                                                         
    ANSI STANDARD 7.6, 8.4                                                                                                          
                                                                                                                                    
SECTION 121.1: ACCURACY OF EXP FUNCTION.                                                                                            
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
EXP FUNCTION FOR ACCURACY. THE INVOCATION MUST RETURN,                                                                              
ACCURATE TO SIX DIGITS, SOME VALUE ACTUALLY TAKEN ON BY                                                                             
THE FUNCTION WITHIN A DOMAIN BOUNDED BY THE ACTUAL ARGUMENT                                                                         
PLUS OR MINUS ONE IN THE SIXTH DIGIT. ALSO, AN                                                                                      
'ERROR MEASURE' IS COMPUTED AND REPORTED. THIS MEASURE                                                                              
IS JUST 2 * THE ABSOLUTE ERROR OVER THE SIZE OF THE RANGE;                                                                          
THUS, A VALUE JUST BARELY PASSING OR FAILING WILL USUALLY                                                                           
HAVE A MEASURE OF ABOUT  1. A VALUE 3 TIMES                                                                                         
AS INACCURATE AS EXPECTED WILL HAVE A MEASURE OF 3.                                                                                 
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ANSI STANDARD                                                                              
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
ARGUMENT                  TRUE                      COMPUTED                  ERROR                     OUTCOME                     
                          VALUE                     VALUE                     MEASURE                                               
                                                                                                                                    
ARITHMETIC UNDERFLOW ON LINE NUMBER 520                                                                                             
-87.49810028076172         1.0001334787892905E-38    1.0001331985295977E-38    0                         OK                         
-85.98760223388672         4.5295994752971613E-38    4.529589385948218E-38     .02203182317316532        OK                         
-75                        2.678636997114156E-33     2.678636997114156E-33     0                         OK  - EXACT                
-44.444400787353516        4.9893311501302393E-20    4.989327272721118E-20     7.692307699471712E-03     OK                         
-23.45669937133789         6.499570326390369E-11     6.499573795837321E-11     5.299416836351156E-03     OK                         
-7.777770042419434         4.18945390265435E-04      4.189453611616045E-04     6.211180239915848E-03     OK                         
-2.222219944000244         .10836826264858246        .10836827009916306        4.705882165580988E-03     OK                         
-1                         .3678794503211975         .3678794503211975         0                         OK  - EXACT                
-.9999989867210388         .36787980794906616        .36787980794906616        0                         OK  - EXACT                
-.4567889869213104         .6333139538764954         .6333139538764954         0                         OK  - EXACT                
-.09876540303230286        .9059551954269409         .9059551954269409         0                         OK  - EXACT                
-9.876539930701256E-03     .9901720881462097         .9901720881462097         0                         OK  - EXACT                
-9.876539697870612E-04     .99901282787323           .99901282787323           0                         OK  - EXACT                
-9.876539843389764E-05     .9999012351036072         .9999012351036072         0                         OK  - EXACT                
-9.876540389086585E-06     .9999901056289673         .9999901056289673         0                         OK  - EXACT                
-9.876539479591884E-07     .9999989867210388         .9999989867210388         0                         OK  - EXACT                
-9.876539763808978E-08     .9999998807907104         .9999998807907104         0                         OK  - EXACT                
-9.876539586173294E-09     1                         1                         0                         OK  - EXACT                
-9.876539586173294E-10     1                         1                         0                         OK  - EXACT                
-9.876539690256703E-15     1                         1                         0                         OK  - EXACT                
-9.876539745057418E-20     1                         1                         0                         OK  - EXACT                
-9.876539646795317E-30     1                         1                         0                         OK  - EXACT                
-9.876539911074916E-38     1                         1                         0                         OK  - EXACT                
 0                         1                         1                        RANGE ZERO                 OK  - EXACT                
 9.876539911074916E-38     1                         1                         0                         OK  - EXACT                
 9.876539646795317E-30     1                         1                         0                         OK  - EXACT                
 9.876539745057418E-20     1                         1                         0                         OK  - EXACT                
 9.876539690256703E-15     1                         1                         0                         OK  - EXACT                
 9.876539586173294E-10     1                         1                         0                         OK  - EXACT                
 9.876539586173294E-09     1                         1                         0                         OK  - EXACT                
 9.876539763808978E-08     1.0000001192092896        1.0000001192092896        0                         OK  - EXACT                
 9.876539479591884E-07     1.0000009536743164        1.0000009536743164        0                         OK  - EXACT                
 9.876540389086585E-06     1.0000098943710327        1.0000098943710327        0                         OK  - EXACT                
 9.876539843389764E-05     1.0000988245010376        1.0000988245010376        0                         OK  - EXACT                
 9.876539697870612E-04     1.0009881258010864        1.0009881258010864        0                         OK  - EXACT                
 9.876539930701256E-03     1.0099254846572876        1.0099254846572876        0                         OK  - EXACT                
 .09876540303230286        1.1038073301315308        1.1038073301315308        0                         OK  - EXACT                
 .4567889869213104         1.578995704650879         1.578995704650879         0                         OK  - EXACT                
 .9999989867210388         2.7182791233062744        2.7182791233062744        0                         OK  - EXACT                
 1                         2.7182817459106445        2.7182817459106445        0                         OK  - EXACT                
 2.222219944000244         9.22779369354248          9.22779369354248          0                         OK  - EXACT                
 7.777770042419434         2386.946044921875         2386.946044921875         0                         OK  - EXACT                
 23.45669937133789         15385632768               15385623552               5.800838116556406E-03     OK                         
 44.444400787353516        2.004276656528687E+19     2.004278195844966E+19     7.494646590203047E-03     OK                         
 75                        3.733241849647479E+32     3.733241849647479E+32     0                         OK  - EXACT                
 85.98760223388672         2.207700734658757E+37     2.207705551731038E+37     2.1336328238248825E-02    OK                         
 87.49810028076172         9.998665097733772E+37     9.998667125974733E+37     2.0181634463369846E-03    OK                         
                                                                                                                                    
*** INFORMATIVE TEST PASSED ***                                                                                                     
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 121                                                                                                                     
