PROGRAM FILE 124: ACCURACY OF LOG FUNCTION.                                                                                         
    ANSI STANDARD 7.6, 8.4                                                                                                          
                                                                                                                                    
SECTION 124.1: ACCURACY OF LOG FUNCTION.                                                                                            
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
LOG FUNCTION FOR ACCURACY. THE INVOCATION MUST RETURN,                                                                              
ACCURATE TO SIX DIGITS, SOME VALUE ACTUALLY TAKEN ON BY                                                                             
THE FUNCTION WITHIN A DOMAIN BOUNDED BY THE ACTUAL ARGUMENT                                                                         
PLUS OR MINUS ONE IN THE SIXTH DIGIT. ALSO, AN                                                                                      
'ERROR MEASURE' IS COMPUTED AND REPORTED. THIS MEASURE                                                                              
IS JUST 2 * THE ABSOLUTE ERROR OVER THE SIZE OF THE RANGE;                                                                          
THUS, A VALUE JUST BARELY PASSING OR FAILING WILL USUALLY                                                                           
HAVE A MEASURE OF ABOUT 1. A VALUE 3 TIMES                                                                                          
AS INACCURATE AS EXPECTED WILL HAVE A MEASURE OF 3.                                                                                 
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ANSI STANDARD                                                                              
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
ARGUMENT                  TRUE                      COMPUTED                  ERROR                     OUTCOME                     
                          VALUE                     VALUE                     MEASURE                                               
                                                                                                                                    
 1.E-38                   -87.4982335               -87.49823353377374         5.624270555999215E-04     OK                         
 1.00001E-38              -87.4982235               -87.49822353382373         5.632595916680102E-04     OK                         
 9.87654E-38              -85.2080713               -85.2080712857783          2.785836943862411E-04     OK                         
 8.98989E-37              -82.9995478               -82.9995478281886          5.510966679806174E-04     OK                         
 7.87878E-36              -80.8288903               -80.8288902782371          4.242280860952505E-04     OK                         
 6.76767E-35              -78.6783214               -78.67832139254168         1.4482185462236298E-04    OK                         
 5.65656E-30              -67.3447369               -67.34473685622727         8.442185041939886E-04     OK                         
 4.54545E-25              -56.0505006               -56.050500592221866        1.4886380273208745E-04    OK                         
 3.43434E-20              -44.8178771               -44.817877092405794        1.4328684151776268E-04    OK                         
 2.32323E-15              -33.6958179               -33.69581793612258         6.646288630456046E-04     OK                         
 .000000000121212         -22.83348                 -22.8334800372935          6.396826731254892E-04     OK                         
 .00000090909             -13.9108217               -13.9108217377691          7.383988240009994E-04     OK                         
 .0000888888              -9.32812441               -9.328124407633066         3.8612289004774723E-04    OK                         
 .000777777               -7.15907071               -7.1590707072635436        4.350487114196359E-04     OK                         
 .00666666                -5.01063629               -5.010636294096756         6.297856761682798E-04     OK                         
 .0555555                 -2.89037276               -2.8903727578966647        3.090867426507477E-04     OK                         
 .123456                  -2.09187046               -2.091870461698873         1.2963548586523486E-04    OK                         
 .298347                  -1.20949804               -1.209498040368774         4.411173712300922E-05     OK                         
 .535353                  -.624828937               -.6248289365829681         1.7607424678131361E-04    OK                         
 .893481                  -.112630209               -.11263020929817469        1.8411527833858834E-04    OK                         
 .999                     -.00100050033             -1.0005003335835344E-03    3.5701337967516817E-06    OK                         
 .9995                    -.000500125042            -5.001250416822429E-04     3.1743934856240847E-07    OK                         
 .9999                    -.000100005               -1.0000500033334732E-04    3.3322233103056317E-07    OK                         
 .99995                   -.00005000125             -5.000125004166272E-05     4.1658550259309976E-08    OK                         
 .99999                   -.00001000005             -1.0000050000287824E-05    2.878143761789748E-10     OK                         
 .999995                  -.0000050000125           -5.000012500074423E-06     7.44229582758543E-11      OK                         
 .999998                  -.000002000002            -2.0000019999491555E-06    5.084406727446731E-11     OK                         
 .999999                  -.0000010000005           -1.000000500029089E-06     2.3271148627059044E-11    OK                         
 1                         0                         0                         0                         OK  - EXACT                
 1.00001                   .00000999995              9.999950000398841E-06     3.9884369914126294E-11    OK                         
 1.00002                   .0000199998               1.9999800002575608E-05    2.575651381142109E-10     OK                         
 1.00005                   .00004999875              4.999875004177061E-05     4.177248941911429E-09     OK                         
 1.0001                    .0000999950003            9.999500033329732E-05     3.3299738841566303E-09    OK                         
 1.0003                    .000299955009             2.9995500899794244E-04    2.0580589817739093E-10    OK                         
 1.001                     .000999500333             9.995003330834232E-04     8.348369861909941E-09     OK                         
 1.003                     .00299550898              2.995508979798371E-03     2.0213259029956482E-08    OK                         
 1.01                      .00995033085              9.950330853168092E-03     3.198156797404372E-07     OK                         
 1.03                      .0295588022               .02955880224154443        4.257124607561831E-06     OK                         
 1.11111                   .105359516                .10535951565732635        3.606901250902668E-05     OK                         
 1.54321                   .433864663                .4338646626298591         5.3024978498087975E-05    OK                         
 2                         .693147181                .6931471805599453         8.000266509879743E-05     OK                         
 2.32323                   .842958459                .8429584587881055         4.409875170548334E-05     OK                         
 2.71828                   .999999327                .999999327347282          5.400124101254507E-05     OK                         
 4                         1.38629436                1.3862943611198906        1.4921927044319656E-04    OK                         
 7.14286                   1.96611326                1.9661132563727528        5.663149366635151E-04     OK                         
 8                         2.07944154                2.0794415416798357        2.685588850532776E-04     OK                         
 53.6789                   3.98302                   3.9830200006501877        9.46416162295102E-05      OK                         
 482.284                   6.17853315                6.178533152151847         3.039332752810928E-04     OK                         
 9621.12                   9.17171596                9.171715960999414         1.653290132280147E-04     OK                         
 86321.4                   11.3658328                11.365832818521532        3.6174868656361776E-04    OK                         
 777777                    13.5641951                13.564195129682869        5.780500388678154E-04     OK                         
 98765400                  18.4082579                18.408257898953757        2.0474407122845806E-05    OK                         
 89898900000               25.2219515                25.221951542531553        8.315064201280936E-04     OK                         
 7979790000000000          36.6156885                36.615688490236664        1.9031838700097993E-04    OK                         
 6.96969E+20               47.9932726                47.993272607337126        1.4246850947770753E-04    OK                         
 5.95959E+25               59.349629                 59.34962901161582         2.2467732381120233E-04    OK                         
 4.94949E+30               70.6768373                70.67683733079096         5.915649825771072E-04     OK                         
 3.93939E+35               81.9615041                81.9615041437802          8.331152112488181E-04     OK                         
 9.87654E+36               85.1832256                85.18322559578108         8.256200681821403E-05     OK                         
 9.87654E+37               87.4858107                87.48581068877513         2.1966477343203622E-04    OK                         
 1.E+38                    87.4982335                87.49823353377374         5.624270555999215E-04     OK                         
                                                                                                                                    
*** INFORMATIVE TEST PASSED ***                                                                                                     
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 124                                                                                                                     
