PROGRAM FILE 128: ACCURACY OF TAN FUNCTION.                                                                                         
    ANSI STANDARD 7.6, 8.4                                                                                                          
                                                                                                                                    
SECTION 128.1: ACCURACY OF TAN FUNCTION.                                                                                            
                                                                                                                                    
THIS PROGRAM TESTS VALUES RETURNED BY INVOCATIONS OF THE                                                                            
TAN FUNCTION FOR ACCURACY. THE INVOCATION MUST RETURN,                                                                              
ACCURATE TO SIX DIGITS, SOME VALUE ACTUALLY TAKEN ON BY                                                                             
THE FUNCTION WITHIN A DOMAIN BOUNDED BY THE ACTUAL ARGUMENT                                                                         
PLUS OR MINUS ONE IN THE SIXTH DIGIT. ALSO, AN                                                                                      
'ERROR MEASURE' IS COMPUTED AND REPORTED. THIS MEASURE                                                                              
IS JUST 2 * THE ABSOLUTE ERROR OVER THE SIZE OF THE RANGE;                                                                          
THUS, A VALUE JUST BARELY PASSING OR FAILING WILL USUALLY                                                                           
HAVE A MEASURE OF ABOUT 1. A VALUE 3 TIMES                                                                                          
AS INACCURATE AS EXPECTED WILL HAVE A MEASURE OF 3.                                                                                 
                                                                                                                                    
THIS TEST IS INFORMATIVE ONLY, SINCE THE ANSI STANDARD                                                                              
DOES NOT MANDATE ANY ACCURACY FOR SUPPLIED-FUNCTIONS.                                                                               
                                                                                                                                    
              BEGIN TEST                                                                                                            
                                                                                                                                    
ARGUMENT                  TRUE                      COMPUTED                  ERROR                     OUTCOME                     
                          VALUE                     VALUE                     MEASURE                                               
                                                                                                                                    
-98778.8984375            -1.3801747560501099       -1.375645637512207         1.5241146087646484E-02    OK                         
-9876.5400390625           .7249919176101685         .7249323129653931         3.906471189111471E-03     OK                         
-987.6539916992188        -2.526461362838745        -2.526400089263916         8.293532766401768E-03     OK                         
-98.7654037475586         -5.069210529327393        -5.069310665130615         .03743983060121536        OK                         
-9.876540184020996        -.48523011803627014       -.48523035645484924        1.8561484292149544E-02    OK                         
-5.5555500984191895        .8906679749488831         .8906677961349487         9.693053551018238E-03     OK                         
-4.712389945983887         980762.0625               1035626.375              RANGE SPLIT                OK                         
-4.567890167236328        -6.872230529785156        -6.872238636016846         1.6634050756692886E-02    OK                         
-4                        -1.1578212976455688       -1.1578212976455688        0                         OK - EXACT                 
-3.141590118408203         2.653589717738214E-06     2.5351816930196946E-06    .01184077002108097        OK                         
-2.876539945602417         .2714390754699707         .2714391350746155         5.305039696395397E-03     OK                         
-2                         2.185039758682251         2.185039758682251         0                         OK - EXACT                 
-1.6161600351333618        22.028947830200195        22.0289306640625          3.4937888849526644E-03    OK                         
-1.5708099603652954        73135.7421875             73348.359375              1.8488409696146846E-03    OK                         
-1.5707999467849731        272241.8125               276243.84375             RANGE SPLIT                OK                         
-1.5707800388336182       -61249.0078125            -61395.0390625             2.4323472753167152E-03    OK                         
-1.2345600128173828       -2.861166000366211        -2.861166000366211         0                         OK - EXACT                 
-1                        -1.5574077367782593       -1.5574077367782593        0                         OK - EXACT                 
-.8765400052070618        -1.201176643371582        -1.201176643371582         0                         OK - EXACT                 
-.23232300579547882       -.2365950495004654        -.2365950644016266         9.569377638399601E-03     OK                         
-.07676760107278824       -.07691875845193863       -.07691875845193863        0                         OK - EXACT                 
-2.3456700146198273E-02   -2.3461002856492996E-02   -2.3461002856492996E-02   RANGE SPLIT                OK - EXACT                 
-1.2345599941909313E-02   -1.2346227653324604E-02   -1.2346227653324604E-02    0                         OK - EXACT                 
-9.876539930701256E-03    -9.876861236989498E-03    -9.876861236989498E-03     0                         OK - EXACT                 
-3.4567799884825945E-03   -.00345679372549057       -.00345679372549057        0                         OK - EXACT                 
-9.876539697870612E-04    -9.876543190330267E-04    -9.876543190330267E-04     0                         OK - EXACT                 
-3.4567801048979163E-04   -3.4567801048979163E-04   -3.4567801048979163E-04    0                         OK - EXACT                 
-9.000000136438757E-05    -9.000000136438757E-05    -9.000000136438757E-05     0                         OK - EXACT                 
-8.999999749903509E-07    -8.999999749903509E-07    -8.999999749903509E-07     0                         OK - EXACT                 
-9.000000189551827E-10    -9.000000189551827E-10    -9.000000189551827E-10     0                         OK - EXACT                 
-8.999999714389703E-20    -8.999999714389703E-20    -8.999999714389703E-20     0                         OK - EXACT                 
-9.000000028539692E-30    -9.000000028539692E-30    -9.000000028539692E-30     0                         OK - EXACT                 
-9.000000256189842E-38    -9.000000256189842E-38    -9.000000256189842E-38     0                         OK - EXACT                 
 0                         0                         0                        RANGE ZERO                 OK - EXACT                 
 9.000000256189842E-38     9.000000256189842E-38     9.000000256189842E-38     0                         OK - EXACT                 
 9.000000028539692E-30     9.000000028539692E-30     9.000000028539692E-30     0                         OK - EXACT                 
 8.999999714389703E-20     8.999999714389703E-20     8.999999714389703E-20     0                         OK - EXACT                 
 9.000000189551827E-10     9.000000189551827E-10     9.000000189551827E-10     0                         OK - EXACT                 
 8.999999749903509E-07     8.999999749903509E-07     8.999999749903509E-07     0                         OK - EXACT                 
 9.000000136438757E-05     9.000000136438757E-05     9.000000136438757E-05     0                         OK - EXACT                 
 3.4567801048979163E-04    3.4567801048979163E-04    3.4567801048979163E-04    0                         OK - EXACT                 
 9.876539697870612E-04     9.876543190330267E-04     9.876543190330267E-04     0                         OK - EXACT                 
 3.4567799884825945E-03    .00345679372549057        .00345679372549057        0                         OK - EXACT                 
 9.876539930701256E-03     9.876861236989498E-03     9.876861236989498E-03     0                         OK - EXACT                 
 1.2345599941909313E-02    1.2346227653324604E-02    1.2346227653324604E-02    0                         OK - EXACT                 
 2.3456700146198273E-02    2.3461002856492996E-02    2.3461002856492996E-02    0                         OK - EXACT                 
 .07676760107278824        .07691875845193863        .07691875845193863        0                         OK - EXACT                 
 .23232300579547882        .2365950495004654         .2365950644016266         9.569377638399601E-03     OK                         
 .8765429854393005         1.2011839151382446        1.2011839151382446        0                         OK - EXACT                 
 1                         1.5574077367782593        1.5574077367782593        0                         OK - EXACT                 
 1.2345600128173828        2.861166000366211         2.861166000366211         0                         OK - EXACT                 
 1.5707800388336182        61249.0078125             61395.0390625             2.4323472753167152E-03    OK                         
 1.5707999467849731       -272241.8125              -276243.84375             RANGE SPLIT                OK                         
 1.5708099603652954       -73135.7421875            -73348.359375              1.8488409696146846E-03    OK                         
 1.6161600351333618       -22.028947830200195       -22.0289306640625          3.4937888849526644E-03    OK                         
 2                        -2.185039758682251        -2.185039758682251         0                         OK - EXACT                 
 2.876539945602417        -.2714390754699707        -.2714391350746155         5.305039696395397E-03     OK                         
 3.141590118408203        -2.653589717738214E-06    -2.5351816930196946E-06    .01184077002108097        OK                         
 4                         1.1578212976455688        1.1578212976455688        0                         OK - EXACT                 
 4.567890167236328         6.872230529785156         6.872238636016846         1.6634050756692886E-02    OK                         
 4.712389945983887        -980762.0625              -1035626.375              RANGE SPLIT                OK                         
 5.5555500984191895       -.8906679749488831        -.8906677961349487         9.693053551018238E-03     OK                         
 9.876540184020996         .48523011803627014        .48523035645484924        1.8561484292149544E-02    OK                         
 98.7654037475586          5.069210529327393         5.069310665130615         .03743983060121536        OK                         
 987.6539916992188         2.526461362838745         2.526400089263916         8.293532766401768E-03     OK                         
 9876.5400390625          -.7249919176101685        -.7249323129653931         3.906471189111471E-03     OK                         
 98778.8984375             1.3801747560501099        1.375645637512207         1.5241146087646484E-02    OK                         
                                                                                                                                    
*** INFORMATIVE TEST PASSED ***                                                                                                     
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 128                                                                                                                     
