PROGRAM FILE 129: EXCEPTION - OVERFLOW ON VALUE OF                                                                                  
        TAN FUNCTION.                                                                                                               
    ANSI STANDARD 8.5                                                                                                               
                                                                                                                                    
SECTION 129.1: EXCEPTION - OVERFLOW ON VALUE OF                                                                                     
        TAN FUNCTION.                                                                                                               
                                                                                                                                    
THE OBJECT OF THIS TEST IS TO SEE WHETHER THE PROCESSOR                                                                             
RECOGNIZES AN EXCEPTION OF THE VALUE RETURNED BY THE                                                                                
TAN FUNCTION EXCEEDS MACHINE INFINITY.                                                                                              
                                                                                                                                    
TO PASS THIS TEST:                                                                                                                  
                                                                                                                                    
    1) OVERFLOW MUST NOT OCCUR, OR                                                                                                  
                                                                                                                                    
    2) WHEN OVERFLOW OCCURS, THE PROCESSOR MUST DISPLAY A                                                                           
       MESSAGE IDENTIFYING THE EXCEPTION, SUPPLY MACHINE                                                                            
       INFINITY AND CONTINUE EXECUTION.                                                                                             
                                                                                                                                    
                                                                                                                                    
                               BEGIN TEST.                                                                                          
                                                                                                                                    
THE PROGRAM ATTEMPTS TO FORCE CONVERGENCE OF THE ARGUMENT                                                                           
TO PI/2, SO AS TO CAUSE OVERFLOW. IF OVERFLOW DOES NOT                                                                              
OCCUR, IT IS LIKELY THAT THIS SYSTEM HAS NO INTERNAL                                                                                
NUMERIC REPRESENTATION FOR WHICH THE TANGENT EXCEEDS                                                                                
MACHINE INFINITY.                                                                                                                   
                                                                                                                                    
ARGUMENT                  VALUE OF TAN                                                                                              
                                                                                                                                    
 1.5699999332427979        1255.6602783203125                                                                                       
 1.5750000476837158       -237.88308715820312                                                                                       
 1.5724999904632568       -586.9697265625                                                                                           
 1.5712499618530273       -2204.4150390625                                                                                          
 1.5706249475479126        5835.01220703125                                                                                         
 1.5709373950958252       -7088.7646484375                                                                                          
 1.5707812309265137        66243.2890625                                                                                            
 1.5708593130111694       -15876.4892578125                                                                                         
 1.5708203315734863       -41658.37109375                                                                                           
 1.57080078125            -224494.34375                                                                                             
 1.5707910060882568        187944.953125                                                                                            
 1.5707958936691284        2308798.25                                                                                               
 1.570798397064209        -483028.9375                                                                                              
 1.5707972049713135       -1138723.375                                                                                              
 1.5707964897155762       -6137956                                                                                                  
 1.570796251296997         13245402                                                                                                 
 1.5707963705062866       -22877332                                                                                                 
 1.570796251296997         13245402                                                                                                 
                                                                                                                                    
ARGUMENTS HAVE CONVERGED. IF OVERFLOW HAS OCCURRED,                                                                                 
PROCESSOR MUST HAVE REPORTED EXCEPTION AND SUPPLIED                                                                                 
MACHINE INFINITY, OTHERWISE,                                                                                                        
***  TEST FAILED  ***                                                                                                               
                                                                                                                                    
                                 END TEST                                                                                           
                                                                                                                                    
END PROGRAM 129                                                                                                                     
