PROGRAM FILE 133: CHI-SQUARE UNIFORMITY TEST FOR                                                                                    
        RND FUNCTION.                                                                                                               
    ANSI STANDARD 8.4                                                                                                               
                                                                                                                                    
SECTION 133.1: CHI-SQUARE UNIFORMITY TEST FOR                                                                                       
        RND FUNCTION.                                                                                                               
                                                                                                                                    
THIS PROGRAM RUNS A SERIES OF 60 EXPERIMENTS OF 1040 SAMPLES                                                                        
TO DETERMINE IF THE RANDOM NUMBERS ARE EQUALLY DISTRIBUTED                                                                          
AMONG 21 EQUAL-SIZE INTERVALS BETWEEN 0 AND 1.  CHI-SQUARE                                                                          
IS COMPUTED AND DISPLAYED FOR EACH OF THESE EXPERIMENTS.                                                                            
EACH CHI-SQUARE RESULT IS CATEGORIZED ACCORDING TO THE                                                                              
PERCENTILE RANGE INTO WHICH ITS VALUE FALLS:                                                                                        
                                                                                                                                    
CATEGORY     % RANGE                CATEGORY    % RANGE                                                                             
    1          0-1                      6        50-75                                                                              
    2          1-5                      7        75-90                                                                              
    3          5-10                     8        90-95                                                                              
    4         10-25                     9        95-99                                                                              
    5         25-50                    10        99-100                                                                             
                                                                                                                                    
THESE CATEGORICAL RESULTS ARE THEN EVALUATED AGAIN USING                                                                            
CHI-SQUARE (THE FIRST AND LAST THREE CATEGORIES ARE EACH                                                                            
CONSOLIDATED INTO ONE), AND IF THE DISTRIBUTION AMONG                                                                               
CATEGORIES IS SUFFICIENTLY IMPROBABLE (TOP OR BOTTOM 5%),                                                                           
THE TEST FAILS.                                                                                                                     
                                                                                                                                    
                    BEGIN TEST                                                                                                      
                                                                                                                                    
EXPERIMENT                CHI-SQUARE                CATEGORY                                                                        
                                                                                                                                    
 1                         17.9200439453125          5                                                                              
 2                         24.239990234375           7                                                                              
 3                         22.9200439453125          6                                                                              
 4                         20.56005859375            6                                                                              
 5                         17.239990234375           5                                                                              
 6                         13.760009765625           4                                                                              
 7                         17.199951171875           5                                                                              
 8                         20.5999755859375          6                                                                              
 9                         25                        7                                                                              
 10                        16.8800048828125          5                                                                              
 11                        22.4000244140625          6                                                                              
 12                        19.9599609375             6                                                                              
 13                        18.52001953125            5                                                                              
 14                        29.0799560546875          8                                                                              
 15                        29.52001953125            8                                                                              
 16                        20.8800048828125          6                                                                              
 17                        24.239990234375           7                                                                              
 18                        24.3599853515625          7                                                                              
 19                        25.719970703125           7                                                                              
 20                        28.52001953125            8                                                                              
 21                        25.47998046875            7                                                                              
 22                        20.43994140625            6                                                                              
 23                        19.4000244140625          6                                                                              
 24                        17.56005859375            5                                                                              
 25                        20.8399658203125          6                                                                              
 26                        17.800048828125           5                                                                              
 27                        13.4000244140625          4                                                                              
 28                        16.280029296875           5                                                                              
 29                        22.9200439453125          6                                                                              
 30                        13.4000244140625          4                                                                              
 31                        26.9599609375             7                                                                              
 32                        26.6400146484375          7                                                                              
 33                        19.3599853515625          6                                                                              
 34                        26.8800048828125          7                                                                              
 35                        24.4000244140625          7                                                                              
 36                        15.1600341796875          4                                                                              
 37                        17.9200439453125          5                                                                              
 38                        19.52001953125            6                                                                              
 39                        22.280029296875           6                                                                              
 40                        31.280029296875           8                                                                              
 41                        22.0799560546875          6                                                                              
 42                        12.199951171875           3                                                                              
 43                        23.0799560546875          6                                                                              
 44                        15.199951171875           4                                                                              
 45                        18.0400390625             5                                                                              
 46                        23.280029296875           6                                                                              
 47                        17.3199462890625          5                                                                              
 48                        28.239990234375           7                                                                              
 49                        14.43994140625            4                                                                              
 50                        10.1600341796875          2                                                                              
 51                        10.0799560546875          2                                                                              
 52                        14.800048828125           4                                                                              
 53                        23.43994140625            6                                                                              
 54                        20.8399658203125          6                                                                              
 55                        21.1199951171875          6                                                                              
 56                        11.9599609375             3                                                                              
 57                        11.1199951171875          3                                                                              
 58                        19.1600341796875          5                                                                              
 59                        20.6400146484375          6                                                                              
 60                        33.800048828125           9                                                                              
                                                                                                                                    
                                                                                                                                    
                                                                                                                                    
SUMMARY EVALUATION STATISTICS                                                                                                       
                                                                                                                                    
                          ACTUAL                    EXPECTED                                                                        
CATEGORY                  COUNT                     COUNT                                                                           
 1                         0                         .5999999642372131                                                              
 2                         2                         2.3999998569488525                                                             
 3                         3                         3                                                                              
 4                         7                         9                                                                              
 5                         12                        15                                                                             
 6                         20                        15                                                                             
 7                         11                        9                                                                              
 8                         4                         3                                                                              
 9                         1                         2.3999998569488525                                                             
 10                        0                         .5999999642372131                                                              
                                                                                                                                    
                                                                                                                                    
WILL CONSOLIDATE CATEGORIES 1-3 AND 8-10, SO THAT                                                                                   
EXPECTED VALUE IN EACH IS >= 5, AS REQUIRED BY                                                                                      
CHI-SQUARE TEST.                                                                                                                    
                                                                                                                                    
FOR FIVE D.F., SHOULD HAVE 1.145476 <= CHI-SQ <= 11.0705                                                                            
(5% TAIL AT EACH END.)                                                                                                              
                                                                                                                                    
ACTUAL CHI-SQ =  3.4888839721679688                                                                                                 
                                                                                                                                    
 ***  TEST PASSED  ***                                                                                                              
                                                                                                                                    
                    END TEST                                                                                                        
                                                                                                                                    
END PROGRAM 133                                                                                                                     
