PROGRAM FILE 134: KOMOLGOROV-SMIRNOV UNIFORMITY TEST FOR                                                                            
        RND FUNCTION.                                                                                                               
    ANSI STANDARD 8.4                                                                                                               
                                                                                                                                    
SECTION 134.1: KOMOLGOROV-SMIRNOV UNIFORMITY TEST FOR                                                                               
        RND FUNCTION.                                                                                                               
                                                                                                                                    
THIS PROGRAM RUNS 30 TESTS OF 1000 SAMPLES EACH TO CHECK                                                                            
UNIFORMITY OF DISTRIBUTION OF RANDOM NUMBERS. KOMOLGOROV-                                                                           
SMIRNOV (K-S) STATISTICS (K+ AND K-) ARE GENERATED FOR                                                                              
EACH TEST. THESE TWO NUMBERS ARE A MEASURE OF THE GREATEST                                                                          
DEVIATION, IN THE POSITIVE AND NEGATIVE DIRECTION, OF THE                                                                           
ACCUMULATION OF THE 1000 NUMBERS FROM THE IDEAL DISTRIBUTION                                                                        
OF F(X)=X, 0<=X<1.                                                                                                                  
                                                                                                                                    
THESE TWO SETS (K+ AND K-) OF 30 STATISTICS THEMSELVES HAVE                                                                         
AN EXPECTED DISTRIBUTION OF F(X) = 1 - EXP(-2*X*X). THE                                                                             
K-S TEST IS RUN AGAIN ON EACH OF THESE TWO SETS, AND IF                                                                             
THE DEVIATION IS TOO GREAT (TOP OR BOTTOM 1%) FOR ANY ONE                                                                           
OF THE RESULTING STATISTICS, THEN THE TEST FAILS.                                                                                   
                                                                                                                                    
                 BEGIN TEST                                                                                                         
                                                                                                                                    
                                                                                                                                    
TEST                      K+                        K-                                                                              
 1                         .9338786023553503         .4104477010372212                                                              
 2                         .6896929990401328         .7423055591432509                                                              
 3                         .2347256518113815         .9980618968099684                                                              
 4                         1.4693552287220817        .47182231251256457                                                             
 5                         .9033871731707728         .3573515684381486                                                              
 6                         .7698490722627124         .6261493695406178                                                              
 7                         1.7121059673139878        .13288364150169116                                                             
 8                         .27535490466522355        .8244590821551929                                                              
 9                         .7543109985169851         .28386040904582704                                                             
 10                        .38718254864927276        1.1531917135485117                                                             
 11                        .586088530781911          .40960833741641983                                                             
 12                        .9337561642492653         .24550752736251724                                                             
 13                        .40409376919940826        .5371859492467095                                                              
 14                        .6937059454751228         .6576466993403054                                                              
 15                        .23493902945465464        1.0133147844791055                                                             
 16                        .5177140868211634         .9953639920989321                                                              
 17                        .6509471453219051         .43512466392164206                                                             
 18                        .28712462138044464        .8926874054712165                                                              
 19                        1.0412318200306985        .08876398897099301                                                             
 20                        .31706327842896975        .9524397756077533                                                              
 21                        .40098793598473936        .7517190182586143                                                              
 22                        .1533995835064852         1.4767974671622228                                                             
 23                        .8969506752140098         .2403793347161034                                                              
 24                        .6577301095662728         .3858380653907252                                                              
 25                        .5549436976545645         .5158653737380033                                                              
 26                        .7387576673509008         .39060441423741415                                                             
 27                        2.8807300194910204E-02    .9266836198159202                                                              
 28                        .15768278589923174        1.07043184419617                                                               
 29                        1.7674570796249267        .2502634448698593                                                              
 30                        .9173364045147303         .2990188580119042                                                              
                                                                                                                                    
SUMMARY K-S STATISTICS FOR THE K+ VALUES                                                                                            
K+ =  .4822739214451292         K- =  .5741954179532808                                                                             
                                                                                                                                    
                                                                                                                                    
SUMMARY K-S STATISTICS FOR THE K- VALUES                                                                                            
K+ =  .6468985408604047         K- =  .5304369739500444                                                                             
                                                                                                                                    
                                                                                                                                    
ALL RESULTS SHOULD FALL BETWEEN .04354 AND 1.4801                                                                                   
                                                                                                                                    
*** TEST PASSED ***                                                                                                                 
                                                                                                                                    
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 134                                                                                                                     
