PROGRAM FILE 134: KOMOLGOROV-SMIRNOV UNIFORMITY TEST FOR                                                                            
        RND FUNCTION.                                                                                                               
    ANSI STANDARD 8.4                                                                                                               
                                                                                                                                    
SECTION 134.1: KOMOLGOROV-SMIRNOV UNIFORMITY TEST FOR                                                                               
        RND FUNCTION.                                                                                                               
                                                                                                                                    
THIS PROGRAM RUNS 30 TESTS OF 1000 SAMPLES EACH TO CHECK                                                                            
UNIFORMITY OF DISTRIBUTION OF RANDOM NUMBERS. KOMOLGOROV-                                                                           
SMIRNOV (K-S) STATISTICS (K+ AND K-) ARE GENERATED FOR                                                                              
EACH TEST. THESE TWO NUMBERS ARE A MEASURE OF THE GREATEST                                                                          
DEVIATION, IN THE POSITIVE AND NEGATIVE DIRECTION, OF THE                                                                           
ACCUMULATION OF THE 1000 NUMBERS FROM THE IDEAL DISTRIBUTION                                                                        
OF F(X)=X, 0<=X<1.                                                                                                                  
                                                                                                                                    
THESE TWO SETS (K+ AND K-) OF 30 STATISTICS THEMSELVES HAVE                                                                         
AN EXPECTED DISTRIBUTION OF F(X) = 1 - EXP(-2*X*X). THE                                                                             
K-S TEST IS RUN AGAIN ON EACH OF THESE TWO SETS, AND IF                                                                             
THE DEVIATION IS TOO GREAT (TOP OR BOTTOM 1%) FOR ANY ONE                                                                           
OF THE RESULTING STATISTICS, THEN THE TEST FAILS.                                                                                   
                                                                                                                                    
                 BEGIN TEST                                                                                                         
                                                                                                                                    
                                                                                                                                    
TEST                      K+                        K-                                                                              
 1                         .9338786602020264         .4104475975036621                                                              
 2                         .6896926164627075         .742304801940918                                                               
 3                         .2347259223461151         .9980620741844177                                                              
 4                         1.4693554639816284        .4718222916126251                                                              
 5                         .903387188911438          .3573514223098755                                                              
 6                         .7698501944541931         .6261491179466248                                                              
 7                         1.7121070623397827        .13288362324237823                                                             
 8                         .27535513043403625        .8244603872299194                                                              
 9                         .7543113827705383         .28386056423187256                                                             
 10                        .38718318939208984        1.153191089630127                                                              
 11                        .5860891342163086         .4096074104309082                                                              
 12                        .9337561130523682         .2455073446035385                                                              
 13                        .4040937125682831         .537186324596405                                                               
 14                        .6937059164047241         .657646119594574                                                               
 15                        .23493891954421997        1.0133143663406372                                                             
 16                        .5177147388458252         .9953629374504089                                                              
 17                        .6509473323822021         .4351246953010559                                                              
 18                        .2871242165565491         .8926868438720703                                                              
 19                        1.0412319898605347        .08876415342092514                                                             
 20                        .3170633912086487         .9524407982826233                                                              
 21                        .4009879231452942         .7517197132110596                                                              
 22                        .15339969098567963        1.4767968654632568                                                             
 23                        .896950364112854          .24037933349609375                                                             
 24                        .6577290892601013         .3858373761177063                                                              
 25                        .5549436211585999         .515865683555603                                                               
 26                        .7387574911117554         .3906060755252838                                                              
 27                        2.8806380927562714E-02    .9266841411590576                                                              
 28                        .15768398344516754        1.0704314708709717                                                             
 29                        1.7674561738967896        .2502634525299072                                                              
 30                        .9173370599746704         .29901865124702454                                                             
                                                                                                                                    
SUMMARY K-S STATISTICS FOR THE K+ VALUES                                                                                            
K+ =  .4822743535041809         K- =  .5741965174674988                                                                             
                                                                                                                                    
                                                                                                                                    
SUMMARY K-S STATISTICS FOR THE K- VALUES                                                                                            
K+ =  .6468985080718994         K- =  .5304346084594727                                                                             
                                                                                                                                    
                                                                                                                                    
ALL RESULTS SHOULD FALL BETWEEN .04354 AND 1.4801                                                                                   
                                                                                                                                    
*** TEST PASSED ***                                                                                                                 
                                                                                                                                    
                                                                                                                                    
               END TEST                                                                                                             
                                                                                                                                    
END PROGRAM 134                                                                                                                     
