PROGRAM FILE 164: GENERAL USE OF NUMERIC EXPRESSIONS                                                                                
        IN LET-STATEMENT.                                                                                                           
    ANSI STANDARD 6.2, 6.4, 7.2, 7.4, 8.2, 8.4,                                                                                     
                  16.2, 16.4                                                                                                        
                                                                                                                                    
THIS PROGRAM EXERCISES THE FULL RANGE OF USES AND VARIETIES                                                                         
OF NUMERIC EXPRESSIONS IN THE LET-STATEMENT. EXPRESSIONS ARE                                                                        
COMPOSED OF ALL TYPES OF PRIMARIES AND ARE USED AS ARGUMENTS                                                                        
OF FUNCTIONS AND AS SUBSCRIPTS.                                                                                                     
                                                                                                                                    
SECTION 164.1: NUMERIC EXPRESSIONS CONTAINING                                                                                       
        SUBSCRIPTED VARIABLES AND FUNCTION REFERENCES.                                                                              
                                                                                                                                    
THIS SECTION TESTS WHETHER SUBSCRIPTED VARIABLES AND                                                                                
REFERENCES TO BOTH IMPLEMENTATION-SUPPLIED AND                                                                                      
USER-DEFINED FUNCTIONS CAN BE USED AS PRIMARIES IN                                                                                  
NUMERIC EXPRESSIONS.                                                                                                                
                                                                                                                                    
                 BEGIN TEST.                                                                                                        
                                                                                                                                    
CASE #                    SHOULD BE                 ACTUAL                    OUTCOME                                               
                                                                                                                                    
 1                         1                         1                         OK                                                   
 2                         1                         .99999998418872           OK                                                   
 3                         7                         7.000000118412735         OK                                                   
 4                         3                         3.000000134184948         OK                                                   
                                                                                                                                    
*** TEST PASSED ***                                                                                                                 
                                                                                                                                    
                  END TEST.                                                                                                         
                                                                                                                                    
SECTION 164.2: NUMERIC EXPRESSIONS USED AS FUNCTION                                                                                 
        ARGUMENTS AND ARRAY SUBSCRIPTS.                                                                                             
                                                                                                                                    
THIS SECTION TESTS WHETHER NUMERIC EXPRESSIONS CAN BE                                                                               
USED AS ARGUMENTS TO BOTH IMPLEMENTATION-SUPPLIED AND                                                                               
USER-DEFINED FUNCTIONS AND ALSO AS SUBSCRIPTS.                                                                                      
                                                                                                                                    
                 BEGIN TEST.                                                                                                        
                                                                                                                                    
CASE #                    SHOULD BE                 ACTUAL                    OUTCOME                                               
                                                                                                                                    
 1                         1                         1.0000000011426666        OK                                                   
 2                         1.2                       1.2                       OK                                                   
 3                         .378568142784461          .378568142784461          OK                                                   
                                                                                                                                    
*** TEST PASSED ***                                                                                                                 
                                                                                                                                    
                  END TEST.                                                                                                         
                                                                                                                                    
SECTION 164.3: EXPRESSIONS USED AS SUBSCRIPTS ARE                                                                                   
        ROUNDED TO NEAREST INTEGER.                                                                                                 
                                                                                                                                    
THIS SECTION ENSURES THAT WHEN EXPRESSIONS ARE USED AS                                                                              
SUBSCRIPTS, THEY ARE ROUNDED TO THE NEAREST INTEGER.                                                                                
                                                                                                                                    
                 BEGIN TEST.                                                                                                        
                                                                                                                                    
CASE #                    SHOULD BE                 ACTUAL                    OUTCOME                                               
                                                                                                                                    
 1                         27                        27                        OK                                                   
 2                         1                         1                         OK                                                   
 3                         11                        11                        OK                                                   
 4                         1                         1                         OK                                                   
 5                         71                        71                        OK                                                   
                                                                                                                                    
*** TEST PASSED ***                                                                                                                 
                                                                                                                                    
                  END TEST.                                                                                                         
                                                                                                                                    
END PROGRAM 164                                                                                                                     
