PROGRAM FILE 206: ERROR - ORDERING RELATIONS BETWEEN STRINGS.                   
    ANSI STANDARD 3.2, 3.4, 3.6, 10.2                                           
                                                                                
THIS PROGRAM TESTS WHETHER, AS AN ENHANCEMENT, THE COMPARISON                   
OF STRINGS WITH THE '<' AND '>' RELATIONS IS ALLOWED.                           
                                                                                
THIS IS A TEST FOR A NON-STANDARD FEATURE OF MINIMAL BASIC.                     
TO PASS THIS TEST, THE PROCESSOR MUST EITHER:                                   
                                                                                
   1) ACCEPT THE PROGRAM AND BE ACCOMPANIED BY DOCUMENTATION                    
      ACCURATELY DESCRIBING THE FEATURE'S INTERPRETATION                        
      BY THE PROCESSOR, OR                                                      
                                                                                
   2) REJECT THE PROGRAM WITH AN APPROPRIATE ERROR MESSAGE                      
                                                                                
SEE THE NBS MINIMAL BASIC TEST PROGRAMS USER'S MANUAL                           
FOR DETAILED CRITERIA.                                                          
                                                                                
SECTION 206.1: COLLATING SEQUENCE.                                              
                                                                                
IF THIS IMPLEMENTATION ALLOWS THE ORDERING RELATIONS,                           
AN INFORMATIVE SORT IS DONE TO DISPLAY THE IMPLICIT                             
COLLATING SEQUENCE OF THE CHARACTERS (ASSUMING THE NATURAL                      
INTERPRETATION IS GIVEN TO THESE RELATIONS).                                    
                                                                                
                    BEGIN TEST.                                                 
                                                                                
COLLATING SEQUENCE OF SELECTED CHARACTERS IS:                                   
(CHARACTERS SURROUNDED BY PERIODS)                                              
                                                                                
. .!.#.$.%.&.'.(.).*.+.,.-.../.                                                 
.1.8.9.:.;.<.=.>.?.A.M.O.Z.^._.                                                 
                                                                                
IF DOCUMENTATION AGREES WITH THE ABOVE RESULTS, THEN                            
*** TEST PASSED ***                                                             
                                                                                
                     END TEST.                                                  
                                                                                
SECTION 206.2: COLLATING MULTI-CHARACTER STRINGS.                               
                                                                                
THIS SECTION DISPLAYS SOME SUGGESTIVE TEST CASES TO                             
SHOW HOW THIS IMPLEMENTATION HANDLES COMPARISONS OF                             
MULTI-CHARACTER STRINGS. ALL STRINGS SHOWN ARE DELIMITED                        
BY APOSTROPHES TO ENABLE THE USER TO DISTINGUISH BLANKS                         
FROM NULL.                                                                      
                                                                                
                    BEGIN TEST.                                                 
                                                                                
'ABC' = 'ABC'                                                                   
'ABC' < 'ABD'                                                                   
'ABC' < 'XYZ'                                                                   
'ABC' < 'ABC  '                                                                 
'ABC' > '  ABC'                                                                 
'ABC  ' > '  ABC'                                                               
'ABC' < 'ABCD'                                                                  
'ABC' > '  '                                                                    
'ABC' > ''                                                                      
'' < '  '                                                                       
'  ' < '    '                                                                   
'  ABC' > ' '                                                                   
'  ABC' > '  '                                                                  
'  ABC' > '   '                                                                 
                                                                                
IF DOCUMENTATION AGREES WITH ABOVE RESULTS, THEN                                
*** TEST PASSED ***                                                             
                                                                                
                     END TEST.                                                  
                                                                                
END PROGRAM 206                                                                 
