################################################################
#
# The author of this software is David M. Gay.
#
# Copyright (c) 1991, 2000, 2001 by Lucent Technologies.
#
# Permission to use, copy, modify, and distribute this software for any
# purpose without fee is hereby granted, provided that this entire notice
# is included in all copies of any software which is or includes a copy
# or modification of this software and in all copies of the supporting
# documentation for such software.
#
# THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED
# WARRANTY.  IN PARTICULAR, NEITHER THE AUTHOR NOR LUCENT MAKES ANY
# REPRESENTATION OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY
# OF THIS SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.
#
# Upstream URL:
# http://netlib.sandia.gov/fp/index.html
#
################################################################
        .section .text,"ax",@progbits
        .globl  g_fmt
        .type   g_fmt, @function
g_fmt:
        pushq   %rbp
        xorps   %xmm1, %xmm1
        movq    %rsp, %rbp
        pushq   %r12
        movq    %rsi, %r12
        pushq   %rbx
        movq    %rdi, %rbx
        subq    $16, %rsp
        ucomisd %xmm1, %xmm0
        jp      0f
        jne     0f
        movb    $32, (%rdi)
        movb    $48, 1(%rdi)
        movb    $32, 2(%rdi)
        movb    $0, 3(%rdi)
        jmp     29f
0:
        leaq    -28(%rbp), %rcx
        movl    $4, %edi
        movl    %r12d, %esi
        leaq    -24(%rbp), %r8
        movabsq $dtoa, %rax
        leaq    -32(%rbp), %rdx
        call    *%rax
        cmpl    $0, -28(%rbp)
        leaq    1(%rbx), %rcx
        movq    %rax, %rdi
        movq    %rcx, %rax
        je      1f
        movb    $45, (%rbx)
        jmp     2f
1:
        movb    $32, (%rbx)
2:
        movl    -32(%rbp), %edx
        cmpl    $9999, %edx
        jne     4f
        movq    %rdi, %rdx
3:
        incq    %rdx
        movb    -1(%rdx), %cl
        testb   %cl, %cl
        movb    %cl, (%rax)
        je      27f
        incq    %rax
        jmp     3b
4:
        movslq  %edx, %r9
        cmpq    %r12, %r9
        jg      5f
        movq    -24(%rbp), %r8
        subq    %rdi, %r8
        movq    %r8, %rsi
        subq    %r12, %rsi
        cmpq    %rsi, %r9
        jge     15f
5:
        movb    (%rdi), %al
        leaq    2(%rcx), %rsi
        movb    %al, (%rcx)
        cmpb    $0, 1(%rdi)
        je      7f
        leaq    1(%rdi), %rax
        movb    $46, 1(%rcx)
6:
        incq    %rax
        movb    -1(%rax), %cl
        testb   %cl, %cl
        movb    %cl, (%rsi)
        je      8f
        incq    %rsi
        jmp     6b
7:
        movb    $46, 1(%rcx)
8:
        movb    $69, (%rsi)
        leaq    2(%rsi), %r9
        decl    %edx
        testl   %edx, %edx
        movl    %edx, -32(%rbp)
        jns     9f
        negl    %edx
        movb    $45, 1(%rsi)
        movl    %edx, -32(%rbp)
        jmp     10f
9:
        movb    $43, 1(%rsi)
10:
        movl    -32(%rbp), %r8d
        movl    $2, %ecx
        movl    $10, %esi
11:
        imull   $10, %esi, %eax
        cmpl    %r8d, %eax
        jg      12f
        incl    %ecx
        movl    %eax, %esi
        jmp     11b
12:
        xorl    %r10d, %r10d
13:
        movl    %r8d, %eax
        cltd
        idivl   %esi
        leal    48(%rax), %edx
        movb    %dl, (%r9,%r10)
        incq    %r10
        cmpl    %r10d, %ecx
        je      14f
        imull   %esi, %eax
        subl    %eax, %r8d
        imull   $10, %r8d, %r8d
        jmp     13b
14:
        decl    %ecx
        movl    %r8d, -32(%rbp)
        movslq  %ecx, %rcx
        addq    %r9, %rcx
        movb    $32, 1(%rcx)
        movb    $0, 2(%rcx)
        jmp     28f
15:
        testl   %edx, %edx
        jle     16f
        movq    %rdi, %rcx
        jmp     22f
16:
        leaq    1(%rcx), %rax
        movb    $46, (%rcx)
17:
        testl   %edx, %edx
        jns     18f
        incq    %rax
        movb    $48, -1(%rax)
        incl    %edx
        jmp     17b
18:
        movl    %edx, -32(%rbp)
        movq    %rdi, %rdx
19:
        incq    %rdx
        movb    -1(%rdx), %cl
        testb   %cl, %cl
        movb    %cl, (%rax)
        je      27f
        incq    %rax
        jmp     19b
20:
        leaq    1(%rax), %rsi
        decl    %edx
        testl   %edx, %edx
        movl    %edx, -32(%rbp)
        je      23f
21:
        movq    %rsi, %rax
22:
        incq    %rcx
        movb    -1(%rcx), %dl
        testb   %dl, %dl
        movb    %dl, (%rax)
        movl    -32(%rbp), %edx
        jne     20b
        jmp     24f
23:
        cmpb    $0, (%rcx)
        je      21b
        leaq    2(%rax), %rsi
        movb    $46, 1(%rax)
        jmp     21b
24:
        xorl    %ecx, %ecx
25:
        movl    %edx, %esi
        subl    %ecx, %esi
        testl   %esi, %esi
        jle     26f
        movb    $48, (%rax,%rcx)
        incq    %rcx
        jmp     25b
26:
        testl   %edx, %edx
        movl    $0, %esi
        cmovns  %edx, %esi
        movslq  %esi, %rcx
        subl    %esi, %edx
        addq    %rcx, %rax
        movl    %edx, -32(%rbp)
27:
        movb    $32, (%rax)
        movb    $0, 1(%rax)
28:
        movabsq $freedtoa, %rax
        call    *%rax
29:
        popq    %rdx
        movq    %rbx, %rax
        popq    %rcx
        popq    %rbx
        popq    %r12
        popq    %rbp
        retq
        .size   g_fmt, .-g_fmt
